unit InfoLoad;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, StdCtrls, ActiveX, SHDocVw_EWB, EmbeddedWB, EwbCore;

type
  TLoadInfo = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    EmbeddedWB1: TEmbeddedWB;
    procedure FormCreate(Sender: TObject);
    procedure EmbeddedWB1DocumentComplete(ASender: TObject; const pDisp: IDispatch; var URL: OleVariant); 
    procedure GoToURL(const URL: string);
    procedure ClearSourceCode(); 
    procedure SetBrowserWindow();
    procedure SetFormWindow();
    function GetSourceCode(): string;
    function GetLoadTime(): string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  
const
  ret = #13#10;

var
  LoadInfo: TLoadInfo;
  SourceCode: string;

implementation

{$R *.dfm}

function ObjStreamToStr(const aDisp: IDispatch): string;
var
  IPsi: IPersistStreamInit;
  Sa: TStreamAdapter;
  Ss: TStringStream;
begin
  Result := '';
  if aDisp = nil then
    Result := '';
  if aDisp.QueryInterface(IPersistStreamInit, IPsi) <> S_OK then
    Result := '';
  Ss := TStringStream.Create('');
  Sa := TStreamAdapter.Create(Ss, soReference);
  IPsi.Save(Sa, True);
  Result := Ss.DataString;
  FreeAndNil(Sa);
  FreeAndNil(Ss);
end;

procedure TLoadInfo.FormCreate(Sender: TObject);
begin
  EmbeddedWB1.AddressBar := False;
  EmbeddedWB1.MenuBar := False;
  EmbeddedWB1.StatusBar := False;
  //EmbeddedWB1.UserAgent := 'Mozilla/5.0 (X11; U; Linux i686; ru; rv:1.9.1.8) Gecko/20100214 Linux Mint/8 (Helena) Firefox/3.5.8';
  EmbeddedWB1.UserAgent := 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.113 Safari/537.36 Edg/81.0.416.62';
  EmbeddedWB1.UserAgentMode := uaInternal;
end;
procedure TLoadInfo.EmbeddedWB1DocumentComplete(ASender: TObject; const pDisp: IDispatch; var URL: OleVariant);
begin
  SourceCode := ObjStreamToStr(EmbeddedWB1.Document);
end;

function DelDoubleSpacesAndLineBreaks(OldText: string): string;
var
  i: Integer;
  s: string;
begin
  OldText := StringReplace(StringReplace(OldText, #10, '', [rfReplaceAll]), #13, '', [rfReplaceAll]);
  if Length(OldText) > 0 then
    s := OldText[1]
  else
    s := '';
  for i := 1 to Length(OldText) do
    begin
      if OldText[i] = ' ' then
        begin
          if not (OldText[i - 1] = ' ') then
            s := s + ' ';
        end
      else
        s := s + OldText[i];
    end;
  Result := StringReplace(s, '> <', '><', [rfReplaceAll]);
end;

function TLoadInfo.GetSourceCode(): string;
var
  SecConter: Integer;
begin
  SecConter := 0;
  while SourceCode = '' do
    begin
      Application.ProcessMessages;
      Sleep(100);
      SecConter := SecConter + 1;
      Application.ProcessMessages;
      if SecConter > 100 then
        break
    end;
  if SourceCode = '' then
    Result := ''
  else
    Result := DelDoubleSpacesAndLineBreaks(SourceCode);
end;

function TLoadInfo.GetLoadTime(): string;
var
  Today: TDateTime;
begin
  Today := Now;
  Result := '<b> : <font color="#ff0000">' +
            stringreplace(DateToStr(Today), '/', '.', [rfReplaceAll, rfIgnoreCase]) +
            ' ' + TimeToStr(Today) + '</font></b>';
end;

procedure TLoadInfo.GoToURL(const URL: string);
var
  Flags, TargetFrameName, PostData, Headers: OLEVariant;
begin
  Flags :='';
  TargetFrameName := '';
  PostData := '';
  //Headers := 'User-Agent:Mozilla/5.0 (X11; U; Linux i686; ru; rv:1.9.1.8) Gecko/20100214 Linux Mint/8 (Helena) Firefox/3.5.8' + ret;
  Headers := 'User-Agent:Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/81.0.4044.113 Safari/537.36 Edg/81.0.416.62' + ret;
  Headers := Headers + 'Accept:text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8' + ret;
  Headers := Headers + 'Accept-Language:ru,en-us;q=0.7,en;q=0.3' + ret;
  Headers := Headers + 'Accept-Encoding:deflate' + ret;
  Headers := Headers + 'Accept-Charset:windows-1251,utf-8;q=0.7,*;q=0.7' + ret;
  Headers := Headers + 'Keep-Alive:300' + ret;
  Headers := Headers + 'Connection:keep-alive' + ret;
  Headers := Headers + 'Referer:https://www.kinopoisk.ru/' + ret;
  Headers := Headers + 'Cookie:users_info[check_sh_bool]=none; search_last_date=2010-02-19; search_last_month=2010-02; PHPSESSID=b6df76a958983da150476d9cfa0aab18';
  {
  Headers := 'Content-Type:text/html; charset=windows-1251' + ret;
  Headers := Headers + 'Accept:image/gif, image/jpeg, image/pjpeg, application/x-ms-application, application/xaml+xml, application/x-ms-xbap, */*' + ret;
  Headers := Headers + 'Accept-Language:ru-RU' + ret;
  Headers := Headers + 'User-Agent:Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36' + ret;
  Headers := Headers + 'Host:www.kinopoisk.ru' + ret;
  Headers := Headers + 'Connection:Keep-Alive' + ret;
  }
  EmbeddedWB1.Navigate(URL, Flags, TargetFrameName, PostData, Headers);
end;

procedure TLoadInfo.ClearSourceCode();
begin
  SourceCode := '';
  Self.Close;
end;

procedure TLoadInfo.SetBrowserWindow();
begin
  GroupBox1.Visible := False;
  Self.Width := 720;
  Self.ClientWidth := 704;
  Self.Height := 644;
  Self.ClientHeight := 614;
  EmbeddedWB1.DownloadOptions := [DownloadImages];
  EmbeddedWB1.Width := 700;
  EmbeddedWB1.Height := 610;
end;

procedure TLoadInfo.SetFormWindow();
begin
  Self.Width := 312;
  Self.ClientWidth := 296;
  Self.Height := 144;
  Self.ClientHeight := 105;
  GroupBox1.Visible := True;
  EmbeddedWB1.Width := 0;
  EmbeddedWB1.Height := 0;
  EmbeddedWB1.DownloadOptions := [DontExecuteScripts,DontExecuteJava,DontExecuteActiveX,DontDownloadActiveX,DownloadButDontDisplay,DontDownloadFrame,DontDownloadBehaviors,DownloadInSilentMode];
end;

end.
