library Kinopoisk_zas_covers;

uses
  amm_pluginapi,
  PicDlg in '..\Kinopoisk_zas\PicDlg.pas' {Form1},
  UpdateFormUnit in '..\Kinopoisk_zas_up\UpdateFormUnit.pas' {Form3},
  InfoLoad in '..\Kinopoisk_zas\InfoLoad.pas' {LoadInfo},
  Windows, Classes, Forms, SysUtils, Dialogs, IniFiles, Graphics, Jpeg, StrUtils, ShlObj;

{$R *.res}

type
  TRGBArray = array[Word] of TRGBTriple;
  pRGBArray = ^TRGBArray;

const
  ret = #13#10;
  INTERNET_CONNECTION_MODEM = 1;
  INTERNET_CONNECTION_LAN = 2;
  INTERNET_CONNECTION_PROXY = 4;

var
  MovieBase: TMovieBase;
  Form: TForm1;
  LoadInfo: TLoadInfo;
  CoversWidth, CoversHeight, ScreenshotsWidth, ScreenshotsHeight: Integer;

function GetVersion4: Integer; far;
begin
  Result := 136;
end;

function GetBaseName4: Pchar; far;
begin
  Result := 'KinoPoisk.ru (Covers only) (z_a_s)';
end;

procedure Init4(Owner: Integer); far;
begin
  OwnerAPP := Owner;
end;

function InternetGetConnectedState(lpdwFlags: LPDWORD; dwReserved: DWORD): BOOL; stdcall; external 'wininet.dll' name 'InternetGetConnectedState';

function IsInternetConnected: Boolean;
var
  dwConnectionTypes: DWORD;
begin
  dwConnectionTypes := INTERNET_CONNECTION_MODEM or
    INTERNET_CONNECTION_LAN or
    INTERNET_CONNECTION_PROXY;
  Result := InternetGetConnectedState(@dwConnectionTypes, 0);
end;

function PosExD(const SubStr, s: string; Direct: Integer = -1): Integer;
var
  i, j, LenSubStr: Integer;
  Offset: Cardinal;
begin
  Offset := Length(s);
  if Direct >= 0 then
    begin
      Result := PosEx(SubStr, s, Offset);
      Exit;
    end;
  i := Offset;
  LenSubStr := Length(SubStr);
  while i >= LenSubStr do
  begin
    if s[i] = SubStr[ LenSubStr ] then
    begin
      j := 1;
      while (j < LenSubStr) and (s[i - j] = SubStr[LenSubStr - j]) do
        Inc(j);
      if (j = LenSubStr) then
      begin
        Result := (i - LenSubStr) + 1;
        exit;
      end;
    end;
    Dec(i);
  end;
  Result := 0;
end;

procedure SmoothResize(Src, Dst: TBitmap);
var
  x, y: Integer;
  xP, yP: Integer;
  xP2, yP2: Integer;
  SrcLine1, SrcLine2: pRGBArray;
  t3: Integer;
  z, z2, iz2: Integer;
  DstLine: pRGBArray;
  DstGap: Integer;
  w1, w2, w3, w4: Integer;
begin
  Src.PixelFormat := pf24Bit;
  Dst.PixelFormat := pf24Bit;
  if (Src.Width = Dst.Width) and (Src.Height = Dst.Height) then
    Dst.Assign(Src)
  else
    begin
      DstLine := Dst.ScanLine[0];
      DstGap := Integer(Dst.ScanLine[1]) - Integer(DstLine);
      xP2 := MulDiv(pred(Src.Width), $10000, Dst.Width);
      yP2 := MulDiv(pred(Src.Height), $10000, Dst.Height);
      yP := 0;
      for y := 0 to pred(Dst.Height) do
        begin
          xP := 0;
          SrcLine1 := Src.ScanLine[yP shr 16];
          if (yP shr 16 < pred(Src.Height)) then
            SrcLine2 := Src.ScanLine[succ(yP shr 16)]
          else
            SrcLine2 := Src.ScanLine[yP shr 16];
          z2 := succ(yP and $FFFF);
          iz2 := succ((not yp) and $FFFF);
          for x := 0 to pred(Dst.Width) do
            begin
              t3 := xP shr 16;
              z := xP and $FFFF;
              w2 := MulDiv(z, iz2, $10000);
              w1 := iz2 - w2;
              w4 := MulDiv(z, z2, $10000);
              w3 := z2 - w4;
              DstLine[x].rgbtRed := (SrcLine1[t3].rgbtRed * w1 + SrcLine1[t3 + 1].rgbtRed * w2 +
                SrcLine2[t3].rgbtRed * w3 + SrcLine2[t3 + 1].rgbtRed * w4) shr 16;
              DstLine[x].rgbtGreen := (SrcLine1[t3].rgbtGreen * w1 + SrcLine1[t3 + 1].rgbtGreen * w2 +
                SrcLine2[t3].rgbtGreen * w3 + SrcLine2[t3 + 1].rgbtGreen * w4) shr 16;
              DstLine[x].rgbtBlue := (SrcLine1[t3].rgbtBlue * w1 + SrcLine1[t3 + 1].rgbtBlue * w2 +
                SrcLine2[t3].rgbtBlue * w3 + SrcLine2[t3 + 1].rgbtBlue * w4) shr 16;
              Inc(xP, xP2);
            end;
          Inc(yP, yP2);
          DstLine := pRGBArray(Integer(DstLine) + DstGap);
        end;
    end;
end;

function GetCoverFromURL(const URL: string): Boolean;
var
  bmp, bmp2: TBItmap;
  Jpg: TJPEGImage;
  NamePic: string;
  Scale, Scale2: Double;
begin
  LoadInfo.Label1.Caption := '  ...';
  LoadInfo.Show;
  Application.ProcessMessages;
  NamePic := MovieBase.Filename + '.jpg';
  NamePic := Form.GetImgStream(URL, NamePic);
  if NamePic = '' then
    begin
      LoadInfo.Close;
      ShowMessage('   ');
      Result := False;
      Exit;
    end;
  LoadInfo.Label1.Caption := '  .....';
  Application.ProcessMessages;
  try
    jpg := TJpegImage.Create;
    bmp := Tbitmap.Create;
    bmp2 := Tbitmap.Create;
    jpg.Loadfromfile(NamePic);
    bmp.Assign(jpg);
    Scale := 1;
    Scale2 := 1;
    if jpg.Width > CoversWidth then
      Scale := jpg.Width / CoversWidth;
    if jpg.Height > CoversHeight then
      Scale2 := jpg.Height / CoversHeight;
    if Scale2 > Scale then
      Scale := Scale2;
    if Scale > 1 then
      begin
        bmp2.Width := Round(bmp.Width / Scale);
        bmp2.Height := Round(bmp.Height / Scale);
        SmoothResize(bmp, bmp2);
        jpg.Assign(bmp2);
        jpg.CompressionQuality := 85;
        jpg.Compress;
        jpg.SaveToFile(NamePic);
      end;
    bmp.Free;
    bmp2.Free;
    jpg.Free;
    MovieBase.CurrentMovie.SetCoverImage(NamePic);
    DeleteFile(NamePic);
  except
    LoadInfo.Close;
    ShowMessage('    ');
    Result := False;
    Exit;
  end;
  Result := True;
  LoadInfo.Close;
end;

function GetScreenFromURL(const URL: string; Cover: Integer): Boolean;
var
  bmp, bmp2: TBItmap;
  Jpg: TJPEGImage;
  NamePic: string;
  Scale, Scale2: Double;
begin
  LoadInfo.Label1.Caption := '  ...';
  LoadInfo.Show;
  Application.ProcessMessages;
  NamePic := MovieBase.Filename + '.jpg';
  NamePic := Form.GetImgStream(URL, NamePic);
  if NamePic = '' then
    begin
      LoadInfo.Close;
      ShowMessage('   ');
      Result := False;
      Exit;
    end;
  LoadInfo.Label1.Caption := '  ...';
  Application.ProcessMessages;
  try
    jpg := TJpegImage.Create;
    bmp := Tbitmap.Create;
    bmp2 := Tbitmap.Create;
    jpg.Loadfromfile(NamePic);
    bmp.Assign(jpg);
    Scale := 1;
    Scale2 := 1;
    if Cover = 1 then
      begin
        if jpg.Width > CoversWidth then
          Scale := jpg.Width / CoversWidth;
        if jpg.Height > CoversHeight then
          Scale2 := jpg.Height / CoversHeight;
      end
    else
      begin
        if jpg.Width > ScreenshotsWidth then
          Scale := jpg.Width / ScreenshotsWidth;
        if jpg.Height > ScreenshotsHeight then
          Scale2 := jpg.Height / ScreenshotsHeight;
      end;
    if Scale2 > Scale then
      Scale := Scale2;
    if Scale > 1 then
      begin
        bmp2.Width := Round(bmp.Width / Scale);
        bmp2.Height := Round(bmp.Height / Scale);
        SmoothResize(bmp, bmp2);
        jpg.Assign(bmp2);
        jpg.CompressionQuality := 85;
        jpg.Compress;
        jpg.SaveToFile(NamePic);
      end;
    bmp.Free;
    bmp2.Free;
    jpg.Free;
    MovieBase.CurrentMovie.SetScreenshot(NamePic);
    DeleteFile(NamePic);
  except
    LoadInfo.Close;
    ShowMessage('    ');
    Result := False;
    Exit;
  end;
  Result := True;
  LoadInfo.Close;
end;

function ReverseString(s: string): string;
var
  i: integer;
begin
  Result := '';
  if Trim(s) <> '' then
    begin
      for i := Length(s) downto 1 do
        Result := Result + s[i];
    end;
end;

function CorrectRequest(req: string): string;
var
  s: string;
  i: Integer;
begin
  s := '';
  for i := 1 to length(req) do
    s := s + '%' + IntToHex(ord(req[i]), 2);
  s := stringreplace(s, '%20', '+', [rfReplaceAll]);
  Result := s;
end;

function AnsiUpFirstLetter(const AStr: string): string;
var
  s: string;
begin
  Result := AnsiLowerCase(AStr);
  s := AnsiUpperCase(Astr);
  if length(s) > 0 then
    Result[1] := s[1]
  else
    Result := '';
end;

function HTMLRemoveTags(const AStr: string): string;
var
  s: string;
begin
  s := AStr;
  while (pos('<script', s) > 0) and (pos('</script>', s) > 0) and (pos('</script>', s) > pos('<script', s)) do
    delete(s, pos('<script', s), pos('</script>', s) - pos('<script', s) + 9);
  while (pos('<', s) > 0) and (pos('>', s) > 0) and (pos('>', s) > pos('<', s)) do
    delete(s, pos('<', s), pos('>', s) - pos('<', s) + 1);
  Result := TrimRight(TrimLeft(s));
end;

function ReplaceTagWithChar(text, html_tag: string; char_code: Char): string;
var
  i, j: integer;
begin
  j := 0;
  i := Pos(html_tag, text);
  while i > j do
    begin
      text[i] := char_code;
      text[i + 1] := ' ';
      text[i + 2] := '<';
      j := i;
      i := Pos(html_tag, text);
    end;
  Result := text;
end;

function NotLatinName(const Name, NameException: string): Boolean;
var
  Sp: PChar;
  Code: Integer;
begin
  Result := False;
  Sp := PChar(Name);
  Code := Ord(Sp^);
  if (Code >= 192) and (Code <= 255) then
    Result := True;
  if pos(Name, NameException) > 0 then
    Result := True;
end;

function HTMLDecode(const AStr: String): String;
var
  Sp, Rp, Cp, Tp: PChar;
  S: String;
  I, Code: Integer;
begin
  SetLength(Result, Length(AStr));
  Sp := PChar(AStr);
  Rp := PChar(Result);
  Cp := Sp;
  try
    while Sp^ <> #0 do
      begin
        case Sp^ of
          '\':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                'u':
                  begin
                    Tp := Sp;
                    Inc(Tp);
                    while (Sp^ in ['u','0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f']) do
                      Inc(Sp);
                    SetString(S, Tp, Sp - Tp);
                    dec(Sp);
                    Val('x'+S, I, Code);
                    if I >= $10000 then
                      begin
                        Rp^ := Char(((I - $10000) div $400) + $d800);
                        Inc(Rp);
                        Rp^ := Char(((I - $10000) and $3ff) + $dc00);
                      end
                    else
                      Rp^ := Chr((I));
                  end;
              end;
            end;
          '&':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                ' ':
                  begin
                    Rp^ := '&';
                    Inc(Rp);
                    Rp^ := ' ';
                  end;
                'n':
                  begin
                    if AnsiStrPos(Sp, 'nbsp;') = Sp then
                      begin
                        inc(Sp, 4);
                        Rp^ := ' ';
                      end;
                    if AnsiStrPos(Sp, 'ndash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'm':
                  begin
                    if AnsiStrPos(Sp, 'mdash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'b':
                  if AnsiStrPos(Sp, 'bull;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '|';
                    end;
                'a':
                  if AnsiStrPos(Sp, 'amp;') = Sp then
                    begin
                      Inc(Sp, 3);
                      Rp^ := '&';
                    end;
                'l', 'g':
                  begin
                    if (AnsiStrPos(Sp, 'lt;') = Sp) or (AnsiStrPos(Sp, 'gt;') = Sp) then
                      begin
                        Cp := Sp;
                        Inc(Sp, 2);
                        while (Sp^ <> ';') and (Sp^ <> #0) do
                          Inc(Sp);
                        if Cp^ = 'l' then
                          Rp^ := '<'
                        else
                          Rp^ := '>';
                      end;
                    if (AnsiStrPos(Sp, 'laquo;') = Sp) then
                      begin
                        Inc(Sp, 5);
                        Rp^ := '"';
                      end;
                  end;
                'r':
                  if (AnsiStrPos(Sp, 'raquo;') = Sp) then
                    begin
                      Inc(Sp, 5);
                      Rp^ := '"';
                    end;
                'q':
                  if AnsiStrPos(Sp, 'quot;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '"';
                    end;
                '#':
                begin
                  Tp := Sp;
                  Inc(Tp);
                  while (Sp^ <> ';') and (Sp^ <> #0) do
                    Inc(Sp);
                  SetString(S, Tp, Sp - Tp);
                  Val(S, I, Code);
                  if I >= $100 then
                    begin
                      S := WideChar(I);
                      Rp^ := S[1];
                    end
                  else
                    Rp^ := Chr((I));
                end;
              end;
            end
        else
          Rp^ := Sp^;
        end;
        Inc(Rp);
        Inc(Sp);
      end;
  except
  end;
  SetLength(Result, Rp - PChar(Result));
end;

function ClearHTML(s: string): string;
var
  i, c: integer;
  stt, st1: string;
begin
  s := stringreplace(s, ret, '$ret$', [rfReplaceAll]);
  s := stringreplace(s, '&nbsp;', ' ', [rfReplaceAll]);
  s := stringreplace(s, #$A, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, #9, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<hr>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</p>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</li>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</div>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '&#8211;', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '$ret$', ret, [rfReplaceAll]);
  s := trim(HTMLDecode(s));
  s := HTMLRemoveTags(s);
  c := 0;
  for i := 1 to Length(s) do
    begin
      stt := copy(s, i, 1);
      if (stt = ' ') and (c >= 1) then
        begin
          stt := '';
          c := c + 1;
        end
      else
        begin
          if (stt = ' ') and (c = 0) then
            c := c + 1
          else
            if (stt <> ' ') then
              c := 0;
        end;
      st1 := st1 + stt;
    end;
  Result := st1;
end;

function ReplaceLatinExt(s: string): string;
begin
  s := stringreplace(s, '&#224;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#225;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#226;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#227;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#228;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#229;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#230;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe0;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe1;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe2;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe3;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe4;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe5;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe6;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#257;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#259;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#261;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#462;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#479;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#481;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#483;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#507;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#509;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#513;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#515;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#551;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#592;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#11365;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&agrave;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aacute;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&acirc;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&atilde;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&auml;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aring;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aelig;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#192;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#193;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#194;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#195;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#196;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#197;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#198;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc0;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc1;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc2;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc3;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc4;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc5;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc6;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#256;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#258;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#260;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#461;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#478;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#480;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#482;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#506;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#508;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#512;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#514;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#550;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#570;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#11375;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&AElig;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aring;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Auml;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Atilde;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Acirc;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aacute;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Agrave;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#384;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#387;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#595;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#385;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#386;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#579;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#665;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#231;', 'c', [rfReplaceAll]); 
  s := stringreplace(s, '&ccedil;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#xe7;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#263;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#265;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#267;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#269;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#392;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#572;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#597;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#663;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#199;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#xc7;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#262;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#264;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#266;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#268;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#391;', 'C', [rfReplaceAll]); 
  s := stringreplace(s, '&#571;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&Ccedil;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#240;', 'd', [rfReplaceAll]);  
  s := stringreplace(s, '&#xf0;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#271;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#273;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#396;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#454;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#499;', 'd', [rfReplaceAll]);   
  s := stringreplace(s, '&#545;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&#568;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#598;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#599;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#675;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#677;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&eth;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#208;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&Eth;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&ETH;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#xd0;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#270;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&#272;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#393;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#394;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#395;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#452;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#453;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#497;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#498;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#232;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#233;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#234;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#235;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe8;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xea;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xeb;', 'e', [rfReplaceAll]);  
  s := stringreplace(s, '&#xE9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEa;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEb;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#275;', 'e', [rfReplaceAll]);  
  s := stringreplace(s, '&#277;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#279;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#281;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#283;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#477;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#517;', 'e', [rfReplaceAll]);    
  s := stringreplace(s, '&#519;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#553;', 'e', [rfReplaceAll]); 
  s := stringreplace(s, '&#583;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#600;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#603;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#604;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#605;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#606;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#666;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#11384;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&egrave;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&eacute;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&ecirc;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&euml;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#200;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#201;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#202;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#203;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc8;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc9;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xca;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xcb;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#274;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#276;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#278;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#280;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#282;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#398;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#400;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#516;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#518;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#552;', 'E', [rfReplaceAll]); 
  s := stringreplace(s, '&#582;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#11387;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Egrave;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Eacute;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Ecirc;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Euml;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#402;', 'f', [rfReplaceAll]);   
  s := stringreplace(s, '&fnof;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#x192;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#401;', 'F', [rfReplaceAll]);
  s := stringreplace(s, '&#285;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#287;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#289;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#291;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#485;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#487;', 'g', [rfReplaceAll]);  
  s := stringreplace(s, '&#501;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#608;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#609;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#284;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#286;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#288;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#290;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#403;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#484;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#486;', 'G', [rfReplaceAll]);  
  s := stringreplace(s, '&#500;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#610;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#667;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#293;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#295;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#543;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#613;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#614;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#686;', 'h', [rfReplaceAll]);   
  s := stringreplace(s, '&#687;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11368;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11382;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#292;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#294;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#542;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#668;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11367;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11381;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#236;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#237;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#238;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#239;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xec;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xed;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xee;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xef;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#299;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#301;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#303;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#305;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#307;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#297;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#410;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#464;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#521;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#523;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#616;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&igrave;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&icirc;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iuml;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#204;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#205;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#206;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#207;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcd;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xce;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcf;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#296;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#298;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#300;', 'I', [rfReplaceAll]); 
  s := stringreplace(s, '&#302;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#304;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#306;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#407;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#463;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#520;', 'I', [rfReplaceAll]);  
  s := stringreplace(s, '&#522;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#618;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Igrave;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iacute;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Icirc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iuml;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#11361;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#309;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#496;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#567;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#585;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#607;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#644;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#669;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#11388;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#308;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#584;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#311;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#312;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#409;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#489;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#670;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#11370;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#310;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#408;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#488;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#11369;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#314;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#316;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#318;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#320;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#322;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#457;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#564;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#620;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#621;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#682;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#683;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#313;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#315;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#317;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#319;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#321;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#455;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#456;', 'L', [rfReplaceAll]); 
  s := stringreplace(s, '&#573;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#619;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#671;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11360;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11362;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#623;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#624;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#625;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#412;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#11374;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#241;', 'n', [rfReplaceAll]); 
  s := stringreplace(s, '&ntilde;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#xf1;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#324;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#326;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#328;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#329;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#331;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#414;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#460;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#505;', 'n', [rfReplaceAll]);  
  s := stringreplace(s, '&#565;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#626;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#627;', 'n', [rfReplaceAll]);
  s := stringreplace(s, 'ñ', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#209;', 'N', [rfReplaceAll]); 
  s := stringreplace(s, '&Ntilde;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&&#xd1;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#323;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#325;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#327;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#330;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#413;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#458;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#459;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#504;', 'N', [rfReplaceAll]);  
  s := stringreplace(s, '&#544;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#628;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#242;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#243;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#244;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#245;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#246;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#248;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf2;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf3;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf4;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf5;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf6;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#xf8;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#333;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#335;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#337;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#339;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#x153;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#417;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#419;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#466;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#491;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#493;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#511;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#525;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#527;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#547;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#555;', 'o', [rfReplaceAll]);    
  s := stringreplace(s, '&#557;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#559;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#561;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#596;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#629;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ograve;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oacute;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ocirc;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oelig;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&otilde;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ouml;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oslash;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#210;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#211;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#212;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#213;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#214;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#216;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd2;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd3;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd4;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd5;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd6;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd8;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#332;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#334;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#336;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#338;', 'O', [rfReplaceAll]); 
  s := stringreplace(s, '&#x152;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#390;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#415;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#416;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#418;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#465;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#490;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#492;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#510;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#524;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#526;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#546;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#554;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#556;', 'O', [rfReplaceAll]);      
  s := stringreplace(s, '&#558;', 'O', [rfReplaceAll]);    
  s := stringreplace(s, '&#560;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#630;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#11386;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ograve;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oacute;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ocirc;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&OElig;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Otilde;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ouml;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oslash;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#421;', 'p', [rfReplaceAll]);
  s := stringreplace(s, '&#420;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#11363;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#569;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#587;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#672;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#586;', 'Q', [rfReplaceAll]);
  s := stringreplace(s, '&#341;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#343;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#345;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#529;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#531;', 'r', [rfReplaceAll]);  
  s := stringreplace(s, '&#589;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#633;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#634;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#635;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#636;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#637;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#638;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#639;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#11385;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#340;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#342;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#344;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#528;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#530;', 'R', [rfReplaceAll]); 
  s := stringreplace(s, '&#588;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#640;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#641;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#11364;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#223;', 's', [rfReplaceAll]); 
  s := stringreplace(s, '&szlig;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#xdf;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#347;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#349;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#351;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#353;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&scaron;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#x161;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#383;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#537;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#575;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#642;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#346;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#348;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#350;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#352;', 'S', [rfReplaceAll]); 
  s := stringreplace(s, '&Scaron;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#x160;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#536;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#11390;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#355;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#357;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#359;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#427;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#429;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#539;', 't', [rfReplaceAll]);   
  s := stringreplace(s, '&#566;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#647;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#648;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#678;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#680;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#354;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#356;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#358;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#428;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#430;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#538;', 'T', [rfReplaceAll]);   
  s := stringreplace(s, '&#574;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#11366;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#254;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&thorn;', 'th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xfe;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&#222;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&THORN;', 'Th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xde;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&#249;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#250;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#251;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#252;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xf9;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfa;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfb;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#361;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#363;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#365;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#367;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#369;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#371;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#432;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#468;', 'u', [rfReplaceAll]);  
  s := stringreplace(s, '&#470;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#472;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#474;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#476;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#533;', 'u', [rfReplaceAll]);     
  s := stringreplace(s, '&#535;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#649;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ugrave;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uacute;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ucirc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uuml;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#217;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#218;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#219;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#220;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xd9;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xda;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdb;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#360;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#362;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#364;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#366;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#368;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#370;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#431;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#467;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#469;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#471;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#473;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#475;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#532;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#534;', 'U', [rfReplaceAll]);      
  s := stringreplace(s, '&#580;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ugrave;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uacute;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ucirc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uuml;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#651;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#652;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11377;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11380;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#434;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#581;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#11389;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#373;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#653;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#11379;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#372;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#11378;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#253;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&yacute;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xfd;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#255;', 'y', [rfReplaceAll]); 
  s := stringreplace(s, '&yuml;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xff;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#375;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#422;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#436;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#563;', 'y', [rfReplaceAll]);  
  s := stringreplace(s, '&#591;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#654;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#221;', 'Y', [rfReplaceAll]); 
  s := stringreplace(s, '&Yacute;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#xdd;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#374;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#376;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&Yuml;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#x178;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#435;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#562;', 'Y', [rfReplaceAll]);  
  s := stringreplace(s, '&#590;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#655;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#378;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#380;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#382;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#438;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#549;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#576;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#656;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#657;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#11372;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#377;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#379;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#381;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#437;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#548;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11371;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11391;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&Middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&#769;', '', [rfReplaceAll]);
  Result := s;
end;

function CharReplace(s: string): string;
begin
  s := stringreplace(s, '"', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '`', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
  Result := s;
end;

function MyPos(sub, s: string; i: Integer): Integer;
var
  j: Integer;
begin
  delete(s, 1, i - 1);
  j := pos(sub, s);
  if j = 0 then
    Result := 0
  else
    Result := i - 1 + j;
end;

function GetSpecialPath(CSIDL: word): string;
var s: string;
begin
  SetLength(s, MAX_PATH);
  if not SHGetSpecialFolderPath(0, PChar(s), CSIDL, true) then
    s := '';
  Result := PChar(s);
end;

procedure GetBrowserWindow(const URL: string);
begin
  LoadInfo.SetBrowserWindow;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  while LoadInfo.Visible = True do
    Application.HandleMessage;
end;

function GetInfoFromUrl(const URL, LCaption: string): string;
begin
  LoadInfo.SetFormWindow;
  LoadInfo.Label1.Caption := LCaption;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  Result := Utf8Decode(LoadInfo.GetSourceCode);
  LoadInfo.ClearSourceCode;
end;

procedure AMM_NewBasePluginStart4(OrigTitle: Pchar; tlength: Integer); far;
const
  FindBlocking = '/captcha/'; //'IP-  ';
var
  Query: string;
  page, page2, page3: string;
  links: TStringList;
  MovieList: TStringList;
  s, s2, s3, s4, ss, UserDir: string;
  i, ii, j, NotSelectTheMovie, kol, NPage, k: Integer;
  CurrentMovieURL, MovieCode, FullMovieCode, TitlePost, TitleSer: string;
  NoDlg1, NoDlg2, MaxNoDlgLoad, NeedURLDelay, MaxURLDelay: Integer;
  uUseAltDlgScreenshots, uUseAltDlgCovers, uCovers, uScreenshots, uAllCoversPage, uAllScreenshotsPage, SmallPic: Integer;
  SmallPicOnly, IfFillURL: Integer;
  ProxyPort, UseRatingKinoPoisk, UseRatingIMDb, UseRatingKritikov: Integer;
  ProxyServer, ProxyUsername, ProxyPassword: string;
  data, Template, List: TStringList;
  tDescription, tSlogan, tBudget, tSborUS, tSborWord, tSborRF, tSborDVD, tPremDataWord, tPremDataRF, tRatingKinoPoisk, tRatingIMDb: string;
  tProducer, tOperator, tComposer, tVoiceDirector, tVoice, tAwards, tLinks, tZnaite, tRecenzia, tMarketing, tBook3500, tLikeMovies: string;
  tVisualEffectsStudio, tVoiceStudio, tProkatStudio, tDVD, tBluRay, tRatingKritikov, tPainter, tCutter, tTranslator: string;
  AutoCheck, NewVer, Ver: Integer;
  LastDate, LoadDate, StrVal, DownloadSection, DownloadSection2: string;
  VerForm: TForm3;
  ResizeCovers, ResizeScreenshots, MaxCovers, MaxScreenshots, MaxRecenzia: Integer;
begin
  UserDir := '';
  RefreshOff;
  try
    UserDir := GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\plugins\';
    if DirectoryExists(UserDir) = false then
      begin
        if DirectoryExists(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\') = false then
          CreateDir(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\');
        CreateDir(UserDir);
      end;
    if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
      begin
        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini') = true then
          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini'), Pchar(UserDir + 'Kinopoisk_zas.ini'), true);
      end;
  except
  end;
  if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
    begin
      List := TStringList.Create;
      List.Add('[DownloadAll]');
      List.Add('[CommentsOptions]');
      List.Add('[DescriptionOptions]');
      List.Add('[RatingOptions]');
      List.Add('[OtherOptions]');
      List.Add('[NameOptions]');
      List.Add('[KinoPoiskOptions]');
      List.Add('[ProxyOptions]');
      List.SaveToFile(UserDir + 'Kinopoisk_zas.ini');
      List.Free;
    end;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
    try
      WriteInteger('Versions', 'Kinopoisk_zas_covers', GetVersion4);
      LastDate := ReadString('LastDate', 'Kinopoisk_zas_covers', '01/08/2009');
      LoadDate := ReadString('LastDate', 'LoadDate', '01/08/2009');
      WriteString('LastDate', 'Kinopoisk_zas_covers', DateToStr(Date));
    finally
      Free;
    end;
  List := TStringList.Create;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      ReadSections(List);
      DownloadSection := ReadString('OtherOptions', 'Profil', 'DownloadAll');
      DownloadSection2 := ReadString('OtherOptions', 'Profil2', DownloadSection);
      uCovers := ReadInteger(DownloadSection, 'Covers', 1);
      uAllCoversPage := ReadInteger(DownloadSection, 'AllCoversPage', 0);
      uScreenshots := ReadInteger(DownloadSection, 'Screenshots', 1);
      uAllScreenshotsPage := ReadInteger(DownloadSection, 'AllScreenshotsPage', 0);
      MaxCovers := ReadInteger(DownloadSection, 'MaxCovers', 500);
      MaxScreenshots := ReadInteger(DownloadSection, 'MaxScreenshots', 500);
      uUseAltDlgScreenshots := ReadInteger('OtherOptions', 'UseAltDlg', 1);
      uUseAltDlgCovers := ReadInteger('OtherOptions', 'UseAltDlg', 1);
      SmallPic := ReadInteger('OtherOptions', 'SmallPic', 0);
      SmallPicOnly := ReadInteger('OtherOptions', 'SmallPicOnly', 0);
      IfFillURL := ReadInteger('OtherOptions', 'IfFillURL', 1);
      NoDlg1 := ReadInteger('OtherOptions', 'NoDlg1', 0);
      NoDlg2 := ReadInteger('OtherOptions', 'NoDlg2', 0);
      MaxNoDlgLoad := ReadInteger('OtherOptions', 'MaxNoDlgLoad', 5);
      if NoDlg1 = 1 then
        MaxCovers := 1;
      if NoDlg2 = 1 then
        MaxScreenshots := MaxNoDlgLoad;
      NeedURLDelay := ReadInteger('OtherOptions', 'NeedURLDelay', 0);
      MaxURLDelay := ReadInteger('OtherOptions', 'MaxURLDelay', 0);
      if NeedURLDelay = 1 then
        begin
          if MaxURLDelay = 0 then
            MaxURLDelay := 500
          else
            if MaxURLDelay > 0 then
              MaxURLDelay := MaxURLDelay * 1000;
        end;
      // 
      ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
      ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
      ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
      ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
      AutoCheck := ReadInteger('OtherOptions', 'AutoCheck', 1);
      ResizeCovers := ReadInteger('OtherOptions', 'ResizeCovers', 0);
      ResizeScreenshots := ReadInteger('OtherOptions', 'ResizeScreenshots', 0);
      CoversWidth := ReadInteger('OtherOptions', 'CoversWidth', 10000);
      if CoversWidth = 0 then
        CoversWidth := 10000;
      CoversHeight := ReadInteger('OtherOptions', 'CoversHeight', 10000);
      if CoversHeight = 0 then
        CoversHeight := 10000;
      ScreenshotsWidth := ReadInteger('OtherOptions', 'ScreenshotsWidth', 10000);
      if ScreenshotsWidth = 0 then
        ScreenshotsWidth := 10000;
      ScreenshotsHeight := ReadInteger('OtherOptions', 'ScreenshotsHeight', 10000);
      if ScreenshotsHeight = 0 then
        ScreenshotsHeight := 10000;
    finally
      Free;
    end;
  i := 0;
  repeat
    begin
      if (List[i] = 'CommentsOptions') or (List[i] = 'DescriptionOptions') or
        (List[i] = 'RatingOptions') or (List[i] = 'KinoPoiskOptions') or
        (List[i] = 'ProxyOptions') or (List[i] = 'NameOptions') or (List[i] = 'OtherOptions')
      then
        List.Delete(i)
      else
        i := i + 1;
    end;
  until (i = List.Count);
  if AutoCheck = 1 then
    begin
      if LastDate <> DateToStr(Date) then
        begin
          VerForm := TForm3.Create(Application);
          VerForm.Caption := '   ';
          VerForm.CheckBox1.Caption := '    ';
          VerForm.Button2.Caption := '  c ';
          VerForm.UserDir := UserDir;
          if (LoadDate <> DateToStr(Date)) and IsInternetConnected then
            begin
              with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                try
                  // 
                  VerForm.IdHTTP1.ProxyParams.ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
                  VerForm.IdHTTP1.ProxyParams.ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
                  VerForm.IdHTTP1.ProxyParams.ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
                  VerForm.IdHTTP1.ProxyParams.ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
                  if VerForm.IdHTTP1.ProxyParams.ProxyPassword <> '' then
                    VerForm.IdHTTP1.ProxyParams.BasicAuthentication := True;
                finally
                  Free;
                end;
              try
                page := VerForm.IdHTTP1.Get('http://films.unkas.net/files/plugins/Kinopoisk_zas_new.ini');
                Template := TStringList.Create;
                Template.Text := page;
                Template.SaveToFile(UserDir + 'Kinopoisk_zas_new.ini');
                Template.Free;
                with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
                  try
                    WriteString('LastDate', 'LoadDate', DateToStr(Date));
                  finally
                    Free;
                  end;
              except
              end;
            end;
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas_covers', '---');
              NewVer := ReadInteger('Versions', 'Kinopoisk_zas_covers', 0);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label3.Caption := s;
            finally
              Free;
            end;
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas_covers', '100');
              Ver := ReadInteger('Versions', 'Kinopoisk_zas_covers', 100);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label2.Caption := s;
            finally
              Free;
            end;
          if NewVer > Ver then
            begin
              VerForm.Memo1.Clear;
              with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
                try
                  for i := NewVer downto Ver + 1 do
                    begin
                      StrVal := IntToStr(i);
                      s := copy(StrVal, 1, 1) + '.';
                      delete(StrVal, 1, 1);
                      s := s + StrVal;
                      StrVal := ReadString('Log', 'Kinopoisk_zas_covers_' + IntToStr(i), '');
                      if StrVal <> '' then
                        begin
                          VerForm.Memo1.Lines.Add(' ' + s);
                          StrVal := stringreplace(StrVal, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
                          VerForm.Memo1.Text := VerForm.Memo1.Text + ret + StrVal + ret + ret;
                        end;
                    end;
                finally
                  Free;
                end;
              VerForm.ShowModal;
            end;
          VerForm.Free;
        end;
    end;
  SetString(Query, OrigTitle, tlength);
  Query := stringreplace(Query, '&', '', [rfReplaceAll, rfIgnoreCase]);
  MovieBase := TMovieBase.Create;
  LoadInfo := TLoadInfo.Create(Application);
  LoadInfo.EmbeddedWB1.ProxySettings.Address := ProxyServer;
  LoadInfo.EmbeddedWB1.ProxySettings.Password := ProxyPassword;
  LoadInfo.EmbeddedWB1.ProxySettings.Port := ProxyPort;
  LoadInfo.EmbeddedWB1.ProxySettings.UserName := ProxyUsername;
  if LoadInfo.EmbeddedWB1.ProxySettings.Password <> '' then
    LoadInfo.EmbeddedWB1.ProxySettings.AutoLoadProxy := True;
  Form := TForm1.Create(Application);
  Form.Caption := '   ';
  Form.Button1.Caption := ' ';
  Form.Button4.Caption := ' ';
  Form.Button5.Caption := '';
  Form.Kol := 0;
  TitlePost := '';
  TitleSer := '';
  CurrentMovieURL := MovieBase.CurrentMovie.URL;
  i := pos('kinopoisk.ru', CurrentMovieURL);
  if i > 0 then
    begin //  ,  ...
      CurrentMovieURL := stringreplace(CurrentMovieURL, '/id_film/', '/film/', [rfReplaceAll, rfIgnoreCase]);
      CurrentMovieURL := stringreplace(CurrentMovieURL, 'http:', 'https:', [rfReplaceAll, rfIgnoreCase]);
      if CurrentMovieURL[Length(CurrentMovieURL)] <> '/' then
        CurrentMovieURL := CurrentMovieURL + '/';
      if IfFillURL = 1 then
        begin
          i := MessageDlg(' URL  ?', mtConfirmation, [mbYes, mbNo], 0);
          if i = 6 then
            begin
              try
                Application.ProcessMessages;
                page := GetInfoFromUrl(CurrentMovieURL, '    .....');
                Application.ProcessMessages;
              except
                page := '';
              end;
              i := pos(FindBlocking, page);
              if (i > 0) or (page = '') then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow(CurrentMovieURL);
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := GetInfoFromUrl(CurrentMovieURL, '    .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      MovieBase.Free;
                      Form.Free;
                      LoadInfo.Destroy;
                      Exit;
                    end;
                end;
            end
          else
            begin
              try
                Application.ProcessMessages;
                page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                     CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                Application.ProcessMessages;
              except
                page := '';
              end;
              i := pos(FindBlocking, page);
              if (i > 0) or (page = '') then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                    CorrectRequest(Query) + '/order/relevant/perpage/10/');
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                         CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      MovieBase.Free;
                      Form.Free;
                      LoadInfo.Destroy;
                      Exit;
                    end;
                end;
            end;
        end
      else
        if IfFillURL = 2 then
          begin
            try
              Application.ProcessMessages;
              page := GetInfoFromUrl(CurrentMovieURL, '    .....');
              Application.ProcessMessages;
            except
              page := '';
            end;
            i := pos(FindBlocking, page);
            if (i > 0) or (page = '') then
              begin
                ShowMessage('    ');
                GetBrowserWindow(CurrentMovieURL);
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := GetInfoFromUrl(CurrentMovieURL, '    .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    MovieBase.Free;
                    Form.Free; 
                    LoadInfo.Destroy;
                    Exit;
                  end;
              end;
          end
        else
          begin
            try
              Application.ProcessMessages;
              page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                   CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
              Application.ProcessMessages;
            except
              page := '';
            end;
            i := pos(FindBlocking, page);
            if (i > 0) or (page = '') then
              begin
                ShowMessage('    ');
                GetBrowserWindow('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                 CorrectRequest(Query) + '/order/relevant/perpage/10/');
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                       CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    MovieBase.Free;
                    Form.Free; 
                    LoadInfo.Destroy;
                    Exit;
                  end;
              end;
          end;
    end
  else
    begin //  
      try
        Application.ProcessMessages;
        page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                             CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
        Application.ProcessMessages;
      except
        page := '';
      end;
      i := pos(FindBlocking, page);
      if (i > 0) or (page = '') then
        begin
          ShowMessage('    ');
          GetBrowserWindow('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                           CorrectRequest(Query) + '/order/relevant/perpage/10/');
          try
            Application.ProcessMessages;
            if NeedURLDelay = 1 then
              Sleep(MaxURLDelay);
            Application.ProcessMessages;
            page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                 CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
            Application.ProcessMessages;
          except
            page := '';
          end;
          i := pos(FindBlocking, page);
          if (i > 0) or (page = '') then
            begin
              ShowMessage('    ');
              MovieBase.Free;
              Form.Free;
              LoadInfo.Destroy;
              Exit;
            end;
        end;
    end;
  if page <> '@@@!!!@@@' then
    begin
      links := TStringList.Create;
      MovieList := TStringList.Create;
      NotSelectTheMovie := 0;
      if trim(page) = '@@@!!!@@@empty' then
        begin //  !
          ShowMessage(' ,      ');
          Form.Free;
          MovieBase.Free;
          Exit;
        end
      else
        begin
          i := pos('@@@!!!@@@', page);
          if i > 0 then
            begin
              s := page;
              i := pos(' :</dt>', s);
              if i > 0 then
                delete(s, 1, i + 19);
              i := Pos('<div class="right">', s);
              if i > 0 then
                delete(s, 1, i + 18);
              while i > 0 do
                begin
                  s2 := '';
                  j := pos('class="num">', s);
                  if j > 0 then
                    begin
                      j := Pos('<p class="name">', s);
                      if j > 0 then
                        delete(s, 1, j + 15);
                      j := Pos('data-id="', s);
                      if j > 0 then
                        delete(s, 1, j + 8);
                      j := Pos('"', s);
                      if j > 0 then
                        MovieCode := trim(copy(s, 1, j - 1));
                      links.Add(MovieCode);
                      delete(s, 1, pos('>', s));
                      j := pos('</a>', s);
                      s2 := copy(s, 1, j - 1); // 
                      s2 := HTMLRemoveTags(s2);
                      s2 := ReplaceLatinExt(s2);
                      s2 := trim(HTMLDecode(s2));
                      delete(s, 1, j + 3);
                      j := Pos('"year">', s);
                      if j > 0 then
                        delete(s, 1, j + 6);
                      j := pos('</span>', s);
                      s3 := copy(s, 1, j - 1); //  
                      s3 := HTMLRemoveTags(s3);
                      s3 := trim(HTMLDecode(s3));
                      delete(s, 1, j + 6);
                      j := pos('"gray">', s);
                      if j > 0 then
                        delete(s, 1, j + 6);
                      j := pos('</span>', s);
                      s4 := copy(s, 1, j - 1); //   ( )  
                      s4 := HTMLRemoveTags(s4);
                      s4 := ReplaceLatinExt(s4);
                      s4 := trim(HTMLDecode(s4));
                      delete(s, 1, j + 6);
                      if s4 = '' then
                        begin
                          s4 := s2;
                          if s3 <> '' then
                            s4 := s4 + ' (' + s3 + ')';
                          s2 := '';
                        end;
                      if s2 <> '' then
                        begin
                          s4 := s2 + ' / ' + s4;
                          if s3 <> '' then
                            s4 := s4 + ' (' + s3 + ')';
                        end;
                      if GetAMMBuild >= 1303 then
                        begin
                          s4 := s4 + '^^^^https://st.kp.yandex.net/images/film/' + MovieCode + '.jpg';
                        end;
                      MovieList.Add(s4);
                    end;
                  i := Pos('<div class="right">', s);
                  if i > 0 then
                    delete(s, 1, i + 18);
                end;
            end
          else
            begin
              NotSelectTheMovie := 1;
              s := page;
              s2 := '';
              i := Pos('content="https://www.kinopoisk.ru/film/', s);
              if i > 0 then
                begin
                  delete(s, 1, i + 38);
                  s2 := copy(s, 1, Pos('/"', s) - 1);
                  i := PosExD('-', s2);
                  if i > 0 then
                    Delete(s2, 1, i);
                end;
              links.Add(s2);
              MovieList.Add('test' + s2);
            end;
        end;
      if NotSelectTheMovie = 0 then // ,   
        i := MovieBase.SelectTheMovie(MovieList.Text)
      else
        i := 0;
      if i > -1 then
        begin
          MovieCode := links[i];
          if MovieCode = '' then
            begin //   !
              ShowMessage('   !');
              Form.Free;
              MovieBase.Free;
              Exit;
            end;
          if NotSelectTheMovie = 0 then
            if MovieCode <> '' then
              begin
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/',
                                         '    .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/');
                    try
                      Application.ProcessMessages;
                      if NeedURLDelay = 1 then
                        Sleep(MaxURLDelay);
                      Application.ProcessMessages;
                      page := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/',
                                             '    .....');
                      Application.ProcessMessages;
                    except
                      page := '';
                    end;
                    i := pos(FindBlocking, page);
                    if (i > 0) or (page = '') then
                      begin
                        ShowMessage('    ');
                        MovieBase.Free;
                        Form.Free;
                        LoadInfo.Destroy;
                        Exit;
                      end;
                  end;
              end
            else
              page := '';
          if MovieCode <> '' then
            MovieBase.CurrentMovie.URL := 'https://www.kinopoisk.ru/film/' + MovieCode + '/';
          links.Free;
          MovieList.Free;  
          if page <> '' then
            begin
              FullMovieCode := '';
              s := page;
              s2 := '';
              i := Pos('<link rel="alternate" href="', s);
              if i > 0 then
                begin
                  delete(s, 1, i + 27);
                  s2 := copy(s, 1, Pos('/"', s) - 1);
                  i := Pos('/film/', s2);
                  if i > 0 then
                    begin
                      delete(s2, 1, Pos('/film/', s2) + 5);
                      FullMovieCode := s2;
                    end;
                end;
              i := pos('class="moviename-big"', s); //    
              if i > 0 then
                begin
                  delete(s, 1, i + 20);
                  i := pos('">', s);
                  if i > 0 then
                    delete(s, 1, i + 1);
                  i := pos('</', s);
                  s2 := copy(s, 1, i - 1);
                  s2 := HTMLRemoveTags(s2);
                  s2 := ReplaceLatinExt(s2);
                  s2 := HTMLDecode(s2);
                  s2 := trim(s2);
                  i := pos('(', s2);
                  if i > 0 then
                    begin
                      with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                        try
                          uCovers := 1;
                          uAllCoversPage := 1;
                          uScreenshots := 1;
                          uAllScreenshotsPage := 1;
                          MaxCovers := ReadInteger(DownloadSection2, 'MaxCovers', 500);
                          MaxScreenshots := ReadInteger(DownloadSection2, 'MaxScreenshots', 500);
                        finally
                          Free;
                        end;
                    end;
                end;
              s := page; //  
              if uCovers = 1 then // 
                begin
                  if SmallPicOnly = 1 then
                    begin
                      Application.ProcessMessages;
                      if NeedURLDelay = 1 then
                        Sleep(MaxURLDelay);
                      Application.ProcessMessages;
                      MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/film_iphone/iphone360_' + MovieCode + '.jpg');
                    end
                  else
                    begin //,    
                      if (Pos('href="/film/' + FullMovieCode + '/posters/', page) > 0) or
                         (Pos('href="/film/' + MovieCode + '/posters/', page) > 0) or
                         (Pos('href="/film/' + FullMovieCode + '/covers/', page) > 0) or
                         (Pos('href="/film/' + MovieCode + '/covers/', page) > 0)
                      then
                        begin
                          Kol := 0;
                          links := TStringList.Create;
                          MovieList := TStringList.Create;
                          Form.Kol := 0;
                          Form.MovieList := TStringList.Create;
                          Form.links := TStringList.Create;
                          Form.JPGLink := TStringList.Create;
                          if (Pos('href="/film/' + FullMovieCode + '/posters/', page) > 0) or
                             (Pos('href="/film/' + MovieCode + '/posters/', page) > 0)
                          then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  s := page2;
                                  i := pos('/images/poster/sm_', s);
                                  delete(s, 1, i + 17);
                                  j := pos('</table>', s);
                                  s := copy(s, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      s2 := '';
                                      j := pos('</td>', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          delete(s, 1, j - 1);
                                          j := pos('.jpg', s2);
                                          if j = 0 then
                                            j := pos('.JPG', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                          Form.links.Add('0');
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s4 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s4);
                                        end;
                                      i := pos('/images/poster/sm_', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              if (uAllCoversPage = 1) and (Kol < MaxCovers) then //    
                                begin
                                  NPage := 2;
                                  ii := pos('/page/' + IntToStr(NPage) + '/', page2);
                                  while ii > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' +
                                                                IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' + IntToStr(NPage) + '/');
                                          try
                                            Application.ProcessMessages;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            Application.ProcessMessages;
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' +
                                                                    IntToStr(NPage) + '/', '  .....');
                                            Application.ProcessMessages;
                                          except
                                            page3 := '';
                                          end;
                                          i := pos(FindBlocking, page3);
                                          if (i > 0) or (page3 = '') then
                                            begin
                                              ShowMessage('    ');
                                              MovieBase.Free;
                                              Form.Free;
                                              LoadInfo.Destroy;
                                              Exit;
                                            end;
                                        end;
                                      if page3 <> '' then
                                        begin
                                          i := pos('/images/poster/sm_', page3);
                                          delete(page3, 1, i + 17);
                                          j := pos('</table>', page3);
                                          s := copy(page3, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              if Kol >= MaxCovers then
                                                break;
                                              s2 := '';
                                              j := pos('</td>', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  Form.Kol := Form.Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  delete(s, 1, j - 1);
                                                  j := pos('.jpg', s2);
                                                  if j = 0 then
                                                    j := pos('.JPG', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  Form.links.Add('0');
                                                  Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                                  s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := ClearHTML(s2);
                                                  s4 := s2 + ' )';
                                                  s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                                  MovieList.Add(s3);
                                                  Form.MovieList.Add(s4);
                                                end;
                                              i := pos('/images/poster/sm_', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      NPage := NPage + 1;
                                      ii := pos('/page/' + IntToStr(NPage) + '/', page3);
                                    end;
                                end;
                            end;
                          if ((Pos('href="/film/' + FullMovieCode + '/covers/', page) > 0) or
                              (Pos('href="/film/' + MovieCode + '/covers/', page) > 0)) and (Kol < MaxCovers)
                          then
                            begin //   
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  i := pos('/images/poster/sm_', page2);
                                  delete(page2, 1, i + 17);
                                  j := pos('</table>', page2);
                                  s := copy(page2, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      s2 := '';
                                      j := pos('</td>', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          delete(s, 1, j - 1);
                                          j := pos('.jpg', s2);
                                          if j = 0 then
                                            j := pos('.JPG', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.links.Add('0');
                                          Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s4 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s4);
                                        end;
                                      i := pos('/images/poster/sm_', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              if (uAllCoversPage = 1) and (Kol < MaxCovers) then //    
                                begin
                                  NPage := 2;
                                  ii := pos('/page/' + IntToStr(NPage) + '/', page2);
                                  while ii > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' +
                                                                IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' + IntToStr(NPage) + '/');
                                          try
                                            Application.ProcessMessages;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            Application.ProcessMessages;
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' +
                                                                    IntToStr(NPage) + '/', '  .....');
                                            Application.ProcessMessages;
                                          except
                                            page3 := '';
                                          end;
                                          i := pos(FindBlocking, page3);
                                          if (i > 0) or (page3 = '') then
                                            begin
                                              ShowMessage('    ');
                                              MovieBase.Free;
                                              Form.Free;
                                              LoadInfo.Destroy;
                                              Exit;
                                            end;
                                        end;
                                      if page3 <> '' then
                                        begin
                                          i := pos('/images/poster/sm_', page3);
                                          delete(page3, 1, i + 17);
                                          j := pos('</table>', page3);
                                          s := copy(page3, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              if Kol >= MaxCovers then
                                                break;
                                              s2 := '';
                                              j := pos('</td>', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  Form.Kol := Form.Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  delete(s, 1, j - 1);
                                                  j := pos('.jpg', s2);
                                                  if j = 0 then
                                                    j := pos('.JPG', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  Form.links.Add('0');
                                                  Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                                  s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := ClearHTML(s2);
                                                  s4 := s2 + ' )';
                                                  s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                                  MovieList.Add(s3);
                                                  Form.MovieList.Add(s4);
                                                end;
                                              i := pos('/images/poster/sm_', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      NPage := NPage + 1;
                                      ii := pos('/page/' + IntToStr(NPage) + '/', page3);
                                    end;
                                end;
                            end;
                          if Kol > 1 then // ,   
                            begin
                              links.Add('ALL');
                              if uUseAltDlgCovers = 1 then
                                begin
                                  links.Add('SEL');
                                  if Form.Kol > 525 then
                                    Form.Kol := 525;
                                  Form.All := Kol;
                                  Form.ShowModal;
                                  i := Form.ReturVal;
                                end
                              else
                                begin
                                  MovieList.Add('  ...');
                                  i := MovieBase.SelectTheMovie(MovieList.Text);
                                end;
                            end
                          else
                            i := 0;
                          if Kol = 0 then
                            i := -1;
                          if i > -1 then
                            begin
                              if links[i] = 'SEL' then
                                begin
                                  j := 0;
                                  for ii := 0 to Kol - 1 do
                                    begin
                                      if Form.links[ii] = '1' then
                                        begin
                                          if j = 0 then
                                            begin
                                              Application.ProcessMessages;
                                              if NeedURLDelay = 1 then
                                                Sleep(MaxURLDelay);
                                              Application.ProcessMessages;
                                              if ResizeCovers = 0 then
                                                MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg')
                                              else
                                                GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg');
                                              j := 1;
                                            end
                                          else
                                            begin
                                              Application.ProcessMessages;
                                              if NeedURLDelay = 1 then
                                                Sleep(MaxURLDelay);
                                              Application.ProcessMessages;
                                              if ResizeCovers = 0 then
                                                MovieBase.GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg')
                                              else
                                                GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg', 1);
                                            end;
                                        end;
                                    end;
                                end
                              else
                                begin
                                  if links[i] = 'ALL' then
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      if ResizeCovers = 0 then
                                        MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[0] + '.jpg')
                                      else
                                        GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[0] + '.jpg');
                                      for ii := 1 to Kol - 1 do
                                        begin
                                          Application.ProcessMessages;
                                          if NeedURLDelay = 1 then
                                            Sleep(MaxURLDelay);
                                          Application.ProcessMessages;
                                          if ResizeCovers = 0 then
                                            MovieBase.GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg')
                                          else
                                            GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg', 1);
                                        end;
                                    end
                                  else
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      if ResizeCovers = 0 then
                                        MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[i] + '.jpg')
                                      else
                                        GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[i] + '.jpg');
                                    end;
                                end;
                            end;
                          links.Free;
                          MovieList.Free;
                          Form.links.Free;
                          Form.MovieList.Free;
                          Form.JPGLink.Free;
                        end
                      else
                        begin
                          if SmallPic = 1 then
                            begin
                              Application.ProcessMessages;
                              if NeedURLDelay = 1 then
                                Sleep(MaxURLDelay);
                              Application.ProcessMessages;
                              MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/film_iphone/iphone360_' + MovieCode + '.jpg');
                            end;
                        end;
                    end;
                end;
              if uScreenshots = 1 then // 
                begin //,     
                  if (Pos('href="/film/' + FullMovieCode + '/stills/', page) > 0) or
                     (Pos('href="/film/' + MovieCode + '/stills/', page) > 0)
                  then
                    begin
                      Kol := 0;
                      links := TStringList.Create;
                      MovieList := TStringList.Create;
                      Form.Kol := 0;
                      Form.MovieList := TStringList.Create;
                      Form.links := TStringList.Create;
                      Form.JPGLink := TStringList.Create;
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/', '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := pos(FindBlocking, page2);
                      if (i > 0) or (page2 = '') then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/', '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free;
                              Form.Free;
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      if page2 <> '' then
                        begin
                          s := page2;
                          s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                          i := pos('<a href="/picture/', s);
                          delete(s, 1, i + 17);
                          j := pos('</table>', s);
                          s := copy(s, 1, j - 1);
                          while i > 0 do
                            begin
                              if Kol >= MaxScreenshots then
                                break;
                              s2 := '';
                              j := pos('</td>', s);
                              ii := pos('src="', s);
                              k := pos('.jpg', s);
                              if k = 0 then
                                k := pos('.JPG', s);
                              if j > 0 then
                                begin
                                  Kol := Kol + 1;
                                  Form.Kol := Form.Kol + 1;
                                  s2 := copy(s, 1, j - 1);
                                  s4 := copy(s2, ii + 5, k - (ii + 5)) + '.jpg';
                                  delete(s, 1, j - 1);
                                  j := pos('/', s2);
                                  s3 := copy(s2, 1, j - 1);
                                  links.Add(s3);
                                  Form.links.Add('0');
                                  Form.JPGLink.Add(s4);
                                  s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := ClearHTML(s2);
                                  s2 := s2 + ' )';
                                  s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                  MovieList.Add(s3);
                                  Form.MovieList.Add(s2);
                                end;
                              i := pos('<a href="/picture/', s);
                              if i > 0 then
                                delete(s, 1, i + 17);
                            end;
                        end;
                      if (uAllScreenshotsPage = 1) and (Kol < MaxScreenshots) then //    
                        begin
                          NPage := 2;
                          ii := pos('/page/' + IntToStr(NPage), page2);
                          while ii > 0 do
                            begin
                              if Kol >= MaxScreenshots then
                                break;
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' +
                                                        IntToStr(NPage) + '/', '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              i := pos(FindBlocking, page3);
                              if (i > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' + IntToStr(NPage) + '/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' +
                                                            IntToStr(NPage) + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page3 <> '' then
                                begin
                                  page3 := stringreplace(page3, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                  i := pos('<a href="/picture/', page3);
                                  delete(page3, 1, i + 17);
                                  j := pos('</table>', page3);
                                  s := copy(page3, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxScreenshots then
                                        break;
                                      s2 := '';
                                      j := pos('</td>', s);
                                      ii := pos('src="', s);
                                      k := pos('.jpg', s);
                                      if k = 0 then
                                        k := pos('.JPG', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                          delete(s, 1, j - 1);
                                          j := pos('/', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.links.Add('0');
                                          Form.JPGLink.Add(s4);
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s2 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s2);
                                        end;
                                      i := pos('<a href="/picture/', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              NPage := NPage + 1;
                              ii := pos('/page/' + IntToStr(NPage), page3);
                            end;
                          if ((Pos('/film/' + FullMovieCode + '/screenshots/', page2) > 0) or
                              (Pos('/film/' + MovieCode + '/screenshots/', page2) > 0)) and (Kol < MaxScreenshots)
                          then
                            begin //,     
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  page2 := stringreplace(page2, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                  i := pos('<a href="/picture/', page2);
                                  delete(page2, 1, i + 17);
                                  j := pos('</table>', page2);
                                  s := copy(page2, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxScreenshots then
                                        break;
                                      s2 := '';
                                      j := pos('</td>', s);
                                      ii := pos('src="', s);
                                      k := pos('.jpg', s);
                                      if k = 0 then
                                        k := pos('.JPG', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                          delete(s, 1, j - 1);
                                          j := pos('/', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.links.Add('0');
                                          Form.JPGLink.Add(s4);
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s2 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s2);
                                        end;
                                      i := pos('<a href="/picture/', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              NPage := 2;
                              ii := pos('/screenshots/page/' + IntToStr(NPage), page2); //    
                              while ii > 0 do
                                begin
                                  if Kol >= MaxScreenshots then
                                    break;
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                            IntToStr(NPage) + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' + IntToStr(NPage) + '/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                                IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                  if page3 <> '' then
                                    begin
                                      page3 := stringreplace(page3, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                      i := pos('<a href="/picture/', page3);
                                      delete(page3, 1, i + 17);
                                      j := pos('</table>', page3);
                                      s := copy(page3, 1, j - 1);
                                      while i > 0 do
                                        begin
                                          if Kol >= MaxScreenshots then
                                            break;
                                          s2 := '';
                                          j := pos('</td>', s);
                                          ii := pos('src="', s);
                                          k := pos('.jpg', s);
                                          if k = 0 then
                                            k := pos('.JPG', s);
                                          if j > 0 then
                                            begin
                                              Kol := Kol + 1;
                                              Form.Kol := Form.Kol + 1;
                                              s2 := copy(s, 1, j - 1);
                                              s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                              delete(s, 1, j - 1);
                                              j := pos('/', s2);
                                              s3 := copy(s2, 1, j - 1);
                                              links.Add(s3);
                                              Form.links.Add('0');
                                              Form.JPGLink.Add(s4);
                                              s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := ClearHTML(s2);
                                              s2 := s2 + ' )';
                                              s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                              MovieList.Add(s3);
                                              Form.MovieList.Add(s2);
                                            end;
                                          i := pos('<a href="/picture/', s);
                                          if i > 0 then
                                            delete(s, 1, i + 17);
                                        end;
                                    end;
                                  NPage := NPage + 1;
                                  ii := pos('/screenshots/page/' + IntToStr(NPage), page3);
                                end;
                            end;
                        end;
                      if Kol > 1 then // ,   
                        begin
                          links.Add('ALL');
                          if uUseAltDlgScreenshots = 1 then
                            begin
                              links.Add('SEL');
                              if Form.Kol > 525 then
                                Form.Kol := 525;
                              Form.All := Kol;
                              if NoDlg2 = 1 then
                                begin
                                  i := Kol;
                                end
                              else
                                begin
                                  Form.ShowModal;
                                  i := Form.ReturVal;
                                end;
                            end
                          else
                            begin
                              MovieList.Add('  ...');
                              i := MovieBase.SelectTheMovie(MovieList.Text)
                            end;
                        end
                      else
                        i := 0;
                      if Kol = 0 then
                        i := -1;
                      if i > -1 then
                        begin
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/', '  .....');
                            Application.ProcessMessages;
                          except
                            page3 := '';
                          end;
                          ii := pos(FindBlocking, page3);
                          if (ii > 0) or (page3 = '') then
                            begin
                              ShowMessage('    ');
                              GetBrowserWindow('https://www.kinopoisk.ru/picture/' + links[0] + '/');
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/', '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              ii := pos(FindBlocking, page3);
                              if (i > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  MovieBase.Free;
                                  Form.Free;
                                  LoadInfo.Destroy;
                                  Exit;
                                end;
                            end;
                          if page3 <> '' then
                            begin
                              ii := pos('/im/kadr/', page3);
                              if ii > 0 then
                                delete(page3, 1, ii - 1);
                              ii := pos('.jpg', page3);
                              if ii = 0 then
                                ii := pos('.JPG', page3);
                              if ii > 0 then
                                begin
                                  s := copy(page3, 1, ii - 1);
                                  s := ReverseString(s);
                                  ii := pos('-', s);
                                  if ii > 0 then
                                    delete(s, 1, ii - 1);
                                  ii := pos('/', s);
                                  if ii > 0 then
                                    begin
                                      s := copy(s, 1, ii - 1);
                                      ss := ReverseString(s);
                                    end;
                                end;
                            end;
                          if links[i] = 'SEL' then
                            begin
                              for ii := 0 to Kol - 1 do
                                begin
                                  if Form.links[ii] = '1' then
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      s := links[ii];
                                      if ResizeScreenshots = 0 then
                                        MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                      else
                                        GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                    end;
                                end;
                            end
                          else
                            begin
                              if links[i] = 'ALL' then
                                begin
                                  for ii := 0 to Kol - 1 do
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      s := links[ii];
                                      if ResizeScreenshots = 0 then
                                        MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                      else
                                        GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                    end;
                                end
                              else
                                begin
                                  Application.ProcessMessages;
                                  if NeedURLDelay = 1 then
                                    Sleep(MaxURLDelay);
                                  Application.ProcessMessages;
                                  s := links[i];
                                  if ResizeScreenshots = 0 then
                                    MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                  else
                                    GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                end;
                            end;
                        end;
                      links.Free;
                      MovieList.Free;
                      Form.links.Free;
                      Form.MovieList.Free;
                      Form.JPGLink.Free;
                    end
                  else
                    begin
                      if (Pos('href="/film/' + FullMovieCode + '/screenshots/', page) > 0) or
                         (Pos('href="/film/' + MovieCode + '/screenshots/', page) > 0)
                      then
                        begin
                          Kol := 0;
                          links := TStringList.Create;
                          MovieList := TStringList.Create;
                          Form.Kol := 0;
                          Form.MovieList := TStringList.Create;
                          Form.links := TStringList.Create;
                          Form.JPGLink := TStringList.Create;
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/');
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  MovieBase.Free;
                                  Form.Free;
                                  LoadInfo.Destroy;
                                  Exit;
                                end;
                            end;
                          if page2 <> '' then
                            begin
                              s := page2;
                              s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                              i := pos('<a href="/picture/', s);
                              delete(s, 1, i + 17);
                              j := pos('</table>', s);
                              s := copy(s, 1, j - 1);
                              while i > 0 do
                                begin
                                  if Kol >= MaxScreenshots then
                                    break;
                                  s2 := '';
                                  j := pos('</td>', s);
                                  ii := pos('src="', s);
                                  k := pos('.jpg', s);
                                  if k = 0 then
                                    k := pos('.JPG', s);
                                  if j > 0 then
                                    begin
                                      Kol := Kol + 1;
                                      Form.Kol := Form.Kol + 1;
                                      s2 := copy(s, 1, j - 1);
                                      s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                      delete(s, 1, j - 1);
                                      j := pos('/', s2);
                                      s3 := copy(s2, 1, j - 1);
                                      links.Add(s3);
                                      Form.links.Add('0');
                                      Form.JPGLink.Add(s4);
                                      s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                      s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                      s2 := ClearHTML(s2);
                                      s2 := s2 + ' )';
                                      s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                      MovieList.Add(s3);
                                      Form.MovieList.Add(s2);
                                    end;
                                  i := pos('<a href="/picture/', s);
                                  if i > 0 then delete(s, 1, i + 17);
                                end;
                            end;
                          if (uAllScreenshotsPage = 1) and (Kol < MaxScreenshots) then //    
                            begin
                              NPage := 2;
                              ii := pos('/page/' + IntToStr(NPage), page2);
                              while ii > 0 do
                                begin
                                  if Kol >= MaxScreenshots then
                                    break;
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                            '/screenshots/page/' + IntToStr(NPage) + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' + IntToStr(NPage) + '/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                                '/screenshots/page/' + IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                  if page3 <> '' then
                                    begin
                                      page3 := stringreplace(page3, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                      i := pos('<a href="/picture/', page3);
                                      delete(page3, 1, i + 17);
                                      j := pos('</table>', page3);
                                      s := copy(page3, 1, j - 1);
                                      while i > 0 do
                                        begin
                                         if Kol >= MaxScreenshots then
                                          break;
                                          s2 := '';
                                          j := pos('</td>', s);
                                          ii := pos('src="', s);
                                          k := pos('.jpg', s);
                                          if k = 0 then
                                            k := pos('.JPG', s);
                                          if j > 0 then
                                            begin
                                              Kol := Kol + 1;
                                              Form.Kol := Form.Kol + 1;
                                              s2 := copy(s, 1, j - 1);
                                              s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                              delete(s, 1, j - 1);
                                              j := pos('/', s2);
                                              s3 := copy(s2, 1, j - 1);
                                              links.Add(s3);
                                              Form.links.Add('0');
                                              Form.JPGLink.Add(s4);
                                              s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := ClearHTML(s2);
                                              s2 := s2 + ' )';
                                              s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                              MovieList.Add(s3);
                                              Form.MovieList.Add(s2);
                                            end;
                                          i := pos('<a href="/picture/', s);
                                          if i > 0 then
                                            delete(s, 1, i + 17);
                                        end;
                                    end;
                                  NPage := NPage + 1;
                                  ii := pos('/page/' + IntToStr(NPage), page3);
                                end;
                            end;
                          if Kol > 1 then // ,   
                            begin
                              links.Add('ALL');
                              if uUseAltDlgScreenshots = 1 then
                                begin
                                  links.Add('SEL');
                                  if Form.Kol > 525 then
                                    Form.Kol := 525;
                                  Form.All := Kol;
                                  if NoDlg2 = 1 then
                                    begin
                                      i := Kol;
                                    end
                                  else
                                    begin
                                      Form.ShowModal;
                                      i := Form.ReturVal;
                                    end;
                                end
                              else
                                begin
                                  MovieList.Add('  ...');
                                  i := MovieBase.SelectTheMovie(MovieList.Text)
                                end;
                            end
                          else
                            i := 0;
                          if Kol = 0 then
                            i := -1;
                          if i > -1 then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/', '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              ii := pos(FindBlocking, page3);
                              if (ii > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/picture/' + links[0] + '/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  ii := pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page3 <> '' then
                                begin
                                  ii := pos('/im/kadr/', page3);
                                  if ii > 0 then
                                    delete(page3, 1, ii - 1);
                                  ii := pos('.jpg', page3);
                                  if ii = 0 then
                                    ii := pos('.JPG', page3);
                                  if ii > 0 then
                                    begin
                                      s := copy(page3, 1, ii - 1);
                                      s := ReverseString(s);
                                      ii := pos('-', s);
                                      if ii > 0 then
                                        delete(s, 1, ii - 1);
                                      ii := pos('/', s);
                                      if ii > 0 then
                                        begin
                                          s := copy(s, 1, ii - 1);
                                          ss := ReverseString(s);
                                        end;
                                    end;
                                end;
                              if links[i] = 'SEL' then
                                begin
                                  for ii := 0 to Kol - 1 do
                                    begin
                                      if Form.links[ii] = '1' then
                                        begin
                                          Application.ProcessMessages;
                                          if NeedURLDelay = 1 then
                                            Sleep(MaxURLDelay);
                                          Application.ProcessMessages;
                                          s := links[ii];
                                          if ResizeScreenshots = 0 then
                                            MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                              s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                          else
                                            GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                              s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                        end;
                                    end;
                                end
                              else
                                begin
                                  if links[i] = 'ALL' then
                                    begin
                                      for ii := 0 to Kol - 1 do
                                        begin
                                          Application.ProcessMessages;
                                          if NeedURLDelay = 1 then
                                            Sleep(MaxURLDelay);
                                          Application.ProcessMessages;
                                          s := links[ii];
                                          if ResizeScreenshots = 0 then
                                            MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                          else
                                            GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                        end;
                                    end
                                  else
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      s := links[i];
                                      if ResizeScreenshots = 0 then
                                        MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                      else
                                        GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                    end;
                                end;
                            end;
                          links.Free;
                          MovieList.Free;
                          Form.links.Free;
                          Form.MovieList.Free;
                          Form.JPGLink.Free;
                        end;
                    end;
                end;
            end;
        end
      else
        begin
          links.Free;
          MovieList.Free;
        end;
    end;
  Form.data.Free;
  Form.Free; 
  LoadInfo.Destroy;
  MovieBase.Free;
end;

exports
  GetBaseName4, AMM_NewBasePluginStart4, Init4, GetVersion4;
begin
  SetThreadLocale(1049);
end.
