unit DllFormUnit;

interface

uses
  amm_pluginapi,
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ProgressBar1: TProgressBar;
    Button2: TButton;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    function CheckExit(Flag: Integer): Integer;
  private
      { Private declarations }
  public
      { Public declarations }
    ExitFlag, DelAndSave, SaveLogFile: Integer;
    MovieBase: TMovieBase;
    LogFileName, UserDir: string;
  end;

var
  Form1: TForm1;

type
  TRGBArray = array[Word] of TRGBTriple;
  pRGBArray = ^TRGBArray;

const
  ret = #13#10;

implementation

{$R *.dfm}

function TForm1.CheckExit(Flag: Integer): Integer;
begin
  Application.ProcessMessages;
  if ExitFlag = 1 then
    begin
      Button2.Caption := '';
      Button1.Enabled := True;
      MovieBase.Free;
    end;
  Result := ExitFlag;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  x, iii, CurrentMovie: Integer;
  OldURL: string;
begin
  MovieBase := TMovieBase.Create;
  ExitFlag := 0;
  Button2.Caption := '';
  Button1.Enabled := False;
  ProgressBar1.Position := 0;
  x := MovieBase.MovieCount;
  Application.ProcessMessages;
  if CheckBox1.Checked = False then
    MovieBase.First;
  MovieBase.EditMovie;
  RefreshOff;
  for iii := 1 to x do
    begin
      Label1.Caption := '(' + IntToStr(iii) + '/' + IntToStr(x) + ') ' + MovieBase.CurrentMovie.Title;
      if CheckExit(0) = 1 then
        Exit;
      OldURL := MovieBase.CurrentMovie.URL; 
      OldURL := stringreplace(OldURL, '/id_film/', '/film/', [rfReplaceAll, rfIgnoreCase]);
      OldURL := stringreplace(OldURL, 'kinopoisk.ru/level/1/film/', 'kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
      OldURL := stringreplace(OldURL, 'http://', 'https://', [rfReplaceAll, rfIgnoreCase]);
      MovieBase.CurrentMovie.URL := OldURL;
      MovieBase.SaveMovie;
      ProgressBar1.Position := Round(100 * iii / x);
      CurrentMovie := MovieBase.CurrentMovie.ID;
      MovieBase.Next;
      MovieBase.EditMovie;
      if CurrentMovie = MovieBase.CurrentMovie.ID then
        begin
          ProgressBar1.Position := 100;
          Break;
        end;
    end;
  ExitFlag := 1;
  ProgressBar1.Position := 100;
  Button2.Caption := '';
  Button1.Enabled := True;
  Label1.Caption := '.';
  Application.ProcessMessages;
  MovieBase.First;
  RefreshOn;
  RefreshWin;
  MovieBase.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if ExitFlag = 1 then
    Close
  else
    begin
      Button2.Caption := '';
      ExitFlag := 1;
      Application.ProcessMessages;
    end;
end;

end.

