library KinoPoisk_zas_setup;

uses
  amm_pluginapi,
  SetupFormUnit in '..\Kinopoisk_zas_up\SetupFormUnit.pas' {Form2},
  UpdateFormUnit in '..\Kinopoisk_zas_up\UpdateFormUnit.pas' {Form3},
  SysUtils, Classes, Forms, Windows, Dialogs, IniFiles, ShlObj;

{$R *.res}

const
  INTERNET_CONNECTION_MODEM = 1;
  INTERNET_CONNECTION_LAN = 2;
  INTERNET_CONNECTION_PROXY = 4;

function GetVersion4: Integer; far;
begin
  Result := 135;
end;

function GetName4: Pchar; far;
begin
  Result := ':    ';
end;

procedure Init4(Owner: Integer); far;
begin
  OwnerAPP := Owner;
end;

function InternetGetConnectedState(lpdwFlags: LPDWORD; dwReserved: DWORD): BOOL; stdcall; external 'wininet.dll' name 'InternetGetConnectedState';

function IsInternetConnected: Boolean;

var dwConnectionTypes: DWORD;
begin
  dwConnectionTypes := INTERNET_CONNECTION_MODEM or
    INTERNET_CONNECTION_LAN or
    INTERNET_CONNECTION_PROXY;
  Result := InternetGetConnectedState(@dwConnectionTypes, 0);
end;

function GetSpecialPath(CSIDL: word): string;
var s: string;
begin
  SetLength(s, MAX_PATH);
  if not SHGetSpecialFolderPath(0, PChar(s), CSIDL, true) then
    s := '';
  result := PChar(s);
end;

procedure AMM_PluginStart4; far;
var
  FormSetup: TForm2;
  List, Template: TStringList;
  i: Integer;
  AutoCheck, NewVer, Ver: Integer;
  LastDate, LoadDate, StrVal, s, page, UserDir: string;
  VerForm: TForm3;
begin
  try
    UserDir := GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\plugins\';
    if DirectoryExists(UserDir) = false then
      begin
        if DirectoryExists(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\') = false then
          CreateDir(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\');
        CreateDir(UserDir);
      end;
    if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
      if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini') = true then
        CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini'), Pchar(UserDir + 'Kinopoisk_zas.ini'), true);
  except
  end;
  if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
    begin
      List := TStringList.Create;
      List.Add('[DownloadAll]');
      List.Add('[CommentsOptions]');
      List.Add('[DescriptionOptions]');
      List.Add('[RatingOptions]');
      List.Add('[OtherOptions]');
      List.Add('[NameOptions]');
      List.Add('[KinoPoiskOptions]');
      List.Add('[ProxyOptions]');
      List.SaveToFile(UserDir + 'Kinopoisk_zas.ini');
      List.Free;
    end;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      AutoCheck := ReadInteger('OtherOptions', 'AutoCheck', 1);
    finally
      Free;
    end;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
    try
      WriteInteger('Versions', 'Kinopoisk_zas_setup', GetVersion4);
      LastDate := ReadString('LastDate', 'Kinopoisk_zas_setup', '01/08/2009');
      LoadDate := ReadString('LastDate', 'LoadDate', '01/08/2009');
      WriteString('LastDate', 'Kinopoisk_zas_setup', DateToStr(Date));
    finally
      Free;
    end;
  //  
  if LastDate <> DateToStr(Date) then
    begin
      VerForm := TForm3.Create(Application);
      VerForm.Caption := '   ';
      VerForm.CheckBox1.Caption := '    ';
      VerForm.Button2.Caption := '  c ';
      VerForm.UserDir := UserDir;
      if (LoadDate <> DateToStr(Date)) and IsInternetConnected then
        begin
          with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
            try
              // 
              VerForm.IdHTTP1.ProxyParams.ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
              VerForm.IdHTTP1.ProxyParams.ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
              VerForm.IdHTTP1.ProxyParams.ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
              VerForm.IdHTTP1.ProxyParams.ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
              if VerForm.IdHTTP1.ProxyParams.ProxyPassword <> '' then
                VerForm.IdHTTP1.ProxyParams.BasicAuthentication := True;
            finally
              Free;
            end;
          try
            page := VerForm.IdHTTP1.Get('http://films.unkas.net/files/plugins/Kinopoisk_zas_new.ini');
            Template := TStringList.Create;
            Template.Text := page;
            Template.SaveToFile(UserDir + 'Kinopoisk_zas_new.ini');
            Template.Free;
            with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
              try
                WriteString('LastDate', 'LoadDate', DateToStr(Date));
              finally
                Free;
              end;
          except
          end;
        end;
      if AutoCheck = 1 then
        begin
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas_setup', '---');
              NewVer := ReadInteger('Versions', 'Kinopoisk_zas_setup', 0);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label3.Caption := s;
            finally
              Free;
            end;
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas_setup', '100');
              Ver := ReadInteger('Versions', 'Kinopoisk_zas_setup', 100);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label2.Caption := s;
            finally
              Free;
            end;
          if NewVer > Ver then
            begin
              VerForm.Memo1.Clear;
              with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
                try
                  for i := NewVer downto Ver + 1 do
                    begin
                      StrVal := IntToStr(i);
                      s := copy(StrVal, 1, 1) + '.';
                      delete(StrVal, 1, 1);
                      s := s + StrVal;
                      StrVal := ReadString('Log', 'Kinopoisk_zas_setup_' + IntToStr(i), '');
                      if StrVal <> '' then
                        begin
                          VerForm.Memo1.Lines.Add(' ' + s);
                          StrVal := stringreplace(StrVal, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
                          VerForm.Memo1.Text := VerForm.Memo1.Text + ret + StrVal + ret + ret;
                        end;
                    end;
                finally
                  Free;
                end;
              VerForm.ShowModal;
            end;
        end;
      VerForm.Free;
    end;
  FormSetup := TForm2.Create(Application);
  List := TStringList.Create;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      ReadSections(List);
    finally
      Free;
    end;
  i := 0;
  repeat
    begin
      if (List[i] = 'CommentsOptions') or (List[i] = 'DescriptionOptions') or
         (List[i] = 'RatingOptions') or (List[i] = 'KinoPoiskOptions') or
         (List[i] = 'ProxyOptions') or (List[i] = 'NameOptions') or (List[i] = 'OtherOptions')
      then
        List.Delete(i)
      else
        i := i + 1;
    end;
  until (i = List.Count);
  FormSetup.ComboBox1.Items := List;
  FormSetup.ComboBox1.ItemIndex := 0;
  FormSetup.ComboBox2.Items := List;
  FormSetup.ComboBox2.ItemIndex := 0;
  FormSetup.ComboBox3.Items := List;
  FormSetup.ComboBox3.ItemIndex := 0;
  FormSetup.UserDir := UserDir;
  List.Free;
  FormSetup.OldSection := FormSetup.ComboBox1.Items[0];
  if GetAMMBuild < 1284 then
    begin
      FormSetup.CheckBox106.Enabled := False;
    end;
  if GetAMMBuild < 1401 then
    begin
      FormSetup.CheckBox169.Enabled := False;
    end;
  FormSetup.ShowModal;
  FormSetup.Free;
  RefreshWin;
end;

exports
  GetName4, AMM_PluginStart4, Init4, GetVersion4;   
begin
  SetThreadLocale(1049);
end.
