{ All My Movies Plugin API definition file  v3.1
Changes log:

v3.2 (12 Jun 2016) added PersonalRating field. works since 1442 build of AMM

v3.1 (17 Dec 2015) added MovieIDs read-only property to TPerson. Comma-delimited of movie IDs with this person. works since 1440 build of AMM 

v3.0 (29 Mar 2015) added Quality property to TMovie

v2.9 (04 Nov 2011) added ProcessMessages procedure for giving some time to process repaints for AMM in case of long plugin action

v2.8 (11 Apr 2011) works since v6.3 1310
  - added DeathYear property to TPerson 

v2.7 (17 Mar 2010) works since v5.9 1294
  - added TMovie.PersonalMarks property for accessing personal marks (comma delimited) for the current movie
  - added TMovieBase.GetAllPersonalMarks function for getting all available personal marks for the current database
  - since 1294 build functions GetUDFieldsCount, GetUDFieldValue, GetUDFieldName, SetUDFieldValue works correctly 

v2.6 (26 Jan 2010) works since v5.8 Build 1292
  - added SaveMovieCardImage to TMovie

v2.5 (01 Jul 2009) works since v5.5 Build 1284
  - added TrailerLink and Price properties to TMovie
  - added Rating property to TPerson (values should be 0-100)
  
v2.4 (29 Apr 2008) works since v4.8 build 1254
 - added tv series support
   * read episodes count using TMovie.EpisodesCount
   * add episode using TMovie.EpisodeAdd function
   * delete Episode N using TMovie.EpisodeDelete(N) function
   * read Episode N details using TMovie.EpisodeGetSeasonNum(N),
     TMovie.EpisodeGetEpisodeNum(N), TMovie.EpisodeGetTitle(N), TMovie.EpisodeGetURL(N),
     TMovie.EpisodeGetAirDate(N) functions
   * write Episode N details using TMovie.EpisodeSetSeasonNum(N,x),
     TMovie.EpisodeSetEpisodeNum(N,x), TMovie.EpisodeSetTitle(N,s), TMovie.EpisodeSetURL(N,s),
     TMovie.EpisodeSetAirDate(N,s) procedures
     
v2.3 (18 Mar 2007)
  - fixed some bugs with Get* functions
  - GetAMMBuild returns Integer now instead of string

v2.2 (10 Mar 2007) works since v4.1 build 1236
  - Added Scenario field support to TMovie
  - Added TPerson class to deal with person's in AMM database

v2.1 (16 Nov 2006) works since v4.0 build 1232
  - GetGenreList added to TMovieBase for filling TMovieBase.GenresList
  - Added TMovie.MovieNum and TMovie.Barcode
  - Added TMovie.DeleteScreenshot(ScreenIndex:Integer) and DeleteCover functions
  - Added TMovieBase.GetScreenFromURL - for screenshot download using HTTP protocol.
    Can be used only with NewBase type plugins
  - Added function TMovieBase.GetActualURL:String; use to detect the actual URL of page
    downloaded with GetGetURL or GetPostURL in case of redirect (if any)

v2.0 (31 Oct 2006)
  - this API will work with 4.x versions only
  - some ideology changes - to add new movie you should call AddMovie function,
    fill the fields of CurrentMovie variable and call SaveMovie function. To
    edit movie details or to get some field values you should call EditMovie first,
    edit some fields and all SaveMovie to save changes to the database
  - TMovieBase.GenresList was removed. May be it will be back in other methods soon
  - Cover and screenshots routines are changed a little
  - NOTE: export functions are changed their names and additional function added.
    Now to be succesfully loaded by All My Movies plugin should export the following
    functions: Init4, GetName4 or GetBaseName4, GetVersion4, AMM_PluginStart4 or
    AMM_NewBasePluginStart4

v1.3 (19 Dec 2005) - works with AMM v3.8 build 1204 and laters
  - added new plugin type - "NewBasePlugin". Such kind of plugins are added to
    the list of the supported online movie databases. Please refer to readme.txt
    for details.
  - added function GetGetURL(URL:String):String;  //downloads html from the URL.
    returns an empty string if operation was not succeded
  - added function GetPostURL(URL, Params:String):String; // exactly as upper
    function but able to pass parameters using POST method
  - added function GetCoverFromURL(URL:String):Boolean; //downloads the cover
    from URL. true if succeded
  - added function SelectTheMovie(MovieList:String):Integer; // pass the movie
    list delimited with CRLFs and get the user selected item index

v1.2 (7 Aug 2005) - works with AMM v3.6 build 1196 and laters:
 - added "Wishlist" property to TMovie
 - added "Seen" property to TMovie
 - added "Studio" property to TMovie
 - function TMovieBase.AddNewMovie was changed accordingly new fields added
 - added function GetAMMBuild:String;
 - added procedure TMovieBase.Compress for database purge
 - added genre list management:
      Use TMovieBase.LoadGenreList to load list to TMovieBase.GenresList (type of
      TStringList). Make any changes and then use TMovieBase.SaveGenreList to
      save changes
 - added readonly property to TMovieBase - Filename. Contains database file name
   with full path
 - since this versions Genre returns and sets additional genres too. Genre is a
   comma delimited string. Example value is "Action, Comedy, Teen" where Action is
   a main genre and the rest ones are additional
 - added ScreenIndex argument to SetScreenshot function
 - added methods ScreenshotExists(ScreenIndex:Integer):Boolean and CoverExists:Boolean
   to TMovie.

v1.1 (28 Feb 2005):
- added "country" property (forgot it in the first release ;)
- added "mpaa" property to TMovie
- added user defined fields support
- added ID read-only property to TMovie
- added function LocateMovieID(IDValue:Integer):Boolean; to TMovieBase class
- added to TMovieBase:
     function SetSQLFilter(FilterStr:String):Boolean;  __USE WITH CARE!__
       FilterStr ex: 'SELECT * FROM table1 WHERE [country]=''USA'''
     function ExecSQL(SQLStr:String):Boolean; __USE WITH CARE!__
     Use ExecSQL to execute queries that do not return a cursor to data (such as
     INSERT, UPDATE, DELETE).

v1.0 - first release
}



{
This unit is easy to use. Just include it in your uses list and
create TMovieBase object. If you have any questions just contact us
by e-mail:  support@bolidesoft.com
}

unit amm_pluginapi;

interface

uses classes;


procedure RefreshWin; //refreshes movie details area
procedure RefreshOff; //disables refreshing of the movie details area
procedure RefreshOn;  //enables refreshing of the movie details area
function GetAMMBuild:Integer; //returns build number of AMM host app.

type
 LPCSTR = PAnsiChar;

 //User defined field class
// TUDField=class(TObject)

 //one person (name) class. You do not need to create it yourself. Use TMovieBase.CurrentName instead
 TPerson=class(TObject)
    constructor Create;
    destructor Destroy;
  private
    function GetNameID:Integer;
    function GetName:String;
    function GetAltName:String;
    function GetBirthDay:String;
    function GetBirthPlace:String;
    function GetBirthYear:Integer;
    function GetDeathYear:Integer;
    function GetRating:Integer;
    function GetBirthCountry:String;
    function GetBiography:String;
    function GetFilmography:String;
    function GetComments:String;
    function GetMovieIDs:String;
    function GetURL:String;

    procedure SetName(s:String);
    procedure SetAltName(s:String);
    procedure SetBirthDay(s:String);
    procedure SetBirthPlace(s:String);
    procedure SetBirthYear(I:Integer);
    procedure SetDeathYear(I:Integer);
    procedure SetRating(I:Integer);
    procedure SetBirthCountry(s:String);
    procedure SetBiography(s:String);
    procedure SetFilmography(s:String);
    procedure SetComments(s:String);
    procedure SetURL(s:String);
  published
    property NameID:Integer read GetNameID;
    property Name:String read GetName write SetName;
    property AltName:String read GetAltName write SetAltName;
    property BirthDay:String read GetBirthDay write SetBirthDay;
    property BirthPlace:String read GetBirthPlace write SetBirthPlace;
    property BirthYear:Integer read GetBirthYear write SetBirthYear;
    property BirthCountry:String read GetBirthCountry write SetBirthCountry;
    property DeathYear:Integer read GetDeathYear write SetDeathYear;
    property Biography:String read GetBiography write SetBiography;
    property Filmography:String read GetFilmography write SetFilmography;
    property Comments:String read GetComments write SetComments;
    property MovieIDs:String read GetMovieIDs;
    property URL:String read GetURL write SetURL;
    property Rating:Integer read GetRating write SetRating default 0;
  public
    function IsPicExists:Boolean;
    function GetPic(FName:String):Boolean;
    function SetPic(FName:String):Boolean; //ONLY JPEG IMAGES WILL BE DISPLAYED CORRECTLY! Saves to the database image loaded from FName
    function DeletePic:Boolean;
 end;

 // one movie class. You do not need to create it yourself. Use TMovieBase.CurrentMovie instead
 TMovie=class(TObject)
    constructor Create;
    destructor Destroy;
  private
    FUDFieldsCount:Integer;
    function GetTitle:String;
    function GetOriginalTitle:String;
    function GetDescription:String;
    function GetGenre:String;
    function GetYear:String;
    function GetResolution:String;
    function GetSize:String;
    function GetDuration:String;
    function GetLoan:String;
    function GetDirector:String;
    function GetVideoInfo:String;
    function GetAudioInfo:String;
    function GetActors:String;
    function GetMediaType:String;
    function GetMediaCount:Integer;
    function GetMediaLocation:String;
    function GetQuality:String;
    function GetRating:Integer;
    function GetPersonalRating:Integer;
    function GetMovieNum:Integer;
    function GetComments:String;
    function GetMediaLabel:String;
    function GetSubtitles:String;
    function GetAspectRatio:String;
    function GetURL:String;
    function GetLocalPath:String;
    function GetCountry:String;
    function GetMPAA:String;
    function GetID:Integer;
    function GetWishlist:Boolean;
    function GetSeen:Boolean;
    function GetStudio:String;
    function GetBarcode:String;
    function GetScenario:String;
    function GetPersonalMarks:String;
    function GetTrailerLink:String;
    function GetPrice:Single;
    procedure SetTitle(s:String);
    procedure SetOriginalTitle(s:String);
    procedure SetDescription(s:String);
    procedure SetGenre(s:String);
    procedure SetYear(s:String);
    procedure SetResolution(s:String);
    procedure SetSize(s:String);
    procedure SetDuration(s:String);
    procedure SetLoan(s:String);
    procedure SetDirector(s:String);
    procedure SetVideoInfo(s:String);
    procedure SetAudioInfo(s:String);
    procedure SetActors(s:String);
    procedure SetMediaType(s:String);
    procedure SetMediaCount(s:Integer);
    procedure SetMediaLocation(s:String);
    procedure SetQuality(s:String);
    procedure SetRating(s:Integer);
    procedure SetPersonalRating(s:Integer);
    procedure SetMovieNum(s:Integer);
    procedure SetComments(s:String);
    procedure SetMediaLabel(s:String);
    procedure SetSubtitles(s:String);
    procedure SetAspectRatio(s:String);
    procedure SetURL(s:String);
    procedure SetLocalPath(s:String);
    procedure SetCountry(s:String);
    procedure SetMPAA(s:String);
    procedure SetWishlist(Val:Boolean);
    procedure SetSeen(Val:Boolean);
    procedure SetStudio(s:String);
    procedure SetBarcode(s:String);
    procedure SetScenario(s:String);
    procedure SetPersonalMarks(s:String);
    procedure SetTrailerLink(s:String);
    procedure SetPrice(s:Single);
    function GetScreenshotsCount:Integer;
    function GetEpisodesCount:Integer;
 published
    property Title:String read GetTitle write SetTitle;
    property OriginalTitle:String read GetOriginalTitle write SetOriginalTitle;
    property Description:String read GetDescription write SetDescription;
    property Genre:String read GetGenre write SetGenre;
    property Year:String read GetYear write SetYear;
    property Resolution:String read GetResolution write SetResolution;
    property Size:String read GetSize write SetSize;
    property Duration:String read GetDuration write SetDuration;
    property Loan:String read GetLoan write SetLoan;
    property Director:String read GetDirector write SetDirector;
    property VideoInfo:String read GetVideoInfo write SetVideoInfo;
    property AudioInfo:String read GetAudioInfo write SetAudioInfo;
    property Actors:String read GetActors write SetActors;
    property MediaType:String read GetMediaType write SetMediaType;
    property MediaCount:Integer read GetMediaCount write SetMediaCount default 1;
    property MediaLocation:String read GetMediaLocation write SetMediaLocation;
    property Quality:String read GetQuality write SetQuality;
    property Rating:Integer read GetRating write SetRating default 0;
    property PersonalRating:Integer read GetPersonalRating write SetPersonalRating default 0;
    property MovieNum:Integer read GetMovieNum write SetMovieNum default 0;
    property Comments:String read GetComments write SetComments;
    property MediaLabel:String read GetMediaLabel write SetMediaLabel;
    property Subtitles:String read GetSubtitles write SetSubtitles;
    property AspectRatio:String read GetAspectRatio write SetAspectRatio;
    property URL:String read GetURL write SetURL;
    property LocalPath:String read GetLocalPath write SetLocalPath;
    property Country: String read GetCountry write SetCountry;
    property MPAA: String read GetMPAA write SetMPAA;
    property ID: Integer read GetID;
    property Wishlist: Boolean read GetWishlist write SetWishlist;
    property Seen: Boolean read GetSeen write SetSeen;
    property Studio: String read GetStudio write SetStudio;
    property Barcode: String read GetBarcode write SetBarcode;
    property Scenario: String read GetScenario write SetScenario;  //comma delimited flag list
    property PersonalMarks: String read GetPersonalMarks write SetPersonalMarks;
    property TrailerLink: String read GetTrailerLink write SetTrailerLink;
    property Price: Single read GetPrice write SetPrice;
    property UDFieldsCount:Integer read FUDFieldsCount write FUDFieldsCount;  //can be 1..10
    property ScreenshotsCount:Integer read GetScreenshotsCount;
    property EpisodesCount:Integer read GetEpisodesCount;
 public
    function IsCoverExists:Boolean;
    function GetScreenshot(FName:String; ScreenIndex:Integer):Boolean;
    function GetCoverImage(FName:String):Boolean; //saves cover image to the Fname
    function SetCoverImage(FName:String):Boolean; //ONLY JPEG IMAGES WILL BE DISPLAYED CORRECTLY! Saves to the database image loaded from FName
    function SetScreenshot(FName:String):Integer; //ONLY JPEG IMAGES WILL BE DISPLAYED CORRECTLY!
    function SaveMovieCardImage(FName:String;w,h:Integer):Boolean; //save an image (JPG, PNG or BMP) of the current movie card with the current HTML template with the given (w)idth and (h)eight
    function DeleteScreenshot(ScreenIndex:Integer):Boolean;
    function DeleteCover:Boolean;
                //Saves to the database image loaded from FName.
    function GetUDFieldValue(Index:Integer):String;
    function GetUDFieldName(Index:Integer):String;
    function SetUDFieldValue(Index:Integer; UDValue:String):Integer;
                // episodes
    //add episode to the current movie. Returns internal EpisodeID value or -1 in case of error
    function EpisodeAdd(SeasonNum, EpisodeNum:Integer; Title, Description, URL, AirDate:String):Integer;
    //deletes episode EpIndex.
    function EpisodeDelete(EpIndex:Integer):Boolean;
    function EpisodeGetSeasonNum(EpIndex:Integer):Integer;
    function EpisodeGetEpisodeNum(EpIndex:Integer):Integer;
    function EpisodeGetTitle(EpIndex:Integer):String;
    function EpisodeGetDescription(EpIndex:Integer):String;
    function EpisodeGetURL(EpIndex:Integer):String;
    function EpisodeGetAirDate(EpIndex:Integer):String;
    procedure EpisodeSetSeasonNum(EpIndex, SeasonNum:Integer);
    procedure EpisodeSetEpisodeNum(EpIndex, EpisodeNum:Integer);
    procedure EpisodeSetTitle(EpIndex:Integer; Title:String);
    procedure EpisodeSetDescription(EpIndex:Integer; Description:String);
    procedure EpisodeSetURL(EpIndex:Integer; URL:String);
    procedure EpisodeSetAirDate(EpIndex:Integer; AirDate:String);
 end;


 //main class
 TMovieBase=class(TObject)
   CurrentMovie:TMovie;
   CurrentName:TPerson;
   GenreList:TStringList;
  private
   function GetMovieCount:Integer;
   function GetFileName:String;
  public
   procedure AddMovie; //clears internal AMM's CurrentMovie object
   function SaveMovie:Integer; //saves CurrentMovie to the database. returns MovieID of the saved movie
   procedure EditMovie; // Fills CurrentMovie with the movie details of the currently selected movie in the database
   procedure DeleteMovie; //deletes current movie from the database
   procedure First;  //  moves to the first movie in the database. It will be available using CurrentMovie property after you use EditMovie
   procedure Last; // moves to the last movie in the database
   procedure Next; //moves to the next movie
   procedure Prior; //moves to the previous movie
   procedure Compress; //compresses and purges database
   procedure ProcessMessages; // give All My Movies a time to process messages and do some paints in case of long plugin action
   function GetAllPersonalMarks:String; //get all available in the current database personal marks as a comma delimited string
   function GetGenreList:Boolean;
   function LocateMovieID(IDValue:Integer):Boolean;
   function SetSQLFilter(FilterStr:String):Boolean;
   function ExecSQL(SQLStr:String):Boolean;

   //persons
   procedure AddName; //clears internal AMM's CurrentName variable
   function SaveName:Integer; //saves CurrentName to the database. returns NameID of the saved person
   procedure EditName; // Fills CurrentName with the person details of the currently selected name in the database
   procedure DeleteName; //deletes current person from the database
   procedure FirstName;  //  moves to the first person's name in the database. It will be available using CurrentName property after you call EditName
   procedure LastName; // moves to the last person in the database
   procedure NextName; //moves to the next person
   procedure PriorName; //moves to the previous person
   function LocateNameID(IDValue:Integer):Boolean; //locate the person with the given NameID in the database. True if found
   function GetNameCount:Integer; //returns how many persons are in the database

   // the functions below are only for the NewBasePlugin type! They will not
   // work in the usual plugins
   function GetGetURL(URL:String):String;  //downloads html from the URL. returns an empty string if operation was not succeded
   function GetPostURL(URL, Params:String):String; // exactly as upper function but able to pass parameters using POST method
   function GetCoverFromURL(URL:String):Boolean; //downloads the cover from URL. true if succeded
   function GetScreenFromURL(URL:String):Boolean; //downloads the screenshot from URL. true if succeded
   function SelectTheMovie(MovieList:String):Integer; // pass the movie list delimited with CRLFs and get the user selected item index
   function GetActualURL:String; // use this function to get an actual URL after GetGetURL or GetPostURL in case of redirect
   /////////////////////////////////////////////////////////////////////////

   // the functions below are only for the NewNamePlugin type! They will not
   // work in the usual plugins
   function NameGetURL(URL:String):String;  //downloads html from the URL. returns an empty string if operation was not succeded
   function NamePostURL(URL, Params:String):String; // exactly as upper function but able to pass parameters using POST method
   function GetNamePicFromURL(URL:String):Boolean; //downloads the picture from URL and attaches it to the CurrentName. true if succeded
   function SelectTheName(NameList:String):Integer; // pass the names list delimited with CRLFs and get the user selected item index
   /////////////////////////////////////////////////////////////////////////


   constructor Create;
   destructor Destroy;
  published
   property MovieCount:Integer read GetMovieCount;
   property Filename:String read GetFileName;
 end;

  iSimpleProc = procedure;stdcall;
  iGetPChar = function(var s:Pchar):Integer;stdcall;
  iGetIndexedPChar = function(Index:Integer; var s:Pchar):Integer;stdcall;
  iSetIndexedPChar = procedure(Index:Integer; Value:Pchar);stdcall;
  iGetCover = function(FName:PChar):Integer;stdcall;
  iSaveMovieCardImage = function (fname:PChar; w,h:Integer):Boolean;stdcall;

  iSimpleFunc = function:Integer;stdcall;
  iGetSingle = function:Single;stdcall;

  iSetPChar = procedure(s:Pchar);stdcall;
  iSetInt = procedure(s:Integer);stdcall;
  iSetBool = procedure(Val:Boolean);stdcall;
  iSetSingle = procedure(s:Single);stdcall;


  iGetIndexedInt = function(IDValue:Integer):Integer;stdcall;
  iSetIndexedInt = procedure(Index, Value:Integer);stdcall;

  iGetWishlist = function:Boolean;stdcall;
  iGetSeen = function:Boolean;stdcall;

  iNGetPic = function(FName:PChar):Boolean;stdcall;
  iNDeletePic = function:Boolean;stdcall;

  iGetGetURL = function (sURL:PChar; var sContent:PChar):integer;stdcall;
  iGetPostURL = function (sURL:PChar; sParams:PChar; var sContent:PChar):integer;stdcall;
  iGetCoverFromURL = function (sURL:PChar):Boolean;stdcall;
  iGetScreenFromURL = function (sURL:PChar):Boolean;stdcall;

  iGetScreenshot = function(FName:PChar; ScreenIndex:Integer):Integer;stdcall;
  iDeleteScreenShot = function(ScreenIndex:Integer):Integer;stdcall;

  iEpisodeAdd = function(SeasonNum, EpisodeNum:Integer; Title, Description, URL, AirDate:PChar):Integer;stdcall;

 function GetProcAddress(hModule: HMODULE; lpProcName: LPCSTR): Pointer; stdcall;
{$EXTERNALSYM GetProcAddress}


var
  OwnerApp:Integer;



implementation

function GetProcAddress; external 'kernel32.dll' name 'GetProcAddress';


// TMovie        ------------------------------------

constructor TMovie.Create;
begin
 inherited;
 FUDFieldsCount := iSimpleFunc(GetProcAddress(OwnerApp, 'GetUDFieldsCount'));
end;

destructor TMovie.Destroy;
begin
 inherited;
end;

function TMovie.GetTitle:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetTitle'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TMovie.GetOriginalTitle:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetOriginalTitle'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;


function TMovie.GetDescription:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 55000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetDescription'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 55000);
  end;
end;

function TMovie.GetGenre:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetGenre'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TMovie.GetYear:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetYear'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetResolution:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetResolution'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetSize:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetSize'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetDuration:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetDuration'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetLoan:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetLoan'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetDirector:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetDirector'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetVideoInfo:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetVideoInfo'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetAudioInfo:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetAudioInfo'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetActors:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 50000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetActors'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 50000);
  end;
end;

function TMovie.GetMediaType:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetMediaType'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetMediaCount:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetMediaCount'));
end;

function TMovie.GetMediaLocation:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetMediaLocation'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetQuality:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetQuality'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetRating:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetRating'));
end;

function TMovie.GetPersonalRating:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetMyRating'));
end;

function TMovie.GetMovieNum:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetMovieNum'));
end;


function TMovie.GetID:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetID'));
end;


function TMovie.GetComments:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 5000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetComments'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 5000);
  end;
end;

function TMovie.GetMediaLabel:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetMediaLabel'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetSubtitles:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetSubtitles'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetAspectRatio:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetAspectRatio'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetURL:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetURL'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetLocalPath:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetLocalPath'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetCountry:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetCountry'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetMPAA:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetMPAA'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetWishlist:Boolean;
begin
 Result:=iGetWishlist(GetProcAddress(OwnerApp, 'GetWishlist'));
end;

function TMovie.GetSeen:Boolean;
begin
 Result:=iGetSeen(GetProcAddress(OwnerApp, 'GetSeen'));
end;

function TMovie.GetStudio:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetStudio'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetBarcode:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetBarcode'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetScenario:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetScenario'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetPersonalMarks:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetPersonalMarks'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetTrailerLink:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetTrailerLink'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetPrice:Single;
begin
 Result:=iGetSingle(GetProcAddress(OwnerApp, 'GetPrice'));
end;

function TMovie.GetScreenshotsCount:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetScreenCount'));
end;

procedure TMovie.SetTitle(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetTitle'))(Pchar(s));
end;

procedure TMovie.SetOriginalTitle(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetOriginalTitle'))(Pchar(s));
end;

procedure TMovie.SetDescription(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetDescription'))(Pchar(s));
end;

procedure TMovie.SetGenre(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetGenre'))(Pchar(s));
end;

procedure TMovie.SetYear(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetYear'))(Pchar(s));
end;

procedure TMovie.SetResolution(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetResolution'))(Pchar(s));
end;

procedure TMovie.SetSize(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetSize'))(Pchar(s));
end;

procedure TMovie.SetDuration(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetDuration'))(Pchar(s));
end;

procedure TMovie.SetLoan(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetLoan'))(Pchar(s));
end;

procedure TMovie.SetDirector(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetDirector'))(Pchar(s));
end;

procedure TMovie.SetVideoInfo(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetVideoInfo'))(Pchar(s));
end;

procedure TMovie.SetAudioInfo(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetAudioInfo'))(Pchar(s));
end;

procedure TMovie.SetActors(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetActors'))(Pchar(s));
end;

procedure TMovie.SetMediaType(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetMediaType'))(Pchar(s));
end;

procedure TMovie.SetMediaCount(s:Integer);
begin
  iSetInt(GetProcAddress(OwnerApp, 'SetMediaCount'))(s);
end;

procedure TMovie.SetMediaLocation(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetMediaLocation'))(Pchar(s));
end;

procedure TMovie.SetQuality(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetQuality'))(Pchar(s));
end;

procedure TMovie.SetRating(s:Integer);
begin
  iSetInt(GetProcAddress(OwnerApp, 'SetRating'))(s);
end;

procedure TMovie.SetPersonalRating(s:Integer);
begin
  iSetInt(GetProcAddress(OwnerApp, 'SetMyRating'))(s);
end;

procedure TMovie.SetMovieNum(s:Integer);
begin
  iSetInt(GetProcAddress(OwnerApp, 'SetMovieNum'))(s);
end;

procedure TMovie.SetComments(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetComments'))(Pchar(s));
end;

procedure TMovie.SetMediaLabel(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetMediaLabel'))(Pchar(s));
end;

procedure TMovie.SetSubtitles(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetSubtitles'))(Pchar(s));
end;

procedure TMovie.SetAspectRatio(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetAspectRatio'))(Pchar(s));
end;

procedure TMovie.SetURL(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetURL'))(Pchar(s));
end;

procedure TMovie.SetLocalPath(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetLocalPath'))(Pchar(s));
end;

procedure TMovie.SetCountry(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetCountry'))(Pchar(s));
end;

procedure TMovie.SetMPAA(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetMPAA'))(Pchar(s));
end;

procedure TMovie.SetWishlist(Val:Boolean);
begin
  iSetBool(GetProcAddress(OwnerApp, 'SetWishlist'))(Val);
end;

procedure TMovie.SetSeen(Val:Boolean);
begin
  iSetBool(GetProcAddress(OwnerApp, 'SetSeen'))(Val);
end;

procedure TMovie.SetStudio(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetStudio'))(Pchar(s));
end;

procedure TMovie.SetBarcode(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetBarcode'))(Pchar(s));
end;

procedure TMovie.SetScenario(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetScenario'))(Pchar(s));
end;

procedure TMovie.SetPersonalMarks(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetPersonalMarks'))(Pchar(s));
end;

procedure TMovie.SetTrailerLink(s:String);
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetTrailerLink'))(Pchar(s));
end;

procedure TMovie.SetPrice(s:Single);
begin
  iSetSingle(GetProcAddress(OwnerApp, 'SetPrice'))(s);
end;

function TMovie.GetScreenshot(FName:String; ScreenIndex:Integer):Boolean;
begin
 result:=iGetScreenShot(GetProcAddress(OwnerApp, 'GetScreenshot'))(Pchar(FName), ScreenIndex)=1;
end;

function TMovie.IsCoverExists:Boolean;
begin
  result:=iSimpleFunc(GetProcAddress(OwnerApp, 'IsCoverExists'))=1;
end;

function TMovie.GetCoverImage(FName:String):Boolean;
begin
 iGetCover(GetProcAddress(OwnerApp, 'GetCover'))(Pchar(FName));
end;

function TMovie.SetCoverImage(FName:String):Boolean;
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetCover'))(Pchar(FName));
end;

function TMovie.SetScreenshot(FName:String):Integer;
begin
  iSetPChar(GetProcAddress(OwnerApp, 'SetScreenshot'))(Pchar(FName));
end;

function TMovie.SaveMovieCardImage(FName:String;w,h:Integer):Boolean;
begin
 result:=iSaveMovieCardImage(GetProcAddress(OwnerApp, 'SaveMovieCardImage'))(PChar(Fname), w, h);
end;

function TMovie.DeleteScreenshot(ScreenIndex:Integer):Boolean;
begin
 result:=iDeleteScreenShot(GetProcAddress(OwnerApp, 'DeleteScreenshot')) (Screenindex)>-1;
end;

function TMovie.DeleteCover:Boolean;
begin
 result:=iSimpleFunc(GetProcAddress(OwnerApp, 'DeleteCover'))>-1;
end;

function TMovie.GetUDFieldValue(Index:Integer):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetIndexedPChar(GetProcAddress(OwnerApp, 'GetUDFieldValue'))(Index, s);
    if i>0 then SetString(result, s, i) else result:='';
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.GetUDFieldName(Index:Integer):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetIndexedPChar(GetProcAddress(OwnerApp, 'GetUDFieldName'))(Index, s);
    if i>0 then SetString(result, s, i) else result:='';
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.SetUDFieldValue(Index:Integer; UDValue:String):Integer;
begin
 iSetIndexedPChar(GetProcAddress(OwnerApp, 'SetUDFieldValue')) (Index, PChar(UDValue));
end;

     ///    episodes    ///

function TMovie.GetEpisodesCount:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetEpisodesCount'));
end;

function TMovie.EpisodeAdd(SeasonNum, EpisodeNum:Integer; Title, Description, URL, AirDate:String):Integer;
begin
 Result:=iEpisodeAdd(GetProcAddress(OwnerApp, 'EpisodeAdd')) (SeasonNum, EpisodeNum, PChar(Title), PChar(Description), PChar(URL), PChar(AirDate));
end;

function TMovie.EpisodeDelete(EpIndex:Integer):Boolean;
begin
 Result:= iGetIndexedInt(GetProcAddress(OwnerApp, 'EpisodeDelete'))(EpIndex)=0;
end;

function TMovie.EpisodeGetSeasonNum(EpIndex:Integer):Integer;
begin
 Result:= iGetIndexedInt(GetProcAddress(OwnerApp, 'EpisodeGetSeasonNum'))(EpIndex);
end;

function TMovie.EpisodeGetEpisodeNum(EpIndex:Integer):Integer;
begin
 Result:= iGetIndexedInt(GetProcAddress(OwnerApp, 'EpisodeGetEpisodeNum'))(EpIndex);
end;

function TMovie.EpisodeGetTitle(EpIndex:Integer):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeGetTitle'))(EpIndex, s);
    if i>0 then SetString(result, s, i) else result:='';
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.EpisodeGetDescription(EpIndex:Integer):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 50000);
  try
    i:=iGetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeGetDescription'))(EpIndex, s);
    if i>0 then SetString(result, s, i) else result:='';
  finally
    FreeMem(s, 50000);
  end;
end;

function TMovie.EpisodeGetURL(EpIndex:Integer):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeGetURL'))(EpIndex, s);
    if i>0 then SetString(result, s, i) else result:='';
  finally
    FreeMem(s, 500);
  end;
end;

function TMovie.EpisodeGetAirDate(EpIndex:Integer):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeGetAirDate'))(EpIndex, s);
    if i>0 then SetString(result, s, i) else result:='';
  finally
    FreeMem(s, 500);
  end;
end;

procedure TMovie.EpisodeSetSeasonNum(EpIndex, SeasonNum:Integer);
begin
 iSetIndexedInt(GetProcAddress(OwnerApp, 'EpisodeSetSeasonNum'))(EpIndex, SeasonNum);
end;

procedure TMovie.EpisodeSetEpisodeNum(EpIndex, EpisodeNum:Integer);
begin
 iSetIndexedInt(GetProcAddress(OwnerApp, 'EpisodeSetEpisodeNum'))(EpIndex, EpisodeNum);
end;

procedure TMovie.EpisodeSetTitle(EpIndex:Integer; Title:String);
begin
 iSetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeSetTitle'))(EpIndex, PChar(Title));
end;

procedure TMovie.EpisodeSetDescription(EpIndex:Integer; Description:String);
begin
 iSetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeSetDescription'))(EpIndex, PChar(Description));
end;

procedure TMovie.EpisodeSetURL(EpIndex:Integer; URL:String);
begin
 iSetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeSetURL'))(EpIndex, PChar(URL));
end;

procedure TMovie.EpisodeSetAirDate(EpIndex:Integer; AirDate:String);
begin
 iSetIndexedPChar(GetProcAddress(OwnerApp, 'EpisodeSetAirDate'))(EpIndex, PChar(AirDate));
end;


// TMovieBase     ------------------------------------

constructor TMovieBase.Create;
begin
 inherited;
 CurrentMovie:=TMovie.Create;
 CurrentName:=TPerson.Create;
 GenreList:=TStringList.Create;
end;

destructor TMovieBase.Destroy;
begin
 GenreList.Destroy;
 CurrentName.Destroy;
 CurrentMovie.Destroy;
 inherited;
end;

procedure TMovieBase.AddMovie;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'AddMovie'));
end;

function TMovieBase.SaveMovie:Integer;
begin
 result:=iSimpleFunc(GetProcAddress(OwnerApp, 'SaveMovie'));
end;

procedure TMovieBase.DeleteMovie;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'DeleteMovie'));
end;

procedure TMovieBase.EditMovie;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'EditMovie'));
end;

procedure TMovieBase.First;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'FirstMovie'));
end;

procedure TMovieBase.Last;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'LastMovie'));
end;

procedure TMovieBase.Next;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'NextMovie'));
end;

procedure TMovieBase.Prior;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'PriorMovie'));
end;

procedure TMovieBase.Compress;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'CompressBase'));
end;

procedure TMovieBase.ProcessMessages;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'ProcessMessages'));
end;


function TMovieBase.GetMovieCount:Integer;
begin
  Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetMovieCount'));
end;

function TMovieBase.LocateMovieID(IDValue:Integer):Boolean;
begin
  Result:=iGetIndexedInt(GetProcAddress(OwnerApp, 'LocateMovieID'))(IDValue)>=0;
end;

function TMovieBase.SetSQLFilter(FilterStr:String):Boolean;
begin
 Result:=iGetCover(GetProcAddress(OwnerApp, 'SetSQLFilter'))(PChar(FilterStr))>=0;
end;

function TMovieBase.ExecSQL(SQLStr:String):Boolean;
begin
 Result:=iGetCover(GetProcAddress(OwnerApp, 'ExecSQL'))(PChar(SQLStr))>=0;
end;

function TMovieBase.GetFileName:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetFileName'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500);
  end;
end;

function TMovieBase.GetGetURL(URL:String):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1500000);
  try
    i:=iGetGetURL(GetProcAddress(OwnerApp, 'GetGetURL'))(PChar(URL),s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1500000);
  end;
end;

function TMovieBase.GetPostURL(URL, Params:String):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1500000);
  try
    i:=iGetPostURL(GetProcAddress(OwnerApp, 'GetPostURL'))(PChar(URL), PChar(Params), s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1500000);
  end;
end;

function TMovieBase.GetCoverFromURL(URL:String):Boolean;
begin
 result:=iGetCoverFromURL(GetProcAddress(OwnerApp, 'GetCoverFromURL'))(PChar(URL));
end;

function TMovieBase.GetScreenFromURL(URL:String):Boolean;
begin
 result:=iGetScreenFromURL(GetProcAddress(OwnerApp, 'GetScreenFromURL'))(PChar(URL));
end;

function TMovieBase.SelectTheMovie(MovieList:String):Integer;
begin
 result:=iGetCover(GetProcAddress(OwnerApp, 'SelectTheMovie'))(PChar(MovieList));
end;

function TMovieBase.NameGetURL(URL:String):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500000);
  try
    i:=iGetGetURL(GetProcAddress(OwnerApp, 'NameGetURL'))(PChar(URL),s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500000);
  end;
end;

function TMovieBase.NamePostURL(URL, Params:String):String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 500000);
  try
    i:=iGetPostURL(GetProcAddress(OwnerApp, 'NamePostURL'))(PChar(URL), PChar(Params), s);
    SetString(result, s, i);
  finally
    FreeMem(s, 500000);
  end;
end;

function TMovieBase.GetNamePicFromURL(URL:String):Boolean;
begin
 result:=iGetCoverFromURL(GetProcAddress(OwnerApp, 'GetNamePicFromURL'))(PChar(URL));
end;

function TMovieBase.SelectTheName(NameList:String):Integer;
begin
 result:=iGetCover(GetProcAddress(OwnerApp, 'SelectTheName'))(PChar(NameList));
end;


function TMovieBase.GetGenreList:Boolean;
var
 s:PChar;
 i:Integer;
 res:String;
begin
  GetMem(s, 500);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetGenreList'))(s);
    if i>0 then SetString(res, s, i) else res:='';
  finally
    FreeMem(s, 500);
  end;
  GenreList.Commatext:=res;
  result:=length(res)>1;
end;

function TMovieBase.GetAllPersonalMarks:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetAllPersonalMarks'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TMovieBase.GetActualURL:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'GetActualURL'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

procedure TMovieBase.AddName;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'AddName'));
end;

function TMovieBase.SaveName:Integer;
begin
 result:=iSimpleFunc(GetProcAddress(OwnerApp, 'SaveName'));
end;

procedure TMovieBase.EditName;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'EditName'));
end;

procedure TMovieBase.DeleteName;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'DeleteName'));
end;

procedure TMovieBase.FirstName;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'FirstName'));
end;

procedure TMovieBase.LastName;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'LastName'));
end;

procedure TMovieBase.NextName;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'NextName'));
end;

procedure TMovieBase.PriorName;
begin
 iSimpleProc(GetProcAddress(OwnerApp, 'PriorName'));
end;

function TMovieBase.LocateNameID(IDValue:Integer):Boolean;
begin
 Result:=iGetIndexedInt(GetProcAddress(OwnerApp, 'LocateNameID'))(IDValue)>=0;
end;

function TMovieBase.GetNameCount:Integer;
begin
 Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetNameCount'));
end;

{----------}

 ////////  TPerson
constructor TPerson.Create;
begin
 //
 inherited;
end;

destructor TPerson.Destroy;
begin
 //
 inherited;
end;

function TPerson.GetNameID:Integer;
begin
 Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'NGetID'));
end;

function TPerson.GetName:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetName'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TPerson.GetAltName:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetAltName'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TPerson.GetBirthDay:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetBirthDay'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TPerson.GetBirthPlace:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetBirthPlace'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TPerson.GetBirthYear:Integer;
begin
 Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'NGetBirthYear'));
end;

function TPerson.GetDeathYear:Integer;
begin
 Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'NGetDeathYear'));
end;

function TPerson.GetRating:Integer;
begin
 Result:=iSimpleFunc(GetProcAddress(OwnerApp, 'NGetRating'));
end;

function TPerson.GetBirthCountry:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetBirthCountry'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

function TPerson.GetBiography:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 50000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetBiography'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 50000);
  end;
end;

function TPerson.GetFilmography:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 50000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetFilmography'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 50000);
  end;
end;

function TPerson.GetComments:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 100000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetComments'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 100000);
  end;
end;

function TPerson.GetMovieIDs:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 10000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetMovieIDs'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 10000);
  end;
end;

function TPerson.GetURL:String;
var
 s:PChar;
 i:Integer;
begin
  GetMem(s, 1000);
  try
    i:=iGetPChar(GetProcAddress(OwnerApp, 'NGetURL'))(s);
    SetString(result, s, i);
  finally
    FreeMem(s, 1000);
  end;
end;

procedure TPerson.SetName(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetName'))(Pchar(s));
end;

procedure TPerson.SetAltName(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetAltName'))(Pchar(s));
end;

procedure TPerson.SetBirthDay(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetBirthday'))(Pchar(s));
end;

procedure TPerson.SetBirthPlace(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetBirthPlace'))(Pchar(s));
end;

procedure TPerson.SetBirthYear(I:Integer);
begin
 iSetInt(GetProcAddress(OwnerApp, 'NSetBirthYear'))(I);
end;

procedure TPerson.SetDeathYear(I:Integer);
begin
 iSetInt(GetProcAddress(OwnerApp, 'NSetDeathYear'))(I);
end;

procedure TPerson.SetRating(I:Integer);
begin
 iSetInt(GetProcAddress(OwnerApp, 'NSetRating'))(I);
end;

procedure TPerson.SetBirthCountry(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetCountry'))(Pchar(s));
end;

procedure TPerson.SetBiography(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetBiography'))(Pchar(s));
end;

procedure TPerson.SetFilmography(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetFilmography'))(Pchar(s));
end;

procedure TPerson.SetComments(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetComments'))(Pchar(s));
end;

procedure TPerson.SetURL(s:String);
begin
 iSetPChar(GetProcAddress(OwnerApp, 'NSetURL'))(Pchar(s));
end;

function TPerson.IsPicExists:Boolean;
begin
 result:=iSimpleFunc(GetProcAddress(OwnerApp, 'NIsPicExists'))=1;
end;

function TPerson.GetPic(FName:String):Boolean;
begin
 iNGetPic(GetProcAddress(OwnerApp, 'NGetPic'))(Pchar(FName));
end;

function TPerson.SetPic(FName:String):Boolean;
begin
 iNGetPic(GetProcAddress(OwnerApp, 'NSetPic'))(Pchar(FName));
end;

function TPerson.DeletePic:Boolean;
begin
 result:=iNDeletePic(GetProcAddress(OwnerApp, 'NDeletePic'));
end;


{----------}

procedure RefreshWin;
begin
  iSimpleProc(GetProcAddress(OwnerApp, 'RefreshWin'));
end;

procedure RefreshOff;
begin
  iSimpleProc(GetProcAddress(OwnerApp, 'RefreshOff'));
end;

procedure RefreshOn;
begin
  iSimpleProc(GetProcAddress(OwnerApp, 'RefreshOn'));
end;

function GetAMMBuild:Integer;
begin
    result:=iSimpleFunc(GetProcAddress(OwnerApp, 'GetAMMBuild'));
end;



end.
