library Kinopoisk_zas_url;

uses
  amm_pluginapi,
  UpdateFormUnit in '..\Kinopoisk_zas_up\UpdateFormUnit.pas' {Form3},
  InfoLoad in '..\Kinopoisk_zas\InfoLoad.pas' {LoadInfo},
  Classes, SysUtils, Forms, Dialogs, IniFiles, Windows, StrUtils, ShlObj;

{$R *.res}

const
   ret = #13#10;
   INTERNET_CONNECTION_MODEM = 1;
   INTERNET_CONNECTION_LAN = 2;
   INTERNET_CONNECTION_PROXY = 4;

var
  LoadInfo: TLoadInfo;

function GetVersion4: Integer; far;
begin
   Result := 124;
end;

function GetBaseName4: Pchar; far;
begin
   Result := 'KinoPoisk.ru (URL only) (z_a_s)';
end;

procedure Init4(Owner: Integer); far;
begin
   OwnerAPP := Owner;
end;

function InternetGetConnectedState(lpdwFlags: LPDWORD; dwReserved: DWORD): BOOL; stdcall; external 'wininet.dll' name 'InternetGetConnectedState';

function IsInternetConnected: Boolean;
var
   dwConnectionTypes: DWORD;
begin
   dwConnectionTypes := INTERNET_CONNECTION_MODEM or
      INTERNET_CONNECTION_LAN or
      INTERNET_CONNECTION_PROXY;
   Result := InternetGetConnectedState(@dwConnectionTypes, 0);
end;

function PosExD(const SubStr, s: string; Direct: Integer = -1): Integer;
var
  i, j, LenSubStr: Integer;
  Offset: Cardinal;
begin
  Offset := Length(s);
  if Direct >= 0 then
    begin
      Result := PosEx(SubStr, s, Offset);
      Exit;
    end;
  i := Offset;
  LenSubStr := Length(SubStr);
  while i >= LenSubStr do
  begin
    if s[i] = SubStr[ LenSubStr ] then
    begin
      j := 1;
      while (j < LenSubStr) and (s[i - j] = SubStr[LenSubStr - j]) do
        Inc(j);
      if (j = LenSubStr) then
      begin
        Result := (i - LenSubStr) + 1;
        exit;
      end;
    end;
    Dec(i);
  end;
  Result := 0;
end;

function CorrectRequest(req: string): string;
var
  s: string;
  i: Integer;
begin
  s := '';
  for i := 1 to length(req) do
    s := s + '%' + IntToHex(ord(req[i]), 2);
  s := stringreplace(s, '%20', '+', [rfReplaceAll]);
  Result := s;
end;

function HTMLRemoveTags(const AStr: string): string;
var
  s: string;
begin
  s := AStr;
  while (pos('<script', s) > 0) and (pos('</script>', s) > 0) and (pos('</script>', s) > pos('<script', s)) do
    delete(s, pos('<script', s), pos('</script>', s) - pos('<script', s) + 9);
  while (pos('<', s) > 0) and (pos('>', s) > 0) and (pos('>', s) > pos('<', s)) do
    delete(s, pos('<', s), pos('>', s) - pos('<', s) + 1);
  Result := TrimRight(TrimLeft(s));
end;

function HTMLDecode(const AStr: String): String;
var
  Sp, Rp, Cp, Tp: PChar;
  S: String;
  I, Code: Integer;
begin
  SetLength(Result, Length(AStr));
  Sp := PChar(AStr);
  Rp := PChar(Result);
  Cp := Sp;
  try
    while Sp^ <> #0 do
      begin
        case Sp^ of
          '\':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                'u':
                  begin
                    Tp := Sp;
                    Inc(Tp);
                    while (Sp^ in ['u','0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f']) do
                      Inc(Sp);
                    SetString(S, Tp, Sp - Tp);
                    dec(Sp);
                    Val('x'+S, I, Code);
                    if I >= $10000 then
                      begin
                        Rp^ := Char(((I - $10000) div $400) + $d800);
                        Inc(Rp);
                        Rp^ := Char(((I - $10000) and $3ff) + $dc00);
                      end
                    else
                      Rp^ := Chr((I));
                  end;
              end;
            end;
          '&':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                ' ':
                  begin
                    Rp^ := '&';
                    Inc(Rp);
                    Rp^ := ' ';
                  end;
                'n':
                  begin
                    if AnsiStrPos(Sp, 'nbsp;') = Sp then
                      begin
                        inc(Sp, 4);
                        Rp^ := ' ';
                      end;
                    if AnsiStrPos(Sp, 'ndash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'm':
                  begin
                    if AnsiStrPos(Sp, 'mdash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'b':
                  if AnsiStrPos(Sp, 'bull;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '|';
                    end;
                'a':
                  if AnsiStrPos(Sp, 'amp;') = Sp then
                    begin
                      Inc(Sp, 3);
                      Rp^ := '&';
                    end;
                'l', 'g':
                  begin
                    if (AnsiStrPos(Sp, 'lt;') = Sp) or (AnsiStrPos(Sp, 'gt;') = Sp) then
                      begin
                        Cp := Sp;
                        Inc(Sp, 2);
                        while (Sp^ <> ';') and (Sp^ <> #0) do
                          Inc(Sp);
                        if Cp^ = 'l' then
                          Rp^ := '<'
                        else
                          Rp^ := '>';
                      end;
                    if (AnsiStrPos(Sp, 'laquo;') = Sp) then
                      begin
                        Inc(Sp, 5);
                        Rp^ := '"';
                      end;
                  end;
                'r':
                  if (AnsiStrPos(Sp, 'raquo;') = Sp) then
                    begin
                      Inc(Sp, 5);
                      Rp^ := '"';
                    end;
                'q':
                  if AnsiStrPos(Sp, 'quot;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '"';
                    end;
                '#':
                begin
                  Tp := Sp;
                  Inc(Tp);
                  while (Sp^ <> ';') and (Sp^ <> #0) do
                    Inc(Sp);
                  SetString(S, Tp, Sp - Tp);
                  Val(S, I, Code);
                  if I >= $100 then
                    begin
                      S := WideChar(I);
                      Rp^ := S[1];
                    end
                  else
                    Rp^ := Chr((I));
                end;
              end;
            end
        else
          Rp^ := Sp^;
        end;
        Inc(Rp);
        Inc(Sp);
      end;
  except
  end;
  SetLength(Result, Rp - PChar(Result));
end;

function GetSpecialPath(CSIDL: word): string;
var s: string;
begin
  SetLength(s, MAX_PATH);
  if not SHGetSpecialFolderPath(0, PChar(s), CSIDL, true) then
    s := '';
  Result := PChar(s);
end;

procedure GetBrowserWindow(const URL: string);
begin
  LoadInfo.SetBrowserWindow;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  while LoadInfo.Visible = True do
    Application.HandleMessage;
end;

function GetInfoFromUrl(const URL, LCaption: string): string;
begin
  LoadInfo.SetFormWindow;
  LoadInfo.Label1.Caption := LCaption;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  Result := Utf8Decode(LoadInfo.GetSourceCode);
  LoadInfo.ClearSourceCode;
end;

procedure AMM_NewBasePluginStart4(OrigTitle: Pchar; tlength: Integer); far;
const
  FindBlocking = '/captcha/'; //'IP-  ';
var
   Query: string;
   MovieBase: TMovieBase;
   links, Template, List: TStringList;
   MovieList: TStringList;
   s, s2, s3, s4: string;
   i, j, NotSelectTheMovie: Integer;
   page, MovieCode: string;
   AutoCheck, NewVer, Ver, ProxyPort: Integer;
   ProxyServer, ProxyUsername, ProxyPassword: string;
   LastDate, LoadDate, StrVal, UserDir: string;
   VerForm: TForm3;
begin
   try
      UserDir := GetSpecialPath(CSIDL_PERSONAL)+'\AllMyMovies\plugins\';
      if DirectoryExists(UserDir) = false then
         begin
            if DirectoryExists(GetSpecialPath(CSIDL_PERSONAL)+'\AllMyMovies\') = false then
               CreateDir(GetSpecialPath(CSIDL_PERSONAL)+'\AllMyMovies\');
            CreateDir(UserDir);
         end;
      if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
        begin
          if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini') = true then
              CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini'), Pchar(UserDir + 'Kinopoisk_zas.ini'),true);
        end;
   except
   end;
   if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
      begin
         List := TStringList.Create;
         List.Add('[DownloadAll]');
         List.Add('[CommentsOptions]');
         List.Add('[DescriptionOptions]');
         List.Add('[RatingOptions]');
         List.Add('[OtherOptions]');
         List.Add('[NameOptions]');
         List.Add('[KinoPoiskOptions]');
         List.Add('[ProxyOptions]');
         List.SaveToFile(UserDir + 'Kinopoisk_zas.ini');
         List.Free;
      end;
   with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
   try
      AutoCheck := ReadInteger('OtherOptions', 'AutoCheck', 1);
      ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
      ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
      ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
      ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
   finally
      Free;
   end;
   with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
   try
      WriteInteger('Versions', 'Kinopoisk_zas_url', GetVersion4);
      LastDate := ReadString('LastDate', 'Kinopoisk_zas_url', '01/08/2009');
      LoadDate := ReadString('LastDate', 'LoadDate', '01/08/2009');
      WriteString('LastDate', 'Kinopoisk_zas_url', DateToStr(Date));
   finally
      Free;
   end;
   if AutoCheck = 1 then //  
      begin
        if LastDate <> DateToStr(Date) then
          begin
            VerForm := TForm3.Create(Application);
            VerForm.Caption := '   ';
            VerForm.CheckBox1.Caption := '    ';
            VerForm.Button2.Caption := '  c ';
            VerForm.UserDir := UserDir;
            if (LoadDate <> DateToStr(Date)) and IsInternetConnected then
              begin
                with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                  try
                    // 
                    VerForm.IdHTTP1.ProxyParams.ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
                    VerForm.IdHTTP1.ProxyParams.ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
                    VerForm.IdHTTP1.ProxyParams.ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
                    VerForm.IdHTTP1.ProxyParams.ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
                    if VerForm.IdHTTP1.ProxyParams.ProxyPassword <> '' then
                      VerForm.IdHTTP1.ProxyParams.BasicAuthentication := True;
                  finally
                    Free;
                  end;
                  try
                    page := VerForm.IdHTTP1.Get('http://films.unkas.net/files/plugins/Kinopoisk_zas_new.ini');
                    Template := TStringList.Create;
                    Template.Text := page;
                    Template.SaveToFile(UserDir + 'Kinopoisk_zas_new.ini');
                    Template.Free;
                    with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
                      try
                        WriteString('LastDate', 'LoadDate', DateToStr(Date));
                      finally
                        Free;
                      end;
                  except
                  end;
              end;
            with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
              try
                StrVal := ReadString('Versions', 'Kinopoisk_zas_url', '---');
                NewVer := ReadInteger('Versions', 'Kinopoisk_zas_url', 0);
                s := copy(StrVal, 1, 1) + '.';
                delete(StrVal, 1, 1);
                s := s + StrVal;
                VerForm.Label3.Caption := s;
              finally
                Free;
              end;
            with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
              try
                StrVal := ReadString('Versions', 'Kinopoisk_zas_url', '100');
                Ver := ReadInteger('Versions', 'Kinopoisk_zas_url', 100);
                s := copy(StrVal, 1, 1) + '.';
                delete(StrVal, 1, 1);
                s := s + StrVal;
                VerForm.Label2.Caption := s;
              finally
                Free;
              end;
             if NewVer > Ver then
                begin
                  VerForm.Memo1.Clear;
                  with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
                    try
                      for i := NewVer downto Ver + 1 do
                        begin
                          StrVal := IntToStr(i);
                          s := copy(StrVal, 1, 1) + '.';
                          delete(StrVal, 1, 1);
                          s := s + StrVal;
                          StrVal := ReadString('Log', 'Kinopoisk_zas_url_' + IntToStr(i), '');
                          if StrVal <> '' then
                            begin
                              VerForm.Memo1.Lines.Add(' ' + s);
                              StrVal := stringreplace(StrVal, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
                              VerForm.Memo1.Text := VerForm.Memo1.Text + ret + StrVal + ret + ret;
                            end;
                        end;
                    finally
                      Free;
                    end;
                  VerForm.ShowModal;
                end;
            VerForm.Free;
          end;
      end;
  SetString(Query, OrigTitle, tlength);
  Query := stringreplace(Query, '&', '', [rfReplaceAll, rfIgnoreCase]);
  MovieBase := TMovieBase.Create;
  LoadInfo := TLoadInfo.Create(Application);
  LoadInfo.EmbeddedWB1.ProxySettings.Address := ProxyServer;
  LoadInfo.EmbeddedWB1.ProxySettings.Password := ProxyPassword;
  LoadInfo.EmbeddedWB1.ProxySettings.Port := ProxyPort;
  LoadInfo.EmbeddedWB1.ProxySettings.UserName := ProxyUsername;
  if LoadInfo.EmbeddedWB1.ProxySettings.Password <> '' then
    LoadInfo.EmbeddedWB1.ProxySettings.AutoLoadProxy := True;
  try
    Application.ProcessMessages;
    page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                         CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
    Application.ProcessMessages;
  except
    page := '';
  end;
  i := pos(FindBlocking, page);
  if (i > 0) or (page = '') then
    begin
      ShowMessage('    ');
      GetBrowserWindow('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                        CorrectRequest(Query) + '/order/relevant/perpage/10/');
      try
        Application.ProcessMessages;
        Sleep(500);
        Application.ProcessMessages;
        page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                             CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
        Application.ProcessMessages;
      except
        page := '';
      end;
      i := pos(FindBlocking, page);
      if (i > 0) or (page = '') then
        begin
          ShowMessage('    ');
          LoadInfo.Destroy;
          MovieBase.Free;
          Exit;
        end;
    end;
  if page <> '@@@!!!@@@' then
    begin
      links := TStringList.Create;
      MovieList := TStringList.Create;
      NotSelectTheMovie := 0;
      if trim(page) = '@@@!!!@@@empty' then
        begin
          //  !
          ShowMessage(' ,      ');
          VerForm.Free;
          MovieBase.Free;
          Exit;
        end
      else
        begin
          i := pos('@@@!!!@@@', page);
          if i > 0 then
            begin
              s := page;
              i := pos(' :</dt>', s);
              if i > 0 then
                delete(s, 1, i + 19);
              i := Pos('<div class="right">', s);
              if i > 0 then
                delete(s, 1, i + 18);
              while i > 0 do
                begin
                  s2 := '';
                  j := pos('class="num">', s);
                  if j > 0 then
                    begin
                      j := Pos('<p class="name">', s);
                      if j > 0 then
                        delete(s, 1, j + 15);
                      j := Pos('data-id="', s);
                      if j > 0 then
                        delete(s, 1, j + 8);
                      j := Pos('"', s);
                      if j > 0 then
                        MovieCode := trim(copy(s, 1, j - 1));
                      links.Add(MovieCode);
                      delete(s, 1, pos('>', s));
                      j := pos('</a>', s);
                      s2 := copy(s, 1, j - 1); // 
                      s2 := HTMLRemoveTags(s2);
                      s2 := trim(HTMLDecode(s2));
                      delete(s, 1, j + 3);
                      j := Pos('"year">', s);
                      if j > 0 then
                        delete(s, 1, j + 6);
                      j := pos('</span>', s);
                      s3 := copy(s, 1, j - 1); //  
                      s3 := HTMLRemoveTags(s3);
                      s3 := trim(HTMLDecode(s3));
                      delete(s, 1, j + 6);
                      j := pos('"gray">', s);
                      if j > 0 then
                        delete(s, 1, j + 6);
                      j := pos('</span>', s);
                      s4 := copy(s, 1, j - 1); //   ( )  
                      s4 := HTMLRemoveTags(s4);
                      s4 := trim(HTMLDecode(s4));
                      delete(s, 1, j + 6);
                      if s4 = '' then
                        begin
                          s4 := s2;
                          if s3 <> '' then
                            s4 := s4 + ' (' + s3 + ')';
                          s2 := '';
                        end;
                      if s2 <> '' then
                        begin
                          s4 := s2 + ' / ' + s4;
                          if s3 <> '' then
                            s4 := s4 + ' (' + s3 + ')';
                        end;
                      if GetAMMBuild >= 1303 then
                        begin
                          s4 := s4 + '^^^^https://st.kp.yandex.net/images/film/' + MovieCode + '.jpg';
                        end;
                      MovieList.Add(s4);
                    end;
                  i := Pos('<div class="right">', s);
                  if i > 0 then
                    delete(s, 1, i + 18);
                end;
            end
          else
            begin
              NotSelectTheMovie := 1;
              s := page;
              s2 := '';
              i := Pos('content="https://www.kinopoisk.ru/film/', s);
              if i > 0 then
                begin
                  delete(s, 1, i + 38);
                  s2 := copy(s, 1, Pos('/"', s) - 1);
                  i := PosExD('-', s2);
                  if i > 0 then
                    Delete(s2, 1, i);
                end;
              links.Add(s2);
              MovieList.Add('test' + s2);
            end;
        end;
      // ,   
      if NotSelectTheMovie = 0 then
        i := MovieBase.SelectTheMovie(MovieList.Text)
      else
        i := 0;
      if i > -1 then
        begin
          MovieCode := links[i];
          if MovieCode <> '' then
            MovieBase.CurrentMovie.URL := 'https://www.kinopoisk.ru/film/' + MovieCode + '/';
        end;
      links.Free;
      MovieList.Free;
    end;
  LoadInfo.Destroy;
  MovieBase.Free;
end;

exports
   GetBaseName4, AMM_NewBasePluginStart4, Init4, GetVersion4;
begin
  SetThreadLocale(1049);
end.
