library Kinopoisk_zas;

uses
  amm_pluginapi,
  //RusClipboard,
  InfoLoad in 'InfoLoad.pas' {LoadInfo},
  PicDlg in 'PicDlg.pas' {Form1},
  UpdateFormUnit in '..\Kinopoisk_zas_up\UpdateFormUnit.pas' {Form3},
  Windows, Classes, Forms, SysUtils, Dialogs, IniFiles, Graphics, Jpeg, StrUtils, ShlObj;

{$R *.res}

type
  TRGBArray = array[Word] of TRGBTriple;
  pRGBArray = ^TRGBArray;

const
  ret = #13#10;
  INTERNET_CONNECTION_MODEM = 1;
  INTERNET_CONNECTION_LAN = 2;
  INTERNET_CONNECTION_PROXY = 4;

var
  MovieBase: TMovieBase;
  Form: TForm1;
  LoadInfo: TLoadInfo;
  CoversWidth, CoversHeight, ScreenshotsWidth, ScreenshotsHeight: Integer;
  RusNameOnly, UseAltName, uRole: Integer;
  NameException: string;

function GetVersion4: Integer; far;
begin
  Result := 214;
end;

function GetBaseName4: Pchar; far;
begin
  Result := 'KinoPoisk.ru (z_a_s)';
end;

procedure Init4(Owner: Integer); far;
begin
  OwnerAPP := Owner;
end;

function InternetGetConnectedState(lpdwFlags: LPDWORD; dwReserved: DWORD): BOOL; stdcall; external 'wininet.dll' name 'InternetGetConnectedState';

function IsInternetConnected: Boolean;
var
  dwConnectionTypes: DWORD;
begin
  dwConnectionTypes := INTERNET_CONNECTION_MODEM or
    INTERNET_CONNECTION_LAN or
    INTERNET_CONNECTION_PROXY;
  Result := InternetGetConnectedState(@dwConnectionTypes, 0);
end;

function PosExD(const SubStr, s: string; Direct: Integer = -1): Integer;
var
  i, j, LenSubStr: Integer;
  Offset: Cardinal;
begin
  Offset := Length(s);
  if Direct >= 0 then
    begin
      Result := PosEx(SubStr, s, Offset);
      Exit;
    end;
  i := Offset;
  LenSubStr := Length(SubStr);
  while i >= LenSubStr do
  begin
    if s[i] = SubStr[ LenSubStr ] then
    begin
      j := 1;
      while (j < LenSubStr) and (s[i - j] = SubStr[LenSubStr - j]) do
        Inc(j);
      if (j = LenSubStr) then
      begin
        Result := (i - LenSubStr) + 1;
        exit;
      end;
    end;
    Dec(i);
  end;
  Result := 0;
end;

function DeleteLineBreaks(const Str: string): string;
const
  D = [' ', #9, #13, #10];
var
  i, ii, jj, Len: Integer;
  s: string;
begin
  s := Str;
  Len := Length(s);
  ii := 0;
  jj := 0;
  for i := 1 to Len do
    begin
      if not (s[i] in D) then
        begin
          ii := i;
          Break;
        end;
    end;
  for i := Len downto 1 do
    begin
      if not (s[i] in D) then
        begin
          jj := i;
          Break;
        end;
    end;
  Result := Trim(Copy(s, ii, jj - ii + 1));
end;

procedure SmoothResize(Src, Dst: TBitmap);
var
  x, y: Integer;
  xP, yP: Integer;
  xP2, yP2: Integer;
  SrcLine1, SrcLine2: pRGBArray;
  t3: Integer;
  z, z2, iz2: Integer;
  DstLine: pRGBArray;
  DstGap: Integer;
  w1, w2, w3, w4: Integer;
begin
  Src.PixelFormat := pf24Bit;
  Dst.PixelFormat := pf24Bit;
  if (Src.Width = Dst.Width) and (Src.Height = Dst.Height) then
    Dst.Assign(Src)
  else
    begin
      DstLine := Dst.ScanLine[0];
      DstGap := Integer(Dst.ScanLine[1]) - Integer(DstLine);
      xP2 := MulDiv(pred(Src.Width), $10000, Dst.Width);
      yP2 := MulDiv(pred(Src.Height), $10000, Dst.Height);
      yP := 0;
      for y := 0 to pred(Dst.Height) do
        begin
          xP := 0;
          SrcLine1 := Src.ScanLine[yP shr 16];
          if (yP shr 16 < pred(Src.Height)) then
            SrcLine2 := Src.ScanLine[succ(yP shr 16)]
          else
            SrcLine2 := Src.ScanLine[yP shr 16];
          z2 := succ(yP and $FFFF);
          iz2 := succ((not yp) and $FFFF);
          for x := 0 to pred(Dst.Width) do
            begin
              t3 := xP shr 16;
              z := xP and $FFFF;
              w2 := MulDiv(z, iz2, $10000);
              w1 := iz2 - w2;
              w4 := MulDiv(z, z2, $10000);
              w3 := z2 - w4;
              DstLine[x].rgbtRed := (SrcLine1[t3].rgbtRed * w1 + SrcLine1[t3 + 1].rgbtRed * w2 +
                SrcLine2[t3].rgbtRed * w3 + SrcLine2[t3 + 1].rgbtRed * w4) shr 16;
              DstLine[x].rgbtGreen := (SrcLine1[t3].rgbtGreen * w1 + SrcLine1[t3 + 1].rgbtGreen * w2 +
                SrcLine2[t3].rgbtGreen * w3 + SrcLine2[t3 + 1].rgbtGreen * w4) shr 16;
              DstLine[x].rgbtBlue := (SrcLine1[t3].rgbtBlue * w1 + SrcLine1[t3 + 1].rgbtBlue * w2 +
                SrcLine2[t3].rgbtBlue * w3 + SrcLine2[t3 + 1].rgbtBlue * w4) shr 16;
              Inc(xP, xP2);
            end;
          Inc(yP, yP2);
          DstLine := pRGBArray(Integer(DstLine) + DstGap);
        end;
    end;
end;

function GetCoverFromURL(const URL: string): Boolean;
var
  bmp, bmp2: TBItmap;
  Jpg: TJPEGImage;
  NamePic: string;
  Scale, Scale2: Double;
begin
  LoadInfo.Label1.Caption := '  ...';
  LoadInfo.Show;
  Application.ProcessMessages;
  NamePic := MovieBase.Filename + '.jpg';
  NamePic := Form.GetImgStream(URL, NamePic);
  if NamePic = '' then
    begin
      LoadInfo.Close;
      ShowMessage('   ');
      Result := False;
      Exit;
    end;
  LoadInfo.Label1.Caption := '  .....';
  Application.ProcessMessages;
  try
    jpg := TJpegImage.Create;
    bmp := Tbitmap.Create;
    bmp2 := Tbitmap.Create;
    jpg.Loadfromfile(NamePic);
    bmp.Assign(jpg);
    Scale := 1;
    Scale2 := 1;
    if jpg.Width > CoversWidth then
      Scale := jpg.Width / CoversWidth;
    if jpg.Height > CoversHeight then
      Scale2 := jpg.Height / CoversHeight;
    if Scale2 > Scale then
      Scale := Scale2;
    if Scale > 1 then
      begin
        bmp2.Width := Round(bmp.Width / Scale);
        bmp2.Height := Round(bmp.Height / Scale);
        SmoothResize(bmp, bmp2);
        jpg.Assign(bmp2);
        jpg.CompressionQuality := 85;
        jpg.Compress;
        jpg.SaveToFile(NamePic);
      end;
    bmp.Free;
    bmp2.Free;
    jpg.Free;
    MovieBase.CurrentMovie.SetCoverImage(NamePic);
    DeleteFile(NamePic);
  except
    LoadInfo.Close;
    ShowMessage('    ');
    Result := False;
    Exit;
  end;
  Result := True;
  LoadInfo.Close;
end;

function GetScreenFromURL(const URL: string; Cover: Integer): Boolean;
var
  bmp, bmp2: TBItmap;
  Jpg: TJPEGImage;
  NamePic: string;
  Scale, Scale2: Double;
begin
  LoadInfo.Label1.Caption := '  ...';
  LoadInfo.Show;
  Application.ProcessMessages;
  NamePic := MovieBase.Filename + '.jpg';
  NamePic := Form.GetImgStream(URL, NamePic);
  if NamePic = '' then
    begin
      LoadInfo.Close;
      ShowMessage('   ');
      Result := False;
      Exit;
    end;
  LoadInfo.Label1.Caption := '  ...';
  Application.ProcessMessages;
  try
    jpg := TJpegImage.Create;
    bmp := Tbitmap.Create;
    bmp2 := Tbitmap.Create;
    jpg.Loadfromfile(NamePic);
    bmp.Assign(jpg);
    Scale := 1;
    Scale2 := 1;
    if Cover = 1 then
      begin
        if jpg.Width > CoversWidth then
          Scale := jpg.Width / CoversWidth;
        if jpg.Height > CoversHeight then
          Scale2 := jpg.Height / CoversHeight;
      end
    else
      begin
        if jpg.Width > ScreenshotsWidth then
          Scale := jpg.Width / ScreenshotsWidth;
        if jpg.Height > ScreenshotsHeight then
          Scale2 := jpg.Height / ScreenshotsHeight;
      end;
    if Scale2 > Scale then
      Scale := Scale2;
    if Scale > 1 then
      begin
        bmp2.Width := Round(bmp.Width / Scale);
        bmp2.Height := Round(bmp.Height / Scale);
        SmoothResize(bmp, bmp2);
        jpg.Assign(bmp2);
        jpg.CompressionQuality := 85;
        jpg.Compress;
        jpg.SaveToFile(NamePic);
      end;
    bmp.Free;
    bmp2.Free;
    jpg.Free;
    MovieBase.CurrentMovie.SetScreenshot(NamePic);
    DeleteFile(NamePic);
  except
    LoadInfo.Close;
    ShowMessage('    ');
    Result := False;
    Exit;
  end;
  Result := True;
  LoadInfo.Close;
end;

function ReverseString(s: string): string;
var
  i: integer;
begin
  Result := '';
  if Trim(s) <> '' then
    begin
      for i := Length(s) downto 1 do
        Result := Result + s[i];
    end;
end;

function CorrectRequest(req: string): string;
var
  s: string;
  i: Integer;
begin
  s := '';
  for i := 1 to length(req) do
    s := s + '%' + IntToHex(ord(req[i]), 2);
  s := stringreplace(s, '%20', '+', [rfReplaceAll]);
  Result := s;
end;

function AnsiUpFirstLetter(const AStr: string): string;
var
  s: string;
begin
  Result := AnsiLowerCase(AStr);
  s := AnsiUpperCase(Astr);
  if length(s) > 0 then
    Result[1] := s[1]
  else
    Result := '';
end;

function HTMLRemoveTags(const AStr: string): string;
var
  s: string;
begin
  s := AStr;
  while (pos('<script', s) > 0) and (pos('</script>', s) > 0) and (pos('</script>', s) > pos('<script', s)) do
    delete(s, pos('<script', s), pos('</script>', s) - pos('<script', s) + 9);
  while (pos('<', s) > 0) and (pos('>', s) > 0) and (pos('>', s) > pos('<', s)) do
    delete(s, pos('<', s), pos('>', s) - pos('<', s) + 1);
  Result := TrimRight(TrimLeft(s));
end;

function ReplaceTagWithChar(text, html_tag: string; char_code: Char): string;
var
  i, j: integer;
begin
  j := 0;
  i := Pos(html_tag, text);
  while i > j do
    begin
      text[i] := char_code;
      text[i + 1] := ' ';
      text[i + 2] := '<';
      j := i;
      i := Pos(html_tag, text);
    end;
  Result := text;
end;

function NotLatinName(const Name, NameException: string): Boolean;
var
  Sp: PChar;
  Code: Integer;
begin
  Result := False;
  Sp := PChar(Name);
  Code := Ord(Sp^);
  if (Code >= 192) and (Code <= 255) then
    Result := True;
  if pos(Name, NameException) > 0 then
    Result := True;
end;

function HTMLDecode(const AStr: String): String;
var
  Sp, Rp, Cp, Tp: PChar;
  S: String;
  I, Code: Integer;
begin
  SetLength(Result, Length(AStr));
  Sp := PChar(AStr);
  Rp := PChar(Result);
  Cp := Sp;
  try
    while Sp^ <> #0 do
      begin
        case Sp^ of
          '\':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                'u':
                  begin
                    Tp := Sp;
                    Inc(Tp);
                    while (Sp^ in ['u','0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f']) do
                      Inc(Sp);
                    SetString(S, Tp, Sp - Tp);
                    dec(Sp);
                    Val('x'+S, I, Code);
                    if I >= $10000 then
                      begin
                        Rp^ := Char(((I - $10000) div $400) + $d800);
                        Inc(Rp);
                        Rp^ := Char(((I - $10000) and $3ff) + $dc00);
                      end
                    else
                      Rp^ := Chr((I));
                  end;
              end;
            end;
          '&':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                ' ':
                  begin
                    Rp^ := '&';
                    Inc(Rp);
                    Rp^ := ' ';
                  end;
                'n':
                  begin
                    if AnsiStrPos(Sp, 'nbsp;') = Sp then
                      begin
                        inc(Sp, 4);
                        Rp^ := ' ';
                      end;
                    if AnsiStrPos(Sp, 'ndash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'm':
                  begin
                    if AnsiStrPos(Sp, 'mdash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'b':
                  if AnsiStrPos(Sp, 'bull;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '|';
                    end;
                'a':
                  if AnsiStrPos(Sp, 'amp;') = Sp then
                    begin
                      Inc(Sp, 3);
                      Rp^ := '&';
                    end;
                'l', 'g':
                  begin
                    if (AnsiStrPos(Sp, 'lt;') = Sp) or (AnsiStrPos(Sp, 'gt;') = Sp) then
                      begin
                        Cp := Sp;
                        Inc(Sp, 2);
                        while (Sp^ <> ';') and (Sp^ <> #0) do
                          Inc(Sp);
                        if Cp^ = 'l' then
                          Rp^ := '<'
                        else
                          Rp^ := '>';
                      end;
                    if (AnsiStrPos(Sp, 'laquo;') = Sp) then
                      begin
                        Inc(Sp, 5);
                        Rp^ := '"';
                      end;
                  end;
                'r':
                  if (AnsiStrPos(Sp, 'raquo;') = Sp) then
                    begin
                      Inc(Sp, 5);
                      Rp^ := '"';
                    end;
                'q':
                  if AnsiStrPos(Sp, 'quot;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '"';
                    end;
                '#':
                begin
                  Tp := Sp;
                  Inc(Tp);
                  while (Sp^ <> ';') and (Sp^ <> #0) do
                    Inc(Sp);
                  SetString(S, Tp, Sp - Tp);
                  Val(S, I, Code);
                  if I >= $100 then
                    begin
                      S := WideChar(I);
                      Rp^ := S[1];
                    end
                  else
                    Rp^ := Chr((I));
                end;
              end;
            end
        else
          Rp^ := Sp^;
        end;
        Inc(Rp);
        Inc(Sp);
      end;
  except
  end;
  SetLength(Result, Rp - PChar(Result));
end;

function ClearHTML(s: string): string;
var
  i, c: integer;
  stt, st1: string;
begin
  s := stringreplace(s, ret, '$ret$', [rfReplaceAll]);
  s := stringreplace(s, '&nbsp;', ' ', [rfReplaceAll]);
  s := stringreplace(s, #$A, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, #9, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<hr>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</p>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</li>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</div>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '&#8211;', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '$ret$', ret, [rfReplaceAll]);
  s := trim(HTMLDecode(s));
  s := HTMLRemoveTags(s);
  c := 0;
  for i := 1 to Length(s) do
    begin
      stt := copy(s, i, 1);
      if (stt = ' ') and (c >= 1) then
        begin
          stt := '';
          c := c + 1;
        end
      else
        begin
          if (stt = ' ') and (c = 0) then
            c := c + 1
          else
            if (stt <> ' ') then
              c := 0;
        end;
      st1 := st1 + stt;
    end;
  Result := st1;
end;

function ReplaceLatinExt(s: string): string;
begin
  s := stringreplace(s, '&#224;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#225;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#226;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#227;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#228;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#229;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#230;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe0;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe1;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe2;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe3;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe4;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe5;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe6;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#257;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#259;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#261;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#462;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#479;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#481;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#483;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#507;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#509;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#513;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#515;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#551;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#592;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#11365;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&agrave;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aacute;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&acirc;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&atilde;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&auml;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aring;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aelig;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#192;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#193;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#194;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#195;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#196;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#197;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#198;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc0;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc1;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc2;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc3;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc4;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc5;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc6;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#256;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#258;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#260;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#461;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#478;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#480;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#482;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#506;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#508;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#512;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#514;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#550;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#570;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#11375;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&AElig;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aring;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Auml;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Atilde;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Acirc;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aacute;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Agrave;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#384;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#387;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#595;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#385;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#386;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#579;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#665;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#231;', 'c', [rfReplaceAll]); 
  s := stringreplace(s, '&ccedil;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#xe7;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#263;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#265;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#267;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#269;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#392;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#572;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#597;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#663;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#199;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#xc7;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#262;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#264;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#266;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#268;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#391;', 'C', [rfReplaceAll]); 
  s := stringreplace(s, '&#571;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&Ccedil;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#240;', 'd', [rfReplaceAll]);  
  s := stringreplace(s, '&#xf0;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#271;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#273;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#396;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#454;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#499;', 'd', [rfReplaceAll]);   
  s := stringreplace(s, '&#545;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&#568;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#598;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#599;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#675;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#677;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&eth;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#208;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&Eth;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&ETH;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#xd0;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#270;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&#272;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#393;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#394;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#395;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#452;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#453;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#497;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#498;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#232;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#233;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#234;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#235;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe8;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xea;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xeb;', 'e', [rfReplaceAll]); 
  s := stringreplace(s, '&#xE9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEa;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEb;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#275;', 'e', [rfReplaceAll]);  
  s := stringreplace(s, '&#277;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#279;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#281;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#283;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#477;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#517;', 'e', [rfReplaceAll]);    
  s := stringreplace(s, '&#519;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#553;', 'e', [rfReplaceAll]); 
  s := stringreplace(s, '&#583;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#600;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#603;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#604;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#605;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#606;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#666;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#11384;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&egrave;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&eacute;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&ecirc;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&euml;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#200;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#201;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#202;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#203;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc8;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc9;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xca;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xcb;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#274;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#276;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#278;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#280;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#282;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#398;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#400;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#516;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#518;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#552;', 'E', [rfReplaceAll]); 
  s := stringreplace(s, '&#582;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#11387;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Egrave;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Eacute;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Ecirc;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Euml;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#402;', 'f', [rfReplaceAll]);   
  s := stringreplace(s, '&fnof;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#x192;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#401;', 'F', [rfReplaceAll]);
  s := stringreplace(s, '&#285;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#287;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#289;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#291;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#485;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#487;', 'g', [rfReplaceAll]);  
  s := stringreplace(s, '&#501;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#608;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#609;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#284;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#286;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#288;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#290;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#403;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#484;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#486;', 'G', [rfReplaceAll]);  
  s := stringreplace(s, '&#500;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#610;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#667;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#293;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#295;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#543;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#613;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#614;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#686;', 'h', [rfReplaceAll]);   
  s := stringreplace(s, '&#687;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11368;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11382;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#292;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#294;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#542;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#668;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11367;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11381;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#236;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#237;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#238;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#239;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xec;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xed;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xee;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xef;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#299;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#301;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#303;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#305;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#307;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#297;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#410;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#464;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#521;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#523;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#616;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&igrave;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&icirc;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iuml;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#204;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#205;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#206;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#207;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcd;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xce;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcf;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#296;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#298;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#300;', 'I', [rfReplaceAll]); 
  s := stringreplace(s, '&#302;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#304;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#306;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#407;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#463;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#520;', 'I', [rfReplaceAll]);  
  s := stringreplace(s, '&#522;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#618;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Igrave;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iacute;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Icirc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iuml;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#11361;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#309;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#496;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#567;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#585;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#607;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#644;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#669;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#11388;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#308;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#584;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#311;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#312;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#409;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#489;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#670;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#11370;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#310;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#408;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#488;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#11369;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#314;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#316;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#318;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#320;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#322;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#457;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#564;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#620;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#621;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#682;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#683;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#313;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#315;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#317;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#319;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#321;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#455;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#456;', 'L', [rfReplaceAll]); 
  s := stringreplace(s, '&#573;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#619;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#671;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11360;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11362;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#623;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#624;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#625;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#412;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#11374;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#241;', 'n', [rfReplaceAll]); 
  s := stringreplace(s, '&ntilde;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#xf1;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#324;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#326;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#328;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#329;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#331;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#414;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#460;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#505;', 'n', [rfReplaceAll]);  
  s := stringreplace(s, '&#565;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#626;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#627;', 'n', [rfReplaceAll]);
  s := stringreplace(s, 'ñ', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#209;', 'N', [rfReplaceAll]); 
  s := stringreplace(s, '&Ntilde;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&&#xd1;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#323;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#325;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#327;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#330;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#413;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#458;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#459;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#504;', 'N', [rfReplaceAll]);  
  s := stringreplace(s, '&#544;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#628;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#242;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#243;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#244;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#245;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#246;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#248;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf2;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf3;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf4;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf5;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf6;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#xf8;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#333;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#335;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#337;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#339;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#x153;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#417;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#419;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#466;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#491;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#493;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#511;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#525;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#527;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#547;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#555;', 'o', [rfReplaceAll]);    
  s := stringreplace(s, '&#557;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#559;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#561;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#596;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#629;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ograve;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oacute;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ocirc;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oelig;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&otilde;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ouml;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oslash;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#210;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#211;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#212;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#213;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#214;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#216;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd2;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd3;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd4;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd5;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd6;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd8;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#332;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#334;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#336;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#338;', 'O', [rfReplaceAll]); 
  s := stringreplace(s, '&#x152;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#390;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#415;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#416;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#418;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#465;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#490;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#492;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#510;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#524;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#526;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#546;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#554;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#556;', 'O', [rfReplaceAll]);      
  s := stringreplace(s, '&#558;', 'O', [rfReplaceAll]);    
  s := stringreplace(s, '&#560;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#630;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#11386;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ograve;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oacute;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ocirc;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&OElig;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Otilde;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ouml;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oslash;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#421;', 'p', [rfReplaceAll]);
  s := stringreplace(s, '&#420;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#11363;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#569;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#587;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#672;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#586;', 'Q', [rfReplaceAll]);
  s := stringreplace(s, '&#341;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#343;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#345;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#529;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#531;', 'r', [rfReplaceAll]);  
  s := stringreplace(s, '&#589;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#633;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#634;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#635;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#636;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#637;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#638;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#639;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#11385;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#340;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#342;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#344;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#528;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#530;', 'R', [rfReplaceAll]); 
  s := stringreplace(s, '&#588;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#640;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#641;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#11364;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#223;', 's', [rfReplaceAll]); 
  s := stringreplace(s, '&szlig;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#xdf;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#347;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#349;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#351;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#353;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&scaron;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#x161;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#383;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#537;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#575;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#642;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#346;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#348;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#350;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#352;', 'S', [rfReplaceAll]); 
  s := stringreplace(s, '&Scaron;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#x160;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#536;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#11390;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#355;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#357;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#359;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#427;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#429;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#539;', 't', [rfReplaceAll]);   
  s := stringreplace(s, '&#566;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#647;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#648;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#678;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#680;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#354;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#356;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#358;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#428;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#430;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#538;', 'T', [rfReplaceAll]);   
  s := stringreplace(s, '&#574;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#11366;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#254;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&thorn;', 'th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xfe;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&#222;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&THORN;', 'Th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xde;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&#249;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#250;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#251;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#252;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xf9;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfa;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfb;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#361;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#363;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#365;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#367;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#369;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#371;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#432;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#468;', 'u', [rfReplaceAll]);  
  s := stringreplace(s, '&#470;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#472;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#474;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#476;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#533;', 'u', [rfReplaceAll]);     
  s := stringreplace(s, '&#535;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#649;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ugrave;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uacute;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ucirc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uuml;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#217;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#218;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#219;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#220;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xd9;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xda;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdb;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#360;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#362;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#364;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#366;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#368;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#370;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#431;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#467;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#469;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#471;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#473;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#475;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#532;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#534;', 'U', [rfReplaceAll]);      
  s := stringreplace(s, '&#580;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ugrave;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uacute;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ucirc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uuml;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#651;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#652;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11377;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11380;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#434;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#581;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#11389;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#373;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#653;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#11379;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#372;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#11378;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#253;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&yacute;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xfd;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#255;', 'y', [rfReplaceAll]); 
  s := stringreplace(s, '&yuml;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xff;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#375;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#422;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#436;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#563;', 'y', [rfReplaceAll]);  
  s := stringreplace(s, '&#591;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#654;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#221;', 'Y', [rfReplaceAll]); 
  s := stringreplace(s, '&Yacute;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#xdd;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#374;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#376;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&Yuml;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#x178;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#435;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#562;', 'Y', [rfReplaceAll]);  
  s := stringreplace(s, '&#590;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#655;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#378;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#380;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#382;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#438;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#549;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#576;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#656;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#657;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#11372;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#377;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#379;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#381;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#437;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#548;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11371;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11391;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&Middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&#769;', '', [rfReplaceAll]);
  Result := s;
end;

function CharReplace(s: string): string;
begin
  s := stringreplace(s, '"', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '`', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
  Result := s;
end;

function RusToTranslit(s: string): string;
const
  rus = 'Ũ';
  trans: array[1..66] of string =(
   'a','b','v','g','d','e','e','zh','z','i','y','k','l',
   'm','n','o','p','r','s','t','u','f','kh','ts','ch','sh',
   'shc','','y','','e','yu','ya',
   'A','B','V','G','D','E','E','Zh','Z','I','Y','K','L',
   'M','N','O','P','R','S','T','U','F','Kh','Ts','Ch','Sh',
   'Shc','','Y','','E','Yu','Ya');
var
res: string;
i: Integer;
begin
  res := '';
  for i := 1 to Length(s) do
  begin
    if Pos(s[i], rus) > 0 then
      res := res + trans[Pos(s[i], rus)]
    else
       res := res + s[i];
    Result := res;
  end;
end;

function MyPos(sub, s: string; i: Integer): Integer;
var
  j: Integer;
begin
  delete(s, 1, i - 1);
  j := pos(sub, s);
  if j = 0 then
    Result := 0
  else
    Result := i - 1 + j;
end;

function PosName(Name: string):Integer;
var
 j,k : Integer;
 l : string;
begin
  if MovieBase.CurrentMovie.UDFieldsCount = 0 then
     begin
       Result := 1000;
       Exit;
     end;
  k := MovieBase.CurrentMovie.UDFieldsCount - 1;
  for j := 0 to k do
    begin
      l := MovieBase.CurrentMovie.GetUDFieldName(j);
      if  l = Name then
        begin
          Result := j;
          Exit;
        end
      else
        Result := 1000;
    end;
end;

function FindNames(const Names, page: string; MaxNames: Integer): string;
var
  i, ii, iii, len, p, kol, j: Integer;
  s, s2, s3, s4, s5, ss: string;
begin
  Result := '';
  s := page;
  i := pos(Names, s);
  if i > 0 then
    begin
      delete(s, 1, i);
      repeat
        i := pos('<div class="dubInfo">', s);
        if i > 0 then
          begin
            j := MyPos('<div class="clear"></div>', s, i);
            if j > 0 then
              delete(s, i, j - i);
          end;
      until (i = 0);
      kol := 0;
      i := Pos('padding-left: 20px; border-bottom: 2px solid #f60; font-size: 16px', s);
      if i > 0 then
        s2 := copy(s, 1, i - 1)
      else
        s2 := s;
      if length(s2) > 0 then
        begin
          repeat
            i := Pos('<div class="name"><a href="/name/', s2);
            delete(s2, 1, i + 5);
            j := Pos('</a>', s2);
            if (i > 0) and (j > 0) then
              begin
                ii := Pos('>', s2);
                delete(s2, 1, ii);
                ii := Pos('</a>', s2);
                s3 := copy(s2, 1, ii - 1);
                s3 := HTMLRemoveTags(s3);
                s3 := ReplaceLatinExt(s3);
                s3 := HTMLDecode(s3);
                s3 := trim(s3);
                ss := s3;
                delete(s2, 1, ii - 1);
                ii := Pos('</span>', s2);
                s4 := copy(s2, 1, ii - 1);
                s4 := HTMLRemoveTags(s4);
                s4 := ReplaceLatinExt(s4);
                s4 := HTMLDecode(s4);
                s4 := trim(s4);
                s5 := s4;
                len := Length(s5);
                p := 0;
                for iii := len downto 1 do
                  begin
                    if s5[iii] = ')' then
                      p := iii
                    else
                      begin
                        if (s5[iii] = '(') and (p > 0) then
                          begin
                            Delete(s5, iii, p - iii + 1);
                            p := 0;
                          end;
                      end;
                  end;
                s4 := s5;
                if s4 <> '' then
                  begin
                    if UseAltName = 1 then
                      s3 := s4;
                    if UseAltName = 2 then
                      s3 := s3 + ' /' + s4 + '/';
                    if UseAltName = 3 then
                      s3 := s4 + ' /' + s3 + '/';
                  end;
                if s3 <> '' then
                  begin
                    if ((NotLatinName(ss, NameException)) and (RusNameOnly = 1)) or (RusNameOnly = 0) then
                      begin
                        if Result <> '' then
                          Result := Result + ', ';
                        Result := Result + s3;
                        kol := kol + 1;
                      end;
                  end;
                if GetAMMBuild > 1400 then
                  begin
                    if uRole = 1 then
                      begin
                        ii := Pos('<div class="role">', s2);
                        if ii > 0 then
                          begin
                            delete(s2, 1, ii - 1);
                            ii := Pos('</div>', s2);
                            s4 := copy(s2, 1, ii - 1);
                            ii := Pos(', <font color=', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', ( ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(',  ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', (aka ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', (,', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            s4 := HTMLRemoveTags(s4);
                            s4 := ReplaceLatinExt(s4);
                            s4 := HTMLDecode(s4);
                            s4 := stringreplace(s4, '... ', '', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, '...', '', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, '/', '\', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, ',', '.', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, '(', '[', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, ')', ']', [rfReplaceAll, rfIgnoreCase]);
                            s4 := trim(s4);
                            if s4 <> '' then
                              Result := Result + ' (' + s4 + ')';
                          end;
                      end;
                  end;
              end;
          until (i = 0) or (kol >= MaxNames);
        end;
    end;
  Result := CharReplace(Result);
  Result := trim(Result);
end;

function CheckLikeMovies(page: string): Boolean;
var
  i: Integer;
  s: string;
begin
  Result := False;
  i := Pos('<!--  -->', page);
  if (i > 0) and (Pos('>    ', page) > 0) then
    begin
      Delete(page, 1, i);
      i := Pos('$.recoms({', page);
        if i > 0 then
          begin
            Delete(page, 1, i);
            i := Pos('</script>', page);
            page := Copy(page, 1, i - 1);
            if Pos('{"films":[],"total_recs":0', page) = 0 then
              Result := True;
          end;
    end
  else
    begin
      i := Pos('>    <span', page);
      if i > 0 then
        begin
          Delete(page, 1, i + 36);
          i := Pos('">', page);
          Delete(page, 1, i + 1);
          i := Pos('</span>', page);
          s := Copy(page, 1, i - 1);
          if s <> '' then
            begin
              try
                i := StrToInt(s);
              except
                i := 0;
              end;
              if i > 0 then
                Result := True;
            end;
        end;
    end;
end;

function GetSpecialPath(CSIDL: word): string;
var s: string;
begin
  SetLength(s, MAX_PATH);
  if not SHGetSpecialFolderPath(0, PChar(s), CSIDL, true) then
    s := '';
  Result := PChar(s);
end;

procedure SaveResultHtmlText(const s: string; const Name: string = 'htmlsource');
var
  ResFile: TextFile;
  FilePath: string;
begin
  try
    FilePath := GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\plugins\Logs\';
    if DirectoryExists(FilePath) = False then
      CreateDir(FilePath);
    Application.ProcessMessages;
    AssignFile(ResFile, FilePath + Name + '.txt');
    Rewrite(ResFile);
    WriteLn (ResFile, s);
    CloseFile(ResFile);
  except
    ShowMessage('     ');
  end;
end;     

{
function GetPythonData(const URL: string): Boolean;
var
  ProcInfo: TProcessInformation;
  StartInfo: TStartupInfo;
  CmdLine: string;
begin
  CmdLine := GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\plugins\helper.exe ' + URL;
  try
    FillChar(StartInfo, SizeOf(StartInfo), 0);
    with StartInfo do
      begin
        cb := SizeOf(TStartupInfo);
        wShowWindow := SW_HIDE;
      end;
    CreateProcess(nil, PChar(CmdLine), nil, nil, True, CREATE_NO_WINDOW, nil, nil, StartInfo, ProcInfo);
    while WaitForSingleObject(ProcInfo.hProcess, 10) > 0 do
      Application.ProcessMessages;
    CloseHandle(ProcInfo.hProcess);
    CloseHandle(ProcInfo.hThread);
    Result := True;
  except
    Result := False;
  end;
end;
}

procedure GetBrowserWindow(const URL: string);
begin
  LoadInfo.SetBrowserWindow;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  while LoadInfo.Visible = True do
    Application.HandleMessage;
end;

function GetInfoFromUrl(const URL, LCaption: string): string;
//var
  //ClipBoard: TRusClipboard;
begin
  //ClipBoard := TRusClipboard.Create;
  //Result := '';
  //if GetPythonData(URL) then
    //begin
      //if ClipBoard.HasFormat(CF_TEXT) then
        //Result := ClipBoard.AsText;
    //end;
  //ClipBoard.Free;
  LoadInfo.SetFormWindow;
  LoadInfo.Label1.Caption := LCaption;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  Result := Utf8Decode(LoadInfo.GetSourceCode);
  LoadInfo.ClearSourceCode;
end;

procedure AMM_NewBasePluginStart4(OrigTitle: Pchar; tlength: Integer); far;
const
  FindBlocking = '/captcha/'; //'IP-  ';
var
  Query, page, page2, page3: string;
  links: TStringList;
  MovieList: TStringList;
  s, s2, s3, s4, s5, ss, UserDir: string;
  tags, tags2, tags3, tags4, tags5, tags6, tags7, tags8: string;
  i, ii, iii, j, jj, NotSelectTheMovie, kol, NPage, season, episode, k, k2, DelTV, SaveSourceCode: Integer;
  EpisodeTitle, AirDate, EpisodeDescription, CurrentMovieURL, MovieCode, FullMovieCode, TitlePost, TitleSer: string;
  OldGenre, OldCountry, OldDirector, OldScenario, OldActors, OldStudio, OldTitle, Title: string;
  OriginalTitle, Comment, Descript, Description, Director, Scenario, Actors, Recenzia: string;
  Other, cAllOther, dAllOther, Awards, Link, Studio, LinksList: string;
  RatingIMDb, RatingKinoPoisk, RatingKritikov, NoDlg1, NoDlg2, MaxNoDlgLoad, NeedURLDelay, MaxURLDelay, Serial: Integer;
  uUseAltDlgScreenshots, uTitle, uOriginalTitle, uAltOriginalTitle, uYear, uCountry, uSlogan, uGenre, uBudget, uSbor: Integer;
  uUseAltDlgCovers, uPremData, uMPAA, uDescription, uRating, uRatingKinoPoisk, uRatingIMDb, uAwards, uLinks, LinksInTable, uZnaite, uErrors: Integer;
  uRecenzia, uAllRecenziaPage, uEpisodes, uEpisodesIfEmpty, uDuration, uDurationOtherFormat, uCovers, uScreenshots, uAllCoversPage: Integer;
  uAllScreenshotsPage, uDVD, uBluRay, uRatingKritikov, SmallPic, uMarketing, uTrailer, uBook3500, uLikeMovies: Integer;
  DelHTML, AddComments, AddComments2, DescriptionAddBR, CommentsAddBR: Integer;
  MaxPainter, MaxCutter, MaxTranslator, MaxDirector, MaxScenario, MaxActors, MaxProducer, MaxOperator, MaxComposer, MaxVoiceDirector, SmallPicOnly: Integer;
  MaxVoice, MaxStudio, DelAndSave, UseTemplates, VisualEffectsStudio, AddDescription, AddDescription2, IfFillURL: Integer;
  MaxVisualEffectsStudio, MaxVoiceStudio, VoiceStudio, MaxProkatStudio, ProkatStudio, ZnaiteIns, ErrorIns, FillOrigName: Integer;
  //[CommentsOptions]
  cBold, cSlogan, cBudget, cSbor, cPremData, cRatingKinoPoisk, cRatingIMDb, cOtherName, cMarketing, AddLoadInfoDate, AddUPLoadInfoDate: Integer;
  cAwards, cLinks, cZnaite, cErrors, cRecenzia, cInsertTegHR, cStudio, cDVD, cBluRay, cRatingKritikov, cBook3500, cLikeMovies: Integer;
  //[DescriptionOptions]
  dBold, dSlogan, dBudget, dSbor, dPremData, dRatingKinoPoisk, dRatingIMDb, dOtherName, dMarketing: Integer;
  dAwards, dLinks, dZnaite, dErrors, dRecenzia, dInsertTegHR, dStudio, dDVD, dBluRay, dRatingKritikov, dBook3500, dLikeMovies: Integer;
  ProxyPort, UseRatingKinoPoisk, UseRatingIMDb, UseRatingKritikov: Integer;
  ProxyServer, ProxyUsername, ProxyPassword: string;
  //[KinoPoiskOptions]
  data, Template, List: TStringList;
  tDescription, tSlogan, tBudget, tSborUS, tSborWord, tSborRF, tSborDVD, tPremDataWord, tPremDataRF, tRatingKinoPoisk, tRatingIMDb: string;
  tProducer, tOperator, tComposer, tVoiceDirector, tVoice, tAwards, tLinks, tZnaite, tErrors, tRecenzia, tMarketing, tBook3500, tLikeMovies: string;
  tVisualEffectsStudio, tVoiceStudio, tProkatStudio, tDVD, tBluRay, tRatingKritikov, tPainter, tCutter, tTranslator: string;
  AutoCheck, NewVer, Ver: Integer;
  LastDate, LoadDate, StrVal, DownloadSection, DownloadSection2: string;
  VerForm: TForm3;
  ResizeCovers, ResizeScreenshots, MaxCovers, MaxScreenshots, MaxRecenzia: Integer;
  LoadStream: TMemoryStream;
  DodPol,DodPolPoz: Integer;
  DodPolName, DodPolName1: string;
  F: TextFile;
begin
  UserDir := '';
  try
    UserDir := GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\plugins\';
    if DirectoryExists(UserDir) = false then
      begin
        if DirectoryExists(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\') = false then
          CreateDir(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\');
        CreateDir(UserDir);
      end;
    if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
      begin
        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini') = true then
          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini'), Pchar(UserDir + 'Kinopoisk_zas.ini'), true);
      end;
  except
  end;
  if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
    begin
      List := TStringList.Create;
      List.Add('[DownloadAll]');
      List.Add('[CommentsOptions]');
      List.Add('[DescriptionOptions]');
      List.Add('[RatingOptions]');
      List.Add('[OtherOptions]');
      List.Add('[NameOptions]');
      List.Add('[KinoPoiskOptions]');
      List.Add('[ProxyOptions]');
      List.SaveToFile(UserDir + 'Kinopoisk_zas.ini');
      List.Free;
    end;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
    try
      WriteInteger('Versions', 'Kinopoisk_zas', GetVersion4);
      LastDate := ReadString('LastDate', 'Kinopoisk_zas', '01/08/2009');
      LoadDate := ReadString('LastDate', 'LoadDate', '01/08/2009');
      WriteString('LastDate', 'Kinopoisk_zas', DateToStr(Date));
    finally
      Free;
    end;
  List := TStringList.Create;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      ReadSections(List);
      DownloadSection := ReadString('OtherOptions', 'Profil', 'DownloadAll');
      DownloadSection2 := ReadString('OtherOptions', 'Profil2', DownloadSection);
      uTitle := ReadInteger(DownloadSection, 'Title', 1);
      uOriginalTitle := ReadInteger(DownloadSection, 'OriginalTitle', 1);
      uAltOriginalTitle := ReadInteger(DownloadSection, 'AltOriginalTitle', 0);
      uYear := ReadInteger(DownloadSection, 'Year', 1);
      uCountry := ReadInteger(DownloadSection, 'Country', 1);
      uSlogan := ReadInteger(DownloadSection, 'Slogan', 1);
      uGenre := ReadInteger(DownloadSection, 'Genre', 1);
      uBudget := ReadInteger(DownloadSection, 'Budget', 1);
      uMarketing := ReadInteger(DownloadSection, 'Marketing', 0);
      uSbor := ReadInteger(DownloadSection, 'Sbor', 1);
      uPremData := ReadInteger(DownloadSection, 'PremData', 1);
      uTrailer := ReadInteger(DownloadSection, 'Trailer', 0);
      uRole := ReadInteger(DownloadSection, 'Role', 0);
      uMPAA := ReadInteger(DownloadSection, 'MPAA', 1);
      uDuration := ReadInteger(DownloadSection, 'Duration', 0);
      uDurationOtherFormat := ReadInteger(DownloadSection, 'DurationOtherFormat', 0);
      uDescription := ReadInteger(DownloadSection, 'Description', 1);
      uRating := ReadInteger(DownloadSection, 'Rating', 1);
      uRatingKinoPoisk := ReadInteger(DownloadSection, 'RatingKinoPoisk', 1);
      uRatingIMDb := ReadInteger(DownloadSection, 'RatingIMDb', 0);
      uRatingKritikov := ReadInteger(DownloadSection, 'RatingKritikov', 0);
      uAwards := ReadInteger(DownloadSection, 'Awards', 1);
      uLinks := ReadInteger(DownloadSection, 'Links', 1);
      LinksInTable := ReadInteger(DownloadSection, 'LinksInTable', 1);
      uZnaite := ReadInteger(DownloadSection, 'Znaite', 1);
      ZnaiteIns := ReadInteger(DownloadSection, 'ZnaiteIns', 1);
      uErrors := ReadInteger(DownloadSection, 'Errors', 0);
      ErrorIns := ReadInteger(DownloadSection, 'ErrorIns', 0);
      uRecenzia := ReadInteger(DownloadSection, 'Recenzia', 0);
      uAllRecenziaPage := ReadInteger(DownloadSection, 'AllRecenziaPage', 0);
      uEpisodes := ReadInteger(DownloadSection, 'Episodes', 1);
      uEpisodesIfEmpty := ReadInteger(DownloadSection, 'EpisodesIfEmpty', 1);
      uCovers := ReadInteger(DownloadSection, 'Covers', 1);
      uAllCoversPage := ReadInteger(DownloadSection, 'AllCoversPage', 0);
      uScreenshots := ReadInteger(DownloadSection, 'Screenshots', 1);
      uAllScreenshotsPage := ReadInteger(DownloadSection, 'AllScreenshotsPage', 0);
      uDVD := ReadInteger(DownloadSection, 'DVD', 0);
      uBluRay := ReadInteger(DownloadSection, 'BluRay', 0);
      uBook3500 := ReadInteger(DownloadSection, 'Book3500', 0);
      uLikeMovies := ReadInteger(DownloadSection, 'LikeMovies', 0);
      MaxCovers := ReadInteger(DownloadSection, 'MaxCovers', 500);
      MaxScreenshots := ReadInteger(DownloadSection, 'MaxScreenshots', 500);
      MaxRecenzia := ReadInteger(DownloadSection, 'MaxRecenzia', 500);
      MaxDirector := ReadInteger(DownloadSection, 'MaxDirector', 10);
      MaxScenario := ReadInteger(DownloadSection, 'MaxScenario', 10);
      MaxActors := ReadInteger(DownloadSection, 'MaxActors', 50);
      MaxProducer := ReadInteger(DownloadSection, 'MaxProducer', 10);
      MaxOperator := ReadInteger(DownloadSection, 'MaxOperator', 10);
      MaxComposer := ReadInteger(DownloadSection, 'MaxComposer', 10);
      MaxVoiceDirector := ReadInteger(DownloadSection, 'MaxVoiceDirector', 10);
      MaxVoice := ReadInteger(DownloadSection, 'MaxVoice', 10);
      MaxPainter := ReadInteger(DownloadSection, 'MaxPainter', 0);
      MaxCutter := ReadInteger(DownloadSection, 'MaxCutter', 0);
      MaxTranslator := ReadInteger(DownloadSection, 'MaxTranslator', 0);
      RusNameOnly := ReadInteger(DownloadSection, 'RusNameOnly', 0);
      NameException := ReadString(DownloadSection, 'NameException', '');
      MaxStudio := ReadInteger(DownloadSection, 'MaxStudio', 5);
      MaxVisualEffectsStudio := ReadInteger(DownloadSection, 'MaxVisualEffectsStudio', 0);
      VisualEffectsStudio := ReadInteger(DownloadSection, 'VisualEffectsStudio', 0);
      MaxVoiceStudio := ReadInteger(DownloadSection, 'MaxVoiceStudio', 0);
      VoiceStudio := ReadInteger(DownloadSection, 'VoiceStudio', 0);
      MaxProkatStudio := ReadInteger(DownloadSection, 'MaxProkatStudio', 0);
      ProkatStudio := ReadInteger(DownloadSection, 'ProkatStudio', 0);
      uUseAltDlgScreenshots := ReadInteger('OtherOptions', 'UseAltDlg', 1);
      uUseAltDlgCovers := ReadInteger('OtherOptions', 'UseAltDlg', 1);
      SmallPic := ReadInteger('OtherOptions', 'SmallPic', 0);
      SmallPicOnly := ReadInteger('OtherOptions', 'SmallPicOnly', 0);
      DelAndSave := 0; // -  
      UseAltName := ReadInteger('OtherOptions', 'UseAltName', 0);
      UseTemplates := ReadInteger('OtherOptions', 'UseTemplates', 0);
      AddDescription := ReadInteger('OtherOptions', 'AddDescription', 0);
      AddDescription2 := ReadInteger('OtherOptions', 'AddDescription2', 0);
      DelTV := ReadInteger('OtherOptions', 'DelTV', 0);
      SaveSourceCode := ReadInteger('OtherOptions', 'SaveSourceCode', 0);
      FillOrigName := ReadInteger('OtherOptions', 'FillOrigName', 1);
      IfFillURL := ReadInteger('OtherOptions', 'IfFillURL', 1);
      DelHTML := ReadInteger('OtherOptions', 'DelHTML', 0);
      if DelHTML = 1 then
        LinksInTable := 0;
      NoDlg1 := ReadInteger('OtherOptions', 'NoDlg1', 0);
      NoDlg2 := ReadInteger('OtherOptions', 'NoDlg2', 0);
      MaxNoDlgLoad := ReadInteger('OtherOptions', 'MaxNoDlgLoad', 5);
      NeedURLDelay := ReadInteger('OtherOptions', 'NeedURLDelay', 0);
      MaxURLDelay := ReadInteger('OtherOptions', 'MaxURLDelay', 0);
      if NeedURLDelay = 1 then
        begin
          if MaxURLDelay = 0 then
            MaxURLDelay := 500
          else
            if MaxURLDelay > 0 then
              MaxURLDelay := MaxURLDelay * 1000;
        end;
      if NoDlg1 = 1 then
        MaxCovers := 1;
      if NoDlg2 = 1 then
        MaxScreenshots := MaxNoDlgLoad;
      DescriptionAddBR := ReadInteger('OtherOptions', 'DescriptionAddBR', 0);
      CommentsAddBR := ReadInteger('OtherOptions', 'CommentsAddBR', 0);
      AddComments := ReadInteger('OtherOptions', 'AddComments', 0);
      AddComments2 := ReadInteger('OtherOptions', 'AddComments2', 0);
      LinksList := ReadString('OtherOptions', 'LinksList', '::: : : : : :-: :');
      cBold := ReadInteger('OtherOptions', 'Bold', 1);
      dBold := ReadInteger('OtherOptions', 'Bold', 1);
      cInsertTegHR := ReadInteger('OtherOptions', 'InsertTegHR', 1);
      dInsertTegHR := ReadInteger('OtherOptions', 'InsertTegHR', 1);
      cSlogan := ReadInteger('CommentsOptions', 'Slogan', 1);
      cBudget := ReadInteger('CommentsOptions', 'Budget', 1);
      cMarketing := ReadInteger('CommentsOptions', 'Marketing', 1);
      cSbor := ReadInteger('CommentsOptions', 'Sbor', 1);
      cPremData := ReadInteger('CommentsOptions', 'PremData', 1);
      cRatingKinoPoisk := ReadInteger('CommentsOptions', 'RatingKinoPoisk', 1);
      cRatingIMDb := ReadInteger('CommentsOptions', 'RatingIMDb', 1);
      cRatingKritikov := ReadInteger('CommentsOptions', 'RatingKritikov', 1);
      cOtherName := ReadInteger('CommentsOptions', 'OtherName', 1);
      cAwards := ReadInteger('CommentsOptions', 'Awards', 0);
      cLinks := ReadInteger('CommentsOptions', 'Links', 0);
      cZnaite := ReadInteger('CommentsOptions', 'Znaite', 0);
      cErrors := ReadInteger('CommentsOptions', 'Errors', 0);
      cRecenzia := ReadInteger('CommentsOptions', 'Recenzia', 1);
      cStudio := ReadInteger('CommentsOptions', 'Studio', 1);
      cDVD := ReadInteger('CommentsOptions', 'DVD', 1);
      cBluRay := ReadInteger('CommentsOptions', 'BluRay', 1);
      cBook3500 := ReadInteger('CommentsOptions', 'Book3500', 0);
      cLikeMovies := ReadInteger('CommentsOptions', 'LikeMovies', 0);
      AddLoadInfoDate := ReadInteger('CommentsOptions', 'AddLoadInfoDate', 0);
      dSlogan := ReadInteger('DescriptionOptions', 'Slogan', 0);
      dBudget := ReadInteger('DescriptionOptions', 'Budget', 0);
      dMarketing := ReadInteger('DescriptionOptions', 'Marketing', 0);
      dSbor := ReadInteger('DescriptionOptions', 'Sbor', 0);
      dPremData := ReadInteger('DescriptionOptions', 'PremData', 0);
      dRatingKinoPoisk := ReadInteger('DescriptionOptions', 'RatingKinoPoisk', 0);
      dRatingIMDb := ReadInteger('DescriptionOptions', 'RatingIMDb', 0);
      dRatingKritikov := ReadInteger('DescriptionOptions', 'RatingKritikov', 0);
      dOtherName := ReadInteger('DescriptionOptions', 'OtherName', 0);
      dAwards := ReadInteger('DescriptionOptions', 'Awards', 1);
      dLinks := ReadInteger('DescriptionOptions', 'Links', 1);
      dZnaite := ReadInteger('DescriptionOptions', 'Znaite', 1);
      dErrors := ReadInteger('DescriptionOptions', 'Errors', 0);
      dRecenzia := ReadInteger('DescriptionOptions', 'Recenzia', 0);
      dStudio := ReadInteger('DescriptionOptions', 'Studio', 0);
      dDVD := ReadInteger('DescriptionOptions', 'DVD', 0);
      dBluRay := ReadInteger('DescriptionOptions', 'BluRay', 0);
      dBook3500 := ReadInteger('DescriptionOptions', 'Book3500', 0);
      dLikeMovies := ReadInteger('DescriptionOptions', 'LikeMovies', 0);
      UseRatingKinoPoisk := ReadInteger('RatingOptions', 'UseRatingKinoPoisk', 1);
      UseRatingIMDb := ReadInteger('RatingOptions', 'UseRatingIMDb', 0);
      UseRatingKritikov := ReadInteger('RatingOptions', 'UseRatingKritikov', 0);
      // 
      ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
      ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
      ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
      ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
      AddUPLoadInfoDate := ReadInteger('OtherOptions', 'AddUPLoadInfoDate', 0);
      AutoCheck := ReadInteger('OtherOptions', 'AutoCheck', 1);
      ResizeCovers := ReadInteger('OtherOptions', 'ResizeCovers', 0);
      ResizeScreenshots := ReadInteger('OtherOptions', 'ResizeScreenshots', 0);
      CoversWidth := ReadInteger('OtherOptions', 'CoversWidth', 10000);
      if CoversWidth = 0 then
        CoversWidth := 10000;
      CoversHeight := ReadInteger('OtherOptions', 'CoversHeight', 10000);
      if CoversHeight = 0 then
        CoversHeight := 10000;
      ScreenshotsWidth := ReadInteger('OtherOptions', 'ScreenshotsWidth', 10000);
      if ScreenshotsWidth = 0 then
        ScreenshotsWidth := 10000;
      ScreenshotsHeight := ReadInteger('OtherOptions', 'ScreenshotsHeight', 10000);
      if ScreenshotsHeight = 0 then
        ScreenshotsHeight := 10000;
    finally
      Free;
    end;
  i := 0;
  repeat
    begin
      if (List[i] = 'CommentsOptions') or (List[i] = 'DescriptionOptions') or
        (List[i] = 'RatingOptions') or (List[i] = 'KinoPoiskOptions') or
        (List[i] = 'ProxyOptions') or (List[i] = 'NameOptions') or (List[i] = 'OtherOptions')
      then
        List.Delete(i)
      else
        i := i + 1;
    end;
  until (i = List.Count);
  if AutoCheck = 1 then
    begin
      if LastDate <> DateToStr(Date) then
        begin
          VerForm := TForm3.Create(Application);
          VerForm.Caption := '   ';
          VerForm.CheckBox1.Caption := '    ';
          VerForm.Button2.Caption := '  c ';
          VerForm.UserDir := UserDir;
          if (LoadDate <> DateToStr(Date)) and IsInternetConnected then
            begin
              with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                try
                  // 
                  VerForm.IdHTTP1.ProxyParams.ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
                  VerForm.IdHTTP1.ProxyParams.ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
                  VerForm.IdHTTP1.ProxyParams.ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
                  VerForm.IdHTTP1.ProxyParams.ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
                  if VerForm.IdHTTP1.ProxyParams.ProxyPassword <> '' then
                    VerForm.IdHTTP1.ProxyParams.BasicAuthentication := True;
                finally
                  Free;
                end;
              try
                page := VerForm.IdHTTP1.Get('http://films.unkas.net/files/plugins/Kinopoisk_zas_new.ini');
                Template := TStringList.Create;
                Template.Text := page;
                Template.SaveToFile(UserDir + 'Kinopoisk_zas_new.ini');
                Template.Free;
                with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
                  try
                    WriteString('LastDate', 'LoadDate', DateToStr(Date));
                  finally
                    Free;
                  end;
              except
              end;
            end;
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas', '---');
              NewVer := ReadInteger('Versions', 'Kinopoisk_zas', 0);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label3.Caption := s;
            finally
              Free;
            end;
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas', '100');
              Ver := ReadInteger('Versions', 'Kinopoisk_zas', 100);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label2.Caption := s;
            finally
              Free;
            end;
          if NewVer > Ver then
            begin
              VerForm.Memo1.Clear;
              with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
                try
                  for i := NewVer downto Ver + 1 do
                    begin
                      StrVal := IntToStr(i);
                      s := copy(StrVal, 1, 1) + '.';
                      delete(StrVal, 1, 1);
                      s := s + StrVal;
                      StrVal := ReadString('Log', 'Kinopoisk_zas_' + IntToStr(i), '');
                      if StrVal <> '' then
                        begin
                          VerForm.Memo1.Lines.Add(' ' + s);
                          StrVal := stringreplace(StrVal, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
                          VerForm.Memo1.Text := VerForm.Memo1.Text + ret + StrVal + ret + ret;
                        end;
                    end;
                finally
                  Free;
                end;
              VerForm.ShowModal;
            end;
          VerForm.Free;
        end;
    end;
  SetString(Query, OrigTitle, tlength);
  Query := stringreplace(Query, '&', '', [rfReplaceAll, rfIgnoreCase]);
  MovieBase := TMovieBase.Create;
  LoadInfo := TLoadInfo.Create(Application);
  LoadInfo.EmbeddedWB1.ProxySettings.Address := ProxyServer;
  LoadInfo.EmbeddedWB1.ProxySettings.Password := ProxyPassword;
  LoadInfo.EmbeddedWB1.ProxySettings.Port := ProxyPort;
  LoadInfo.EmbeddedWB1.ProxySettings.UserName := ProxyUsername;
  if LoadInfo.EmbeddedWB1.ProxySettings.Password <> '' then
    LoadInfo.EmbeddedWB1.ProxySettings.AutoLoadProxy := True;
  Form := TForm1.Create(Application);
  Form.Caption := '   ';
  Form.Button1.Caption := ' ';
  Form.Button4.Caption := ' ';
  Form.Button5.Caption := '';
  Form.Kol := 0;
  OldTitle := '';
  TitlePost := '';
  TitleSer := '';
  CurrentMovieURL := MovieBase.CurrentMovie.URL;
  if AddDescription2 = 1 then
    AddDescription := 1;
  if AddComments2 = 1 then
    AddComments := 1;
  i := Pos('kinopoisk.ru', CurrentMovieURL);
  if i > 0 then
    begin //  ,  ...
      CurrentMovieURL := stringreplace(CurrentMovieURL, '/id_film/', '/film/', [rfReplaceAll, rfIgnoreCase]);
      CurrentMovieURL := stringreplace(CurrentMovieURL, 'http:', 'https:', [rfReplaceAll, rfIgnoreCase]);
      if CurrentMovieURL[Length(CurrentMovieURL)] <> '/' then
        CurrentMovieURL := CurrentMovieURL + '/';
      OldTitle := MovieBase.CurrentMovie.Title;
      AddDescription := 0;
      if AddDescription2 = 1 then
        AddDescription := 1;
      AddComments := 0;
      if AddComments2 = 1 then
        AddComments := 1;
      if IfFillURL = 1 then
        begin
          i := MessageDlg(' URL  ?', mtConfirmation, [mbYes, mbNo], 0);
          if i = 6 then
            begin
              try
                Application.ProcessMessages;
                page := GetInfoFromUrl(CurrentMovieURL, '    .....');
                Application.ProcessMessages;
              except
                page := '';
              end;
              i := Pos(FindBlocking, page);
              if (i > 0) or (page = '') then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow(CurrentMovieURL);
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := GetInfoFromUrl(CurrentMovieURL, '    .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := Pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      MovieBase.Free;
                      Form.Free;
                      LoadInfo.Destroy;
                      Exit;
                    end;
                end;
            end
          else
            begin
              try
                Application.ProcessMessages;
                page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                     CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                Application.ProcessMessages;
              except
                page := '';
              end;
              i := Pos(FindBlocking, page);
              if (i > 0) or (page = '') then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                    CorrectRequest(Query) + '/order/relevant/perpage/10/');
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                         CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      MovieBase.Free;
                      Form.Free;
                      LoadInfo.Destroy;
                      Exit;
                    end;
                end;
            end;
        end
      else
        if IfFillURL = 2 then
          begin
            try
              Application.ProcessMessages;
              page := GetInfoFromUrl(CurrentMovieURL, '    .....');
              Application.ProcessMessages;
            except
              page := '';
            end;
            i := pos(FindBlocking, page);
            if (i > 0) or (page = '') then
              begin
                ShowMessage('    ');
                GetBrowserWindow(CurrentMovieURL);
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := GetInfoFromUrl(CurrentMovieURL, '    .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := Pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    MovieBase.Free;
                    Form.Free; 
                    LoadInfo.Destroy;
                    Exit;
                  end;
              end;
          end
        else
          begin
            try
              Application.ProcessMessages;
              page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                   CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
              Application.ProcessMessages;
            except
              page := '';
            end;
            i := Pos(FindBlocking, page);
            if (i > 0) or (page = '') then
              begin
                ShowMessage('    ');
                GetBrowserWindow('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                 CorrectRequest(Query) + '/order/relevant/perpage/10/');
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                       CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := Pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    MovieBase.Free;
                    Form.Free; 
                    LoadInfo.Destroy;
                    Exit;
                  end;
              end;
          end;
    end
  else
    begin //  
      try
        Application.ProcessMessages;
        page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                             CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
        Application.ProcessMessages;
      except
        page := '';
      end;
      i := Pos(FindBlocking, page);
      if (i > 0) or (page = '') then
        begin
          ShowMessage('    ');
          GetBrowserWindow('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                           CorrectRequest(Query) + '/order/relevant/perpage/10/');
          try
            Application.ProcessMessages;
            if NeedURLDelay = 1 then
              Sleep(MaxURLDelay);
            Application.ProcessMessages;
            page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/film/list/1/find/' +
                                                 CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
            Application.ProcessMessages;
          except
            page := '';
          end;
          i := Pos(FindBlocking, page);
          if (i > 0) or (page = '') then
            begin
              ShowMessage('    ');
              MovieBase.Free;
              Form.Free;
              LoadInfo.Destroy;
              Exit;
            end;
        end;
    end;
  if page <> '@@@!!!@@@' then
    begin
      if SaveSourceCode = 1 then
        SaveResultHtmlText(page, 'SearchMovieInfo');
      links := TStringList.Create;
      MovieList := TStringList.Create;
      NotSelectTheMovie := 0;
      if trim(page) = '@@@!!!@@@empty' then
        begin //  !
          ShowMessage(' ,      ');
          Form.Free;
          MovieBase.Free;
          Exit;
        end
      else
        begin
          i := Pos('@@@!!!@@@', page);
          if i > 0 then
            begin
              s := page;
              i := Pos(' :</dt>', s);
              if i > 0 then
                delete(s, 1, i + 19);
              i := Pos('<div class="right">', s);
              if i > 0 then
                delete(s, 1, i + 18);
              while i > 0 do
                begin
                  s2 := '';
                  j := Pos('class="num">', s);
                  if j > 0 then
                    begin
                      j := Pos('<p class="name">', s);
                      if j > 0 then
                        delete(s, 1, j + 15);
                      j := Pos('data-id="', s);
                      if j > 0 then
                        delete(s, 1, j + 8);
                      j := Pos('"', s);
                      if j > 0 then
                        MovieCode := trim(copy(s, 1, j - 1));
                      links.Add(MovieCode);
                      delete(s, 1, Pos('>', s));
                      j := Pos('</a>', s);
                      s2 := copy(s, 1, j - 1); // 
                      s2 := HTMLRemoveTags(s2);
                      s2 := ReplaceLatinExt(s2);
                      s2 := trim(HTMLDecode(s2));
                      delete(s, 1, j + 3);
                      j := Pos('"year">', s);
                      if j > 0 then
                        delete(s, 1, j + 6);
                      j := Pos('</span>', s);
                      s3 := copy(s, 1, j - 1); //  
                      s3 := HTMLRemoveTags(s3);
                      s3 := trim(HTMLDecode(s3));
                      delete(s, 1, j + 6);
                      j := Pos('"gray">', s);
                      if j > 0 then
                        delete(s, 1, j + 6);
                      j := Pos('</span>', s);
                      s4 := copy(s, 1, j - 1); //   ( )  
                      s4 := HTMLRemoveTags(s4);
                      s4 := ReplaceLatinExt(s4);
                      s4 := trim(HTMLDecode(s4));
                      delete(s, 1, j + 6);
                      if s4 = '' then
                        begin
                          s4 := s2;
                          if s3 <> '' then
                            s4 := s4 + ' (' + s3 + ')';
                          s2 := '';
                        end;
                      if s2 <> '' then
                        begin
                          s4 := s2 + ' / ' + s4;
                          if s3 <> '' then
                            s4 := s4 + ' (' + s3 + ')';
                        end;
                      if GetAMMBuild >= 1303 then
                        begin
                          s4 := s4 + '^^^^https://st.kp.yandex.net/images/film/' + MovieCode + '.jpg';
                        end;
                      MovieList.Add(s4);
                    end;
                  i := Pos('<div class="right">', s);
                  if i > 0 then
                    delete(s, 1, i + 18);
                end;
            end
          else
            begin
              NotSelectTheMovie := 1;
              s := page;
              s2 := '';
              i := Pos('content="https://www.kinopoisk.ru/film/', s);
              if i = 0 then
                i := Pos('content="https://desktop.kinopoisk.ru/film/', s);
              if i > 0 then
                begin
                  delete(s, 1, i);
                  i := Pos('/film/', s);
                  if i > 0 then
                    delete(s, 1, i + 5);
                  s2 := copy(s, 1, Pos('/"', s) - 1);
                  i := PosExD('-', s2);
                  if i > 0 then
                    Delete(s2, 1, i);
                end
              else
                begin
                  if i = 0 then
                    i := Pos('content="https://www.kinopoisk.ru/series/', s);
                  if i = 0 then
                    i := Pos('content="https://desktop.kinopoisk.ru/series/', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i);
                      i := Pos('/series/', s);
                      if i > 0 then
                        delete(s, 1, i + 7);
                      s2 := copy(s, 1, Pos('/"', s) - 1);
                      i := PosExD('-', s2);
                      if i > 0 then
                        Delete(s2, 1, i);
                    end;
                end;
              links.Add(s2);
              MovieList.Add('test' + s2);
            end;
        end;
      if NotSelectTheMovie = 0 then // ,   
        i := MovieBase.SelectTheMovie(MovieList.Text)
      else
        i := 0;
      if i > -1 then
        begin
          MovieCode := links[i];
          if MovieCode = '' then
            begin //   !
              ShowMessage('   !');
              Form.Free;
              MovieBase.Free;
              Exit;
            end;
          if NotSelectTheMovie = 0 then
            if MovieCode <> '' then
              begin
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/',
                                         '    .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := Pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/');
                    try
                      Application.ProcessMessages;
                      if NeedURLDelay = 1 then
                        Sleep(MaxURLDelay);
                      Application.ProcessMessages;
                      page := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/',
                                             '    .....');
                      Application.ProcessMessages;
                    except
                      page := '';
                    end;
                    i := Pos(FindBlocking, page);
                    if (i > 0) or (page = '') then
                      begin
                        ShowMessage('    ');
                        MovieBase.Free;
                        Form.Free;
                        LoadInfo.Destroy;
                        Exit;
                      end;
                  end;
              end
            else
              page := '';
          if MovieCode <> '' then
            MovieBase.CurrentMovie.URL := 'https://www.kinopoisk.ru/film/' + MovieCode + '/';
          links.Free;
          MovieList.Free;
          if page <> '' then
            begin
              if SaveSourceCode = 1 then
                SaveResultHtmlText(page, 'MovieInfo' + MovieCode);
              if DelAndSave = 1 then
                begin
                  OldGenre := MovieBase.CurrentMovie.Genre;
                  OldCountry := MovieBase.CurrentMovie.Country;
                  OldDirector := MovieBase.CurrentMovie.Director;
                  OldScenario := MovieBase.CurrentMovie.Scenario;
                  OldActors := MovieBase.CurrentMovie.Actors;
                  OldStudio := MovieBase.CurrentMovie.Studio;
                  if uGenre = 1 then
                    MovieBase.CurrentMovie.Genre := '';
                  if uCountry = 1 then
                    MovieBase.CurrentMovie.Country := '';
                  if MaxDirector > 0 then
                    MovieBase.CurrentMovie.Director := '';
                  if MaxScenario > 0 then
                    MovieBase.CurrentMovie.Scenario := '';
                  if MaxActors > 0 then
                    MovieBase.CurrentMovie.Actors := '';
                  if MaxStudio > 0 then
                    MovieBase.CurrentMovie.Studio := '';
                  MovieBase.SaveMovie;
                end;
              Comment := '';
              Descript := '';
              Description := '';
              FullMovieCode := '';
              s := page;
              s2 := '';
              i := Pos('<link rel="alternate" href="', s);
              if i > 0 then
                begin
                  delete(s, 1, i + 27);
                  s2 := copy(s, 1, Pos('/"', s) - 1);
                  i := Pos('/film/', s2);
                  if i > 0 then
                    begin
                      delete(s2, 1, Pos('/film/', s2) + 5);
                      FullMovieCode := s2;
                    end;
                end;
              i := Pos('class="moviename-big"', s); //    
              if i > 0 then
                begin
                  delete(s, 1, i + 20);
                  i := Pos('">', s);
                  if i > 0 then
                    delete(s, 1, i + 1);
                  i := Pos('</', s);
                  s2 := copy(s, 1, i - 1);
                  s2 := HTMLRemoveTags(s2);
                  s2 := ReplaceLatinExt(s2);
                  s2 := HTMLDecode(s2);
                  s2 := trim(s2);
                  i := Pos('(', s2);
                  if i > 0 then
                    begin
                      Serial := 1;
                      with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                        try
                          uTitle := ReadInteger(DownloadSection2, 'Title', 1);
                          uOriginalTitle := ReadInteger(DownloadSection2, 'OriginalTitle', 1);
                          uAltOriginalTitle := ReadInteger(DownloadSection2, 'AltOriginalTitle', 0);
                          uYear := ReadInteger(DownloadSection2, 'Year', 1);
                          uCountry := ReadInteger(DownloadSection2, 'Country', 1);
                          uSlogan := ReadInteger(DownloadSection2, 'Slogan', 1);
                          uGenre := ReadInteger(DownloadSection2, 'Genre', 1);
                          uBudget := ReadInteger(DownloadSection2, 'Budget', 1);
                          uMarketing := ReadInteger(DownloadSection2, 'Marketing', 0);
                          uSbor := ReadInteger(DownloadSection2, 'Sbor', 1);
                          uPremData := ReadInteger(DownloadSection2, 'PremData', 1);
                          uTrailer := ReadInteger(DownloadSection2, 'Trailer', 0);
                          uRole := ReadInteger(DownloadSection2, 'Role', 0);
                          uMPAA := ReadInteger(DownloadSection2, 'MPAA', 1);
                          uDuration := ReadInteger(DownloadSection2, 'Duration', 0);
                          uDurationOtherFormat := ReadInteger(DownloadSection2, 'DurationOtherFormat', 0);
                          uDescription := ReadInteger(DownloadSection2, 'Description', 1);
                          uRating := ReadInteger(DownloadSection2, 'Rating', 1);
                          uRatingKinoPoisk := ReadInteger(DownloadSection2, 'RatingKinoPoisk', 1);
                          uRatingIMDb := ReadInteger(DownloadSection2, 'RatingIMDb', 0);
                          uRatingKritikov := ReadInteger(DownloadSection2, 'RatingKritikov', 0);
                          uAwards := ReadInteger(DownloadSection2, 'Awards', 1);
                          uLinks := ReadInteger(DownloadSection2, 'Links', 1);
                          LinksInTable := ReadInteger(DownloadSection2, 'LinksInTable', 1);
                          uZnaite := ReadInteger(DownloadSection2, 'Znaite', 1);
                          ZnaiteIns := ReadInteger(DownloadSection2, 'ZnaiteIns', 1);
                          uErrors := ReadInteger(DownloadSection2, 'Errors', 0);
                          ErrorIns := ReadInteger(DownloadSection2, 'ErrorIns', 0);
                          uRecenzia := ReadInteger(DownloadSection2, 'Recenzia', 0);
                          uAllRecenziaPage := ReadInteger(DownloadSection2, 'AllRecenziaPage', 0);
                          uEpisodes := ReadInteger(DownloadSection2, 'Episodes', 1);
                          uEpisodesIfEmpty := ReadInteger(DownloadSection2, 'EpisodesIfEmpty', 1);
                          uCovers := ReadInteger(DownloadSection2, 'Covers', 1);
                          uAllCoversPage := ReadInteger(DownloadSection2, 'AllCoversPage', 0);
                          uScreenshots := ReadInteger(DownloadSection2, 'Screenshots', 1);
                          uAllScreenshotsPage := ReadInteger(DownloadSection2, 'AllScreenshotsPage', 0);
                          uDVD := ReadInteger(DownloadSection2, 'DVD', 0);
                          uBluRay := ReadInteger(DownloadSection2, 'BluRay', 0);
                          uBook3500 := ReadInteger(DownloadSection2, 'Book3500', 0);
                          uLikeMovies := ReadInteger(DownloadSection2, 'LikeMovies', 0);
                          MaxCovers := ReadInteger(DownloadSection2, 'MaxCovers', 500);
                          MaxScreenshots := ReadInteger(DownloadSection2, 'MaxScreenshots', 500);
                          MaxRecenzia := ReadInteger(DownloadSection2, 'MaxRecenzia', 500);
                          MaxDirector := ReadInteger(DownloadSection2, 'MaxDirector', 10);
                          MaxScenario := ReadInteger(DownloadSection2, 'MaxScenario', 10);
                          MaxActors := ReadInteger(DownloadSection2, 'MaxActors', 50);
                          MaxProducer := ReadInteger(DownloadSection2, 'MaxProducer', 10);
                          MaxOperator := ReadInteger(DownloadSection2, 'MaxOperator', 10);
                          MaxComposer := ReadInteger(DownloadSection2, 'MaxComposer', 10);
                          MaxVoiceDirector := ReadInteger(DownloadSection2, 'MaxVoiceDirector', 10);
                          MaxVoice := ReadInteger(DownloadSection2, 'MaxVoice', 10);
                          MaxPainter := ReadInteger(DownloadSection2, 'MaxPainter', 0);
                          MaxCutter := ReadInteger(DownloadSection2, 'MaxCutter', 0);
                          MaxTranslator := ReadInteger(DownloadSection2, 'MaxTranslator', 0);
                          RusNameOnly := ReadInteger(DownloadSection2, 'RusNameOnly', 0);
                          NameException := ReadString(DownloadSection2, 'NameException', '');
                          MaxStudio := ReadInteger(DownloadSection2, 'MaxStudio', 5);
                          MaxVisualEffectsStudio := ReadInteger(DownloadSection2, 'MaxVisualEffectsStudio', 0);
                          VisualEffectsStudio := ReadInteger(DownloadSection2, 'VisualEffectsStudio', 0);
                          MaxVoiceStudio := ReadInteger(DownloadSection2, 'MaxVoiceStudio', 0);
                          VoiceStudio := ReadInteger(DownloadSection2, 'VoiceStudio', 0);
                          MaxProkatStudio := ReadInteger(DownloadSection2, 'MaxProkatStudio', 0);
                          ProkatStudio := ReadInteger(DownloadSection2, 'ProkatStudio', 0);
                        finally
                          Free;
                        end;
                    end;
                end
              else
                begin
                  i := Pos('<h1 class="film-header', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 21);
                      s2 := copy(s, Pos('">', s) + 2, Pos('</h1>', s) - 1);
                      s2 := HTMLRemoveTags(s2);
                      s2 := ReplaceLatinExt(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      i := Pos('', s2);
                      if i > 0 then
                        begin
                          Serial := 1;
                          with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                            try
                              uTitle := ReadInteger(DownloadSection2, 'Title', 1);
                              uOriginalTitle := ReadInteger(DownloadSection2, 'OriginalTitle', 1);
                              uAltOriginalTitle := ReadInteger(DownloadSection2, 'AltOriginalTitle', 0);
                              uYear := ReadInteger(DownloadSection2, 'Year', 1);
                              uCountry := ReadInteger(DownloadSection2, 'Country', 1);
                              uSlogan := ReadInteger(DownloadSection2, 'Slogan', 1);
                              uGenre := ReadInteger(DownloadSection2, 'Genre', 1);
                              uBudget := ReadInteger(DownloadSection2, 'Budget', 1);
                              uMarketing := ReadInteger(DownloadSection2, 'Marketing', 0);
                              uSbor := ReadInteger(DownloadSection2, 'Sbor', 1);
                              uPremData := ReadInteger(DownloadSection2, 'PremData', 1);
                              uTrailer := ReadInteger(DownloadSection2, 'Trailer', 0);
                              uRole := ReadInteger(DownloadSection2, 'Role', 0);
                              uMPAA := ReadInteger(DownloadSection2, 'MPAA', 1);
                              uDuration := ReadInteger(DownloadSection2, 'Duration', 0);
                              uDurationOtherFormat := ReadInteger(DownloadSection2, 'DurationOtherFormat', 0);
                              uDescription := ReadInteger(DownloadSection2, 'Description', 1);
                              uRating := ReadInteger(DownloadSection2, 'Rating', 1);
                              uRatingKinoPoisk := ReadInteger(DownloadSection2, 'RatingKinoPoisk', 1);
                              uRatingIMDb := ReadInteger(DownloadSection2, 'RatingIMDb', 0);
                              uRatingKritikov := ReadInteger(DownloadSection2, 'RatingKritikov', 0);
                              uAwards := ReadInteger(DownloadSection2, 'Awards', 1);
                              uLinks := ReadInteger(DownloadSection2, 'Links', 1);
                              LinksInTable := ReadInteger(DownloadSection2, 'LinksInTable', 1);
                              uZnaite := ReadInteger(DownloadSection2, 'Znaite', 1);
                              ZnaiteIns := ReadInteger(DownloadSection2, 'ZnaiteIns', 1);
                              uErrors := ReadInteger(DownloadSection2, 'Errors', 0);
                              ErrorIns := ReadInteger(DownloadSection2, 'ErrorIns', 0);
                              uRecenzia := ReadInteger(DownloadSection2, 'Recenzia', 0);
                              uAllRecenziaPage := ReadInteger(DownloadSection2, 'AllRecenziaPage', 0);
                              uEpisodes := ReadInteger(DownloadSection2, 'Episodes', 1);
                              uEpisodesIfEmpty := ReadInteger(DownloadSection2, 'EpisodesIfEmpty', 1);
                              uCovers := ReadInteger(DownloadSection2, 'Covers', 1);
                              uAllCoversPage := ReadInteger(DownloadSection2, 'AllCoversPage', 0);
                              uScreenshots := ReadInteger(DownloadSection2, 'Screenshots', 1);
                              uAllScreenshotsPage := ReadInteger(DownloadSection2, 'AllScreenshotsPage', 0);
                              uDVD := ReadInteger(DownloadSection2, 'DVD', 0);
                              uBluRay := ReadInteger(DownloadSection2, 'BluRay', 0);
                              uBook3500 := ReadInteger(DownloadSection2, 'Book3500', 0);
                              uLikeMovies := ReadInteger(DownloadSection2, 'LikeMovies', 0);
                              MaxCovers := ReadInteger(DownloadSection2, 'MaxCovers', 500);
                              MaxScreenshots := ReadInteger(DownloadSection2, 'MaxScreenshots', 500);
                              MaxRecenzia := ReadInteger(DownloadSection2, 'MaxRecenzia', 500);
                              MaxDirector := ReadInteger(DownloadSection2, 'MaxDirector', 10);
                              MaxScenario := ReadInteger(DownloadSection2, 'MaxScenario', 10);
                              MaxActors := ReadInteger(DownloadSection2, 'MaxActors', 50);
                              MaxProducer := ReadInteger(DownloadSection2, 'MaxProducer', 10);
                              MaxOperator := ReadInteger(DownloadSection2, 'MaxOperator', 10);
                              MaxComposer := ReadInteger(DownloadSection2, 'MaxComposer', 10);
                              MaxVoiceDirector := ReadInteger(DownloadSection2, 'MaxVoiceDirector', 10);
                              MaxVoice := ReadInteger(DownloadSection2, 'MaxVoice', 10);
                              MaxPainter := ReadInteger(DownloadSection2, 'MaxPainter', 0);
                              MaxCutter := ReadInteger(DownloadSection2, 'MaxCutter', 0);
                              MaxTranslator := ReadInteger(DownloadSection2, 'MaxTranslator', 0);
                              RusNameOnly := ReadInteger(DownloadSection2, 'RusNameOnly', 0);
                              NameException := ReadString(DownloadSection2, 'NameException', '');
                              MaxStudio := ReadInteger(DownloadSection2, 'MaxStudio', 5);
                              MaxVisualEffectsStudio := ReadInteger(DownloadSection2, 'MaxVisualEffectsStudio', 0);
                              VisualEffectsStudio := ReadInteger(DownloadSection2, 'VisualEffectsStudio', 0);
                              MaxVoiceStudio := ReadInteger(DownloadSection2, 'MaxVoiceStudio', 0);
                              VoiceStudio := ReadInteger(DownloadSection2, 'VoiceStudio', 0);
                              MaxProkatStudio := ReadInteger(DownloadSection2, 'MaxProkatStudio', 0);
                              ProkatStudio := ReadInteger(DownloadSection2, 'ProkatStudio', 0);
                            finally
                              Free;
                            end;
                        end;
                    end
                  else
                    begin
                      i := Pos('<title>', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 6);
                          i := Pos('</title>', s);
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := ReplaceLatinExt(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          i := Pos('(', s2);
                          if i > 0 then
                            begin
                              Serial := 1;
                              with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                                try
                                  uTitle := ReadInteger(DownloadSection2, 'Title', 1);
                                  uOriginalTitle := ReadInteger(DownloadSection2, 'OriginalTitle', 1);
                                  uAltOriginalTitle := ReadInteger(DownloadSection2, 'AltOriginalTitle', 0);
                                  uYear := ReadInteger(DownloadSection2, 'Year', 1);
                                  uCountry := ReadInteger(DownloadSection2, 'Country', 1);
                                  uSlogan := ReadInteger(DownloadSection2, 'Slogan', 1);
                                  uGenre := ReadInteger(DownloadSection2, 'Genre', 1);
                                  uBudget := ReadInteger(DownloadSection2, 'Budget', 1);
                                  uMarketing := ReadInteger(DownloadSection2, 'Marketing', 0);
                                  uSbor := ReadInteger(DownloadSection2, 'Sbor', 1);
                                  uPremData := ReadInteger(DownloadSection2, 'PremData', 1);
                                  uTrailer := ReadInteger(DownloadSection2, 'Trailer', 0);
                                  uRole := ReadInteger(DownloadSection2, 'Role', 0);
                                  uMPAA := ReadInteger(DownloadSection2, 'MPAA', 1);
                                  uDuration := ReadInteger(DownloadSection2, 'Duration', 0);
                                  uDurationOtherFormat := ReadInteger(DownloadSection2, 'DurationOtherFormat', 0);
                                  uDescription := ReadInteger(DownloadSection2, 'Description', 1);
                                  uRating := ReadInteger(DownloadSection2, 'Rating', 1);
                                  uRatingKinoPoisk := ReadInteger(DownloadSection2, 'RatingKinoPoisk', 1);
                                  uRatingIMDb := ReadInteger(DownloadSection2, 'RatingIMDb', 0);
                                  uRatingKritikov := ReadInteger(DownloadSection2, 'RatingKritikov', 0);
                                  uAwards := ReadInteger(DownloadSection2, 'Awards', 1);
                                  uLinks := ReadInteger(DownloadSection2, 'Links', 1);
                                  LinksInTable := ReadInteger(DownloadSection2, 'LinksInTable', 1);
                                  uZnaite := ReadInteger(DownloadSection2, 'Znaite', 1);
                                  ZnaiteIns := ReadInteger(DownloadSection2, 'ZnaiteIns', 1);
                                  uErrors := ReadInteger(DownloadSection2, 'Errors', 0);
                                  ErrorIns := ReadInteger(DownloadSection2, 'ErrorIns', 0);
                                  uRecenzia := ReadInteger(DownloadSection2, 'Recenzia', 0);
                                  uAllRecenziaPage := ReadInteger(DownloadSection2, 'AllRecenziaPage', 0);
                                  uEpisodes := ReadInteger(DownloadSection2, 'Episodes', 1);
                                  uEpisodesIfEmpty := ReadInteger(DownloadSection2, 'EpisodesIfEmpty', 1);
                                  uCovers := ReadInteger(DownloadSection2, 'Covers', 1);
                                  uAllCoversPage := ReadInteger(DownloadSection2, 'AllCoversPage', 0);
                                  uScreenshots := ReadInteger(DownloadSection2, 'Screenshots', 1);
                                  uAllScreenshotsPage := ReadInteger(DownloadSection2, 'AllScreenshotsPage', 0);
                                  uDVD := ReadInteger(DownloadSection2, 'DVD', 0);
                                  uBluRay := ReadInteger(DownloadSection2, 'BluRay', 0);
                                  uBook3500 := ReadInteger(DownloadSection2, 'Book3500', 0);
                                  uLikeMovies := ReadInteger(DownloadSection2, 'LikeMovies', 0);
                                  MaxCovers := ReadInteger(DownloadSection2, 'MaxCovers', 500);
                                  MaxScreenshots := ReadInteger(DownloadSection2, 'MaxScreenshots', 500);
                                  MaxRecenzia := ReadInteger(DownloadSection2, 'MaxRecenzia', 500);
                                  MaxDirector := ReadInteger(DownloadSection2, 'MaxDirector', 10);
                                  MaxScenario := ReadInteger(DownloadSection2, 'MaxScenario', 10);
                                  MaxActors := ReadInteger(DownloadSection2, 'MaxActors', 50);
                                  MaxProducer := ReadInteger(DownloadSection2, 'MaxProducer', 10);
                                  MaxOperator := ReadInteger(DownloadSection2, 'MaxOperator', 10);
                                  MaxComposer := ReadInteger(DownloadSection2, 'MaxComposer', 10);
                                  MaxVoiceDirector := ReadInteger(DownloadSection2, 'MaxVoiceDirector', 10);
                                  MaxVoice := ReadInteger(DownloadSection2, 'MaxVoice', 10);
                                  MaxPainter := ReadInteger(DownloadSection2, 'MaxPainter', 0);
                                  MaxCutter := ReadInteger(DownloadSection2, 'MaxCutter', 0);
                                  MaxTranslator := ReadInteger(DownloadSection2, 'MaxTranslator', 0);
                                  RusNameOnly := ReadInteger(DownloadSection2, 'RusNameOnly', 0);
                                  NameException := ReadString(DownloadSection2, 'NameException', '');
                                  MaxStudio := ReadInteger(DownloadSection2, 'MaxStudio', 5);
                                  MaxVisualEffectsStudio := ReadInteger(DownloadSection2, 'MaxVisualEffectsStudio', 0);
                                  VisualEffectsStudio := ReadInteger(DownloadSection2, 'VisualEffectsStudio', 0);
                                  MaxVoiceStudio := ReadInteger(DownloadSection2, 'MaxVoiceStudio', 0);
                                  VoiceStudio := ReadInteger(DownloadSection2, 'VoiceStudio', 0);
                                  MaxProkatStudio := ReadInteger(DownloadSection2, 'MaxProkatStudio', 0);
                                  ProkatStudio := ReadInteger(DownloadSection2, 'ProkatStudio', 0);
                                finally
                                  Free;
                                end;
                            end;
                        end;
                    end;
                end;
              s := page; //  
              if GetAMMBuild > 1283 then //
                begin
                  if uTrailer = 1 then
                    begin //,     
                      if (Pos('<li><s></s><u></u><a href="/film/' + FullMovieCode + '/video/"', page) > 0) or
                         (Pos('<li><s></s><u></u><a href="/film/' + MovieCode + '/video/"', page) > 0)
                      then
                          MovieBase.CurrentMovie.TrailerLink := 'https://www.kinopoisk.ru/film/' + MovieCode + '/video/'
                      else
                        begin
                          if Pos('" href="/film/' + MovieCode + '/video/">', page) > 0 then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/video/',
                                                        '    .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := Pos(FindBlocking, page2);
                              if (i > 0) or (page = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/video/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/video/',
                                                           '    .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := Pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  if Pos('<!--  -->', page2) > 0 then
                                    MovieBase.CurrentMovie.TrailerLink := 'https://www.kinopoisk.ru/film/' + MovieCode + '/video/';
                                end;
                            end;
                        end;
                    end;
                end;
              tDescription := ''; //
              if uDescription = 1 then
                begin
                  i := Pos('<div class="brand_words film-synopsys" itemprop="description">', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 61);
                      s2 := '';
                      i := Pos('</td></tr>', s);
                      if i > 0 then
                        s2 := copy(s, 1, i - 1);
                      s2 := ClearHTML(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          Description := s2;
                          tDescription := s2;
                        end;
                    end
                  else
                    begin
                      i := Pos('"><p class="film-synopsis__paragraph">', s);
                      if i = 0 then
                        i := Pos('"><p class="styles_paragraph', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 1);
                          s2 := '<div>' + copy(s, 1, Pos('</div></div>', s) + 5);
                          s2 := ClearHTML(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              Description := s2;
                              tDescription := s2;
                            end;
                        end;
                    end;
                end;
              s := page;
              i := Pos('> </', s);
              if i > 0 then
                s := copy(s, 1, i - 1);
              s := stringreplace(s, '</a>)</', ')</a></', [rfReplaceAll, rfIgnoreCase]);
              s := stringreplace(s, '</a>]</', ']</a></', [rfReplaceAll, rfIgnoreCase]);
              s := stringreplace(s, '>-</', '>-</a></', [rfReplaceAll, rfIgnoreCase]);
              OriginalTitle := '';
              if uTitle = 1 then // 
                begin
                  s2 := '';
                  i := pos('class="moviename-big"', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 20);
                      i := pos('">', s);
                      if i > 0 then
                        delete(s, 1, i + 1);
                      i := pos('</', s);
                      s2 := copy(s, 1, i - 1);
                      s2 := HTMLRemoveTags(s2);
                      s2 := ReplaceLatinExt(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if TitleSer <> '' then
                        begin
                          i := pos('(', s2);
                          if i > 0 then
                            begin
                              s2 := copy(s2, 1, i - 1);
                              s2 := trim(s2);
                            end;
                          s2 := s2 + '  ' + TitleSer;
                        end
                      else
                        s2 := s2 + TitlePost;
                    end
                  else
                    begin
                      i := pos('name="description" content="', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 27);
                          i := pos(') ', s);
                          if i > 0 then
                            begin
                              s2 := copy(s, 1, i - 6);
                              s2 := HTMLRemoveTags(s2);
                              s2 := ReplaceLatinExt(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                            end;
                        end
                      else
                        begin
                          i := pos('<title>', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 6);
                              i := pos('     </title>', s);
                              if i = 0 then
                                i := pos('  </title>', s);
                              s2 := copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := ReplaceLatinExt(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                            end
                          else
                            begin
                              i := pos('<title', s);
                              if i > 0 then
                                begin
                                  delete(s, 1, i + 5);
                                  delete(s, 1, pos('">', s) + 1);
                                  i := pos('     </title>', s);
                                  if i = 0 then
                                    i := pos('  </title>', s);
                                  s2 := copy(s, 1, i - 1);
                                  s2 := HTMLRemoveTags(s2);
                                  s2 := ReplaceLatinExt(s2);
                                  s2 := HTMLDecode(s2);
                                  s2 := trim(s2);
                                end;
                            end;
                        end;
                    end;
                  if DelTV = 1 then
                    begin
                      i := pos('(', s2);
                      if i > 0 then
                        s2 := copy(s2, 1, i - 1);
                      i := pos('(-', s2);
                      if i > 0 then
                        s2 := copy(s2, 1, i - 1);
                      i := pos('()', s2);
                      if i > 0 then
                        s2 := copy(s2, 1, i - 1);
                      i := pos('()', s2);
                      if i > 0 then
                        s2 := copy(s2, 1, i - 1);
                    end;
                  s2 := stringreplace(s2, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                  s2 := trim(s2);
                  if (s2 <> '') and (s2 <> '-') then
                    MovieBase.CurrentMovie.Title := s2;
                end;
              s := page;
              if uOriginalTitle = 1 then
                begin
                  i := pos('class="moviename-big"', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 20);
                      i := pos('</h1>', s);
                      if i > 0 then
                        delete(s, 1, i + 4);
                      i := pos('<span', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i - 1);
                          i := pos('</span>', s);
                          if i > 0 then
                            begin
                              s2 := copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := ReplaceLatinExt(s2);
                              s2 := HTMLDecode(s2);
                              s2 := stringreplace(s2, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  MovieBase.CurrentMovie.OriginalTitle := s2;
                                  OriginalTitle := s2;
                                end;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('property="title" content="', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 25);
                          i := pos(' (', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 2);
                              i := pos(')" />', s);
                              if i > 0 then
                                begin
                                  s2 := copy(s, 1, i - 7);
                                  s2 := HTMLRemoveTags(s2);
                                  s2 := ReplaceLatinExt(s2);
                                  s2 := HTMLDecode(s2);
                                  s2 := trim(s2);
                                  if (s2 <> '') and (s2 <> '-') then
                                    begin
                                      MovieBase.CurrentMovie.OriginalTitle := s2;
                                      OriginalTitle := s2;
                                    end;
                                end;
                            end;
                        end
                      else
                        begin
                          i := pos('<span class="styles_originalTitle', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 32);
                              i := pos('">', s);
                              delete(s, 1, i + 1);
                              i := pos('</span>', s);
                              if i > 0 then
                                begin
                                  s2 := copy(s, 1, i - 1);
                                  s2 := HTMLRemoveTags(s2);
                                  s2 := ReplaceLatinExt(s2);
                                  s2 := HTMLDecode(s2);
                                  s2 := trim(s2);
                                  if (s2 <> '') and (s2 <> '-') then
                                    begin
                                      MovieBase.CurrentMovie.OriginalTitle := s2;
                                      OriginalTitle := s2;
                                    end;
                                end;
                            end;
                        end;
                    end;
                  if (trim(OriginalTitle) = '') and (FillOrigName = 1) then
                    begin
                      if trim(MovieBase.CurrentMovie.Title) <> '' then
                        MovieBase.CurrentMovie.OriginalTitle := MovieBase.CurrentMovie.Title;
                    end;
                end;
              if uAltOriginalTitle = 1 then
                begin
                  if MovieBase.CurrentMovie.OriginalTitle = MovieBase.CurrentMovie.Title then
                    MovieBase.CurrentMovie.OriginalTitle := RusToTranslit(MovieBase.CurrentMovie.Title);
                end;
              if uTitle = 1 then
                begin
                  if (OldTitle <> '') and (MovieBase.CurrentMovie.OriginalTitle = MovieBase.CurrentMovie.Title) then
                    MovieBase.CurrentMovie.Title := OldTitle;
                end;
              if uYear = 1 then //
                begin
                  i := pos('> </', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 18);
                      i := pos('quick_filters=films">', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 20);
                          i := pos('</a>', s);
                          s2 := copy(s, 1, i - 1);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            MovieBase.CurrentMovie.Year := s2;
                        end
                      else
                        begin
                          i := pos('quick_filters=serials">', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 22);
                              i := pos('</a>', s);
                              s2 := copy(s, 1, i - 1);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                MovieBase.CurrentMovie.Year := s2;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('></', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 5);
                          i := pos('</', s);
                          s2 := '<' + copy(s, 1, i - 1);
                          i := pos('&nbsp;', s2);
                          if i > 0 then
                            s2 := copy(s2, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            MovieBase.CurrentMovie.Year := s2;
                        end;
                    end;
                end;
              if uCountry = 1 then //
                begin
                  i := pos('></div>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 12);
                      i := pos('</a></div>', s);
                      s2 := copy(s, 1, i + 9);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        MovieBase.CurrentMovie.Country := s2;
                    end
                  else
                    begin
                      i := pos('></', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 8);
                          i := pos('</td>', s);
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            MovieBase.CurrentMovie.Country := s2;
                        end;
                    end;
                end;
              tSlogan := '';
              if uSlogan = 1 then //
                begin
                  i := pos('></div>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 12);
                      i := pos('</div></div></div>', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i + 11);
                          s2 := HTMLRemoveTags(s2);
                          s2 := ReplaceLatinExt(s2);
                          s2 := HTMLDecode(s2);
                          s2 := stringreplace(s2, '', '"', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '', '"', [rfReplaceAll, rfIgnoreCase]);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSlogan := s2;
                              if cSlogan = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>: </b>' + s2
                                  else
                                    Comment := Comment + ': ' + s2;
                                end;
                              if dSlogan = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>: </b>' + s2
                                  else
                                    Descript := Descript + ': ' + s2;
                                end;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('></', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 8);
                          i := pos('">', s);
                          if i > 0 then
                            delete(s, 1, i + 1);
                          i := pos('</', s);
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := ReplaceLatinExt(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSlogan := s2;
                              if cSlogan = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>: </b>' + s2
                                  else
                                    Comment := Comment + ': ' + s2;
                                end;
                              if dSlogan = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>: </b>' + s2
                                  else
                                    Descript := Descript + ': ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              s := page;
              if uGenre = 1 then //
                begin
                  i := pos('></div>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 10);
                      i := pos('</div></div>', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i + 5);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := stringreplace(s2, ', ...', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            MovieBase.CurrentMovie.Genre := AnsiUpFirstLetter(s2);
                        end;
                    end
                  else
                    begin
                      i := pos('></', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 6);
                          delete(s, 1, pos('>', s));
                          s2 := copy(s, 1, pos('</td></tr>', s) - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := stringreplace(s2, ', ...', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            MovieBase.CurrentMovie.Genre := AnsiUpFirstLetter(s2);
                        end;
                    end;
                end;
              tBudget := ''; //  
              if uBudget = 1 then
                begin
                  i := pos('></div>', s);
                  if i > 0 then
                    begin  
                      j := 0;
                      delete(s, 1, i + 12);
                      i := pos('</a></div></div>', s);
                      if i = 0 then
                        j := pos('</div></div></div>', s);
                      if (i > 0) or (j > 0) then
                        begin
                          if i > 0 then
                            s2 := copy(s, 1, i + 9);
                          if j > 0 then
                            s2 := copy(s, 1, i + 11);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tBudget := s2;
                              if cBudget = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>: </b>' + s2
                                  else
                                    Comment := Comment + ': ' + s2;
                                end;
                              if dBudget = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>: </b>' + s2
                                  else
                                    Descript := Descript + ': ' + s2;
                                end;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('></', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 8);
                          i := pos('</', s);
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tBudget := s2;
                              if cBudget = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>: </b>' + s2
                                  else
                                    Comment := Comment + ': ' + s2;
                                end;
                              if dBudget = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>: </b>' + s2
                                  else
                                    Descript := Descript + ': ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              tMarketing := ''; //
              if uMarketing = 1 then
                begin
                  i := pos('></', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 11);
                      i := pos('</', s);
                      s2 := '<' + copy(s, 1, i - 1);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          tMarketing := s2;
                          if cMarketing = 1 then
                            begin
                              if Comment <> '' then
                                Comment := Comment + ret;
                              if cBold = 1 then
                                Comment := Comment + '<b>: </b>' + s2
                              else
                                Comment := Comment + ': ' + s2;
                            end;
                          if dMarketing = 1 then
                            begin
                              if Descript <> '' then
                                Descript := Descript + ret;
                              if dBold = 1 then
                                Descript := Descript + '<b>: </b>' + s2
                              else
                                Descript := Descript + ': ' + s2;
                            end;
                        end;
                    end;
                end;
              tSborUS := '';
              tSborWord := '';
              tSborRF := '';
              tSborDVD := '';
              if uSbor = 1 then
                begin
                  i := pos('>  </div>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 17);
                      i := pos('</a></div></div>', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i + 9);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSborUS := s2;
                              if cSbor = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>  : </b>' + s2
                                  else
                                    Comment := Comment + '  : ' + s2;
                                end;
                              if dSbor = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>  : </b>' + s2
                                  else
                                    Descript := Descript + '  : ' + s2;
                                end;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('>  </', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 13);
                          i := pos('</', s);
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSborUS := s2;
                              if cSbor = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>  : </b>' + s2
                                  else
                                    Comment := Comment + '  : ' + s2;
                                end;
                              if dSbor = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>  : </b>' + s2
                                  else
                                    Descript := Descript + '  : ' + s2;
                                end;
                            end;
                        end;
                    end;
                  s := page;
                  i := pos('> DVD</', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 12);
                      i := pos('</', s);
                      s2 := '<' + copy(s, 1, i - 1);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          tSborDVD := s2;
                          if cSbor = 1 then
                            begin
                              if Comment <> '' then
                                Comment := Comment + ret;
                              if cBold = 1 then
                                Comment := Comment + '<b> DVD: </b>' + s2
                              else
                                Comment := Comment + ' DVD: ' + s2;
                            end;
                          if dSbor = 1 then
                            begin
                              if Descript <> '' then
                                Descript := Descript + ret;
                              if dBold = 1 then
                                Descript := Descript + '<b> DVD: </b>' + s2
                              else
                                Descript := Descript + ' DVD: ' + s2;
                            end;
                        end;
                    end;
                  s := page;
                  i := pos('>  </div>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 18);
                      i := pos('</a></div></div>', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i + 9);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := stringreplace(s2, '', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSborWord := s2;
                              if cSbor = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>  : </b>' + s2
                                  else
                                    Comment := Comment + '  : ' + s2;
                                end;
                              if dSbor = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>  : </b>' + s2
                                  else
                                    Descript := Descript + '  : ' + s2;
                                end;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('>  </', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 14);
                          i := pos('</', s);
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSborWord := s2;
                              if cSbor = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>  : </b>' + s2
                                  else
                                    Comment := Comment + '  : ' + s2;
                                end;
                              if dSbor = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>  : </b>' + s2
                                  else
                                    Descript := Descript + '  : ' + s2;
                                end;
                            end;
                        end;
                    end;
                  s := page;
                  i := pos('>  </div>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 20);
                      i := pos('</a></div></div>', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i + 9);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSborRF := s2;
                              if cSbor = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>  : </b>' + s2
                                  else
                                    Comment := Comment + '  : ' + s2;
                                end;
                              if dSbor = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>  : </b>' + s2
                                  else
                                    Descript := Descript + '  : ' + s2;
                                end;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('>  </', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 16);
                          i := pos('</', s);
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSborRF := s2;
                              if cSbor = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b>  : </b>' + s2
                                  else
                                    Comment := Comment + '  : ' + s2;
                                end;
                              if dSbor = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b>  : </b>' + s2
                                  else
                                    Descript := Descript + '  : ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              s := page;
              tPremDataWord := '';
              tPremDataRF := '';
              if uPremData = 1 then //
                begin
                  i := pos('> ()</', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 16);
                      i := pos('</a>', s);
                      s2 := '<a' + copy(s, 1, i - 1);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          tPremDataWord := s2;
                          if cPremData = 1 then
                            begin
                              if Comment <> '' then
                                Comment := Comment + ret;
                              if cBold = 1 then
                                Comment := Comment + '<b> (): </b>' + s2
                              else
                                Comment := Comment + ' (): ' + s2;
                            end;
                          if dPremData = 1 then
                            begin
                              if Descript <> '' then
                                Descript := Descript + ret;
                              if dBold = 1 then
                                Descript := Descript + '<b> (): </b>' + s2
                              else
                                Descript := Descript + ' (): ' + s2;
                            end;
                        end;
                    end
                  else
                    begin
                      s5 := s;
                      i := pos('>  </div>', s5);
                      if i > 0 then
                        begin
                          delete(s5, 1, i + 21);
                          i := pos('</div></div>', s5);
                          if i > 0 then
                            begin
                              s2 := copy(s5, 1, i + 5);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := stringreplace(s2, ', ...', '', [rfReplaceAll, rfIgnoreCase]);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tPremDataWord := s2;
                                  if cPremData = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> (): </b>' + s2
                                      else
                                        Comment := Comment + ' (): ' + s2;
                                    end;
                                  if dPremData = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> (): </b>' + s2
                                      else
                                        Descript := Descript + ' (): ' + s2;
                                    end;
                                end;
                            end;
                        end;
                    end;
                  i := pos('> ()</', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 15);
                      i := pos('</a>', s);
                      s2 := '<a' + copy(s, 1, i - 1);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          tPremDataRF := s2;
                          if cPremData = 1 then
                            begin
                              if Comment <> '' then
                                Comment := Comment + ret;
                              if cBold = 1 then
                                Comment := Comment + '<b> (): </b>' + s2
                              else
                                Comment := Comment + ' (): ' + s2;
                            end;
                          if dPremData = 1 then
                            begin
                              if Descript <> '' then
                                Descript := Descript + ret;
                              if dBold = 1 then
                                Descript := Descript + '<b> (): </b>' + s2
                              else
                                Descript := Descript + ' (): ' + s2;
                            end;
                        end;
                    end
                  else
                    begin
                      s5 := s;
                      i := pos('>  c</div>', s5);
                      if i > 0 then
                        begin
                          delete(s5, 1, i + 23);
                          i := pos('</div></div>', s5);
                          if i > 0 then
                            begin
                              s2 := copy(s5, 1, i + 5);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tPremDataRF := s2;
                                  if cPremData = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> (): </b>' + s2
                                      else
                                        Comment := Comment + ' (): ' + s2;
                                    end;
                                  if dPremData = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> (): </b>' + s2
                                      else
                                        Descript := Descript + ' (): ' + s2;
                                    end;
                                end;
                            end;
                        end;
                    end;
                end;
              s5 := s;
              tDVD := '';
              if uDVD = 1 then
                begin
                  i := pos('>  DVD</', s5);
                  if i > 0 then
                    begin
                      delete(s5, 1, i + 14);
                      i := pos('</td>', s5);
                      s2 := '<' + copy(s5, 1, i + 4);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          i := pos(',', s2);
                          if i > 0 then
                            s2 := copy(s2, 1, i - 1);
                          tDVD := s2;
                          if cDVD = 1 then
                            begin
                              if Comment <> '' then
                                Comment := Comment + ret;
                              if cBold = 1 then
                                Comment := Comment + '<b>  DVD: </b>' + s2
                              else
                                Comment := Comment + '  DVD: ' + s2;
                            end;
                          if dDVD = 1 then
                            begin
                              if Descript <> '' then
                                Descript := Descript + ret;
                              if dBold = 1 then
                                Descript := Descript + '<b>  DVD: </b>' + s2
                              else
                                Descript := Descript + '  DVD: ' + s2;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('>  DVD</div>', s5);
                      if i > 0 then
                        begin
                          Delete(s5, 1, i + 18);
                          i := pos('</div></div>', s5);
                          if i > 0 then
                            begin
                              s2 := copy(s5, 1, i + 11);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  i := pos(',', s2);
                                  if i > 0 then
                                    s2 := copy(s2, 1, i - 1);
                                  tDVD := s2;
                                  if cDVD = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>  DVD: </b>' + s2
                                      else
                                        Comment := Comment + '  DVD: ' + s2;
                                    end;
                                  if dDVD = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>  DVD: </b>' + s2
                                      else
                                        Descript := Descript + '  DVD: ' + s2;
                                    end;
                                end;
                            end;
                        end;
                    end;
                end;
              s5 := s;
              tBluRay := '';
              if uBluRay = 1 then
                begin
                  i := pos('>  Blu-ray</', s5);
                  if i > 0 then
                    begin
                      Delete(s5, 1, i + 18);
                      i := pos('</td>', s5);
                      s2 := '<' + copy(s5, 1, i + 4);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          i := pos(',', s2);
                          if i > 0 then
                            s2 := copy(s2, 1, i - 1);
                          tBluRay := s2;
                          if cBluRay = 1 then
                            begin
                              if Comment <> '' then
                                Comment := Comment + ret;
                              if cBold = 1 then
                                Comment := Comment + '<b>  Blu-Ray: </b>' + s2
                              else
                                Comment := Comment + '  Blu-Ray: ' + s2;
                            end;
                          if dBluRay = 1 then
                            begin
                              if Descript <> '' then
                                Descript := Descript + ret;
                              if dBold = 1 then
                                Descript := Descript + '<b>  Blu-Ray: </b>' + s2
                              else
                                Descript := Descript + '  Blu-Ray: ' + s2;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('>  Blu-ray</div>', s5);
                      if i > 0 then
                        begin
                          Delete(s5, 1, i + 22);
                          i := pos('</div></div>', s5);
                          if i > 0 then
                            begin
                              s2 := copy(s5, 1, i + 11);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  i := pos(',', s2);
                                  if i > 0 then
                                    s2 := copy(s2, 1, i - 1);
                                  tBluRay := s2;
                                  if cBluRay = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>  Blu-Ray: </b>' + s2
                                      else
                                        Comment := Comment + '  Blu-Ray: ' + s2;
                                    end;
                                  if dBluRay = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>  Blu-Ray: </b>' + s2
                                      else
                                        Descript := Descript + '  Blu-Ray: ' + s2;
                                    end;
                                end;
                            end;
                        end;
                    end;
                end;
              if uMPAA = 1 then // mpaa
                begin
                  i := pos('> MPAA</div>', s);
                  if i > 0 then
                    begin
                      Delete(s, 1, i + 18);
                      i := pos('</div></div></div>', s);
                      if i > 0 then
                        begin   
                          s2 := copy(s, 1, i + 11);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            MovieBase.CurrentMovie.MPAA := s2;
                        end;
                    end
                  else
                    begin
                      i := pos('> MPAA</', s);
                      if i > 0 then
                        begin
                          Delete(s, 1, i + 14);
                          i := pos('/rn/', s);
                          Delete(s, 1, i + 3);
                          i := pos('/', s);
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            MovieBase.CurrentMovie.MPAA := s2;
                        end;
                    end;
                end;
              if uDuration = 1 then // 
                begin
                  i := pos('></', s);
                  if i > 0 then
                    begin
                      Delete(s, 1, i + 7);
                      i := pos('</', s);
                      s2 := '<' + copy(s, 1, i - 1);
                      s2 := HTMLRemoveTags(s2);
                      s2 := HTMLDecode(s2);
                      s2 := trim(s2);
                      if (s2 <> '') and (s2 <> '-') then
                        begin
                          if uDurationOtherFormat = 1 then
                            begin
                              s4 := s2;
                              i := pos('', s2);
                              if i > 0 then
                                begin
                                  s2 := trim(copy(s2, 1, i - 1));
                                  try
                                    i := StrToInt(s2);
                                    j := i div 60;
                                    i := i mod 60;
                                    s2 := IntToStr(j);
                                    s3 := IntToStr(i);
                                    if length(s3) = 1 then
                                      s3 := '0' + s3;
                                    s2 := s2 + ':' + s3;
                                  except
                                    s2 := s4;
                                  end;
                                end;
                            end;
                          MovieBase.CurrentMovie.Duration := s2;
                        end;
                    end
                  else
                    begin
                      i := pos('></div>', s);
                      if i > 0 then
                        begin
                          Delete(s, 1, i + 11);
                          i := pos('</div></div></div>', s);
                          if i > 0 then
                            begin
                              s2 := copy(s, 1, i + 11);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  if uDurationOtherFormat = 1 then
                                    begin
                                      s4 := s2;
                                      i := pos('', s2);
                                      if i > 0 then
                                        begin
                                          s2 := trim(copy(s2, 1, i - 1));
                                          try
                                            i := StrToInt(s2);
                                            j := i div 60;
                                            i := i mod 60;
                                            s2 := IntToStr(j);
                                            s3 := IntToStr(i);
                                            if length(s3) = 1 then
                                              s3 := '0' + s3;
                                            s2 := s2 + ':' + s3;
                                          except
                                            s2 := s4;
                                          end;
                                        end;
                                    end;
                                  MovieBase.CurrentMovie.Duration := s2;
                                end;
                            end;
                        end;
                    end;
                end;
              s := page;
              tRatingKinoPoisk := '';
              tRatingIMDb := '';
              tRatingKritikov := '';
              RatingKinoPoisk := 0;
              if (uRatingKinoPoisk = 1) or (UseRatingKinoPoisk + uRating = 2) then // kinopoisk
                begin
                  i := Pos('<a href="/film/' + FullMovieCode + '/votes/', s);
                  if i = 0 then
                    i := Pos('<a href="/film/' + MovieCode + '/votes/', s);
                  if i > 0 then
                    begin
                      Delete(s, 1, i - 1);
                      i := Pos('<a ', s);
                      j := Pos('</div>', s);
                      if (i > 0) and (j > 0) then
                        begin
                          j := j + 6;
                          s2 := copy(s, i, j - i);
                          s2 := stringreplace(s2, 'ratingCount">', 'ratingCount"> (',[rfReplaceAll, rfIgnoreCase]);
                          s2 := ClearHTML(s2);
                          s2 := StringReplace(s2, #10, '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := StringReplace(s2, #13, '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := s2 + ')';
                          i := Pos('>To250:', s);
                          if i = 0 then
                            i := Pos('>250:', s);
                          if i > 0 then
                            begin
                              j := MyPos('</a>', s, i);
                              s3 := '<' + copy(s, i, j - i);
                              s3 := HTMLRemoveTags(s3);
                              s3 := HTMLDecode(s3);
                              s3 := trim(s3);
                              if s3 <> '' then
                                s2 := s2 + ', ' + s3;
                            end;
                          if length(s2) > 0 then
                            begin
                              s3 := s2;
                              i := pos('.', s3);
                              if i > 0 then
                                Delete(s3, i, 1)
                              else
                                i := 2;
                              s3 := copy(s3, 1, i);
                              try
                                RatingKinoPoisk := StrToInt(s3);
                              except
                              end;
                              if (uRatingKinoPoisk = 1) and (RatingKinoPoisk > 0) then
                                begin
                                  tRatingKinoPoisk := s2;
                                  if cRatingKinoPoisk = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> : </b>' + s2
                                      else
                                        Comment := Comment + ' : ' + s2;
                                    end;
                                  if dRatingKinoPoisk = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> : </b>' + s2
                                      else
                                        Descript := Descript + ' : ' + s2;
                                    end;
                                end;
                            end;
                        end;
                    end
                  else
                    begin
                      s2 := s;
                      i := Pos('.rating.kinopoisk":{"value":', s2);
                      if i > 0 then
                        begin
                          Delete(s2, 1, i + 27);
                          i := Pos(',"count":', s2);
                          s3 := copy(s2, 1, i - 1) + ' (';
                          Delete(s2, 1, i + 8);
                          s3 := s3 + copy(s2, 1, Pos(',"', s2) - 1) + ')';
                          s3 := trim(s3);
                          if length(s3) > 0 then
                            begin
                              s4 := s3;
                              i := pos('.', s4);
                              if i > 0 then
                                Delete(s4, i, 1)
                              else
                                i := 2;
                              s4 := copy(s4, 1, i);
                              try
                                RatingKinoPoisk := StrToInt(s4);
                              except
                              end;
                              if (uRatingKinoPoisk = 1) and (RatingKinoPoisk > 0) then
                                begin
                                  tRatingKinoPoisk := s3;
                                  if cRatingKinoPoisk = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> : </b>' + s3
                                      else
                                        Comment := Comment + ' : ' + s3;
                                    end;
                                  if dRatingKinoPoisk = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> : </b>' + s3
                                      else
                                        Descript := Descript + ' : ' + s3;
                                    end;
                                end;
                            end;
                        end
                      else
                        begin
                          s2 := s;
                          i := Pos('%22kinopoisk%22:%7B%22value%22:', s2);
                          if i > 0 then
                            begin
                              Delete(s2, 1, i + 30);
                              i := Pos(',%22count%22:', s2);
                              s3 := copy(s2, 1, i - 1) + ' (';
                              Delete(s2, 1, i + 12);
                              s3 := s3 + copy(s2, 1, Pos(',%', s2) - 1) + ')';
                              s3 := trim(s3);
                              if length(s3) > 0 then
                                begin
                                  s4 := s3;
                                  i := pos('.', s4);
                                  if i > 0 then
                                    Delete(s4, i, 1)
                                  else
                                    i := 2;
                                  s4 := copy(s4, 1, i);
                                  try
                                    RatingKinoPoisk := StrToInt(s4);
                                  except
                                  end;
                                  if (uRatingKinoPoisk = 1) and (RatingKinoPoisk > 0) then
                                    begin
                                      tRatingKinoPoisk := s3;
                                      if cRatingKinoPoisk = 1 then
                                        begin
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          if cBold = 1 then
                                            Comment := Comment + '<b> : </b>' + s3
                                          else
                                            Comment := Comment + ' : ' + s3;
                                        end;
                                      if dRatingKinoPoisk = 1 then
                                        begin
                                          if Descript <> '' then
                                            Descript := Descript + ret;
                                          if dBold = 1 then
                                            Descript := Descript + '<b> : </b>' + s3
                                          else
                                            Descript := Descript + ' : ' + s3;
                                        end;
                                    end;
                                end;
                            end;
                        end;
                    end;
                end;
              s := page;
              RatingIMDb := 0;
              if (uRatingIMDb = 1) or (UseRatingIMDb + uRating = 2) then // imdb
                begin
                  i := pos('IMDB: ', s);
                  if i = 0 then
                    i := pos('IMDb: ', s);
                  if i > 0 then
                    begin
                      Delete(s, 1, i + 5);
                      i := pos(' ', s);
                      j := pos(')', s);
                      s2 := copy(s, 1, i - 1);
                      s3 := copy(s, 1, j);
                      s3 := HTMLRemoveTags(s3);
                      s3 := HTMLDecode(s3);
                      s3 := trim(s3);
                      if uRatingIMDb = 1 then
                        begin
                          if (s3 <> '') and (s3 <> '-') then
                            begin
                              tRatingIMDb := s3;
                              if cRatingIMDb = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if cBold = 1 then
                                    Comment := Comment + '<b> IMDb: </b>' + s3
                                  else
                                    Comment := Comment + ' IMDb: ' + s3;
                                end;
                              if dRatingIMDb = 1 then
                                begin
                                  if Descript <> '' then
                                    Descript := Descript + ret;
                                  if dBold = 1 then
                                    Descript := Descript + '<b> IMDb: </b>' + s3
                                  else
                                    Descript := Descript + ' IMDb: ' + s3;
                                end;
                            end;
                        end;
                      i := pos('.', s2);
                      if i > 0 then
                        Delete(s2, i, 1)
                      else
                        i := 2;
                      s2 := copy(s2, 1, i);
                      try
                        RatingIMDb := StrToInt(s2);
                      except
                      end;
                    end
                  else
                    begin
                      s2 := s;
                      i := Pos('.rating.imdb":{"value":', s2);
                      if i > 0 then
                        begin
                          Delete(s2, 1, i + 22);
                          i := Pos(',"count":', s2);
                          s3 := copy(s2, 1, i - 1);
                          s3 := trim(s3);
                          Delete(s2, 1, i + 8);
                          s4 := copy(s2, 1, Pos(',"', s2) - 1);
                          s4 := trim(s4);
                          if uRatingIMDb = 1 then
                            begin
                              if (s4 <> '') and (s4 <> '-') then
                                begin
                                  tRatingIMDb := s4;
                                  if cRatingIMDb = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> IMDb: </b>' + s4
                                      else
                                        Comment := Comment + ' IMDb: ' + s4;
                                    end;
                                  if dRatingIMDb = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> IMDb: </b>' + s4
                                      else
                                        Descript := Descript + ' IMDb: ' + s4;
                                    end;
                                end;
                            end;
                          i := pos('.', s3);
                          if i > 0 then
                            Delete(s3, i, 1)
                          else
                            i := 2;
                          s3 := copy(s3, 1, i);
                          try
                            RatingIMDb := StrToInt(s3);
                          except
                          end;
                        end
                      else
                        begin
                          s2 := s;
                          i := Pos('%22imdb%22:%7B%22value%22:', s2);
                          if i > 0 then
                            begin
                              Delete(s2, 1, i + 25);
                              i := Pos(',%22count%22:', s2);
                              s3 := copy(s2, 1, i - 1);
                              s3 := trim(s3);
                              Delete(s2, 1, i + 12);
                              s4 := copy(s2, 1, Pos(',%', s2) - 1);
                              s4 := trim(s4);
                              if uRatingIMDb = 1 then
                                begin
                                  if (s4 <> '') and (s4 <> '-') then
                                    begin
                                      tRatingIMDb := s4;
                                      if cRatingIMDb = 1 then
                                        begin
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          if cBold = 1 then
                                            Comment := Comment + '<b> IMDb: </b>' + s4
                                          else
                                            Comment := Comment + ' IMDb: ' + s4;
                                        end;
                                      if dRatingIMDb = 1 then
                                        begin
                                          if Descript <> '' then
                                            Descript := Descript + ret;
                                          if dBold = 1 then
                                            Descript := Descript + '<b> IMDb: </b>' + s4
                                          else
                                            Descript := Descript + ' IMDb: ' + s4;
                                        end;
                                    end;
                                end;
                              i := pos('.', s3);
                              if i > 0 then
                                Delete(s3, i, 1)
                              else
                                i := 2;
                              s3 := copy(s3, 1, i);
                              try
                                RatingIMDb := StrToInt(s3);
                              except
                              end;
                            end;
                        end;
                    end;
                end;
              s := page;
              RatingKritikov := 0;
              if (uRatingKritikov = 1) or (UseRatingKritikov + uRating = 2) then // 
                begin
                  i := pos('.rating.worldwideCritics":{"value":', s);
                  if i > 0 then
                    begin
                      s2 := '';
                      s4 := '';
                      delete(s, 1, i + 34);
                      i := pos(',"percent":', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i - 1);     //7.4
                          delete(s, 1, i + 10);
                          i := pos(',"count":', s);
                          s4 := copy(s, 1, i - 1);     //90
                          if s4 <> 'null' then
                            begin
                              s3 := '';
                              delete(s, 1, i + 8);
                              s5 := copy(s, 1, pos(',"', s) - 1);
                              if s5 <> 'null' then
                                begin
                                  i := pos(',"positiveCount":', s);
                                  if i > 0 then
                                    begin
                                      delete(s, 1, i + 16);
                                      i := pos(',"negativeCount":', s);
                                      s3 := copy(s, 1, i - 1);
                                      delete(s, 1, i + 16);
                                      if s3 <> 'null' then
                                        s4 := ' (' + s4 + '%, ' + s3 + ' + ' + copy(s, 1, pos(',"', s) - 1) + ' = ' + s5  + ')' // (90%, 96 + 11 = 107)
                                      else
                                        s4 := ' (' + s4 + '%)'; // (90%)
                                    end;
                                end;   
                              s3 := s2 + s4;
                              if uRatingKritikov = 1 then
                                begin
                                  if (s3 <> '') and (s3 <> '-') then
                                    begin
                                      tRatingKritikov := trim(s3);
                                      if cRatingKritikov = 1 then
                                        begin
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          if cBold = 1 then
                                            Comment := Comment + '<b> : </b>' + trim(s3)
                                          else
                                            Comment := Comment + ' : ' + trim(s3);
                                        end;
                                      if dRatingKritikov = 1 then
                                        begin
                                          if Descript <> '' then
                                            Descript := Descript + ret;
                                          if dBold = 1 then
                                            Descript := Descript + '<b> : </b>' + trim(s3)
                                          else
                                            Descript := Descript + ' : ' + trim(s3);
                                        end;
                                    end;
                                end;
                            end;
                          if s2 <> 'null' then
                            begin
                              i := pos('.', s2);
                              if i > 0 then
                                delete(s2, i, 1)
                              else
                                i := 2;
                              s2 := copy(s2, 1, i);
                              try
                                RatingKritikov := StrToInt(s2);
                              except
                              end;
                            end;
                        end;
                    end
                  else
                    begin
                      i := pos('> <', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i);
                          s4 := '';
                          i := pos('<span class="num">', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 17);
                              j := pos('</span>', s);
                              s4 := trim(copy(s, 1, j - 1));  //90
                              if s4 <> '' then
                                begin
                                  s2 := '';
                                  i := pos('<span class="el1">', s);
                                  if i > 0 then
                                    begin
                                      delete(s, 1, i + 17);
                                      j := pos('<div', s);
                                      s2 := trim(copy(s, 1, j - 1));
                                      s2 := HTMLRemoveTags(s2);   //96 + 11 = 107
                                    end;
                                  if s2 <> '' then
                                    s4 := ' (' + s4 + '%, ' + s2 + ')'   // (90%, 96 + 11 = 107)
                                  else
                                    s4 := ' (' + s4 + '%)';   // (90%)
                                end;
                              s2 := '';
                              i := pos('<div class="star"><s></s>', s);
                              if i > 0 then
                                begin
                                  delete(s, 1, i + 24);
                                  j := pos('</div>', s);
                                  s2 := trim(copy(s, 1, j - 1));   //7.4
                                end;
                              s3 := s2 + s4;                       //7.4 (90%, 96 + 11 = 107)
                              if uRatingKritikov = 1 then
                                begin
                                  if (s3 <> '') and (s3 <> '-') then
                                    begin
                                      tRatingKritikov := trim(s3);
                                      if cRatingKritikov = 1 then
                                        begin
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          if cBold = 1 then
                                            Comment := Comment + '<b> : </b>' + trim(s3)
                                          else
                                            Comment := Comment + ' : ' + trim(s3);
                                        end;
                                      if dRatingKritikov = 1 then
                                        begin
                                          if Descript <> '' then
                                            Descript := Descript + ret;
                                          if dBold = 1 then
                                            Descript := Descript + '<b> : </b>' + trim(s3)
                                          else
                                            Descript := Descript + ' : ' + trim(s3);
                                        end;
                                    end;
                                end;
                            end;
                          i := pos('.', s2);
                          if i > 0 then
                            delete(s2, i, 1)
                          else
                            i := 2;
                          s2 := copy(s2, 1, i);
                          try
                            RatingKritikov := StrToInt(s2);
                          except
                          end;
                        end;
                    end;
                end;
              if uRating = 1 then
                begin
                  MovieBase.CurrentMovie.Rating := 0;
                  if UseRatingKinoPoisk = 0 then
                    RatingKinoPoisk := 0;
                  if UseRatingIMDb = 0 then
                    RatingIMDb := 0;
                  if UseRatingKritikov = 0 then
                    RatingKritikov := 0;
                  if RatingKinoPoisk = 0 then
                    UseRatingKinoPoisk := 0;
                  if RatingIMDb = 0 then
                    UseRatingIMDb := 0;
                  if RatingKritikov = 0 then
                    UseRatingKritikov := 0;
                  if (UseRatingKinoPoisk + UseRatingIMDb + UseRatingKritikov) > 0 then
                    MovieBase.CurrentMovie.Rating := Round((RatingIMDb + RatingKinoPoisk + RatingKritikov) /
                                                           (UseRatingKinoPoisk + UseRatingIMDb + UseRatingKritikov));
                end;
              if MaxStudio + MaxVisualEffectsStudio + MaxVoiceStudio + MaxProkatStudio > 0 then
                begin //,    
                  if (Pos('href="/film/' + FullMovieCode + '/studio/', page) > 0) or
                     (Pos('href="/film/' + MovieCode + '/studio/', page) > 0)
                  then
                    begin
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/studio/',
                                                '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := Pos(FindBlocking, page2);
                      if (i > 0) or (page2 = '') then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/studio/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/studio/',
                                                   '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := Pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free;
                              Form.Free;
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      if page2 <> '' then
                        begin
                          if SaveSourceCode = 1 then
                            SaveResultHtmlText(page2, 'MovieStudios' + MovieCode);
                          Studio := '';
                          if MaxStudio > 0 then
                            begin
                              kol := 0;
                              i := Pos('>:</b></td>', page2);
                              if i > 0 then
                                begin
                                  delete(page2, 1, i - 1);
                                  i := Pos('<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                  s2 := copy(page2, 1, i - 1);
                                  repeat
                                    i := Pos('/" class="all">', s2);
                                    if i > 0 then
                                      begin
                                        delete(s2, 1, i + 14);
                                        j := Pos('</a>', s2);
                                        s := copy(s2, 1, j - 1);
                                        delete(s2, 1, j + 3);
                                        s := HTMLRemoveTags(s); 
                                        s := ReplaceLatinExt(s);
                                        s := HTMLDecode(s);
                                        if Studio <> '' then
                                          Studio := Studio + ', ';
                                        Studio := Studio + trim(s);
                                        kol := kol + 1;
                                      end;
                                  until (i = 0) or (kol >= MaxStudio);
                                end;
                            end;
                          tVisualEffectsStudio := '';
                          if MaxVisualEffectsStudio > 0 then
                            begin
                              kol := 0;
                              i := Pos('>:</b></td>', page2);
                              if i > 0 then
                                begin
                                  delete(page2, 1, i - 1);
                                  i := Pos('<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                  s2 := copy(page2, 1, i - 1);
                                  repeat
                                    i := Pos('/" class="all">', s2);
                                    if i > 0 then
                                      begin
                                        delete(s2, 1, i + 14);
                                        j := Pos('</a>', s2);
                                        s := copy(s2, 1, j - 1);
                                        delete(s2, 1, j + 3);
                                        s := HTMLRemoveTags(s);
                                        s := ReplaceLatinExt(s);
                                        s := HTMLDecode(s);
                                        if tVisualEffectsStudio <> '' then
                                          tVisualEffectsStudio := tVisualEffectsStudio + ', ';
                                        tVisualEffectsStudio := tVisualEffectsStudio + trim(s);
                                        kol := kol + 1;
                                      end;
                                  until (i = 0) or (kol >= MaxVisualEffectsStudio);
                                end;
                            end;
                          if tVisualEffectsStudio <> '' then
                            begin
                              if VisualEffectsStudio = 1 then
                                begin
                                  Studio := Studio + ', ' + trim(tVisualEffectsStudio);
                                  tVisualEffectsStudio := '';
                                end
                              else
                                begin
                                  if cStudio = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>: </b>' + tVisualEffectsStudio
                                      else
                                        Comment := Comment + ': ' + tVisualEffectsStudio;
                                    end;
                                  if dStudio = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>: </b>' + tVisualEffectsStudio
                                      else
                                        Descript := Descript + ': ' + tVisualEffectsStudio;
                                    end;
                                end;
                            end;
                          tVoiceStudio := '';
                          if MaxVoiceStudio > 0 then
                            begin
                              kol := 0;
                              i := Pos('> :</b></td>', page2);
                              if i > 0 then
                                begin
                                  delete(page2, 1, i - 1);
                                  i := Pos('<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                  s2 := copy(page2, 1, i - 1);
                                  repeat
                                    i := Pos('/" class="all">', s2);
                                    if i > 0 then
                                      begin
                                        delete(s2, 1, i + 14);
                                        j := Pos('</a>', s2);
                                        s := copy(s2, 1, j - 1);
                                        delete(s2, 1, j + 3);
                                        s := HTMLRemoveTags(s);
                                        s := ReplaceLatinExt(s);
                                        s := HTMLDecode(s);
                                        if tVoiceStudio <> '' then
                                          tVoiceStudio := tVoiceStudio + ', ';
                                        tVoiceStudio := tVoiceStudio + trim(s);
                                        kol := kol + 1;
                                      end;
                                  until (i = 0) or (kol >= MaxVoiceStudio);
                                end;
                            end;
                          if tVoiceStudio <> '' then
                            begin
                              if VoiceStudio = 1 then
                                begin
                                  Studio := Studio + ', ' + trim(tVoiceStudio);
                                  tVoiceStudio := '';
                                end
                              else
                                begin
                                  if cStudio = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> : </b>' + tVoiceStudio
                                      else
                                        Comment := Comment + ' : ' + tVoiceStudio;
                                    end;
                                  if dStudio = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> : </b>' + tVoiceStudio
                                      else
                                        Descript := Descript + ' : ' + tVoiceStudio;
                                    end;
                                end;
                            end;
                          tProkatStudio := '';
                          if MaxProkatStudio > 0 then
                            begin
                              kol := 0;
                              i := Pos('>:</b></td>', page2);
                              if i > 0 then
                                begin
                                  delete(page2, 1, i - 1);
                                  i := Pos('<tr><td colspan=3 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                  s2 := copy(page2, 1, i - 1);
                                  repeat
                                    i := Pos('/" class="all">', s2);
                                    if i > 0 then
                                      begin
                                        delete(s2, 1, i + 14);
                                        j := Pos('</a>', s2);
                                        s := copy(s2, 1, j - 1);
                                        delete(s2, 1, j + 3);
                                        s := HTMLRemoveTags(s);
                                        s := ReplaceLatinExt(s);
                                        s := HTMLDecode(s);
                                        if tProkatStudio <> '' then
                                          tProkatStudio := tProkatStudio + ', ';
                                        tProkatStudio := tProkatStudio + trim(s);
                                        kol := kol + 1;
                                      end;
                                  until (i = 0) or (kol >= MaxProkatStudio);
                                end;
                            end;
                          if tProkatStudio <> '' then
                            begin
                              if ProkatStudio = 1 then
                                begin
                                  Studio := Studio + ', ' + trim(tProkatStudio);
                                  tProkatStudio := '';
                                end
                              else
                                begin
                                  if cStudio = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>: </b>' + tProkatStudio
                                      else
                                        Comment := Comment + ': ' + tProkatStudio;
                                    end;
                                  if dStudio = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>: </b>' + tProkatStudio
                                      else
                                        Descript := Descript + ': ' + tProkatStudio;
                                    end;
                                end;
                            end;
                           Studio := trim(Studio);
                          if Studio <> '' then
                            MovieBase.CurrentMovie.Studio := Studio;
                        end;
                    end;
                end;
              if Descript <> '' then
                begin
                  if Description <> '' then
                    begin
                      if dInsertTegHR = 1 then
                        Description := Description + ret + '<hr>'
                      else
                        Description := Description + ret + ret;
                    end;
                  Description := Description + Descript;
                end;
              tProducer := '';
              tOperator := '';
              tComposer := '';
              tVoiceDirector := '';
              tVoice := '';
              tPainter := '';
              tCutter := '';
              tTranslator := '';
              if (MaxDirector + MaxScenario + MaxActors + MaxProducer + MaxOperator + MaxComposer +
                  MaxVoiceDirector + MaxVoice + MaxPainter + MaxCutter + MaxTranslator) > 0
              then
                begin
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/',
                                            '  .....');
                    Application.ProcessMessages;
                  except
                    page2 := '';
                  end;
                  i := pos(FindBlocking, page2);
                  if (i > 0) or (page2 = '') then
                    begin
                      ShowMessage('    ');
                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/');
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/',
                                                '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := pos(FindBlocking, page2);
                      if (i > 0) or (page2 = '') then
                        begin
                          ShowMessage('    ');
                          MovieBase.Free;
                          Form.Free;
                          LoadInfo.Destroy;
                          Exit;
                        end;
                    end;
                  if page2 <> '' then //   
                    begin
                      if SaveSourceCode = 1 then
                        SaveResultHtmlText(page2, 'MovieCasts' + MovieCode);
                      if MaxDirector > 0 then //
                        begin
                          if Serial = 1 then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                        '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                            end;
                          Director := FindNames('></div>', page2, MaxDirector);
                          if Director = '' then
                            Director := FindNames('></div>', page2, MaxDirector);
                          if Director = '' then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                        '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              i := pos(FindBlocking, page3);
                              if (i > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              Director := FindNames('></div>', page3, MaxDirector);
                              if Director = '' then
                                Director := FindNames('></div>', page3, MaxDirector);
                            end;
                          if Director <> '' then
                            MovieBase.CurrentMovie.Director := Director;
                        end;
                      if MaxScenario > 0 then //
                        begin
                          if Serial = 1 then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                        '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                            end;
                          Scenario := FindNames('></div>', page2, MaxScenario);
                          if Scenario = '' then
                            Scenario := FindNames('></div>', page2, MaxScenario);
                          if Scenario = '' then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                        '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              i := pos(FindBlocking, page3);
                              if (i > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              Scenario := FindNames('></div>', page3, MaxScenario);
                              if Scenario = '' then
                                Scenario := FindNames('></div>', page3, MaxScenario);
                            end;
                          if Scenario <> '' then
                            MovieBase.CurrentMovie.Scenario := Scenario;
                        end;
                      if MaxActors > 0 then //
                        begin
                          if Serial = 1 then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/actor/',
                                                        '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/actor/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/actor/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                            end;
                          Actors := FindNames('></div>', page2, MaxActors);
                          if Actors = '' then
                            Actors := FindNames('></div>', page2, MaxActors);
                          if Actors <> '' then
                            MovieBase.CurrentMovie.Actors := Actors;
                        end;
                      DodPol := 0; // 1 -     , 0 - 
                      if (MaxProducer + MaxOperator + MaxComposer + MaxVoiceDirector + MaxVoice + MaxPainter + MaxCutter + MaxTranslator) > 0 then
                        begin
                          cAllOther := '';
                          dAllOther := '';
                          if MaxProducer > 0 then //
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/producer/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/producer/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/producer/',
                                                                '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := '';
                              Other := FindNames('></div>', page2, MaxProducer);
                              if Other = '' then
                                Other := FindNames('></div>', page2, MaxProducer);
                              if Other <> '' then
                                begin
                                  tProducer := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + ': ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + ': ' + trim(Other);
                                        end;
                                    end;
                                end;
                            end;
                          if MaxOperator > 0 then //
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/operator/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/operator/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/operator/',
                                                                '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := '';
                              Other := FindNames('></div>', page2, MaxOperator);
                              if Other = '' then
                                Other := FindNames('></div>', page2, MaxOperator);
                              if Other <> '' then
                                begin
                                  tOperator := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + ': ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + ': ' + trim(Other);
                                        end;
                                    end;
                                end;
                            end;
                          if MaxComposer > 0 then //
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/composer/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/composer/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/composer/',
                                                                '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := '';
                              Other := FindNames('></div>', page2, MaxComposer);
                              if Other = '' then
                                Other := FindNames('></div>', page2, MaxComposer);
                              if Other <> '' then
                                begin
                                  tComposer := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + ': ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + ': ' + trim(Other);
                                        end;
                                    end;
                                end;
                            end;
                          if MaxVoiceDirector > 0 then //c 
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice_director/',
                                                            '   .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice_director/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice_director/',
                                                                '   .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := 'c ';
                              Other := FindNames('> </div>', page2, MaxVoiceDirector);
                              if Other = '' then
                                Other := FindNames('> </div>', page2, MaxVoiceDirector);
                              if Other <> '' then
                                begin
                                  tVoiceDirector := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b>c : </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + 'c : ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b>c : </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + 'c : ' + trim(Other);
                                        end;
                                    end
                                end;
                            end;
                          if MaxVoice > 0 then //  ( )
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice/',
                                                            '   .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice/',
                                                                '   .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := ' ';
                              Other := FindNames('> </div>', page2, MaxVoice);
                              if Other = '' then
                                Other := FindNames('> </div>', page2, MaxVoice);
                              if Other <> '' then
                                begin
                                  tVoice := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b> : </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + ' : ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b> : </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + ' : ' + trim(Other);
                                        end;
                                    end
                                end;
                            end;
                          if MaxPainter > 0 then //
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/design/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/design/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/design/',
                                                                '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := '';
                              Other := FindNames('></div>', page2, MaxPainter);
                              if Other = '' then
                                Other := FindNames('></div>', page2, MaxPainter);
                              if Other <> '' then
                                begin
                                  tPainter := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + ': ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + ': ' + trim(Other);
                                        end;
                                    end;
                                end;
                            end;
                          if MaxCutter > 0 then //
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/editor/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/editor/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/editor/',
                                                                '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := '';
                              Other := FindNames('></div>', page2, MaxCutter);
                              if Other = '' then
                                Other := FindNames('></div>', page2, MaxCutter);
                              if Other <> '' then
                                begin
                                  tCutter := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + ': ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + ': ' + trim(Other);
                                        end;
                                    end;
                                end;
                            end;
                          if MaxTranslator > 0 then //
                            begin
                              if Serial = 1 then
                                begin
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/translator/',
                                                            '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/translator/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/translator/',
                                                                '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page2 := '';
                                      end;
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                end;
                              DodPolName := '';
                              Other := FindNames('></div>', page2, MaxTranslator);
                              if Other = '' then
                                Other := FindNames('></div>', page2, MaxTranslator);
                              if Other <> '' then
                                begin
                                  tTranslator := trim(Other);
                                  DodPolPoz := PosName(DodPolName);
                                  if DodPolPoz <> 1000 then
                                    MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz, trim(Other))
                                  else
                                    begin
                                      if cOtherName = 1 then
                                        begin
                                          if cAllOther <> '' then
                                            cAllOther := cAllOther + ret;
                                          if cBold = 1 then
                                            cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            cAllOther := cAllOther + ': ' + trim(Other);
                                        end;
                                      if dOtherName = 1 then
                                        begin
                                          if dAllOther <> '' then
                                            dAllOther := dAllOther + ret;
                                          if dBold = 1 then
                                            dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                          else
                                            dAllOther := dAllOther + ': ' + trim(Other);
                                        end;
                                    end;
                                end;
                            end;
                          if cAllOther <> '' then
                            begin
                              if Comment <> '' then
                                begin
                                  if cInsertTegHR = 1 then
                                    Comment := Comment + ret + '<hr>'
                                  else
                                    Comment := Comment + ret + ret;
                                end;
                              Comment := Comment + trim(cAllOther);
                            end;
                          if dAllOther <> '' then
                            begin
                              if Description <> '' then
                                begin
                                  if dInsertTegHR = 1 then
                                    Description := Description + ret + '<hr>'
                                  else
                                    Description := Description + ret + ret;
                                end;
                              Description := Description + trim(dAllOther);
                            end;
                        end;
                    end;
                  page2 := '';
                end;
              tAwards := '';
              if uAwards = 1 then //
                begin //,    
                  if (Pos('href="/film/' + FullMovieCode + '/awards/', page) > 0) or
                     (Pos('href="/film/' + MovieCode + '/awards/', page) > 0)
                  then
                    begin
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/awards/', '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := Pos(FindBlocking, page2);
                      if (i > 0) or (page2 = '') then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/awards/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/awards/',
                                                    '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := Pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free;
                              Form.Free;
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      if page2 <> '' then
                        begin
                          if SaveSourceCode = 1 then
                            SaveResultHtmlText(page2, 'MovieAwards' + MovieCode);
                          i := Pos('class=all> ', page2);
                          if i > 0 then
                            begin
                              Awards := '<b>:</b>';
                              delete(page2, 1, i - 1);
                              //      ,   . 
                              i := Pos('<div style="background-color:#f2f2f2;padding:15px">', page2);
                              if i > 0 then
                                begin
                                  delete(page2, 1, i - 1);
                                  i := Pos('</div>', page2);
                                  s := copy(page2, 1, i - 1);
                                  s := HTMLRemoveTags(s);
                                  s := HTMLDecode(s);
                                  Awards := Awards + ret + trim(s);
                                end;
                              repeat //    
                                i := Pos('<b><a href="/awards/', page2);
                                if i > 0 then
                                  begin
                                    j := Pos('<b><a href="/awards/', page2);
                                    delete(page2, 1, j + 12);
                                    j := Pos('</a></b></td>', page2);
                                    s := copy(page2, 1, j - 1);
                                    jj := Pos('="all">', s);
                                    delete(s, 1, jj + 6);
                                    s := HTMLRemoveTags(s);
                                    s := HTMLDecode(s);
                                    if Awards = '<b>:</b>' then
                                      Awards := Awards + ret + '<b><u>' + trim(s) + '</u></b>'
                                    else
                                      Awards := Awards + ret + ret + '<b><u>' + trim(s) + '</u></b>';
                                    delete(page2, 1, j + 12);
                                    ii := Pos('<tr><td class="news">&nbsp;</td></tr>', page2);
                                    s2 := copy(page2, 1, ii - 1);
                                    repeat
                                      ii := Pos('<tr><td class="news" style="padding: 10px; color: #777">', s2);
                                      if ii > 0 then
                                        begin
                                          delete(s2, 1, ii + 55);
                                          j := Pos('</td></tr>', s2);
                                          s := copy(s2, 1, j - 1);
                                          delete(s2, 1, j + 9);
                                          Awards := Awards + ret + trim(s) + ' ';
                                          j := Pos('<ul class="trivia">', s2);
                                          delete(s2, 1, j - 1);
                                          j := Pos('</ul>', s2);
                                          s := copy(s2, 1, j - 1);
                                          s := stringreplace(s, #13, '', [rfReplaceAll, rfIgnoreCase]);
                                          s := stringreplace(s, #10, '', [rfReplaceAll, rfIgnoreCase]);
                                          s := ReplaceTagWithChar(s, '</li>', ';');
                                          s := HTMLRemoveTags(s);
                                          s := stringreplace(s, '  ', '', [rfReplaceAll]);
                                          s := HTMLDecode(s);
                                          s[Length(s)] := ' ';
                                          Awards := Awards + trim(s);
                                        end;
                                    until (ii = 0);
                                  end;
                              until (i = 0);
                            end;
                          if Awards <> '<b>:</b>' then
                            begin
                              Awards := stringreplace(Awards, ' ;', ';', [rfReplaceAll, rfIgnoreCase]);
                              if cAwards = 1 then
                                begin
                                  if Comment <> '' then
                                    begin
                                      if cInsertTegHR = 1 then
                                        Comment := Comment + ret + '<hr>'
                                      else
                                        Comment := Comment + ret + ret;
                                    end;
                                  Comment := Comment + Awards;
                                end;
                              if dAwards = 1 then
                                begin
                                  if Description <> '' then
                                    begin
                                      if dInsertTegHR = 1 then
                                        Description := Description + ret + '<hr>'
                                      else
                                        Description := Description + ret + ret;
                                    end;
                                  Description := Description + Awards;
                                end;
                              delete(Awards, 1, 17);
                              tAwards := Awards;
                            end;
                        end;
                    end;
                  page2 := '';
                end;
              tLinks := '';
              if uLinks = 1 then //
                begin //,    
                  page2 := '';
                  if (Pos('href="/film/' + FullMovieCode + '/other/', page) > 0) or
                     (Pos('href="/film/' + MovieCode + '/other/', page) > 0)
                  then
                    begin
                      j := Pos('" href="/film/' + MovieCode + '/other/', page);
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/other/',
                                                '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := Pos(FindBlocking, page2);
                      if (((i > 0) or (page2 = '')) and (j = 0)) or ((i > 0) and (j = 1)) then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/other/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/other/',
                                                    '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free;
                              Form.Free;
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      if page2 <> '' then
                        begin
                          if SaveSourceCode = 1 then
                            SaveResultHtmlText(page2, 'MovieRelations' + MovieCode);
                          i := Pos('>', page2);
                          if i > 0 then
                            begin
                              Link := '<b>:</b>';
                              delete(page2, 1, i - 1);
                              if LinksInTable = 1 then
                                begin
                                  tags := '<table width=100% border=0><tr><td colspan=2 style="border-bottom:2px solid #f60"><b>';
                                  tags2 := '</b></td></tr><tr><td colspan=2 height=10><spacer type=block height=10></td></tr><tr>';
                                  tags3 := '<td width="5%" valign="top">';
                                  tags4 := '.</td>';
                                  tags5 := '<td width="95%" align="left"><div style="position: relative; padding-right: 22px">';
                                  tags6 := '<font color="#999999">';
                                  tags7 := '</font></div></td></tr>';
                                  tags8 := '<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr></table>';
                                  i := Pos('<table cellspacing="0" cellpadding="0" border="0" width="100%">', page2);
                                  delete(page2, 1, i - 1);
                                  j := Pos('<td style="border-top: 1px solid #ccc; padding-left: 15px">', page2);
                                  s := copy(page2, 1 , j + 58);
                                  repeat
                                    i := Pos('style="color: #f60; white-space: nowrap">', s);
                                    if i > 0 then
                                      begin
                                        delete(s, 1, i + 40);
                                        j := Pos('</td></tr>', s);
                                        s2 := copy(s, 1, j - 1);
                                        if pos(s2, LinksList) = 0 then
                                          begin
                                            delete(s, 1, j + 9);
                                            Continue;
                                          end;
                                        if LinksInTable = 1 then
                                          begin
                                            delete(s, 1, j + 9);
                                            s2 := tags + s2 + tags2;
                                            s2 := HTMLDecode(s2);
                                            Link := Link + ret + s2;
                                            j := Pos('<table cellspacing="0" cellpadding="0" border="0" width="100%">', s);
                                            if j = 0 then
                                              j := Pos('<td style="border-top: 1px solid #ccc; padding-left: 15px">', s);
                                            if j > 0 then
                                              ss := copy(s, 1, j - 1);
                                            repeat
                                              ii := Pos('<span class="num">', ss);
                                              if ii > 0 then
                                                begin
                                                  delete(ss, 1, ii + 17);
                                                  j := Pos('</span>', ss);
                                                  s3 := copy(ss, 1, j - 1);
                                                  delete(ss, 1, j + 6);
                                                  s3 := tags3 + s3 + tags4;
                                                  iii := Pos('<span class="name">', ss);
                                                  delete(ss, 1, iii + 18);
                                                  j := Pos('</a>', ss);
                                                  s4 := ReplaceLatinExt(copy(ss, 1, j + 3));
                                                  s4 := stringreplace(s4, #13, '', [rfReplaceAll]);
                                                  s4 := stringreplace(s4, #10, '', [rfReplaceAll]);
                                                  s4 := trim(s4);
                                                  s4 := tags5 + s4 + '<br />';
                                                  iii := Pos('<span class="role">', ss);
                                                  delete(ss, 1, iii + 18);
                                                  j := Pos('</span>', ss);
                                                  s5 := ReplaceLatinExt(copy(ss, 1, j - 1));
                                                  s5 := stringreplace(s5, #13, '', [rfReplaceAll]);
                                                  s5 := stringreplace(s5, #10, '', [rfReplaceAll]);
                                                  s5 := trim(s5);
                                                  s5 := tags6 + s5 + tags7;
                                                  s5 := s3 + s4 + s5;
                                                  s5 := HTMLDecode(s5);
                                                  Link := Link + s5;
                                                end;
                                            until (ii = 0);
                                            Link := Link + tags8;
                                            delete(s, 1, j + 62);
                                          end;
                                      end;
                                  until (i = 0);
                                end
                              else
                                begin
                                  repeat
                                    i := Pos('style="color: #f60; white-space: nowrap">', page2);
                                    if i > 0 then
                                      begin
                                        delete(page2, 1, i + 40);
                                        j := Pos('</td></tr>', page2);
                                        s := copy(page2, 1, j - 1);
                                        s := HTMLRemoveTags(s);
                                        s := HTMLDecode(s);
                                        if pos(s, LinksList) = 0 then
                                          begin
                                            delete(page2, 1, j + 9);
                                            Continue;
                                          end;
                                        if LinksInTable = 0 then
                                          begin
                                            delete(page2, 1, j + 9);
                                            Link := Link + ret + '<b><u>' + trim(s) + '</u></b>';
                                            ii := Pos('<table cellspacing="0" cellpadding="0" border="0" width="100%">', page2);
                                            if ii = 0 then
                                              ii := Pos('<td style="border-top: 1px solid #ccc; padding-left: 15px">', page2);
                                            if ii > 0 then
                                              s2 := copy(page2, 1, ii - 1);
                                            repeat
                                              ii := Pos(' class="name">', s2);
                                              if ii > 0 then
                                                begin
                                                  delete(s2, 1, ii + 13);
                                                  ii := Pos('/">', s2);
                                                  delete(s2, 1, ii + 2);
                                                  j := Pos('</a>', s2);
                                                  s := ReplaceLatinExt(copy(s2, 1, j - 1));
                                                  delete(s2, 1, j - 1);
                                                  s := HTMLDecode(s);
                                                  s := HTMLRemoveTags(s);
                                                  Link := Link + ret + '  ' + trim(s);
                                                end;
                                            until (ii = 0);
                                          end;
                                      end;
                                  until (i = 0);
                                end;
                            end;
                          Link := stringreplace(Link, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                          if Link <> '<b>:</b>' then
                            begin
                              if cLinks = 1 then
                                begin
                                  if Comment <> '' then
                                    begin
                                      if cInsertTegHR = 1 then
                                        Comment := Comment + ret + '<hr>'
                                      else
                                        Comment := Comment + ret + ret;
                                    end;
                                  Comment := Comment + Link;
                                end;
                              if dLinks = 1 then
                                begin
                                  if Description <> '' then
                                    begin
                                      if dInsertTegHR = 1 then
                                        Description := Description + ret + '<hr>'
                                      else
                                        Description := Description + ret + ret;
                                    end;
                                  Description := Description + Link;
                                end;
                              if LinksInTable = 1 then
                                delete(Link, 1, 13)
                              else
                                delete(Link, 1, 15);
                              tLinks := Link;
                            end;
                        end;
                    end;
                  page2 := '';
                end;
              tZnaite := '';
              if uZnaite = 1 then //   , ...
                begin
                  i := pos('>  , ...<', page);
                  if i > 0 then
                    begin
                      s := page;
                      delete(s, 1, i);
                      i := Pos('<ul', s);
                      j := Pos('<li class="add', s);
                      if (j = 0) then
                        j := Pos('</div>', s);
                      if (i > 0) and (j > 0) then
                        begin
                          s2 := copy(s, i, j - i);
                          i := Pos('<li class="attention', s2);
                          if (i > 0) then
                            begin
                              s3 := copy(s2, 1, i - 1);
                              delete(s2, 1, i + 19);
                              j := Pos('</li>', s2);
                              delete(s2, 1, j + 4);
                              s2 := s3 + s2;
                            end;
                          s2 := stringreplace(s2, '<ul>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</li>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '<li>', ' ', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</ul>', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</span>', '</span></li>', [rfReplaceAll, rfIgnoreCase]);
                        end
                      else
                        s2 := '';
                      s2 := ClearHTML(s2);
                      if s2 <> '' then
                        begin
                          if ZnaiteIns = 1 then
                            begin
                              List := TStringList.Create;
                              List.Text := s2;
                              s2 := '';
                              for i := 0 to List.Count - 1 do
                                begin
                                  if trim(List[i]) <> '' then
                                    begin
                                      if s2 <> '' then
                                        s2 := s2 + ret;
                                      if (List[i][1] <> '') and (List[i][1] <> '-') then
                                        s2 := s2 + ' ';
                                      s2 := s2 + List[i];
                                    end;
                                end;
                              List.Free;
                            end;
                          s2 := stringreplace(s2, ' ', '', [rfReplaceAll, rfIgnoreCase]);
                          tZnaite := s2;
                          if cZnaite = 1 then
                            begin
                              if Comment <> '' then
                                begin
                                  if cInsertTegHR = 1 then
                                    Comment := Comment + ret + '<hr>'
                                  else
                                    Comment := Comment + ret + ret;
                                end;
                              Comment := Comment + '<b>  , : </b>' + ret;
                              Comment := Comment + s2;
                            end;
                          if dZnaite = 1 then
                            begin
                              if Description <> '' then
                                begin
                                  if dInsertTegHR = 1 then
                                    Description := Description + ret + '<hr>'
                                  else
                                    Description := Description + ret + ret;
                                end;
                              Description := Description + '<b>  , : </b>' + ret;
                              Description := Description + s2;
                            end;
                        end;
                    end;
                end;
              tErrors := '';
              if uErrors = 1 then //   
                begin
                  i := pos('>  ', page);
                  if i > 0 then
                    begin
                      s := page;
                      delete(s, 1, i);
                      i := Pos('<ul', s);
                      j := Pos('<li class="add', s);
                      if (j = 0) then
                        j := Pos('</div>', s);
                      if (i > 0) and (j > 0) then
                        begin
                          s2 := copy(s, i, j - i);
                          i := Pos('<li class="attention', s2);
                          if (i > 0) then
                            begin
                              s3 := copy(s2, 1, i - 1);
                              delete(s2, 1, i + 19);
                              j := Pos('</li>', s2);
                              delete(s2, 1, j + 4);
                              s2 := s3 + s2;
                            end;
                          s2 := stringreplace(s2, '<ul>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</li>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '<li>', ' ', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</ul>', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</span>', '</span></li>', [rfReplaceAll, rfIgnoreCase]);
                        end
                      else
                        s2 := '';
                      s2 := ClearHTML(s2);
                      if s2 <> '' then
                        begin
                          if ErrorIns = 1 then
                            begin
                              List := TStringList.Create;
                              List.Text := s2;
                              s2 := '';
                              for i := 0 to List.Count - 1 do
                                begin
                                  if trim(List[i]) <> '' then
                                    begin
                                      if s2 <> '' then
                                        s2 := s2 + ret;
                                      if (List[i][1] <> '') and (List[i][1] <> '-') then
                                        s2 := s2 + ' ';
                                      s2 := s2 + List[i];
                                    end;
                                end;
                              List.Free;
                            end;
                          s2 := stringreplace(s2, ' ', '', [rfReplaceAll, rfIgnoreCase]);
                          tErrors := s2;
                          if cErrors = 1 then
                            begin
                              if Comment <> '' then
                                begin
                                  if cInsertTegHR = 1 then
                                    Comment := Comment + ret + '<hr>'
                                  else
                                    Comment := Comment + ret + ret;
                                end;
                              Comment := Comment + '<b>  : </b>' + ret;
                              Comment := Comment + s2;
                            end;
                          if dErrors = 1 then
                            begin
                              if Description <> '' then
                                begin
                                  if dInsertTegHR = 1 then
                                    Description := Description + ret + '<hr>'
                                  else
                                    Description := Description + ret + ret;
                                end;
                              Description := Description + '<b>  : </b>' + ret;
                              Description := Description + s2;
                            end;
                        end;
                    end;
                end;
              tBook3500 := '';
              if uBook3500 = 1 then //   3500 
                begin
                  i := pos('>  3500 <', page);
                  if i > 0 then
                    begin
                      s := page;
                      delete(s, 1, i);
                      i := Pos('<table', s);
                      j := Pos('</table>', s);
                      if (i > 0) and (j > 0) then
                        s2 := copy(s, i, j - i)
                      else
                        s2 := '';
                      i := pos('<a href="/review/', s2);
                      if i > 0 then
                        begin
                          j := Pos('" class="continue">', s2);
                          if j > 0 then
                            s3 := copy(s2, i, j - i)
                          else
                            s3 := '';
                          s3 := stringreplace(s3, '<a href="', 'https://www.kinopoisk.ru', [rfReplaceAll, rfIgnoreCase]);
                          s3 := stringreplace(s3, 'rev_id/', '', [rfReplaceAll, rfIgnoreCase]);
                          if s3 <> '' then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl(s3, '    3500 .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow(s3);
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl(s3, '    3500 .....');
                                    Application.ProcessMessages;
                                  except
                                        page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  if SaveSourceCode = 1 then
                                    SaveResultHtmlText(page2, 'MovieReviews' + MovieCode);
                                  i := pos('>* !    .  .<', page2);
                                  if i > 0 then
                                    begin
                                      s3 := '';
                                      s4 := '';
                                      delete(page2, 1, i);
                                      i := Pos('> <', page2);
                                      j := Pos('</table>', page2);
                                      if (i > 0) and (j > 0) then
                                        begin
                                          s2 := copy(page2, i, j - i);
                                          s2 := stringreplace(s2, '</i><br><br>', '</i>', [rfReplaceAll, rfIgnoreCase]);
                                          i := Pos('<td style=', s2);
                                          j := Pos('</tr>', s2);
                                          if (i > 0) and (j > 0) then
                                            s3 := copy(s2, i, j - i);
                                          i := Pos('<i>', s2);
                                          j := Pos('</i>', s2);
                                          if (i > 0) and (j > 0) then
                                            s4 := copy(s2, i, j - i);
                                          if s3 <> '' then
                                            s4 := s4 + ' (' + s3 + ')';
                                          i := Pos('<img src=', s2);
                                          j := Pos('<br><br>', s2);
                                          if (i > 0) and (j > 0) then
                                            s2 := copy(s2, i, j - i);
                                          if s4 <> '' then
                                            s2 := s4 + ret + ret + s2;
                                        end;
                                    end;
                                end
                              else
                                s2 := '';
                            end;
                        end;
                      s2 := ClearHTML(s2);
                      if s2 <> '' then
                        begin
                          tBook3500 := s2;
                          if cBook3500 = 1 then
                            begin
                              if Comment <> '' then
                                begin
                                  if cInsertTegHR = 1 then
                                    Comment := Comment + ret + '<hr>'
                                  else
                                    Comment := Comment + ret + ret;
                                end;
                              Comment := Comment + '<b>  3500 : </b>' + ret;
                              Comment := Comment + s2;
                            end;
                          if dBook3500 = 1 then
                            begin
                              if Description <> '' then
                                begin
                                  if dInsertTegHR = 1 then
                                    Description := Description + ret + '<hr>'
                                  else
                                    Description := Description + ret + ret;
                                end;
                              Description := Description + '<b>  3500 : </b>' + ret;
                              Description := Description + s2;
                            end;
                        end;
                    end;
                  page2 := '';
                end;
              tLikeMovies := '';
              // if (uLikeMovies = 1) and (CheckLikeMovies(page)) then
              if uLikeMovies = 1 then //     ,  ...
                begin
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/like/',
                                             '     .....');
                    Application.ProcessMessages;
                  except
                    page2 := '';
                  end;
                  i := pos(FindBlocking, page2);
                  if (i > 0) or (page2 = '') then
                    begin
                      ShowMessage('    ');
                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/like/');
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/like/',
                                                '     .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := pos(FindBlocking, page2);
                      if (i > 0) or (page2 = '') then
                        begin
                          ShowMessage('    ');
                          MovieBase.Free;
                          Form.Free;
                          LoadInfo.Destroy;
                          Exit;
                        end;
                    end;
                  if page2 <> '' then
                    begin
                      if SaveSourceCode = 1 then
                        SaveResultHtmlText(page2, 'MovieLikes' + MovieCode);
                      s4 := '';
                      ii := pos('<div style="margin-bottom: 9px"><a style="font-size: 13px; font-weight: bold" href=', page2);
                      while ii > 0 do
                        begin
                          delete(page2, 1, ii);
                          i := pos('<a style="font-size: 13px; font-weight: bold" href=', page2);
                          j := Pos('<nobr>', page2);
                          if (i > 0) and (j > 0) then
                            s3 := copy(page2, i, j - i)
                          else
                            s3 := '';
                          s3 := stringreplace(s3, '</a><span style="color: #888; font-family: arial; font-size: 11px; display: block">', '</a> <font color="#999999"> / ', [rfReplaceAll, rfIgnoreCase]);
                          s3 := stringreplace(s3, '<a style="font-size: 13px; font-weight: bold" href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                          s3 := stringreplace(s3, '" class="all">', '">', [rfReplaceAll, rfIgnoreCase]);
                          s3 := s3 + '</font>';
                          s3 := stringreplace(s3, '</a> <font color="#999999"> / </font>', '</a>', [rfReplaceAll, rfIgnoreCase]);
                          if s4 <> '' then
                            s4 := s4 + ret;
                          s4 := s4 + s3;
                          ii := pos('<div style="margin-bottom: 9px"><a style="font-size: 13px; font-weight: bold" href=', page2);
                        end;
                      s2 := trim(s4);
                    end;
                  if s2 <> '' then
                    begin
                      tLikeMovies := s2;
                      if cLikeMovies = 1 then
                        begin
                          if Comment <> '' then
                            begin
                              if cInsertTegHR = 1 then
                                Comment := Comment + ret + '<hr>'
                              else
                                Comment := Comment + ret + ret;
                            end;
                          Comment := Comment + '<b>    ,  : </b>' + ret;
                          Comment := Comment + s2;
                        end;
                      if dLikeMovies = 1 then
                        begin
                          if Description <> '' then
                            begin
                              if dInsertTegHR = 1 then
                                Description := Description + ret + '<hr>'
                              else
                                Description := Description + ret + ret;
                            end;
                          Description := Description + '<b>    ,  : </b>' + ret;
                          Description := Description + s2;
                        end;
                    end;
                  page2 := '';
                end;
              if uEpisodes = 1 then // 
                begin
                  if (uEpisodesIfEmpty = 0) or (MovieBase.CurrentMovie.EpisodesCount = 0) then
                    begin
                      if pos('/episodes/', page) > 0 then //,   
                        begin
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/episodes/',
                                                    '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/episodes/');
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/episodes/',
                                                        '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  MovieBase.Free;
                                  Form.Free;
                                  LoadInfo.Destroy;
                                  Exit;
                                end;
                            end;
                          if page2 <> '' then
                            begin
                              if SaveSourceCode = 1 then
                                SaveResultHtmlText(page2, 'MovieEpisodes' + MovieCode);
                              j := MovieBase.CurrentMovie.EpisodesCount;
                              while j > 0 do
                                begin
                                  MovieBase.CurrentMovie.EpisodeDelete(0);
                                  j := MovieBase.CurrentMovie.EpisodesCount;
                                end;
                              i := pos('<a name="s1"></a>', page2);
                              j := MyPos('<br><br><br><br><br>', page2, i + 1);
                              if j = 0 then
                                j := MyPos('<br /><br /><br /><br /><br />', page2, i + 1);
                              if (i > 0) and (j > 0) then
                                begin
                                  s := copy(page2, i, j - i);
                                  season := 0;
                                  i := pos('<span style="color:#777"> ', s);
                                  while i > 0 do
                                    begin
                                      episode := -1;
                                      s2 := '<h1 class="moviename-big" style="font-size:21px;padding:0px;margin:0px;color:#f60"> ';
                                      k := pos(s2, s);
                                      if (k < i) and (k <> 0) then
                                        begin
                                          j := MyPos('</h1>', s, k + 1);
                                          s3 := copy(s, k + length(s2), j - k - length(s2));
                                          try
                                            season := StrToInt(s3);
                                          except
                                            season := 0;
                                          end;
                                        end;
                                      j := MyPos('</tr>', s, i + 1);
                                      if j > 0 then
                                        begin
                                          s2 := '<span style="color:#777"> ';
                                          s3 := copy(s, i + length(s2), j - i - length(s2));
                                          delete(s, 1, j + 4);
                                          k := pos('</span>', s3);
                                          try
                                            if k > 0 then
                                              try
                                                episode := StrToInt(copy(s3, 1, k - 1));
                                              finally
                                              end
                                            else
                                              episode := -1;
                                          except
                                            episode := -1;
                                          end;
                                          if episode >= 0 then
                                            begin
                                              delete(s3, 1, k + 6);
                                              EpisodeTitle := '';
                                              k := pos('<b>', s3);
                                              if k > 0 then
                                                begin
                                                  k2 := MyPos('</b>', s3, k + 1);
                                                  if k2 > 0 then
                                                    begin
                                                      EpisodeTitle := copy(s3, k + 3, k2 - k - 3);
                                                      EpisodeTitle := ClearHTML(EpisodeTitle);
                                                    end;
                                                end;
                                              AirDate := '';
                                              s2 := '<td width=20% class="news" align=right valign=bottom style="border-bottom:1px dotted #ccc;padding:15px 0px;font-size:12px" align=left>';
                                              k := pos(s2, s3);
                                              if k > 0 then
                                                begin
                                                  k2 := MyPos('</td>', s3, k + 1);
                                                  if k2 > 0 then
                                                    AirDate := copy(s3, k + length(s2), k2 - k - length(s2));
                                                  AirDate := ClearHTML(AirDate);
                                                end;
                                              EpisodeDescription := '';
                                            end;
                                        end;
                                      if episode >= 0 then
                                        MovieBase.CurrentMovie.EpisodeAdd(season, episode, EpisodeTitle, EpisodeDescription, '', AirDate);
                                      i := pos('<span style="color:#777"> ', s);
                                    end;
                                end;
                            end;
                        end;
                    end;
                end;
              tRecenzia := '';
              if uRecenzia = 1 then //  
                begin
                  Recenzia := '<b> :</b>';
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/ord/rating/',
                                            '   .....');
                    Application.ProcessMessages;
                  except
                    page2 := '';
                  end;
                  i := pos(FindBlocking, page2);
                  if (i > 0) or (page2 = '') then
                    begin
                      ShowMessage('    ');
                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/ord/rating/');
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/ord/rating/',
                                                '   .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := pos(FindBlocking, page2);
                      if (i > 0) or (page2 = '') then
                        begin
                          ShowMessage('    ');
                          MovieBase.Free;
                          Form.Free;
                          LoadInfo.Destroy;
                          Exit;
                        end;
                    end;
                  if page2 <> '' then
                    begin
                      if SaveSourceCode = 1 then
                        SaveResultHtmlText(page2, 'MovieRatings' + MovieCode);
                      s := page2;
                    end
                  else
                    s := '';
                  Kol := 0;
                  i := pos('>   ', s); //,   
                  if i > 0 then
                    begin
                      delete(s, 1, i - 1);
                      i := pos('<p class="profile_name">', s);
                      while i > 0 do
                        begin
                          if Kol >= MaxRecenzia then
                            break;
                          Kol := Kol + 1;
                          delete(s, 1, i - 1);
                          j := pos('</p>', s); //
                          s2 := copy(s, 1, j - 1);
                          s2 := HTMLDecode(s2);
                          s2 := HTMLRemoveTags(s2);
                          s2 := trim(s2);
                          if Recenzia = '<b> :</b>' then
                            Recenzia := Recenzia + ret + '<b><u>' + trim(s2) + '</u></b>'
                          else
                            Recenzia := Recenzia + ret + ret + '<b><u>' + trim(s2) + '</u></b>';
                          delete(s, 1, j - 1);
                          j := pos('<p class="sub_title"', s); // 
                          if j > 0 then
                            begin
                              delete(s, 1, j - 1);
                              j := pos('</p>', s);
                              s2 := copy(s, 1, j - 1);
                              s2 := ClearHTML(s2);
                              s2 := trim(s2);
                              if s2 <> '' then
                                Recenzia := Recenzia + ret + '<b>' + s2 + '</b>';
                              delete(s, 1, j - 1);
                            end;
                          j := pos('<p id="ext_text', s); // 
                          if j > 0 then
                            begin
                              delete(s, 1, j - 1);
                              j := pos('</p>', s);
                              s2 := copy(s, 1, j - 1);
                              s2 := ClearHTML(s2);
                              s2 := trim(s2);
                              if s2 <> '' then
                                Recenzia := Recenzia + ret + ret + s2;
                              delete(s, 1, j - 1);
                            end;
                          i := pos('<p class="profile_name">', s);
                        end;
                      if (uAllRecenziaPage = 1) and (Kol < MaxRecenzia) then //    
                        begin
                          NPage := 2;
                          ii := pos('href="/film/' + FullMovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                          if ii = 0 then
                            ii := pos('href="/film/' + MovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                          while ii > 0 do
                            begin
                              if Kol >= MaxRecenzia then
                                break;
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                        '/ord/rating/perpage/10/page/' + IntToStr(NPage) + '/',
                                                        '   .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode +
                                                   '/ord/rating/perpage/10/page/' + IntToStr(NPage) + '/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                            '/ord/rating/perpage/10/page/' + IntToStr(NPage) + '/',
                                                            '   .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  s := page2;
                                  i := pos('>   ', s); //,   
                                  if i > 0 then
                                    begin
                                      delete(s, 1, i - 1);
                                      i := pos('<p class="profile_name">', s);
                                      while i > 0 do
                                        begin
                                          if Kol >= MaxRecenzia then
                                            break;
                                           Kol := Kol + 1;
                                          delete(s, 1, i - 1);
                                          j := pos('</p>', s); //
                                          s2 := copy(s, 1, j - 1); 
                                          s2 := HTMLRemoveTags(s2); 
                                          s2 := ReplaceLatinExt(s2);
                                          s2 := HTMLDecode(s2);
                                          s2 := trim(s2);
                                          if Recenzia = '<b> :</b>' then
                                            Recenzia := Recenzia + ret + '<b><u>' + trim(s2) + '</u></b>'
                                          else
                                            Recenzia := Recenzia + ret + ret + '<b><u>' + trim(s2) + '</u></b>';
                                          delete(s, 1, j - 1);
                                          j := pos('<p class="sub_title"', s); // 
                                          if j > 0 then
                                            begin
                                              delete(s, 1, j - 1);
                                              j := pos('</p>', s);
                                              s2 := copy(s, 1, j - 1);
                                              s2 := ClearHTML(s2);
                                              s2 := trim(s2);
                                              if s2 <> '' then
                                                Recenzia := Recenzia + ret + '<b>' + s2 + '</b>';
                                              delete(s, 1, j - 1);
                                            end;
                                          j := pos('<p id="ext_text', s); // 
                                          if j > 0 then
                                            begin
                                              delete(s, 1, j - 1);
                                              j := pos('</p>', s);
                                              s2 := copy(s, 1, j - 1);
                                              s2 := ClearHTML(s2);
                                              s2 := trim(s2);
                                              if s2 <> '' then
                                                Recenzia := Recenzia + ret + s2;
                                              delete(s, 1, j - 1);
                                            end;
                                          i := pos('<p class="profile_name">', s);
                                        end;
                                    end;
                                end;
                              NPage := NPage + 1;
                              ii := pos('href="/film/' + FullMovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                              if ii = 0 then
                                ii := pos('href="/film/' + MovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                            end;
                        end;
                      if Recenzia <> '<b> :</b>' then
                        begin
                          if cRecenzia = 1 then
                            begin
                              if Comment <> '' then
                                begin
                                  if cInsertTegHR = 1 then
                                    Comment := Comment + ret + '<hr>'
                                  else
                                    Comment := Comment + ret + ret;
                                end;
                              Comment := Comment + Recenzia;
                            end;
                          if dRecenzia = 1 then
                            begin
                              if Description <> '' then
                                begin
                                  if dInsertTegHR = 1 then
                                    Description := Description + ret + '<hr>'
                                  else
                                    Description := Description + ret + ret;
                                end;
                              Description := Description + Recenzia;
                            end;
                          delete(Recenzia, 1, 25);
                          tRecenzia := Recenzia;
                        end;
                    end;
                end;
              if Pos('href="/film/' + MovieCode + '/images/', page) > 0 then
                begin
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/images/',
                                            '    .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := Pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/images/');
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/images/',
                                               '    .....');
                        Application.ProcessMessages;
                      except
                        page := '';
                      end;
                      i := Pos(FindBlocking, page);
                      if (i > 0) or (page = '') then
                        begin
                          ShowMessage('    ');
                          MovieBase.Free;
                          Form.Free;
                          LoadInfo.Destroy;
                          Exit;
                        end;
                    end;
                end;
              if uCovers = 1 then // 
                begin
                  if SmallPicOnly = 1 then
                    begin
                      Application.ProcessMessages;
                      if NeedURLDelay = 1 then
                        Sleep(MaxURLDelay);
                      Application.ProcessMessages;
                      MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/film_iphone/iphone360_' + MovieCode + '.jpg');
                    end
                  else
                    begin //,    
                      if (Pos('href="/film/' + FullMovieCode + '/posters/', page) > 0) or
                         (Pos('href="/film/' + MovieCode + '/posters/', page) > 0) or
                         (Pos('href="/film/' + FullMovieCode + '/covers/', page) > 0) or
                         (Pos('href="/film/' + MovieCode + '/covers/', page) > 0)
                      then
                        begin
                          Kol := 0;
                          links := TStringList.Create;
                          MovieList := TStringList.Create;
                          Form.Kol := 0;
                          Form.MovieList := TStringList.Create;
                          Form.links := TStringList.Create;
                          Form.JPGLink := TStringList.Create;
                          if (Pos('href="/film/' + FullMovieCode + '/posters/', page) > 0) or
                             (Pos('href="/film/' + MovieCode + '/posters/', page) > 0)
                          then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := Pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := Pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  s := page2;
                                  i := Pos('/images/poster/sm_', s);
                                  delete(s, 1, i + 17);
                                  j := Pos('</table>', s);
                                  s := copy(s, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      s2 := '';
                                      j := Pos('</td>', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          delete(s, 1, j - 1);
                                          j := Pos('.jpg', s2);
                                          if j = 0 then
                                            j := Pos('.JPG', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                          Form.links.Add('0');
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s4 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s4);
                                        end;
                                      i := Pos('/images/poster/sm_', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              if (uAllCoversPage = 1) and (Kol < MaxCovers) then //    
                                begin
                                  NPage := 2;
                                  ii := Pos('/page/' + IntToStr(NPage) + '/', page2);
                                  while ii > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' +
                                                                IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := Pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' + IntToStr(NPage) + '/');
                                          try
                                            Application.ProcessMessages;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            Application.ProcessMessages;
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' +
                                                                    IntToStr(NPage) + '/', '  .....');
                                            Application.ProcessMessages;
                                          except
                                            page3 := '';
                                          end;
                                          i := Pos(FindBlocking, page3);
                                          if (i > 0) or (page3 = '') then
                                            begin
                                              ShowMessage('    ');
                                              MovieBase.Free;
                                              Form.Free;
                                              LoadInfo.Destroy;
                                              Exit;
                                            end;
                                        end;
                                      if page3 <> '' then
                                        begin
                                          i := Pos('/images/poster/sm_', page3);
                                          delete(page3, 1, i + 17);
                                          j := Pos('</table>', page3);
                                          s := copy(page3, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              if Kol >= MaxCovers then
                                                break;
                                              s2 := '';
                                              j := Pos('</td>', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  Form.Kol := Form.Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  delete(s, 1, j - 1);
                                                  j := Pos('.jpg', s2);
                                                  if j = 0 then
                                                    j := Pos('.JPG', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  Form.links.Add('0');
                                                  Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                                  s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := ClearHTML(s2);
                                                  s4 := s2 + ' )';
                                                  s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                                  MovieList.Add(s3);
                                                  Form.MovieList.Add(s4);
                                                end;
                                              i := Pos('/images/poster/sm_', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      NPage := NPage + 1;
                                      ii := Pos('/page/' + IntToStr(NPage) + '/', page3);
                                    end;
                                end;
                            end;
                          if ((Pos('href="/film/' + FullMovieCode + '/covers/', page) > 0) or
                              (Pos('href="/film/' + MovieCode + '/covers/', page) > 0)) and (Kol < MaxCovers)
                          then
                            begin //   
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := Pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := Pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  i := Pos('/images/poster/sm_', page2);
                                  delete(page2, 1, i + 17);
                                  j := Pos('</table>', page2);
                                  s := copy(page2, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      s2 := '';
                                      j := Pos('</td>', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          delete(s, 1, j - 1);
                                          j := Pos('.jpg', s2);
                                          if j = 0 then
                                            j := Pos('.JPG', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.links.Add('0');
                                          Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s4 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s4);
                                        end;
                                      i := Pos('/images/poster/sm_', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              if (uAllCoversPage = 1) and (Kol < MaxCovers) then //    
                                begin
                                  NPage := 2;
                                  ii := Pos('/page/' + IntToStr(NPage) + '/', page2);
                                  while ii > 0 do
                                    begin
                                      if Kol >= MaxCovers then
                                        break;
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' +
                                                                IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := Pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' + IntToStr(NPage) + '/');
                                          try
                                            Application.ProcessMessages;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            Application.ProcessMessages;
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' +
                                                                    IntToStr(NPage) + '/', '  .....');
                                            Application.ProcessMessages;
                                          except
                                            page3 := '';
                                          end;
                                          i := Pos(FindBlocking, page3);
                                          if (i > 0) or (page3 = '') then
                                            begin
                                              ShowMessage('    ');
                                              MovieBase.Free;
                                              Form.Free;
                                              LoadInfo.Destroy;
                                              Exit;
                                            end;
                                        end;
                                      if page3 <> '' then
                                        begin
                                          i := Pos('/images/poster/sm_', page3);
                                          delete(page3, 1, i + 17);
                                          j := Pos('</table>', page3);
                                          s := copy(page3, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              if Kol >= MaxCovers then
                                                break;
                                              s2 := '';
                                              j := Pos('</td>', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  Form.Kol := Form.Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  delete(s, 1, j - 1);
                                                  j := Pos('.jpg', s2);
                                                  if j = 0 then
                                                    j := Pos('.JPG', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  Form.links.Add('0');
                                                  Form.JPGLink.Add('https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg');
                                                  s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                                  s2 := ClearHTML(s2);
                                                  s4 := s2 + ' )';
                                                  s3 := ' ' + IntToStr(Kol) + ': ' + s4 + '^^^^https://st.kp.yandex.net/images/poster/sm_' + s3 + '.jpg';
                                                  MovieList.Add(s3);
                                                  Form.MovieList.Add(s4);
                                                end;
                                              i := Pos('/images/poster/sm_', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      NPage := NPage + 1;
                                      ii := Pos('/page/' + IntToStr(NPage) + '/', page3);
                                    end;
                                end;
                            end;
                          if Kol > 1 then // ,   
                            begin
                              links.Add('ALL');
                              if uUseAltDlgCovers = 1 then
                                begin
                                  links.Add('SEL');
                                  if Form.Kol > 525 then
                                    Form.Kol := 525;
                                  Form.All := Kol;
                                  Form.ShowModal;
                                  i := Form.ReturVal;
                                end
                              else
                                begin
                                  MovieList.Add('  ...');
                                  i := MovieBase.SelectTheMovie(MovieList.Text)
                                end;
                            end
                          else
                            i := 0;
                          if Kol = 0 then
                            i := -1;
                          if i > -1 then
                            begin
                              if links[i] = 'SEL' then
                                begin
                                  j := 0;
                                  for ii := 0 to Kol - 1 do
                                    begin
                                      if Form.links[ii] = '1' then
                                        begin
                                          if j = 0 then
                                            begin
                                              Application.ProcessMessages;
                                              if NeedURLDelay = 1 then
                                                Sleep(MaxURLDelay);
                                              Application.ProcessMessages;
                                              if ResizeCovers = 0 then
                                                MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg')
                                              else
                                                GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg');
                                              j := 1;
                                            end
                                          else
                                            begin
                                              Application.ProcessMessages;
                                              if NeedURLDelay = 1 then
                                                Sleep(MaxURLDelay);
                                              Application.ProcessMessages;
                                              if ResizeCovers = 0 then
                                                MovieBase.GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg')
                                              else
                                                GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg', 1);
                                            end;
                                        end;
                                    end;
                                end
                              else
                                begin
                                  if links[i] = 'ALL' then
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      if ResizeCovers = 0 then
                                        MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[0] + '.jpg')
                                      else
                                        GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[0] + '.jpg');
                                      for ii := 1 to Kol - 1 do
                                        begin
                                          Application.ProcessMessages;
                                          if NeedURLDelay = 1 then
                                            Sleep(MaxURLDelay);
                                          Application.ProcessMessages;
                                          if ResizeCovers = 0 then
                                            MovieBase.GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg')
                                          else
                                            GetScreenFromURL('https://st.kp.yandex.net/images/poster/' + links[ii] + '.jpg', 1);
                                        end;
                                    end
                                  else
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      if ResizeCovers = 0 then
                                        MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[i] + '.jpg')
                                      else
                                        GetCoverFromURL('https://st.kp.yandex.net/images/poster/' + links[i] + '.jpg');
                                    end;
                                end;
                            end;
                          links.Free;
                          MovieList.Free;
                          Form.links.Free;
                          Form.MovieList.Free;
                          Form.JPGLink.Free;
                        end
                      else
                        begin
                          if SmallPic = 1 then
                            begin
                              Application.ProcessMessages;
                              if NeedURLDelay = 1 then
                                Sleep(MaxURLDelay);
                              Application.ProcessMessages;
                              MovieBase.GetCoverFromURL('https://st.kp.yandex.net/images/film_iphone/iphone360_' + MovieCode + '.jpg');
                            end;
                        end;
                    end;
                end;
              if uScreenshots = 1 then // 
                begin //,     
                  if (Pos('href="/film/' + FullMovieCode + '/stills/', page) > 0) or
                     (Pos('href="/film/' + MovieCode + '/stills/', page) > 0)
                  then
                    begin
                      Kol := 0;
                      links := TStringList.Create;
                      MovieList := TStringList.Create;
                      Form.Kol := 0;
                      Form.MovieList := TStringList.Create;
                      Form.links := TStringList.Create;
                      Form.JPGLink := TStringList.Create;
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/', '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := Pos(FindBlocking, page2);
                      if (i > 0) or (page2 = '') then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/',
                                                    '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := Pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free;
                              Form.Free;
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      if page2 <> '' then
                        begin
                          s := page2;
                          s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                          i := Pos('<a href="/picture/', s);
                          delete(s, 1, i + 17);
                          j := Pos('</table>', s);
                          s := copy(s, 1, j - 1);
                          while i > 0 do
                            begin
                              if Kol >= MaxScreenshots then
                                break;
                              s2 := '';
                              j := Pos('</td>', s);
                              ii := Pos('src="', s);
                              k := Pos('.jpg', s);
                              if k = 0 then
                                k := Pos('.JPG', s);
                              if j > 0 then
                                begin
                                  Kol := Kol + 1;
                                  Form.Kol := Form.Kol + 1;
                                  s2 := copy(s, 1, j - 1);
                                  s4 := copy(s2, ii + 5, k - (ii + 5)) + '.jpg';
                                  delete(s, 1, j - 1);
                                  j := Pos('/', s2);
                                  s3 := copy(s2, 1, j - 1);
                                  links.Add(s3);
                                  Form.links.Add('0');
                                  Form.JPGLink.Add(s4);
                                  s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := ClearHTML(s2);
                                  s2 := s2 + ' )';
                                  s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                  MovieList.Add(s3);
                                  Form.MovieList.Add(s2);
                                end;
                              i := Pos('<a href="/picture/', s);
                              if i > 0 then
                                delete(s, 1, i + 17);
                            end;
                        end;
                      if (uAllScreenshotsPage = 1) and (Kol < MaxScreenshots) then //    
                        begin
                          NPage := 2;
                          ii := Pos('/page/' + IntToStr(NPage), page2);
                          while ii > 0 do
                            begin
                              if Kol >= MaxScreenshots then
                                break;
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' +
                                                        IntToStr(NPage) + '/', '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              i := Pos(FindBlocking, page3);
                              if (i > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' + IntToStr(NPage) + '/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' +
                                                            IntToStr(NPage) + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := Pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page3 <> '' then
                                begin
                                  page3 := stringreplace(page3, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                  i := Pos('<a href="/picture/', page3);
                                  delete(page3, 1, i + 17);
                                  j := Pos('</table>', page3);
                                  s := copy(page3, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxScreenshots then
                                        break;
                                      s2 := '';
                                      j := Pos('</td>', s);
                                      ii := Pos('src="', s);
                                      k := Pos('.jpg', s);
                                      if k = 0 then
                                        k := Pos('.JPG', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                          delete(s, 1, j - 1);
                                          j := Pos('/', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.links.Add('0');
                                          Form.JPGLink.Add(s4);
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s2 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s2);
                                        end;
                                      i := Pos('<a href="/picture/', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              NPage := NPage + 1;
                              ii := Pos('/page/' + IntToStr(NPage), page3);
                            end;
                          if ((Pos('/film/' + FullMovieCode + '/screenshots/', page2) > 0) or
                              (Pos('/film/' + MovieCode + '/screenshots/', page2) > 0)) and (Kol < MaxScreenshots)
                          then
                            begin //,     
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := Pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page2 := '';
                                  end;
                                  i := Pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page2 <> '' then
                                begin
                                  page2 := stringreplace(page2, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                  i := Pos('<a href="/picture/', page2);
                                  delete(page2, 1, i + 17);
                                  j := Pos('</table>', page2);
                                  s := copy(page2, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      if Kol >= MaxScreenshots then
                                        break;
                                      s2 := '';
                                      j := Pos('</td>', s);
                                      ii := Pos('src="', s);
                                      k := Pos('.jpg', s);
                                      if k = 0 then
                                        k := Pos('.JPG', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          Form.Kol := Form.Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                          delete(s, 1, j - 1);
                                          j := Pos('/', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          Form.links.Add('0');
                                          Form.JPGLink.Add(s4);
                                          s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                          s2 := ClearHTML(s2);
                                          s2 := s2 + ' )';
                                          s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                          MovieList.Add(s3);
                                          Form.MovieList.Add(s2);
                                        end;
                                      i := Pos('<a href="/picture/', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              NPage := 2;
                              ii := Pos('/screenshots/page/' + IntToStr(NPage), page2); //    
                              while ii > 0 do
                                begin
                                  if Kol >= MaxScreenshots then
                                    break;
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                            IntToStr(NPage) + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := Pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' + IntToStr(NPage) + '/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                                IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := Pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                  if page3 <> '' then
                                    begin
                                      page3 := stringreplace(page3, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                      i := Pos('<a href="/picture/', page3);
                                      delete(page3, 1, i + 17);
                                      j := Pos('</table>', page3);
                                      s := copy(page3, 1, j - 1);
                                      while i > 0 do
                                        begin
                                          if Kol >= MaxScreenshots then
                                            break;
                                          s2 := '';
                                          j := Pos('</td>', s);
                                          ii := Pos('src="', s);
                                          k := Pos('.jpg', s);
                                          if k = 0 then
                                            k := Pos('.JPG', s);
                                          if j > 0 then
                                            begin
                                              Kol := Kol + 1;
                                              Form.Kol := Form.Kol + 1;
                                              s2 := copy(s, 1, j - 1);
                                              s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                              delete(s, 1, j - 1);
                                              j := Pos('/', s2);
                                              s3 := copy(s2, 1, j - 1);
                                              links.Add(s3);
                                              Form.links.Add('0');
                                              Form.JPGLink.Add(s4);
                                              s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := ClearHTML(s2);
                                              s2 := s2 + ' )';
                                              s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                              MovieList.Add(s3);
                                              Form.MovieList.Add(s2);
                                            end;
                                          i := Pos('<a href="/picture/', s);
                                          if i > 0 then
                                            delete(s, 1, i + 17);
                                        end;
                                    end;
                                  NPage := NPage + 1;
                                  ii := Pos('/screenshots/page/' + IntToStr(NPage), page3);
                                end;
                            end;
                        end;
                      if Kol > 1 then // ,   
                        begin
                          links.Add('ALL');
                          if uUseAltDlgScreenshots = 1 then
                            begin
                              links.Add('SEL');
                              if Form.Kol > 525 then
                                Form.Kol := 525;
                              Form.All := Kol;
                              if NoDlg2 = 1 then
                                begin
                                  i := Kol;
                                end
                              else
                                begin
                                  Form.ShowModal;
                                  i := Form.ReturVal;
                                end;
                            end
                          else
                            begin
                              MovieList.Add('  ...');
                              i := MovieBase.SelectTheMovie(MovieList.Text)
                            end;
                        end
                      else
                        i := 0;
                      if Kol = 0 then
                        i := -1;
                      if i > -1 then
                        begin
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/', '  .....');
                            Application.ProcessMessages;
                          except
                            page3 := '';
                          end;
                          ii := Pos(FindBlocking, page3);
                          if (ii > 0) or (page3 = '') then
                            begin
                              ShowMessage('    ');
                              GetBrowserWindow('https://www.kinopoisk.ru/picture/' + links[0] + '/');
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/',
                                                        '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              ii := Pos(FindBlocking, page3);
                              if (ii > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  MovieBase.Free;
                                  Form.Free;
                                  LoadInfo.Destroy;
                                  Exit;
                                end;
                            end;
                          if page3 <> '' then
                            begin
                              ii := Pos('/im/kadr/', page3);
                              if ii > 0 then
                                delete(page3, 1, ii - 1);
                              ii := Pos('.jpg', page3);
                              if ii = 0 then
                                ii := Pos('.JPG', page3);
                              if ii > 0 then
                                begin
                                  s := copy(page3, 1, ii - 1);
                                  s := ReverseString(s);
                                  ii := Pos('-', s);
                                  if ii > 0 then
                                    delete(s, 1, ii - 1);
                                  ii := Pos('/', s);
                                  if ii > 0 then
                                    begin
                                      s := copy(s, 1, ii - 1);
                                      ss := ReverseString(s);
                                    end;
                                end;
                            end;
                          if links[i] = 'SEL' then
                            begin
                              for ii := 0 to Kol - 1 do
                                begin
                                  if Form.links[ii] = '1' then
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      s := links[ii];
                                      if ResizeScreenshots = 0 then
                                        MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                          s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                      else
                                        GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                          s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                    end;
                                end;
                            end
                          else
                            begin
                              if links[i] = 'ALL' then
                                begin
                                  for ii := 0 to Kol - 1 do
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      s := links[ii];
                                      if ResizeScreenshots = 0 then
                                        MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                          s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                      else
                                        GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                          s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                    end;
                                end
                              else
                                begin
                                  Application.ProcessMessages;
                                  if NeedURLDelay = 1 then
                                    Sleep(MaxURLDelay);
                                  Application.ProcessMessages;
                                  s := links[i];
                                  if ResizeScreenshots = 0 then
                                    MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                      s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                  else
                                    GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                      s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                end;
                            end;
                        end;
                      links.Free;
                      MovieList.Free;
                      Form.links.Free;
                      Form.MovieList.Free;
                      Form.JPGLink.Free;
                    end
                  else
                    begin
                      if (Pos('href="/film/' + FullMovieCode + '/screenshots/', page) > 0) or
                         (Pos('href="/film/' + MovieCode + '/screenshots/', page) > 0)
                      then
                        begin
                          Kol := 0;
                          links := TStringList.Create;
                          MovieList := TStringList.Create;
                          Form.Kol := 0;
                          Form.MovieList := TStringList.Create;
                          Form.links := TStringList.Create;
                          Form.JPGLink := TStringList.Create;
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := Pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/');
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/', '  .....');
                                Application.ProcessMessages;
                              except
                                page2 := '';
                              end;
                              i := Pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  MovieBase.Free;
                                  Form.Free;
                                  LoadInfo.Destroy;
                                  Exit;
                                end;
                            end;
                          if page2 <> '' then
                            begin
                              s := page2;
                              s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                              i := Pos('<a href="/picture/', s);
                              delete(s, 1, i + 17);
                              j := Pos('</table>', s);
                              s := copy(s, 1, j - 1);
                              while i > 0 do
                                begin
                                  if Kol >= MaxScreenshots then
                                    break;
                                  s2 := '';
                                  j := Pos('</td>', s);
                                  ii := Pos('src="', s);
                                  k := Pos('.jpg', s);
                                  if k = 0 then
                                    k := Pos('.JPG', s);
                                  if j > 0 then
                                    begin
                                      Kol := Kol + 1;
                                      Form.Kol := Form.Kol + 1;
                                      s2 := copy(s, 1, j - 1);
                                      s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                      delete(s, 1, j - 1);
                                      j := Pos('/', s2);
                                      s3 := copy(s2, 1, j - 1);
                                      links.Add(s3);
                                      Form.links.Add('0');
                                      Form.JPGLink.Add(s4);
                                      s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                      s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                      s2 := ClearHTML(s2);
                                      s2 := s2 + ' )';
                                      s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                      MovieList.Add(s3);
                                      Form.MovieList.Add(s2);
                                    end;
                                  i := Pos('<a href="/picture/', s);
                                  if i > 0 then delete(s, 1, i + 17);
                                end;
                            end;
                          if (uAllScreenshotsPage = 1) and (Kol < MaxScreenshots) then //    
                            begin
                              NPage := 2;
                              ii := Pos('/page/' + IntToStr(NPage), page2);
                              while ii > 0 do
                                begin
                                  if Kol >= MaxScreenshots then
                                    break;
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                            '/screenshots/page/' + IntToStr(NPage) + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  i := Pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' + IntToStr(NPage) + '/');
                                      try
                                        Application.ProcessMessages;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        Application.ProcessMessages;
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                                '/screenshots/page/' + IntToStr(NPage) + '/', '  .....');
                                        Application.ProcessMessages;
                                      except
                                        page3 := '';
                                      end;
                                      i := Pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          MovieBase.Free;
                                          Form.Free;
                                          LoadInfo.Destroy;
                                          Exit;
                                        end;
                                    end;
                                  if page3 <> '' then
                                    begin
                                      page3 := stringreplace(page3, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                      i := Pos('<a href="/picture/', page3);
                                      delete(page3, 1, i + 17);
                                      j := Pos('</table>', page3);
                                      s := copy(page3, 1, j - 1);
                                      while i > 0 do
                                        begin
                                         if Kol >= MaxScreenshots then
                                          break;
                                          s2 := '';
                                          j := Pos('</td>', s);
                                          ii := Pos('src="', s);
                                          k := Pos('.jpg', s);
                                          if k = 0 then
                                            k := Pos('.JPG', s);
                                          if j > 0 then
                                            begin
                                              Kol := Kol + 1;
                                              Form.Kol := Form.Kol + 1;
                                              s2 := copy(s, 1, j - 1);
                                              s4 := copy(s, ii + 5, k - (ii + 5)) + '.jpg';
                                              delete(s, 1, j - 1);
                                              j := Pos('/', s2);
                                              s3 := copy(s2, 1, j - 1);
                                              links.Add(s3);
                                              Form.links.Add('0');
                                              Form.JPGLink.Add(s4);
                                              s2 := stringreplace(s2, '&times;', 'x', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := '<' + stringreplace(s2, 'target="_blank"', '> (<', [rfReplaceAll, rfIgnoreCase]);
                                              s2 := ClearHTML(s2);
                                              s2 := s2 + ' )';
                                              s3 := ' ' + IntToStr(Kol) + ': ' + s2 + '^^^^' + s4;
                                              MovieList.Add(s3);
                                              Form.MovieList.Add(s2);
                                            end;
                                          i := Pos('<a href="/picture/', s);
                                          if i > 0 then
                                            delete(s, 1, i + 17);
                                        end;
                                    end;
                                  NPage := NPage + 1;
                                  ii := Pos('/page/' + IntToStr(NPage), page3);
                                end;
                            end;
                          if Kol > 1 then // ,   
                            begin
                              links.Add('ALL');
                              if uUseAltDlgScreenshots = 1 then
                                begin
                                  links.Add('SEL');
                                  if Form.Kol > 525 then
                                    Form.Kol := 525;
                                  Form.All := Kol;
                                  if NoDlg2 = 1 then
                                    begin
                                      i := Kol;
                                    end
                                  else
                                    begin
                                      Form.ShowModal;
                                      i := Form.ReturVal;
                                    end;
                                end
                              else
                                begin
                                  MovieList.Add('  ...');
                                  i := MovieBase.SelectTheMovie(MovieList.Text)
                                end;
                            end
                          else
                            i := 0;
                          if Kol = 0 then
                            i := -1;
                          if i > -1 then
                            begin
                              try
                                Application.ProcessMessages;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                Application.ProcessMessages;
                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/', '  .....');
                                Application.ProcessMessages;
                              except
                                page3 := '';
                              end;
                              ii := Pos(FindBlocking, page3);
                              if (ii > 0) or (page3 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/picture/' + links[0] + '/');
                                  try
                                    Application.ProcessMessages;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    Application.ProcessMessages;
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/', '  .....');
                                    Application.ProcessMessages;
                                  except
                                    page3 := '';
                                  end;
                                  ii := Pos(FindBlocking, page3);
                                  if (ii > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      MovieBase.Free;
                                      Form.Free;
                                      LoadInfo.Destroy;
                                      Exit;
                                    end;
                                end;
                              if page3 <> '' then
                                begin
                                  ii := Pos('/im/kadr/', page3);
                                  if ii > 0 then
                                    delete(page3, 1, ii - 1);
                                  ii := Pos('.jpg', page3);
                                  if ii = 0 then
                                    ii := Pos('.JPG', page3);
                                  if ii > 0 then
                                    begin
                                      s := copy(page3, 1, ii - 1);
                                      s := ReverseString(s);
                                      ii := Pos('-', s);
                                      if ii > 0 then
                                        delete(s, 1, ii - 1);
                                      ii := Pos('/', s);
                                      if ii > 0 then
                                        begin
                                          s := copy(s, 1, ii - 1);
                                          ss := ReverseString(s);
                                        end;
                                    end;
                                end;
                              if links[i] = 'SEL' then
                                begin
                                  for ii := 0 to Kol - 1 do
                                    begin
                                      if Form.links[ii] = '1' then
                                        begin
                                          Application.ProcessMessages;
                                          if NeedURLDelay = 1 then
                                            Sleep(MaxURLDelay);
                                          Application.ProcessMessages;
                                          s := links[ii];
                                          if ResizeScreenshots = 0 then
                                            MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                              s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                          else
                                            GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                              s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                        end;
                                    end;
                                end
                              else
                                begin
                                  if links[i] = 'ALL' then
                                    begin
                                      for ii := 0 to Kol - 1 do
                                        begin
                                          Application.ProcessMessages;
                                          if NeedURLDelay = 1 then
                                            Sleep(MaxURLDelay);
                                          Application.ProcessMessages;
                                          s := links[ii];
                                          if ResizeScreenshots = 0 then
                                            MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                              s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                          else
                                            GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                              s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                        end;
                                    end
                                  else
                                    begin
                                      Application.ProcessMessages;
                                      if NeedURLDelay = 1 then
                                        Sleep(MaxURLDelay);
                                      Application.ProcessMessages;
                                      s := links[i];
                                      if ResizeScreenshots = 0 then
                                        MovieBase.GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                          s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg')
                                      else
                                        GetScreenFromURL('https://st.kp.yandex.net/im/kadr/' +
                                          s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg', 0);
                                    end;
                                end;
                            end;
                          links.Free;
                          MovieList.Free;
                          Form.links.Free;
                          Form.MovieList.Free;
                          Form.JPGLink.Free;
                        end;
                    end;
                end;
              if UseTemplates = 1 then
                begin
                  try
                    if FileExists(UserDir + 'Kinopoisk_zas_Description.ini') = false then
                      begin
                        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Description.ini') = true then
                          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Description.ini'), Pchar(UserDir +
                            'Kinopoisk_zas_Description.ini'), true);
                      end;
                  except
                  end;
                  if FileExists(UserDir + 'Kinopoisk_zas_Description.ini') = false then
                    begin
                      List := TStringList.Create;
                      List.Add('%%%%');
                      List.Add('<hr><b>:</b><br>%%%%');
                      List.Add('<hr><b>:</b><br>%%%%');
                      List.Add('<hr><b>  , : </b><br>%%%%');
                      List.Add('<hr><b>  3500 :</b><br>%%3500%%');
                      List.SaveToFile(UserDir + 'Kinopoisk_zas_Description.ini');
                      List.Free;
                    end;
                  Template := TStringList.Create;
                  Template.LoadFromFile(UserDir + 'Kinopoisk_zas_Description.ini');
                  Description := '';
                  for i := 0 to Template.Count - 1 do
                    begin
                      ii := Pos('%%', Template[i]);
                      if ii > 0 then
                        begin
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDescription <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDescription, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tAwards <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tAwards, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLinks <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLinks, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tZnaite <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tZnaite, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tErrors <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tErrors, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%3500%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBook3500 <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%3500%%', tBook3500, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLikeMovies <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLikeMovies, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSlogan <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSlogan, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBudget <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tBudget, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tMarketing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tMarketing, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborUS <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSborUS, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborWord <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSborWord, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborRF <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSborRF, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%DVD%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborDVD <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%DVD%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborDVD <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tPremDataWord <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tPremDataWord, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tPremDataRF <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tPremDataRF, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%DVD%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDVD <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%DVD%%', tDVD, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%BluRay%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBluRay <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%BluRay%%', tBluRay, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVisualEffectsStudio <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tVisualEffectsStudio, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoiceStudio <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tVoiceStudio, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tProkatStudio <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tProkatStudio, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRatingKinoPoisk <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRatingKinoPoisk, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRatingKritikov <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRatingKritikov, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%IMDb%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRatingIMDb <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%IMDb%%', tRatingIMDb, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tProducer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tProducer, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tOperator <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tOperator, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tComposer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tComposer, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoiceDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tVoiceDirector, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tVoice, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tTranslator, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tPainter, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tCutter, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                          ii := Pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRecenzia <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRecenzia, [rfReplaceAll]);
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                              Continue;
                            end;
                        end
                      else
                        begin
                          if Description <> '' then
                            Description := Description + ret;
                          Description := Description + Template[i];
                        end;
                    end;
                  Template.Free;
                  try
                    if FileExists(UserDir + 'Kinopoisk_zas_Comments.ini') = false then
                      begin
                        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Comments.ini') = true then
                          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Comments.ini'), Pchar(UserDir +
                            'Kinopoisk_zas_Comments.ini'), true);
                      end;
                  except
                  end;
                  if FileExists(UserDir + 'Kinopoisk_zas_Comments.ini') = false then
                    begin
                      List := TStringList.Create;
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>  :</b> %%%%');
                      List.Add('<b> DVD:</b> %%DVD%%');
                      List.Add('<b>  :</b> %%%%');
                      List.Add('<b>  :</b> %%%%');
                      List.Add('<b> ():</b> %%%%');
                      List.Add('<b> ():</b> %%%%');
                      List.Add('<b>  DVD:</b> %%DVD%%');
                      List.Add('<b>  Blu-Ray:</b> %%BluRay%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b> IMDb:</b> %%IMDb%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>c :</b> %%c%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b><br>%%%%');
                      List.Add('<hr><b> :</b><br>%%%%');
                      List.SaveToFile(UserDir + 'Kinopoisk_zas_Comments.ini');
                      List.Free;
                    end;
                  Template := TStringList.Create;
                  Template.LoadFromFile(UserDir + 'Kinopoisk_zas_Comments.ini');
                  Comment := '';
                  for i := 0 to Template.Count - 1 do
                    begin
                      ii := pos('%%', Template[i]);
                      if ii > 0 then
                        begin
                          if trim(Template[i]) = '' then
                            begin
                              Comment := Comment + ret;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDescription <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDescription, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tAwards <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tAwards, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLinks <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLinks, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tZnaite <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tZnaite, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tErrors <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tErrors, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%3500%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBook3500 <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%3500%%', tBook3500, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLikeMovies <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLikeMovies, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSlogan <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSlogan, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBudget <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tBudget, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tMarketing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tMarketing, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborUS <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSborUS, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborWord <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSborWord, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborRF <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSborRF, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%DVD%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborDVD <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%DVD%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSborDVD <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tPremDataWord <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tPremDataWord, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tPremDataRF <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tPremDataRF, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%DVD%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDVD <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%DVD%%', tDVD, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%BluRay%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBluRay <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%BluRay%%', tBluRay, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVisualEffectsStudio <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tVisualEffectsStudio, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoiceStudio <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tVoiceStudio, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tProkatStudio <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tProkatStudio, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRatingKinoPoisk <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRatingKinoPoisk, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRatingKritikov <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRatingKritikov, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%IMDb%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRatingIMDb <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%IMDb%%', tRatingIMDb, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tProducer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tProducer, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tOperator <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tOperator, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tComposer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tComposer, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoiceDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tVoiceDirector, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tVoice, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tTranslator, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tPainter, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoice <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tCutter, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRecenzia <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRecenzia, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                        end
                      else
                        begin
                          if Comment <> '' then
                            Comment := Comment + ret;
                          Comment := Comment + Template[i];
                        end;
                    end;
                  Template.Free;
                end;
              if DelHTML = 1 then
                begin
                  Comment := ClearHTML(Comment);
                  Description := ClearHTML(Description);
                end;
              if Comment <> '' then
                begin
                  if AddLoadInfoDate = 1 then
                    begin
                      if AddUPLoadInfoDate = 1 then
                        begin
                          if AddComments = 1 then
                            begin
                              if MovieBase.CurrentMovie.Comments <> '' then
                                begin
                                  s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                  i := Pos('<b> : <font', s);
                                  if i > 0 then
                                    begin
                                      s2 := Copy(s, 1, i - 1);
                                      delete(s, 1, i + 27);
                                      i := Pos('</font></b>', s);
                                      delete(s, 1, i + 10);
                                      s2 := DeleteLineBreaks(Trim(s2));
                                      s := DeleteLineBreaks(Trim(s));
                                      if s2 <> '' then
                                        begin
                                          if s <> '' then
                                            s2 := s2 + ret + s;
                                        end
                                      else
                                        s2 := s;
                                      if s2 <> '' then
                                        MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime() + ret + ret + s2 + ret + Comment
                                      else
                                        MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime() + ret + ret + Comment;
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime() + ret + ret + s + ret + Comment;
                                end
                              else
                                MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime() + ret + ret + Comment;
                            end
                          else
                            MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime() + ret + ret + Comment;
                          if CommentsAddBR = 1 then
                            MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret;
                        end
                      else
                        begin
                          if AddComments = 1 then
                            begin
                              if MovieBase.CurrentMovie.Comments <> '' then
                                begin
                                  s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                  i := Pos('<b> : <font', s);
                                  if i > 0 then
                                    begin
                                      s2 := Copy(s, 1, i - 1);
                                      delete(s, 1, i + 27);
                                      i := Pos('</font></b>', s);
                                      delete(s, 1, i + 10);
                                      s2 := DeleteLineBreaks(Trim(s2));
                                      s := DeleteLineBreaks(Trim(s));
                                      if s2 <> '' then
                                        begin
                                          if s <> '' then
                                            s2 := s2 + ret + s;
                                        end
                                      else
                                        s2 := s;
                                      if s2 <> '' then
                                        MovieBase.CurrentMovie.Comments := s2 + ret + Comment + ret + ret + LoadInfo.GetLoadTime()
                                      else
                                        MovieBase.CurrentMovie.Comments := Comment + ret + ret + LoadInfo.GetLoadTime();
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := s + ret + Comment + ret + ret + LoadInfo.GetLoadTime();
                                end
                              else
                                MovieBase.CurrentMovie.Comments := Comment + ret + ret + LoadInfo.GetLoadTime();
                            end
                          else
                            MovieBase.CurrentMovie.Comments := Comment + ret + ret + LoadInfo.GetLoadTime();
                          if CommentsAddBR = 1 then
                            MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret;
                        end;
                    end
                  else
                    begin
                      if AddComments = 1 then
                        begin
                          if MovieBase.CurrentMovie.Comments <> '' then
                            MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret + Comment
                          else
                            MovieBase.CurrentMovie.Comments := Comment;
                        end
                      else
                        MovieBase.CurrentMovie.Comments := Comment;
                      if CommentsAddBR = 1 then
                        MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret;
                    end;
                end
              else
                begin
                  if AddLoadInfoDate = 1 then
                    begin
                      if AddUPLoadInfoDate = 1 then
                        begin
                          if AddComments = 1 then
                            begin
                              if MovieBase.CurrentMovie.Comments <> '' then
                                begin
                                  s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                  i := Pos('<b> : <font', s);
                                  if i > 0 then
                                    begin
                                      s2 := Copy(s, 1, i - 1);
                                      delete(s, 1, i + 27);
                                      i := Pos('</font></b>', s);
                                      delete(s, 1, i + 10);
                                      s2 := DeleteLineBreaks(Trim(s2));
                                      s := DeleteLineBreaks(Trim(s));
                                      if s2 <> '' then
                                        begin
                                          if s <> '' then
                                            s2 := s2 + ret + s;
                                        end
                                      else
                                        s2 := s;
                                      if s2 <> '' then
                                        MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime() + ret + ret + s2
                                      else
                                        MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime();
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime() +
                                      ret + ret + s;
                                end
                              else
                                MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime();
                            end
                          else
                            MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime();
                        end
                      else
                        begin
                          if AddComments = 1 then
                            begin
                              if MovieBase.CurrentMovie.Comments <> '' then
                                begin
                                  s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                  i := Pos('<b> : <font', s);
                                  if i > 0 then
                                    begin
                                      s2 := Copy(s, 1, i - 1);
                                      delete(s, 1, i + 27);
                                      i := Pos('</font></b>', s);
                                      delete(s, 1, i + 10);
                                      s2 := DeleteLineBreaks(Trim(s2));
                                      s := DeleteLineBreaks(Trim(s));
                                      if s2 <> '' then
                                        begin
                                          if s <> '' then
                                            s2 := s2 + ret + s;
                                        end
                                      else
                                        s2 := s;
                                      if s2 <> '' then
                                        MovieBase.CurrentMovie.Comments := s2 + ret + ret + LoadInfo.GetLoadTime()
                                      else
                                        MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime();
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := s + ret + ret + LoadInfo.GetLoadTime();
                                end
                              else
                                MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime();
                            end
                          else
                            MovieBase.CurrentMovie.Comments := LoadInfo.GetLoadTime();
                        end;
                    end;
                end;
              if Description <> '' then
                begin
                  if AddDescription = 1 then
                    begin
                      if MovieBase.CurrentMovie.Description <> '' then
                        MovieBase.CurrentMovie.Description := MovieBase.CurrentMovie.Description + ret + Description
                      else
                        MovieBase.CurrentMovie.Description := Description;
                    end
                  else
                    MovieBase.CurrentMovie.Description := Description;
                  if DescriptionAddBR = 1 then
                    MovieBase.CurrentMovie.Description := MovieBase.CurrentMovie.Description + ret;
                end;
              if DelAndSave = 1 then
                begin
                  if trim(MovieBase.CurrentMovie.Genre) = '' then
                    MovieBase.CurrentMovie.Genre := OldGenre;
                  if trim(MovieBase.CurrentMovie.Country) = '' then
                    MovieBase.CurrentMovie.Country := OldCountry;
                  if trim(MovieBase.CurrentMovie.Director) = '' then
                    MovieBase.CurrentMovie.Director := OldDirector;
                  if trim(MovieBase.CurrentMovie.Scenario) = '' then
                    MovieBase.CurrentMovie.Scenario := OldScenario;
                  if trim(MovieBase.CurrentMovie.Actors) = '' then
                    MovieBase.CurrentMovie.Actors := OldActors;
                  if trim(MovieBase.CurrentMovie.Studio) = '' then
                    MovieBase.CurrentMovie.Studio := OldStudio;
                end;
            end;
        end
      else
        begin
          links.Free;
          MovieList.Free;
        end;
    end;
  Form.Data.Free;
  Form.Free;
  LoadInfo.Destroy;
  MovieBase.Free;
end;

exports
  GetBaseName4, AMM_NewBasePluginStart4, Init4, GetVersion4;
begin
  SetThreadLocale(1049);
end.
