library Kinopoisk_zas_person;

uses
  amm_pluginapi,
  UpdateFormUnit in '..\Kinopoisk_zas_up\UpdateFormUnit.pas' {Form3},
  InfoLoad in '..\Kinopoisk_zas\InfoLoad.pas' {LoadInfo},
  PersonFind in 'PersonFind.pas' {FindPerson},
  ShlObj, Windows, Classes, Forms, SysUtils, Dialogs, IniFiles, StrUtils;

{$R *.res}

const
  ret = #13#10;
  INTERNET_CONNECTION_MODEM = 1;
  INTERNET_CONNECTION_LAN = 2;
  INTERNET_CONNECTION_PROXY = 4;

var
  MovieBase: TMovieBase;
  LoadInfo: TLoadInfo;
  VerForm: TForm3;

function GetVersion4: Integer; far;
begin
  Result := 193;
end;

function GetBaseName4: Pchar; far;
begin
  Result := 'KinoPoisk.ru (z_a_s)';
end;

procedure Init4(Owner: Integer); far;
begin
  OwnerAPP := Owner;
end;

function InternetGetConnectedState(lpdwFlags: LPDWORD; dwReserved: DWORD): BOOL; stdcall; external 'wininet.dll' name 'InternetGetConnectedState';

function IsInternetConnected: Boolean;
var
  dwConnectionTypes: DWORD;
begin
  dwConnectionTypes := INTERNET_CONNECTION_MODEM or
    INTERNET_CONNECTION_LAN or
    INTERNET_CONNECTION_PROXY;
  Result := InternetGetConnectedState(@dwConnectionTypes, 0);
end;

function PosExD(const SubStr, s: string; Direct: Integer; Offset: Cardinal = 1): Integer;
var
  i, j, LenSubStr: Integer;
begin
  if Direct >= 0 then
    begin
      Result := PosEx(SubStr, s, Offset);
      Exit;
    end;
  i := Offset;
  LenSubStr := Length(SubStr);
  while i >= LenSubStr do
  begin
    if s[i] = SubStr[ LenSubStr ] then
    begin
      j := 1;
      while (j < LenSubStr) and (s[i - j] = SubStr[LenSubStr - j]) do
        Inc(j);
      if (j = LenSubStr) then
      begin
        Result := (i - LenSubStr) + 1;
        exit;
      end;
    end;
    Dec(i);
  end;
  Result := 0;
end;

function CorrectRequest(req: string): string;
var
  s: string;
  i: Integer;
begin
  s := '';
  for i := 1 to length(req) do
    s := s + '%' + IntToHex(ord(req[i]), 2);
  s := stringreplace(s, '%20', '+', [rfReplaceAll]);
  Result := s;
end;

function AnsiUpFirstLetter(const AStr: string): string;
var
  s: string;
begin
  Result := AnsiLowerCase(AStr);
  s := AnsiUpperCase(Astr);
  if length(s) > 0 then
    Result[1] := s[1]
  else
    Result := '';
end;

function HTMLRemoveTags(const AStr: string): string;
var
  s: string;
begin
  s := AStr;
  while (pos('<script', s) > 0) and (pos('</script>', s) > 0) and (pos('</script>', s) > pos('<script', s)) do
    delete(s, pos('<script', s), pos('</script>', s) - pos('<script', s) + 9);
  while (pos('<', s) > 0) and (pos('>', s) > 0) and (pos('>', s) > pos('<', s)) do
    delete(s, pos('<', s), pos('>', s) - pos('<', s) + 1);
  Result := TrimRight(TrimLeft(s));
end;

function DelProb(const AStr: string): string;
var
  s: string;
begin
  s := AStr;
  while pos('  ', s) <> 0 do
    s := StringReplace(s, '  ', ' ', [rfreplaceall]);
  Result := TrimRight(TrimLeft(s));
end;

function ReplaceTagWithChar(text, html_tag: string; char_code: Char): string;
var
  i, j: integer;
begin
  j := 0;
  i := Pos(html_tag, text);
  while i > j do
    begin
      text[i] := char_code;
      text[i + 1] := ' ';
      text[i + 2] := '<';
      j := i;
      i := Pos(html_tag, text);
    end;
  Result := text;
end;

function HTMLDecode(const AStr: String): String;
var
  Sp, Rp, Cp, Tp: PChar;
  S: String;
  I, Code: Integer;
begin
  SetLength(Result, Length(AStr));
  Sp := PChar(AStr);
  Rp := PChar(Result);
  Cp := Sp;
  try
    while Sp^ <> #0 do
      begin
        case Sp^ of
          '\':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                'u':
                  begin
                    Tp := Sp;
                    Inc(Tp);
                    while (Sp^ in ['u','0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f']) do
                      Inc(Sp);
                    SetString(S, Tp, Sp - Tp);
                    dec(Sp);
                    Val('x'+S, I, Code);
                    if I >= $10000 then
                      begin
                        Rp^ := Char(((I - $10000) div $400) + $d800);
                        Inc(Rp);
                        Rp^ := Char(((I - $10000) and $3ff) + $dc00);
                      end
                    else
                      Rp^ := Chr((I));
                  end;
              end;
            end;
          '&':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                ' ':
                  begin
                    Rp^ := '&';
                    Inc(Rp);
                    Rp^ := ' ';
                  end;
                'n':
                  begin
                    if AnsiStrPos(Sp, 'nbsp;') = Sp then
                      begin
                        inc(Sp, 4);
                        Rp^ := ' ';
                      end;
                    if AnsiStrPos(Sp, 'ndash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'm':
                  begin
                    if AnsiStrPos(Sp, 'mdash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'b':
                  if AnsiStrPos(Sp, 'bull;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '|';
                    end;
                'a':
                  if AnsiStrPos(Sp, 'amp;') = Sp then
                    begin
                      Inc(Sp, 3);
                      Rp^ := '&';
                    end;
                'l', 'g':
                  begin
                    if (AnsiStrPos(Sp, 'lt;') = Sp) or (AnsiStrPos(Sp, 'gt;') = Sp) then
                      begin
                        Cp := Sp;
                        Inc(Sp, 2);
                        while (Sp^ <> ';') and (Sp^ <> #0) do
                          Inc(Sp);
                        if Cp^ = 'l' then
                          Rp^ := '<'
                        else
                          Rp^ := '>';
                      end;
                    if (AnsiStrPos(Sp, 'laquo;') = Sp) then
                      begin
                        Inc(Sp, 5);
                        Rp^ := '"';
                      end;
                  end;
                'r':
                  if (AnsiStrPos(Sp, 'raquo;') = Sp) then
                    begin
                      Inc(Sp, 5);
                      Rp^ := '"';
                    end;
                'q':
                  if AnsiStrPos(Sp, 'quot;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '"';
                    end;
                '#':
                begin
                  Tp := Sp;
                  Inc(Tp);
                  while (Sp^ <> ';') and (Sp^ <> #0) do
                    Inc(Sp);
                  SetString(S, Tp, Sp - Tp);
                  Val(S, I, Code);
                  if I >= $100 then
                    begin
                      S := WideChar(I);
                      Rp^ := S[1];
                    end
                  else
                    Rp^ := Chr((I));
                end;
              end;
            end
        else
          Rp^ := Sp^;
        end;
        Inc(Rp);
        Inc(Sp);
      end;
  except
  end;
  SetLength(Result, Rp - PChar(Result));
end;

function ClearHTML(s: string): string;
var
  i, c: integer;
  stt, st1: string;
begin
  s := stringreplace(s, ret, '$ret$', [rfReplaceAll]);
  s := stringreplace(s, '&nbsp;', ' ', [rfReplaceAll]);
  s := stringreplace(s, #$A, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, #9, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<hr>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</p>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</li>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</div>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '&#8211;', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '$ret$', ret, [rfReplaceAll]);
  s := trim(HTMLDecode(s));
  s := HTMLRemoveTags(s);
  c := 0;
  for i := 1 to Length(s) do
    begin
      stt := copy(s, i, 1);
      if (stt = ' ') and (c >= 1) then
        begin
          stt := '';
          c := c + 1;
        end
      else
        begin
          if (stt = ' ') and (c = 0) then
            c := c + 1
          else
            if (stt <> ' ') then
              c := 0;
        end;
      st1 := st1 + stt;
    end;
  Result := st1;
end;

function ReplaceLatinExt(s: string): string;
begin
  s := stringreplace(s, '&#224;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#225;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#226;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#227;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#228;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#229;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#230;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe0;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe1;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe2;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe3;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe4;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe5;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe6;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#257;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#259;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#261;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#462;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#479;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#481;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#483;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#507;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#509;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#513;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#515;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#551;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#592;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#11365;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&agrave;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aacute;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&acirc;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&atilde;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&auml;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aring;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aelig;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#192;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#193;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#194;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#195;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#196;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#197;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#198;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc0;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc1;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc2;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc3;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc4;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc5;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc6;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#256;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#258;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#260;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#461;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#478;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#480;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#482;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#506;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#508;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#512;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#514;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#550;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#570;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#11375;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&AElig;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aring;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Auml;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Atilde;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Acirc;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aacute;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Agrave;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#384;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#387;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#595;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#385;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#386;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#579;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#665;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#231;', 'c', [rfReplaceAll]); 
  s := stringreplace(s, '&ccedil;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#xe7;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#263;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#265;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#267;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#269;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#392;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#572;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#597;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#663;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#199;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#xc7;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#262;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#264;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#266;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#268;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#391;', 'C', [rfReplaceAll]); 
  s := stringreplace(s, '&#571;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&Ccedil;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#240;', 'd', [rfReplaceAll]);  
  s := stringreplace(s, '&#xf0;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#271;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#273;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#396;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#454;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#499;', 'd', [rfReplaceAll]);   
  s := stringreplace(s, '&#545;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&#568;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#598;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#599;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#675;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#677;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&eth;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#208;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&Eth;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&ETH;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#xd0;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#270;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&#272;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#393;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#394;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#395;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#452;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#453;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#497;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#498;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#232;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#233;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#234;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#235;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe8;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xea;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xeb;', 'e', [rfReplaceAll]); 
  s := stringreplace(s, '&#xE9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEa;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEb;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#275;', 'e', [rfReplaceAll]);  
  s := stringreplace(s, '&#277;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#279;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#281;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#283;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#477;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#517;', 'e', [rfReplaceAll]);    
  s := stringreplace(s, '&#519;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#553;', 'e', [rfReplaceAll]); 
  s := stringreplace(s, '&#583;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#600;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#603;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#604;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#605;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#606;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#666;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#11384;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&egrave;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&eacute;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&ecirc;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&euml;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#200;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#201;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#202;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#203;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc8;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc9;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xca;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xcb;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#274;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#276;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#278;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#280;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#282;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#398;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#400;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#516;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#518;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#552;', 'E', [rfReplaceAll]); 
  s := stringreplace(s, '&#582;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#11387;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Egrave;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Eacute;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Ecirc;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Euml;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#402;', 'f', [rfReplaceAll]);   
  s := stringreplace(s, '&fnof;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#x192;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#401;', 'F', [rfReplaceAll]);
  s := stringreplace(s, '&#285;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#287;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#289;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#291;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#485;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#487;', 'g', [rfReplaceAll]);  
  s := stringreplace(s, '&#501;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#608;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#609;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#284;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#286;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#288;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#290;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#403;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#484;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#486;', 'G', [rfReplaceAll]);  
  s := stringreplace(s, '&#500;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#610;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#667;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#293;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#295;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#543;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#613;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#614;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#686;', 'h', [rfReplaceAll]);   
  s := stringreplace(s, '&#687;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11368;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11382;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#292;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#294;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#542;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#668;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11367;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11381;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#236;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#237;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#238;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#239;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xec;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xed;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xee;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xef;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#299;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#301;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#303;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#305;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#307;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#297;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#410;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#464;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#521;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#523;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#616;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&igrave;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&icirc;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iuml;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#204;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#205;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#206;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#207;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcd;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xce;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcf;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#296;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#298;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#300;', 'I', [rfReplaceAll]); 
  s := stringreplace(s, '&#302;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#304;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#306;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#407;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#463;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#520;', 'I', [rfReplaceAll]);  
  s := stringreplace(s, '&#522;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#618;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Igrave;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iacute;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Icirc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iuml;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#11361;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#309;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#496;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#567;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#585;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#607;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#644;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#669;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#11388;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#308;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#584;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#311;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#312;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#409;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#489;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#670;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#11370;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#310;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#408;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#488;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#11369;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#314;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#316;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#318;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#320;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#322;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#457;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#564;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#620;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#621;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#682;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#683;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#313;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#315;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#317;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#319;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#321;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#455;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#456;', 'L', [rfReplaceAll]); 
  s := stringreplace(s, '&#573;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#619;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#671;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11360;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11362;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#623;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#624;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#625;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#412;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#11374;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#241;', 'n', [rfReplaceAll]); 
  s := stringreplace(s, '&ntilde;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#xf1;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#324;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#326;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#328;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#329;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#331;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#414;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#460;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#505;', 'n', [rfReplaceAll]);  
  s := stringreplace(s, '&#565;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#626;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#627;', 'n', [rfReplaceAll]);
  s := stringreplace(s, 'ñ', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#209;', 'N', [rfReplaceAll]); 
  s := stringreplace(s, '&Ntilde;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&&#xd1;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#323;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#325;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#327;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#330;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#413;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#458;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#459;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#504;', 'N', [rfReplaceAll]);  
  s := stringreplace(s, '&#544;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#628;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#242;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#243;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#244;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#245;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#246;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#248;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf2;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf3;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf4;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf5;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf6;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#xf8;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#333;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#335;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#337;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#339;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#x153;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#417;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#419;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#466;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#491;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#493;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#511;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#525;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#527;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#547;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#555;', 'o', [rfReplaceAll]);    
  s := stringreplace(s, '&#557;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#559;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#561;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#596;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#629;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ograve;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oacute;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ocirc;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oelig;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&otilde;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ouml;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oslash;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#210;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#211;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#212;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#213;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#214;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#216;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd2;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd3;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd4;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd5;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd6;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd8;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#332;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#334;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#336;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#338;', 'O', [rfReplaceAll]); 
  s := stringreplace(s, '&#x152;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#390;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#415;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#416;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#418;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#465;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#490;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#492;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#510;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#524;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#526;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#546;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#554;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#556;', 'O', [rfReplaceAll]);      
  s := stringreplace(s, '&#558;', 'O', [rfReplaceAll]);    
  s := stringreplace(s, '&#560;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#630;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#11386;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ograve;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oacute;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ocirc;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&OElig;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Otilde;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ouml;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oslash;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#421;', 'p', [rfReplaceAll]);
  s := stringreplace(s, '&#420;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#11363;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#569;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#587;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#672;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#586;', 'Q', [rfReplaceAll]);
  s := stringreplace(s, '&#341;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#343;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#345;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#529;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#531;', 'r', [rfReplaceAll]);  
  s := stringreplace(s, '&#589;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#633;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#634;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#635;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#636;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#637;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#638;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#639;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#11385;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#340;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#342;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#344;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#528;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#530;', 'R', [rfReplaceAll]); 
  s := stringreplace(s, '&#588;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#640;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#641;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#11364;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#223;', 's', [rfReplaceAll]); 
  s := stringreplace(s, '&szlig;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#xdf;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#347;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#349;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#351;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#353;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&scaron;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#x161;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#383;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#537;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#575;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#642;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#346;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#348;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#350;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#352;', 'S', [rfReplaceAll]); 
  s := stringreplace(s, '&Scaron;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#x160;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#536;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#11390;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#355;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#357;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#359;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#427;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#429;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#539;', 't', [rfReplaceAll]);   
  s := stringreplace(s, '&#566;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#647;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#648;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#678;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#680;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#354;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#356;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#358;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#428;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#430;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#538;', 'T', [rfReplaceAll]);   
  s := stringreplace(s, '&#574;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#11366;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#254;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&thorn;', 'th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xfe;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&#222;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&THORN;', 'Th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xde;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&#249;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#250;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#251;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#252;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xf9;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfa;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfb;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#361;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#363;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#365;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#367;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#369;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#371;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#432;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#468;', 'u', [rfReplaceAll]);  
  s := stringreplace(s, '&#470;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#472;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#474;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#476;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#533;', 'u', [rfReplaceAll]);     
  s := stringreplace(s, '&#535;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#649;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ugrave;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uacute;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ucirc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uuml;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#217;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#218;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#219;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#220;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xd9;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xda;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdb;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#360;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#362;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#364;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#366;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#368;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#370;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#431;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#467;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#469;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#471;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#473;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#475;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#532;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#534;', 'U', [rfReplaceAll]);      
  s := stringreplace(s, '&#580;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ugrave;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uacute;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ucirc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uuml;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#651;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#652;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11377;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11380;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#434;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#581;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#11389;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#373;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#653;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#11379;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#372;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#11378;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#253;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&yacute;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xfd;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#255;', 'y', [rfReplaceAll]); 
  s := stringreplace(s, '&yuml;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xff;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#375;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#422;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#436;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#563;', 'y', [rfReplaceAll]);  
  s := stringreplace(s, '&#591;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#654;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#221;', 'Y', [rfReplaceAll]); 
  s := stringreplace(s, '&Yacute;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#xdd;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#374;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#376;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&Yuml;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#x178;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#435;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#562;', 'Y', [rfReplaceAll]);  
  s := stringreplace(s, '&#590;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#655;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#378;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#380;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#382;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#438;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#549;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#576;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#656;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#657;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#11372;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#377;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#379;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#381;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#437;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#548;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11371;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11391;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&Middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&#769;', '', [rfReplaceAll]);
  Result := s;
end;

function ClearName(s: string): string;
begin
  s := stringreplace(s, ' ', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, ' ', '', [rfReplaceAll, rfIgnoreCase]);
  Result := s;
end;

function CharReplace(s: string): string;
begin
  s := stringreplace(s, '"', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '`', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
  Result := s;
end;

function Before(Src, s: string): string;
var
  f: Word;
begin
  f := Pos(AnsiLowerCase(Src), ANSILowerCase(s));
  if f = 0 then
    Before := s
  else
    Before := Copy(s, 1, f - 1);
end;

function After(Src, s: string): string;
var
  f: Word;
begin
  f := Pos(ANSILowercase(Src), ANSILowercase(s));
  if f = 0 then
    After := ''
  else
    After := Copy(s, f + Length(src), Length(s));
end;

function GetText(SubStr, b, a: string; var Str: string): string;
begin
  if Pos(SubStr, Str) > 0 then
    begin
      Str := After(SubStr, Str);
      Result := Before(b, After(a, Str));
    end
  else Result := '';
end;

function RusToTranslit(s: string): string;
const
  rus='Ũ';
  trans: array[1..66] of string =(
   'a','b','v','g','d','e','e','zh','z','i','y','k','l',
   'm','n','o','p','r','s','t','u','f','kh','ts','ch','sh',
   'shc','','y','','e','yu','ya',
   'A','B','V','G','D','E','E','Zh','Z','I','Y','K','L',
   'M','N','O','P','R','S','T','U','F','Kh','Ts','Ch','Sh',
   'Shc','','Y','','E','Yu','Ya');
var
res: string;
i: Integer;
begin
  res := '';
  for i := 1 to Length(s) do
  begin
    if Pos(s[i], rus) > 0 then
      res := res + trans[Pos(s[i], rus)]
    else
       res := res + s[i];
    Result:=res;
  end;
end;

function GetSpecialPath(CSIDL: word): string;
var s: string;
begin
  SetLength(s, MAX_PATH);
  if not SHGetSpecialFolderPath(0, PChar(s), CSIDL, true) then
    s := '';
  result := PChar(s);
end;

procedure SaveResultHtmlText(const s: string; const Name: string = 'htmlsource');
var
  ResFile: TextFile;
  FilePath: string;
begin
  try 
    FilePath := GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\plugins\Logs\';
    if DirectoryExists(FilePath) = False then
      CreateDir(FilePath);
    AssignFile(ResFile, FilePath + Name + '.txt');
    Rewrite(ResFile);
    WriteLn (ResFile, s);
    CloseFile(ResFile);
  except
    ShowMessage('     ');
  end;
end;

procedure GetBrowserWindow(const URL: string);
begin
  LoadInfo.SetBrowserWindow;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  while LoadInfo.Visible = True do
    Application.HandleMessage;
end;

function GetInfoFromUrl(const URL, LCaption: string): string;
begin
  LoadInfo.SetFormWindow;
  LoadInfo.Label1.Caption := LCaption;
  LoadInfo.Show;
  LoadInfo.GoToURL(URL);
  Result := Utf8Decode(LoadInfo.GetSourceCode);
  LoadInfo.ClearSourceCode;
end;

procedure AMM_NewNamePluginStart4(OrigTitle: Pchar; tlength: Integer); far;
const
  FindBlocking = '/captcha/'; //'IP-  ';
var
  FindPerson: TFindPerson;
  Query: string;
  page, page2: string;
  links, List, Template, NameList: TStringList;
  s, s2, s3, s4, s5: string;
  i, j, ii, jj, NotSelectName, kol, Index, Load, UseTemplates, FilmAsLink, OtherColor, IfFillURL, DelHTML, SaveSourceCode: Integer;
  CurrentNameURL, NameCode: string;
  Comment, Filmography, Biography, Sex, Awards, Link, Color: string;
  tRost, tDeadDay, tDeadPlace, tSuprug, tSupruga, tAwards, tLinks, tZnaite, tTotalFilms: string;
  tGenre, tFirstFilm, tLastFilm, tBestFilms, tActor, tActress, tActorDubbing, tActressDubbing: string;
  tActorHimself, tActressHerself, tDirector, tVoiceDirector, tWriter, tProducer, tOperator, tComposer: string;
  uName, uAltName, uRusAltName, uBirthDay, uBirthPlace, uFilmography, uFoto, uLinks: Integer;
  uFillAltName, uSwapNameAltName, uDeadDay, uDeadPlace, uRost, uSuprug, uZnaite, uBold, uAwards, ZnaiteIns: Integer;
  uTotalFilms, uGenre, uFirstFilm, uLastFilm, uBestFilms, AddLoadInfoDate, AddUPLoadInfoDate: Integer;
  cRost, cSuprug, cDeadDay, cDeadPlace, cTotalFilms, cGenre, cFirstFilm, cLastFilm: Integer;
  cBestFilms, cZnaite, cAwards, cLinks, NeedURLDelay, MaxURLDelay: Integer;
  AutoCheck, NewVer, Ver, ProxyPort, FoundedItems,SearchBasedOnMovies, CountPersonForSearch: Integer;
  ProxyServer, ProxyUsername, ProxyPassword: string;
  LastDate, LoadDate, StrVal, UserDir: string;
  uMovies: array of array of string;
  Founded: Boolean;
begin
  try
    UserDir := GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\plugins\';
    if DirectoryExists(UserDir) = False then
      begin
        if DirectoryExists(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\') = False then
          CreateDir(GetSpecialPath(CSIDL_PERSONAL) + '\AllMyMovies\');
        CreateDir(UserDir);
      end;
    if FileExists(UserDir + 'Kinopoisk_zas.ini') = False then
      begin
        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini') = true then
          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas.ini'), Pchar(UserDir + 'Kinopoisk_zas.ini'), true);
      end;
  except
  end;
  if FileExists(UserDir + 'Kinopoisk_zas.ini') = false then
    begin
      List := TStringList.Create;
      List.Add('[DownloadAll]');
      List.Add('[CommentsOptions]');
      List.Add('[DescriptionOptions]');
      List.Add('[RatingOptions]');
      List.Add('[OtherOptions]');
      List.Add('[NameOptions]');
      List.Add('[KinoPoiskOptions]');
      List.Add('[ProxyOptions]');
      List.SaveToFile(UserDir + 'Kinopoisk_zas.ini');
      List.Free;
    end;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      uName := ReadInteger('NameOptions', 'Name', 1);
      uAltName := ReadInteger('NameOptions', 'AltName', 1);
      uRusAltName := ReadInteger('NameOptions', 'RusAltName', 0);
      uFillAltName := ReadInteger('NameOptions', 'FillAltName', 0);
      uSwapNameAltName := ReadInteger('NameOptions', 'SwapNameAltName', 0);
      uBirthDay := ReadInteger('NameOptions', 'BirthDay', 1);
      uBirthPlace := ReadInteger('NameOptions', 'BirthPlace', 1);
      uFilmography := ReadInteger('NameOptions', 'Filmography', 1);
      uFoto := ReadInteger('NameOptions', 'Foto', 1);
      uDeadDay := ReadInteger('NameOptions', 'DeadDay', 1);
      uDeadPlace := ReadInteger('NameOptions', 'DeadPlace', 1);
      uRost := ReadInteger('NameOptions', 'Rost', 1);
      uSuprug := ReadInteger('NameOptions', 'Suprug', 1);
      uZnaite := ReadInteger('NameOptions', 'Znaite', 1);
      uLinks := ReadInteger('NameOptions', 'Links', 0);
      uAwards := ReadInteger('NameOptions', 'Awards', 1);
      uTotalFilms := ReadInteger('NameOptions', 'TotalFilms', 0);
      uGenre := ReadInteger('NameOptions', 'Genre', 0);
      uFirstFilm := ReadInteger('NameOptions', 'FirstFilm', 0);
      uLastFilm := ReadInteger('NameOptions', 'LastFilm', 0);
      uBestFilms := ReadInteger('NameOptions', 'BestFilms', 0);
      cRost := ReadInteger('NameOptions', 'cRost', 1);
      cSuprug := ReadInteger('NameOptions', 'cSuprug', 1);
      cDeadDay := ReadInteger('NameOptions', 'cDeadDay', 1);
      cDeadPlace := ReadInteger('NameOptions', 'cDeadPlace', 1);
      cTotalFilms := ReadInteger('NameOptions', 'cTotalFilms', 3);
      cGenre := ReadInteger('NameOptions', 'cGenre', 3);
      cFirstFilm := ReadInteger('NameOptions', 'cFirstFilm', 3);
      cLastFilm := ReadInteger('NameOptions', 'cLastFilm', 3);
      cBestFilms := ReadInteger('NameOptions', 'cBestFilms', 3);
      cZnaite := ReadInteger('NameOptions', 'cZnaite', 1);
      cAwards := ReadInteger('NameOptions', 'cAwards', 1);
      cLinks := ReadInteger('NameOptions', 'cLinks', 1);
      uBold := ReadInteger('NameOptions', 'Bold', 1);
      ZnaiteIns := ReadInteger('NameOptions', 'ZnaiteIns', 1);
      UseTemplates := ReadInteger('NameOptions', 'UseTemplates', 0);
      FilmAsLink := ReadInteger('NameOptions', 'FilmAsLink', 0);
      OtherColor := ReadInteger('NameOptions', 'OtherColor', 0);
      Color := ReadString('NameOptions', 'Color', '#ff6600');
      AddLoadInfoDate := ReadInteger('NameOptions', 'AddLoadInfoDate', 0);
      SearchBasedOnMovies := ReadInteger('NameOptions', 'SearchBasedOnMovies', 0);
      CountPersonForSearch := ReadInteger('NameOptions', 'CountPersonForSearch', 3);
      DelHTML := ReadInteger('NameOptions', 'DelHTML', 0);
      if DelHTML = 1 then
        uLinks := 0;
      AutoCheck := ReadInteger('OtherOptions', 'AutoCheck', 1);
      IfFillURL := ReadInteger('OtherOptions', 'IfFillURL', 1);
      NeedURLDelay := ReadInteger('OtherOptions', 'NeedURLDelay', 0);
      MaxURLDelay := ReadInteger('OtherOptions', 'MaxURLDelay', 0);
      if NeedURLDelay = 1 then
        begin
          if MaxURLDelay = 0 then
            MaxURLDelay := 500
          else
            if MaxURLDelay > 0 then
              MaxURLDelay := MaxURLDelay * 1000;
        end;
      AddUPLoadInfoDate := ReadInteger('OtherOptions', 'AddUPLoadInfoDate', 0);
      SaveSourceCode := ReadInteger('OtherOptions', 'SaveSourceCode', 0);
      // 
      ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
      ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
      ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
      ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
    finally
      Free;
    end;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
    try
      WriteInteger('Versions', 'Kinopoisk_zas_person', GetVersion4);
      LastDate := ReadString('LastDate', 'Kinopoisk_zas_person', '01/08/2009');
      LoadDate := ReadString('LastDate', 'LoadDate', '01/08/2009');
      WriteString('LastDate', 'Kinopoisk_zas_person', DateToStr(Date));
    finally
      Free;
    end;
  if AutoCheck = 1 then
    begin
      if LastDate <> DateToStr(Date) then //  
        begin
          VerForm := TForm3.Create(Application);
          VerForm.Caption := '   ';
          VerForm.CheckBox1.Caption := '    ';
          VerForm.Button2.Caption := '  c ';
          VerForm.UserDir := UserDir;
          if (LoadDate <> DateToStr(Date)) and IsInternetConnected then
            begin
              with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                try // 
                  VerForm.IdHTTP1.ProxyParams.ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
                  VerForm.IdHTTP1.ProxyParams.ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
                  VerForm.IdHTTP1.ProxyParams.ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
                  VerForm.IdHTTP1.ProxyParams.ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
                  if VerForm.IdHTTP1.ProxyParams.ProxyPassword <> '' then
                    VerForm.IdHTTP1.ProxyParams.BasicAuthentication := True;
                finally
                  Free;
                end;
              try
                page := VerForm.IdHTTP1.Get('http://films.unkas.net/files/plugins/Kinopoisk_zas_new.ini');
                Template := TStringList.Create;
                Template.Text := page;
                Template.SaveToFile(UserDir + 'Kinopoisk_zas_new.ini');
                Template.Free;
                with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
                  try
                    WriteString('LastDate', 'LoadDate', DateToStr(Date));
                  finally
                    Free;
                  end;
              except
              end;
            end;
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas_person', '---');
              NewVer := ReadInteger('Versions', 'Kinopoisk_zas_person', 0);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label3.Caption := s;
            finally
              Free;
            end;
          with TIniFile.Create(UserDir + 'Kinopoisk_zas_versions.ini') do
            try
              StrVal := ReadString('Versions', 'Kinopoisk_zas_person', '100');
              Ver := ReadInteger('Versions', 'Kinopoisk_zas_person', 100);
              s := copy(StrVal, 1, 1) + '.';
              delete(StrVal, 1, 1);
              s := s + StrVal;
              VerForm.Label2.Caption := s;
            finally
              Free;
            end;
          if NewVer > Ver then
            begin
              VerForm.Memo1.Clear;
              with TIniFile.Create(UserDir + 'Kinopoisk_zas_new.ini') do
                try
                  for i := NewVer downto Ver + 1 do
                    begin
                      StrVal := IntToStr(i);
                      s := copy(StrVal, 1, 1) + '.';
                      delete(StrVal, 1, 1);
                      s := s + StrVal;
                      StrVal := ReadString('Log', 'Kinopoisk_zas_person_' + IntToStr(i), '');
                      if StrVal <> '' then
                        begin
                          VerForm.Memo1.Lines.Add(' ' + s);
                          StrVal := stringreplace(StrVal, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
                          VerForm.Memo1.Text := VerForm.Memo1.Text + ret + StrVal + ret + ret;
                        end;
                    end;
                finally
                  Free;
                end;
              VerForm.ShowModal;
            end;
          VerForm.Free;
        end;
    end;
  MovieBase := TMovieBase.Create;
  SetString(Query, OrigTitle, tlength);
  LoadInfo := TLoadInfo.Create(Application);
  LoadInfo.EmbeddedWB1.ProxySettings.Address := ProxyServer;
  LoadInfo.EmbeddedWB1.ProxySettings.Password := ProxyPassword;
  LoadInfo.EmbeddedWB1.ProxySettings.Port := ProxyPort;
  LoadInfo.EmbeddedWB1.ProxySettings.UserName := ProxyUsername;
  if LoadInfo.EmbeddedWB1.ProxySettings.Password <> '' then
    LoadInfo.EmbeddedWB1.ProxySettings.AutoLoadProxy := True;
  Load := 1;
  Index := 0;
  j := 0;
  CurrentNameURL := MovieBase.CurrentName.URL;
  i := pos('kinopoisk.ru', CurrentNameURL);
  if i > 0 then
    begin //  ,  ...
      CurrentNameURL := stringreplace(CurrentNameURL, 'http:', 'https:', [rfReplaceAll, rfIgnoreCase]);
      if IfFillURL = 1 then
        begin
          i := MessageDlg(' URL  ?', mtConfirmation, [mbYes, mbNo], 0);
          if i = 6 then
            begin
              try
                Application.ProcessMessages;
                page := GetInfoFromUrl(CurrentNameURL + '/view_info/ok/', '    .....');
                Application.ProcessMessages;
              except
                page := '';
              end;
              i := pos(FindBlocking, page);
              if (i > 0) or (page = '') then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow(CurrentNameURL + '/view_info/ok/');
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := GetInfoFromUrl(CurrentNameURL + '/view_info/ok/', '    .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      MovieBase.Free;
                      LoadInfo.Destroy;
                      Exit;
                    end;
                end;
            end
          else
            begin
              try
                Application.ProcessMessages;
                page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/people/list/1/find/' +
                                                     CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                Application.ProcessMessages;
              except
                page := '';
              end;
              i := pos(FindBlocking, page);
              if (i > 0) or (page = '') then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow('https://www.kinopoisk.ru/s/type/people/list/1/find/' + CorrectRequest(Query) + '/order/relevant/perpage/10/');
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/people/list/1/find/' +
                                                         CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      MovieBase.Free;
                      LoadInfo.Destroy;
                      Exit;
                    end;
                end;
            end;
        end
      else
        if IfFillURL = 2 then
          begin
            try
              Application.ProcessMessages;
              page := GetInfoFromUrl(CurrentNameURL + '/view_info/ok/', '    .....');
              Application.ProcessMessages;
            except
              page := '';
            end;
            i := pos(FindBlocking, page);
            if (i > 0) or (page = '') then
              begin
                ShowMessage('    ');
                GetBrowserWindow(CurrentNameURL + '/view_info/ok/');
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := GetInfoFromUrl(CurrentNameURL + '/view_info/ok/', '    .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    MovieBase.Free;
                    LoadInfo.Destroy;
                    Exit;
                  end;
              end;
          end
        else
          begin
            try
              Application.ProcessMessages;
              page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/people/list/1/find/' +
                                                   CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
              Application.ProcessMessages;
            except
              page := '';
            end;
            i := pos(FindBlocking, page);
            if (i > 0) or (page = '') then
              begin
                ShowMessage('    ');
                GetBrowserWindow('https://www.kinopoisk.ru/s/type/people/list/1/find/' + CorrectRequest(Query) + '/order/relevant/perpage/10/');
                try
                  Application.ProcessMessages;
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  Application.ProcessMessages;
                  page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/people/list/1/find/' +
                                                       CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
                  Application.ProcessMessages;
                except
                  page := '';
                end;
                i := pos(FindBlocking, page);
                if (i > 0) or (page = '') then
                  begin
                    ShowMessage('    ');
                    MovieBase.Free;
                    LoadInfo.Destroy;
                    Exit;
                  end;
              end;
          end;
    end
  else
    begin // 
      try
        Application.ProcessMessages;
        page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/people/list/1/find/' +
                                             CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
        Application.ProcessMessages;
      except
        page := '';
      end;
      i := pos(FindBlocking, page);
      if (i > 0) or (page = '') then
        begin
          ShowMessage('    ');
          GetBrowserWindow('https://www.kinopoisk.ru/s/type/people/list/1/find/' + CorrectRequest(Query) + '/order/relevant/perpage/10/');
          try
            Application.ProcessMessages;
            if NeedURLDelay = 1 then
              Sleep(MaxURLDelay);
            Application.ProcessMessages;
            page := '@@@!!!@@@' + GetInfoFromUrl('https://www.kinopoisk.ru/s/type/people/list/1/find/' +
                                                 CorrectRequest(Query) + '/order/relevant/perpage/10/', '  .....');
            Application.ProcessMessages;
          except
            page := '';
          end;
          i := pos(FindBlocking, page);
          if (i > 0) or (page = '') then
            begin
              ShowMessage('    ');
              MovieBase.Free; 
              LoadInfo.Destroy;
              Exit;
            end;
        end;
    end;
  if page <> '@@@!!!@@@' then
    begin
      if SaveSourceCode = 1 then
        SaveResultHtmlText(page, 'PersonSearchInfo');
      links := TStringList.Create;
      NameList := TStringList.Create;
      NotSelectName := 0;
      kol := 0;
      if trim(page) = '@@@!!!@@@empty' then
        begin //  !
          ShowMessage(' ,      ');
          MovieBase.Free;
          LoadInfo.Destroy;
          Exit;
        end
      else
        begin
          i := pos('@@@!!!@@@', page);
          if i > 0 then
            begin
              s := page;
              i := pos(' :</dt>', s);
              if i > 0 then
                delete(s, 1, i + 19);
              i := Pos('<div class="right">', s);
              if i > 0 then
                begin
                  delete(s, 1, i + 18);
                  ii := 0;
                  while i > 0 do
                    begin
                      s2 := '';
                      s3 := '';
                      s5 := '';
                      j := pos('class="num">', s);
                      if j > 0 then
                        begin
                          ii := ii + 1;
                          s5 := copy(s, 1, j - 1);
                          delete(s, 1, j + 11);
                          j := Pos('<p class="name">', s5);
                          if j > 0 then
                            delete(s5, 1, j + 15);
                          j := Pos('data-id="', s5);
                          if j > 0 then
                            delete(s5, 1, j + 8);
                          j := Pos('"', s5);
                          s2 := trim(copy(s5, 1, j - 1)); // 
                          links.Add(s2);
                          j := Pos('">', s5);
                          delete(s5, 1, j + 1);
                          j := pos('</a>', s5);
                          s2 := copy(s5, 1, j - 1); // 
                          s2 := HTMLRemoveTags(s2);
                          s2 := ReplaceLatinExt(s2);
                          s2 := trim(HTMLDecode(s2));
                          s2 := CharReplace(s2);
                          delete(s5, 1, j + 3);
                          j := Pos('"year">', s5);
                          if j > 0 then
                            begin
                              delete(s5, 1, j + 6);
                              j := pos('</span>', s5);
                              s3 := copy(s5, 1, j - 1); // 
                              s3 := HTMLRemoveTags(s3);
                              s3 := trim(HTMLDecode(s3));
                              s3 := CharReplace(s3);
                            end;
                          j := pos('"gray">', s5);
                          if j > 0 then
                            delete(s5, 1, j + 6);
                          j := pos('</span>', s5);
                          s4 := copy(s5, 1, j - 1);
                          s4 := HTMLRemoveTags(s4); // .   
                          s4 := ReplaceLatinExt(s4);
                          s4 := trim(HTMLDecode(s4));
                          s4 := CharReplace(s4);
                          if s4 = '' then
                            begin
                              s4 := s2;
                              if s3 <> '' then
                                s4 := s4 + ' (' + s3 + ')';
                              s2 := '';
                            end;
                          if (trim(Query) = trim(s2)) or (trim(Query) = trim(s4)) then
                            begin
                              kol := kol + 1;
                              Index := ii - 1;
                            end;
                          if s2 <> '' then
                             begin
                               s4 := s2 + ' / ' + s4;
                               if s3 <> '' then
                                s4 := s4 + ' (' + s3 + ')';
                             end;
                          NameList.Add(s4);
                        end;
                      i := Pos('<div class="right">', s);
                      if i > 0 then
                        delete(s, 1, i + 18);
                    end;
                end;
            end
          else
            begin
              NotSelectName := 1;
              Load := 0;
              s := '';
              page := StringReplace(page, 'https://www.kinopoisk.ru:443/name/', 'https://www.kinopoisk.ru/name/', [rfReplaceAll, rfIgnoreCase]);
              i := pos('://www.kinopoisk.ru/name/', page);
              if i > 0 then
                begin
                  s := page;
                  delete(s, 1, i);
                  i := pos('/name/', s);
                  s := copy(s, i + 6, i + 38);
                  s2 := copy(s, 1, pos('/', s) - 1);
                end
              else
                begin
                  page := '';
                  s2 := '';
                end;
              links.Add(s2);
              NameList.Add('test' + s2);
              Index := 0;
            end;
        end;
      if kol = 1 then
        NotSelectName := 1;
      if NotSelectName = 0 then // ,  
        begin
          if (SearchBasedOnMovies = 1) and (MovieBase.CurrentName.MovieIDs <> '') then
            begin
              j := 0;
              for ii := 1 to Length(MovieBase.CurrentName.MovieIDs) do
                begin
                  if MovieBase.CurrentName.MovieIDs[ii] = ',' then
                    Inc(j);
                end;
              SetLength(uMovies, j + 1);
              for ii := Low(uMovies) to High(uMovies) do
                SetLength( uMovies[ii], 3);
              if j > 0 then
                begin
                  s := MovieBase.CurrentName.MovieIDs + ',';
                  for ii := 0 to j do
                    begin
                      uMovies[ii][0] := Trim(Copy(s, 1, Pos(',', s) - 1));
                      Delete(s, 1, Pos(',', s));
                    end;
                end
              else
                uMovies[0][0] := MovieBase.CurrentName.MovieIDs;
              FindPerson := TFindPerson.Create(Application);
              with FindPerson.SelQuery do
                begin
                  try
                    FindPerson.DBConnect.Database := MovieBase.Filename;
                    FindPerson.DBConnect.Connect;
                    for ii := Low(uMovies) to High(uMovies) do
                      begin
                        SQL.Text := 'SELECT originaltitle, Name FROM movies WHERE MovieID = ' + uMovies[ii][0];
                        DisableControls;
                        try
                          Execute;
                          First;
                          if RecordCount > 0 then
                            begin
                              uMovies[ii][1] := Fields.Fields[0].AsString;
                              uMovies[ii][2] := Fields.Fields[1].AsString;
                            end
                          else
                            uMovies := nil;
                        except
                          ShowMessage('   !');
                          uMovies := nil;
                        end;
                      end;
                    FindPerson.DBConnect.Disconnect;
                    FindPerson.Destroy;
                  except
                    ShowMessage('    !');
                    uMovies := nil;
                  end;
                end;
              Founded := False;
              if Length(uMovies) > 0 then
                begin
                  for ii := 0 to links.Count - 1 do
                    begin
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + links[ii] + '/view_info/ok/',
                                               '   .....');
                        Application.ProcessMessages;
                      except
                        page := '';
                      end;
                      i := pos(FindBlocking, page);
                      if (i > 0) or (page = '') then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/name/' + links[ii] + '/view_info/ok/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + links[ii] + '/view_info/ok/',
                                                   '   .....');
                            Application.ProcessMessages;
                          except
                            page := '';
                          end;
                          i := pos(FindBlocking, page);
                          if (i > 0) or (page = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free;
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      FoundedItems := 0;
                      s := page;
                      i := pos('> :<', s);
                      if i = 0 then
                        i := pos('class="specializationBox first_pers_block', s);
                      if i > 0 then
                        delete(s, 1, i);
                      for i := Low(uMovies) to High(uMovies) do
                        begin
                          if (Pos(uMovies[i][1], s) > 0) then
                            Inc(FoundedItems)
                          else
                            begin
                              if (Pos(uMovies[i][2], s) > 0) then
                                Inc(FoundedItems);
                            end;
                        end;
                      i := 0;
                      if FoundedItems > Length(uMovies) / 100 * 50 then
                        begin
                          Founded := True;
                          Load := 0;
                          i := ii;
                          break;
                        end;
                      if (CountPersonForSearch > 0) and (ii = CountPersonForSearch)then
                        break;
                    end;
                  uMovies := nil;
                end;
              if Founded = False then
                i := MovieBase.SelectTheName(NameList.Text);
            end
          else
            i := MovieBase.SelectTheName(NameList.Text);
        end
      else
        i := Index;
      if i > -1 then
        begin
          NameCode := links[i];
          Comment := '';
          Biography := '';
          Filmography := '';
          if Load = 1 then
            begin
              try
                Application.ProcessMessages;
                if NeedURLDelay = 1 then
                  Sleep(MaxURLDelay);
                Application.ProcessMessages;
                page := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + NameCode + '/view_info/ok/',
                                       '    .....');
                Application.ProcessMessages;
              except
                page := '';
              end;
              i := pos(FindBlocking, page);
              if (i > 0) or (page = '') then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow('https://www.kinopoisk.ru/name/' + NameCode + '/view_info/ok/');
                  try
                    Application.ProcessMessages;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    Application.ProcessMessages;
                    page := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + NameCode + '/view_info/ok/',
                                           '    .....');
                    Application.ProcessMessages;
                  except
                    page := '';
                  end;
                  i := pos(FindBlocking, page);
                  if (i > 0) or (page = '') then
                    begin
                      ShowMessage('    ');
                      MovieBase.Free;
                      LoadInfo.Destroy;
                      Exit;
                    end;
                end;
            end;
          if NameCode <> '' then
            MovieBase.CurrentName.URL := 'https://www.kinopoisk.ru/name/' + NameCode;
          ii := pos('<title>.ru.   </title>', page);
          if ii > 0 then
            begin
              ShowMessage('   !!!');
              MovieBase.Free;
              LoadInfo.Destroy;
              Exit;
            end;
          ii := pos('<title>404:    - </title>', page);
          if ii > 0 then
            begin
              ShowMessage('   !!!');
              MovieBase.Free;
              LoadInfo.Destroy;
              Exit;
            end;
          ii := pos('<title>404 -   </title>', page);
          if ii > 0 then
            begin
              ShowMessage('   !!!');
              MovieBase.Free;
              LoadInfo.Destroy;
              Exit;
            end;
          if NameCode = '' then
            begin
              ShowMessage('   !!!');
              MovieBase.Free;
              LoadInfo.Destroy;
              Exit;
            end;
          links.Free;
          NameList.Free;
          if page <> '' then
            begin //  
              page := ReplaceLatinExt(page);
              if SaveSourceCode = 1 then
                SaveResultHtmlText(page, 'PersonInfo');
              s := page;
              if uName = 1 then //
                begin
                  i := pos('<h1 class="moviename-big" itemprop="name">', s);
                  delete(s, 1, i + 41);
                  i := pos('</h1>', s);
                  s2 := copy(s, 1, i - 1);
                  s2 := HTMLRemoveTags(s2);
                  s2 := HTMLDecode(s2);
                  s2 := ClearName(s2);
                  s2 := CharReplace(s2);
                  MovieBase.CurrentName.Name := trim(s2);
                end;
              if uAltName = 1 then //. 
                begin
                  i := pos('<span itemprop="alternateName">', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 30);
                      i := pos('</span>', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := CharReplace(s2);
                          s2 := trim(s2);
                          if s2 <> '' then
                            MovieBase.CurrentName.AltName := trim(s2);
                        end;
                    end;
                end;
              if uRusAltName = 1 then
                begin
                  if (MovieBase.CurrentName.Name = MovieBase.CurrentName.AltName) or (MovieBase.CurrentName.AltName = '') then
                    begin
                      s2 := MovieBase.CurrentName.Name;
                      MovieBase.CurrentName.AltName := RusToTranslit(s2);
                    end;
                end;
              if MovieBase.CurrentName.AltName = MovieBase.CurrentName.Name then
                MovieBase.CurrentName.AltName := '';
              if uFillAltName = 1 then
                begin
                  if MovieBase.CurrentName.AltName = '' then
                    MovieBase.CurrentName.AltName := MovieBase.CurrentName.Name;
                end;
              if uSwapNameAltName = 1 then
                begin
                  if MovieBase.CurrentName.AltName <> '' then
                    begin
                      s4 := MovieBase.CurrentName.Name;
                      MovieBase.CurrentName.Name := MovieBase.CurrentName.AltName;
                      MovieBase.CurrentName.AltName := s4;
                    end;
                end;
              tRost := '';
              if uRost = 1 then //
                begin
                  s := page;
                  i := pos('></', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 6);
                      i := Pos('</', s);
                      if i > 0 then
                        begin
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tRost := s2;
                              if cRost = 1 then
                                begin
                                  if uBold = 1 then
                                    Comment := '<b>: </b>' + s2
                                  else
                                    Comment := ': ' + s2;
                                end;
                              if cRost = 2 then
                                begin
                                  if uBold = 1 then
                                    Biography := '<b>: </b>' + s2
                                  else
                                    Biography := ': ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              if uBirthDay = 1 then // 
                begin
                  MovieBase.CurrentName.BirthDay := '';
                  i := pos('> </', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 15);
                      i := Pos('<tr><td class="type">', s);
                      s2 := '<' + copy(s, 1, i - 1);
                      i := pos('/lists/m_act[birthday][day]', s2);
                      if i = 0 then
                        i := pos('/lists/m_act%5Bbirthday%5D%5Bday%5D/', s2);
                      if i > 0 then
                        begin
                          delete(s2, 1, i + 1);
                          i := pos('">', s2);
                          delete(s2, 1, i + 1);
                          i := Pos('</a>', s2);
                          s3 := copy(s2, 1, i - 1);
                          s3 := HTMLRemoveTags(s3);
                          s3 := HTMLDecode(s3);
                          s3 := trim(s3);
                          if s3 <> '' then
                            MovieBase.CurrentName.BirthDay := s3;
                        end
                      else
                        begin
                          i := pos('/lists/m_act[birthday][month]', s2);
                          if i = 0 then
                            i := pos('/lists/m_act%5Bbirthday%5D%5Bmonth%5D/', s2);
                          if i > 0 then
                            begin
                              delete(s2, 1, i + 1);
                              i := pos('">', s2);
                              delete(s2, 1, i + 1);
                              i := Pos('</a>', s2);
                              s3 := copy(s2, 1, i - 1);
                              s3 := HTMLRemoveTags(s3);
                              s3 := HTMLDecode(s3);
                              s3 := trim(s3);
                              if s3 <> '' then
                                MovieBase.CurrentName.BirthDay := s3;
                            end
                        end;
                      i := pos('/lists/m_act[birthday][year]', s2);
                      if i = 0 then
                        i := pos('/lists/m_act%5Bbirthday%5D%5Byear%5D/', s2);
                      if i > 0 then
                        begin
                          delete(s2, 1, i + 1);
                          i := pos('">', s2);
                          delete(s2, 1, i + 1);
                          i := Pos('</a>', s2);
                          s3 := copy(s2, 1, i - 1);
                          s3 := HTMLRemoveTags(s3);
                          s3 := HTMLDecode(s3);
                          s3 := trim(s3);
                          if s3 <> '' then
                            try
                              begin
                                ii := StrToint(s3);
                                if ii <> 0 then
                                  MovieBase.CurrentName.BirthYear := ii;
                              end;
                            except
                            end;
                        end;
                    end;
                end;
              s := stringreplace(s, '</a>', '', [rfReplaceAll, rfIgnoreCase]);
              if uBirthPlace = 1 then // 
                begin
                  MovieBase.CurrentName.BirthPlace := '';
                  MovieBase.CurrentName.BirthCountry := '';
                  i := pos('> </', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 16);
                      i := 1;
                      j := Pos('</', s);
                      if j > 0 then
                        begin
                          s2 := '<' + copy(s, i, j - i);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := stringreplace(s2, ', (', ' (', [rfReplaceAll, rfIgnoreCase]);
                          s2 := trim(s2);
                          if s2 <> '-' then
                            s3 := s2
                          else
                            s3 := '';
                          i := Pos(', ', s3);
                          if i > 0 then
                            begin
                              s2 := '';
                              repeat
                                if s2 <> '' then
                                  s2 := s2 + ', ';
                                s2 := s2 + copy(s3, 1, i - 1);
                                delete(s3, 1, i + 1);
                                i := Pos(', ', s3);
                              until (i = 0);
                              i := Pos(')', s3);
                              if i > 0 then
                                begin
                                  if Pos('(', s3) = 0 then
                                    begin
                                      s2 := s2 + ')';
                                      s3 := copy(s3, 1, i - 1);
                                    end;
                                end;
                              i := Pos(']', s3);
                              if i > 0 then
                                begin
                                  if Pos('[', s3) = 0 then
                                    begin
                                      s2 := s2 + ']';
                                      s3 := copy(s3, 1, i - 1);
                                    end;
                                end;
                              if s3 = '-' then
                                begin
                                  s2 := s2 + ', ' + s3;
                                  s3 := '';
                                end;
                              MovieBase.CurrentName.BirthPlace := s2;
                              MovieBase.CurrentName.BirthCountry := s3;
                            end
                          else
                            begin
                              s2 := '';
                              if trim(s3) = ' () ' then
                                begin
                                  s2 := '';
                                  s3 := ' ()';
                                end;
                              MovieBase.CurrentName.BirthPlace := s2;
                              MovieBase.CurrentName.BirthCountry := s3;
                            end;
                        end;
                    end;
                end;
              tDeadDay := '';
              if uDeadDay = 1 then //  
                begin
                  i := pos('> </', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 13);
                      i := 1;
                      j := Pos('</td>', s);
                      if j > 0 then
                        begin
                          s2 := '<' + copy(s, i, j - i);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '-') and (s2 <> '') then
                            begin
                              s2 := stringreplace(s2, '', '|', [rfReplaceAll, rfIgnoreCase]);
                              tDeadDay := s2;
                              if cDeadDay = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b> : </b>' + s2
                                  else
                                    Comment := Comment + ' : ' + s2;
                                end;
                              if cDeadDay = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b> : </b>' + s2
                                  else
                                    Biography := Biography + ' : ' + s2;
                                end;
                              i := pos(',', s2); // 
                              if i > 0 then
                                begin
                                  delete(s2, 1, i + 1);
                                  j := Pos('|', s2);
                                  if j > 0 then
                                    begin
                                      s2 := copy(s2, 1, j - 1);
                                    end;
                                  s2 := trim(s2);
                                  try
                                    begin
                                      ii := StrToInt(s2);
                                      if ii <> 0 then
                                        MovieBase.CurrentName.DeathYear := ii;
                                    end;
                                  except
                                  end;
                                end;
                            end;
                        end;
                    end;
                end;
              tDeadPlace := '';
              if uDeadPlace = 1 then //  
                begin
                  i := pos('> </', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 14);
                      i := 1;
                      j := Pos('</', s);
                      if j > 0 then
                        begin
                          s2 := '<' + copy(s, i, j - i);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '-') and (s2 <> '') then
                            begin
                              tDeadPlace := s2;
                              if cDeadPlace = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b> : </b>' + s2
                                  else
                                    Comment := Comment + ' : ' + s2;
                                end;
                              if cDeadPlace = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b> : </b>' + s2
                                  else
                                    Biography := Biography + ' : ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              tGenre := '';
              if uGenre = 1 then //
                begin
                  i := pos('></', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 7);
                      i := Pos('</', s);
                      if i > 0 then
                        begin
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tGenre := s2;
                              if cGenre = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b>: </b>' + s2
                                  else
                                    Comment := Comment + ': ' + s2;
                                end;
                              if cGenre = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b>: </b>' + s2
                                  else
                                    Biography := Biography + ': ' + s2;
                                end;
                              if cGenre = 3 then
                                begin
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  if uBold = 1 then
                                    Filmography := Filmography + '<b>: </b>' + s2
                                  else
                                    Filmography := Filmography + ': ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              tTotalFilms := '';
              if uTotalFilms = 1 then // 
                begin
                  i := pos('> </', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 15);
                      i := Pos('</', s);
                      if i > 0 then
                        begin
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tTotalFilms := s2;
                              if cTotalFilms = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b> : </b>' + s2
                                  else
                                    Comment := Comment + ' : ' + s2;
                                end;
                              if cTotalFilms = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b> : </b>' + s2
                                  else
                                    Biography := Biography + ' : ' + s2;
                                end;
                              if cTotalFilms = 3 then
                                begin
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  if uBold = 1 then
                                    Filmography := Filmography + '<b> : </b>' + s2
                                  else
                                    Filmography := Filmography + ' : ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              tSuprug := '';
              tSupruga := '';
              if uSuprug = 1 then //()
                begin
                  s := page;
                  i := pos('></', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 8);
                      i := Pos('</span>', s);
                      if i > 0 then
                        begin
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := ReplaceTagWithChar(s2, '<br>', ',');
                          s2 := ReplaceTagWithChar(s2, '<br />', ',');
                          s2 := ReplaceTagWithChar(s2, '</br>', ',');
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          s2 := stringreplace(s2, ', ...', ' ...', [rfReplaceAll, rfIgnoreCase]);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSuprug := s2;
                              if cSuprug = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b>: </b>' + s2
                                  else
                                    Comment := Comment + ': ' + s2;
                                end;
                              if cSuprug = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b>: </b>' + s2
                                  else
                                    Biography := Biography + ': ' + s2;
                                end;
                            end;
                        end;
                    end;
                  i := pos('></', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 9);
                      i := Pos('</span>', s);
                      if i > 0 then
                        begin
                          s2 := '<' + copy(s, 1, i - 1);
                          s2 := ReplaceTagWithChar(s2, '<br>', ',');
                          s2 := ReplaceTagWithChar(s2, '<br />', ',');
                          s2 := ReplaceTagWithChar(s2, '</br>', ',');
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          s2 := stringreplace(s2, ', ...', ' ...', [rfReplaceAll, rfIgnoreCase]);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tSupruga := s2;
                              if cSuprug = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b>: </b>' + s2
                                  else
                                    Comment := Comment + ': ' + s2;
                                end;
                              if cSuprug = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b>: </b>' + s2
                                  else
                                    Biography := Biography + ': ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              tFirstFilm := '';
              if uFirstFilm = 1 then // 
                begin
                  i := pos('='' ''>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 15);
                      i := Pos('</', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tFirstFilm := s2;
                              if cFirstFilm = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b> : </b>' + s2
                                  else
                                    Comment := Comment + ' : ' + s2;
                                end;
                              if cFirstFilm = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b> : </b>' + s2
                                  else
                                    Biography := Biography + ' : ' + s2;
                                end;
                              if cFirstFilm = 3 then
                                begin
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  if uBold = 1 then
                                    Filmography := Filmography + '<b> : </b>' + s2
                                  else
                                    Filmography := Filmography + ' : ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              tLastFilm := '';
              if uLastFilm = 1 then // 
                begin
                  i := pos('='' ''>', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i + 18);
                      i := Pos('</', s);
                      if i > 0 then
                        begin
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tLastFilm := s2;
                              if cLastFilm = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b> : </b>' + s2
                                  else
                                    Comment := Comment + ' : ' + s2;
                                end;
                              if cLastFilm = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b> : </b>' + s2
                                  else
                                    Biography := Biography + ' : ' + s2;
                                end;
                              if cLastFilm = 3 then
                                begin
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  if uBold = 1 then
                                    Filmography := Filmography + '<b> : </b>' + s2
                                  else
                                    Filmography := Filmography + ' : ' + s2;
                                end;
                            end;
                        end;
                    end;
                end;
              tBestFilms := '';
              if uBestFilms = 1 then //   
                begin
                  i := pos('> ', s);
                  if i > 0 then
                    begin
                      i := pos('> :</', s);
                      if i = 0 then
                        j := pos('> :</', s);
                      if i > 0 then
                        begin
                          i := Pos('<ul>', s);
                          delete(s, 1, i - 1);
                          i := Pos('</div>', s);
                          s2 := '<table cellspacing=0 cellpadding=0 style="width: 100%; border: none">' + trim(copy(s, 1, i - 1)) + '</table>';
                          s2 := stringreplace(s2, '<li>', '<tr><td style="color:#999" align=left>', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</li>', '</tr></td>', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                          s2 := StringReplace(s2, #10, '', [rfReplaceAll]);
                          s2 := StringReplace(s2, #13, '', [rfReplaceAll]);
                          s2 := stringreplace(s2, '<ul>', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</ul>', '', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '<i>', '<!--', [rfReplaceAll, rfIgnoreCase]);
                          s2 := stringreplace(s2, '</i>', '-->', [rfReplaceAll, rfIgnoreCase]);
                          if uBold = 1 then
                            begin
                              s2 := stringreplace(s2, '<h4> :</h4>', '<tr><td><b> :</b></tr></td>', [rfReplaceAll, rfIgnoreCase]);
                            end
                          else
                            begin
                              s2 := stringreplace(s2, '<h4> :</h4>', '<tr><td> :</tr></td>', [rfReplaceAll, rfIgnoreCase]);
                            end;
                          s2 := DelProb(s2);
                          s2 := trim(s2);
                          i := Pos('<a href=', s2);
                          if i = 0 then
                            s2 := '';
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              tBestFilms := s2;
                              if cBestFilms = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b> : </b><br>' + s2
                                  else
                                    Comment := Comment + ' : <br>' + s2;
                                end;
                              if cBestFilms = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b> : </b><br>' + s2
                                  else
                                    Biography := Biography + ' : <br>' + s2;
                                end;
                              if cBestFilms = 3 then
                                begin
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  if uBold = 1 then
                                    Filmography := Filmography + '<b> : </b><br>' + s2
                                  else
                                    Filmography := Filmography + ' : <br>' + s2;
                                end;
                            end;
                        end
                      else
                        begin
                          if (i = 0) and (j > 0) then
                            begin
                              i := Pos('<ul>', s);
                              delete(s, 1, i - 1);
                              i := Pos('</div>', s);
                              s2 := '<table cellspacing=0 cellpadding=0 style="width: 100%; border: none">' + trim(copy(s, 1, i - 1)) + '</table>';
                              s2 := stringreplace(s2, '<li>', '<tr><td style="color:#999" align=left>', [rfReplaceAll, rfIgnoreCase]);
                              s2 := stringreplace(s2, '</li>', '</tr></td>', [rfReplaceAll, rfIgnoreCase]);
                              s2 := stringreplace(s2, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s2 := StringReplace(s2, #10, '', [rfReplaceAll]);
                              s2 := StringReplace(s2, #13, '', [rfReplaceAll]);
                              s2 := stringreplace(s2, '<ul>', '', [rfReplaceAll, rfIgnoreCase]);
                              s2 := stringreplace(s2, '</ul>', '', [rfReplaceAll, rfIgnoreCase]);
                              s2 := stringreplace(s2, '<i>', '<!--', [rfReplaceAll, rfIgnoreCase]);
                              s2 := stringreplace(s2, '</i>', '-->', [rfReplaceAll, rfIgnoreCase]);
                              if uBold = 1 then
                                begin
                                  s2 := stringreplace(s2, '<h4> :</h4>', '<tr><td><b> :</b></tr></td>', [rfReplaceAll, rfIgnoreCase]);
                                end
                              else
                                begin
                                  s2 := stringreplace(s2, '<h4> :</h4>', '<tr><td> :</tr></td>', [rfReplaceAll, rfIgnoreCase]);
                                end;
                              s2 := DelProb(s2);
                              s2 := trim(s2);
                              i := Pos('<a href=', s2);
                              if i = 0 then
                                s2 := '';
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tBestFilms := s2;
                                  if cBestFilms = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if uBold = 1 then
                                        Comment := Comment + '<b> : </b><br>' + s2
                                      else
                                        Comment := Comment + ' : <br>' + s2;
                                    end;
                                  if cBestFilms = 2 then
                                    begin
                                      if Biography <> '' then
                                        Biography := Biography + ret;
                                      if uBold = 1 then
                                        Biography := Biography + '<b> : </b><br>' + s2
                                      else
                                        Biography := Biography + ' : <br>' + s2;
                                    end;
                                  if cBestFilms = 3 then
                                    begin
                                      if Filmography <> '' then
                                        Filmography := Filmography + ret;
                                      if uBold = 1 then
                                        Filmography := Filmography + '<b> : </b><br>' + s2
                                      else
                                        Filmography := Filmography + ' : <br>' + s2;
                                    end;
                                end;
                            end;
                        end;
                    end;
                end;
              tZnaite := '';
              if uZnaite = 1 then //   , ...
                begin
                  page2 := page;
                  i := pos('">  ', page2);
                  if i > 0 then
                    begin
                      delete(page2, 1, i);
                      i := Pos('<table', page2);
                      j := Pos('</table>', page2);
                      if (i > 0) and (j > 0) then
                        s2 := copy(page2, i, j - i)
                      else
                        s2 := '';
                      if pos('(...&nbsp;)', s2) > 0 then
                        begin
                          i := pos('">  ', page2);
                          if i > 0 then
                            begin
                              delete(page2, 1, i);
                              i := Pos('<table', page2);
                              j := Pos('</table>', page2);
                              if (i > 0) and (j > 0) then
                                s2 := copy(page2, i, j - i)
                              else
                                s2 := '';
                            end;
                        end;
                      s2 := ClearHTML(s2);
                      i := pos('(... )', s2);
                      if i > 0 then
                        s2 := copy(s2, 1, i - 1);
                      s2 := trim(s2);
                      if s2 <> '' then
                        begin
                          if ZnaiteIns = 1 then
                            begin
                              List := TStringList.Create;
                              List.Text := s2;
                              s2 := '';
                              for i := 0 to List.Count - 1 do
                                begin
                                  if trim(List[i]) <> '' then
                                    begin
                                      if s2 <> '' then
                                        s2 := s2 + ret;
                                      if (List[i][1] <> '') and (List[i][1] <> '-') then
                                        s2 := s2 + ' ';
                                      s2 := s2 + List[i];
                                    end;
                                end;
                              List.Free;
                            end;
                          s2 := stringreplace(s2, '  ', '', [rfReplaceAll]);
                          s2 := stringreplace(s2, ' ', '', [rfReplaceAll]);
                          s2 := stringreplace(s2, '', ' ', [rfReplaceAll]);
                          if cZnaite = 1 then
                            begin
                              if Comment <> '' then
                                Comment := Comment + ret + ret;
                              if uBold = 1 then
                                Comment := Comment + '<b>  , : </b>' + ret
                              else
                                Comment := Comment + '  , : ' + ret;
                              Comment := Comment + s2;
                            end;
                          if cZnaite = 2 then
                            begin
                              if Biography <> '' then
                                Biography := Biography + ret + ret;
                              if uBold = 1 then
                                Biography := Biography + '<b>  , : </b>' + ret
                              else
                                Biography := Biography + '  , : ' + ret;
                              Biography := Biography + s2;
                            end;
                          tZnaite := s2;
                        end;
                    end;
                  page2 := '';
                end;
              tActor := ''; tActress := '';
              tActorDubbing := ''; tActressDubbing := '';
              tActorHimself := ''; tActressHerself := '';
              tDirector := ''; tVoiceDirector := '';
              tWriter := ''; tProducer := '';
              tOperator := ''; tComposer := '';
              if uFilmography = 1 then
                begin
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if uBold = 1 then
                    Sex := '<b>:</b>'
                  else
                    Sex := ':';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); // 
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if uBold = 1 then
                    Sex := '<b>:</b>'
                  else
                    Sex := ':';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //: 
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>: <', s);
                  if uBold = 1 then
                    Sex := '<b>. :</b>'
                  else
                    Sex := '. :';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //: 
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>: <', s);
                  if uBold = 1 then
                    Sex := '<b>. :</b>'
                  else
                    Sex := '. :';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //:   
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>:   <', s);
                  if uBold = 1 then
                    Sex := '<b>.   :</b>'
                  else
                    Sex := '.   :';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //:   
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>:   <', s);
                  if uBold = 1 then
                    Sex := '<b>.   :</b>'
                  else
                    Sex := '.   :';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //: ,    
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>: ,    <', s);
                  if uBold = 1 then
                    Sex := '<b>. ,    :</b>'
                  else
                    Sex := '. ,    :';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //. ,    
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>: ,    <', s);
                  if uBold = 1 then
                    Sex := '<b>. ,    :</b>'
                  else
                    Sex := '. ,    :';
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      Filmography := Filmography + Sex;
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //c
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>c<', s);
                  if i = 0 then i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>c:</b>'
                      else
                        Filmography := Filmography + 'c:';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //c 
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('>c <', s);
                  if i = 0 then
                    i := pos('> <', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>c :</b>'
                      else
                        Filmography := Filmography + 'c :';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
					            if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>:</b>'
                      else
                        Filmography := Filmography + ':';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>:</b>'
                      else
                        Filmography := Filmography + ':';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>:</b>'
                      else
                        Filmography := Filmography + ':';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>:</b>'
                      else
                        Filmography := Filmography + ':';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
                      if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>:</b>'
                      else
                        Filmography := Filmography + ':';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
					            if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>:</b>'
                      else
                        Filmography := Filmography + ':';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
					            if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                  s := page;
                  i := pos('> :<', s); //
                  if i = 0 then
                    i := pos('class="specializationBox first_pers_block', s);
                  if i > 0 then
                    delete(s, 1, i);
                  i := pos('><', s);
                  if i > 0 then
                    begin
                      if Filmography <> '' then
                        Filmography := Filmography + ret + ret;
                      if uBold = 1 then
                        Filmography := Filmography + '<b>:</b>'
                      else
                        Filmography := Filmography + ':';
                      delete(s, 1, i - 1);
                      i := Pos('<div class="MyKP_Folder_Select', s);
                      delete(s, 1, i - 1);
                      j := Pos('class="specializationBox', s);
					            if j = 0 then
                        j := Length(s);
                      s2 := copy(s, 1, j);
                      ii := pos('</td></tr></table>', s2);
                      while ii > 0 do
                        begin
                          s4 := '';
                          s5 := '';
                          s3 := copy(s2, 1, ii + 4) + '>';
                          i := Pos('<span class="name"><a href="/film/', s3);
                          if i = 0 then
                            i := Pos('<span class="name"><a href="/series/', s3);
                          if i > 0 then
                            begin
                              delete(s3, 1, i - 1);
                              i := Pos('</a>', s3);
                              s4 := copy(s3, 1, i + 3);
                              s4 := stringreplace(s4, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<a href="/series/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                              s4 := stringreplace(s4, '<span class="name">', '', [rfReplaceAll, rfIgnoreCase]);
                              if FilmAsLink = 0 then
                                s4 := HTMLRemoveTags(s4);
                              s4 := HTMLDecode(s4);
                              delete(s3, 1, i + 3);
                              i := Pos('#393', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := '<' + copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  if OtherColor = 1 then
                                    s4 := s4 + ', <font color="' + Color + '">' + s5 + '</font>'
                                  else
                                    s4 := s4 + ', ' + s5;
                                end;
                              i := Pos('&nbsp;...&nbsp;', s3);
                              if i > 0 then
                                begin
                                  delete(s3, 1, i - 1);
                                  i := Pos('</span>', s3);
                                  s5 := copy(s3, 1, i - 1);
                                  s5 := HTMLRemoveTags(s5);
                                  s5 := HTMLDecode(s5);
                                  s4 := s4 + s5;
                                end;
                            end;
                          if s4 <> '' then
                            begin
                              Filmography := Filmography + ret + trim(s4);
                              tActor := tActor + ret + trim(s4);
                            end;
                          delete(s2, 1, ii + 4);
                          ii := pos('</td></tr></table>', s2);
                        end;
                    end;
                end;
              tAwards := '';
              if uAwards = 1 then //
                begin
                  if pos('href="/name/' + NameCode + '/awards/', page) > 0 then //,    
                    begin
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + NameCode + '/awards/',
                                                '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := pos(FindBlocking, page2);
                      if (i > 0) or (page = '') then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/name/' + NameCode + '/awards/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + NameCode + '/awards/',
                                                    '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free;   
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      if page2 <> '' then
                        begin
                          if SaveSourceCode = 1 then
                            SaveResultHtmlText(page2, 'PersonAwards' + NameCode);
                          i := Pos('class=all> ', page2);
                          if i > 0 then
                            begin
                              Awards := '';
                              delete(page2, 1, i - 1);
                              repeat
                                i := Pos('<b><a href="/awards/', page2);
                                if i > 0 then
                                  begin
                                    delete(page2, 1, i - 1);
                                    j := Pos(' class="all">', page2);
                                    delete(page2, 1, j + 12);
                                    j := Pos('</a></b></td>', page2);
                                    s := copy(page2, 1, j - 1);
                                    s := HTMLRemoveTags(s);
                                    s := HTMLDecode(s);
                                    if Awards = '' then
                                      Awards := Awards + ret + '<b><u>' + trim(s) + '</u></b>'
                                    else
                                      Awards := Awards + ret + ret + '<b><u>' + trim(s) + '</u></b>';
                                    delete(page2, 1, j + 12);
                                    ii := Pos('<tr><td class="news">&nbsp;</td></tr>', page2);
                                    s2 := copy(page2, 1, ii - 1);
                                    repeat
                                      ii := Pos('<tr><td class="news" style="padding: 10px; color: #777">', s2);
                                      if ii > 0 then
                                        begin
                                          delete(s2, 1, ii + 55);
                                          j := Pos('</td></tr>', s2);
                                          s := copy(s2, 1, j - 1);
                                          delete(s2, 1, j + 9);
                                          Awards := Awards + ret + trim(s) + ' ';
                                          j := Pos('<ul class="trivia">', s2);
                                          delete(s2, 1, j - 1);
                                          j := Pos('</ul>', s2);
                                          s := copy(s2, 1, j - 1);
                                          s := stringreplace(s, #13, '', [rfReplaceAll, rfIgnoreCase]);
                                          s := stringreplace(s, #10, '', [rfReplaceAll, rfIgnoreCase]);
                                          s := ReplaceTagWithChar(s, '</li>', ';');
                                          s := HTMLRemoveTags(s);
                                          s := stringreplace(s, '  ', '', [rfReplaceAll, rfIgnoreCase]);
                                          s := HTMLDecode(s);
                                          s[Length(s)] := ' ';
                                          Awards := Awards + trim(s);
                                        end;
                                    until (ii = 0);
                                  end;
                              until (i = 0);
                            end;
                          if Awards <> '' then
                            begin
                              Awards := stringreplace(Awards, ' ;', ';', [rfReplaceAll, rfIgnoreCase]);
                              tAwards := Awards;
                              if cAwards = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b>: </b>' + Awards
                                  else
                                    Comment := Comment + ': ' + Awards;
                                end;
                              if cAwards = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b>: </b>' + Awards
                                  else
                                    Biography := Biography + ': ' + Awards;
                                end;
                            end;
                        end;
                    end;
                  page2 := '';
                end;
              tLinks := '';
              if uLinks = 1 then //
                begin
                  if pos('href="/name/' + NameCode + '/relations/', page) > 0 then //,    
                    begin
                      try
                        Application.ProcessMessages;
                        if NeedURLDelay = 1 then
                          Sleep(MaxURLDelay);
                        Application.ProcessMessages;
                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + NameCode + '/relations/',
                                                '  .....');
                        Application.ProcessMessages;
                      except
                        page2 := '';
                      end;
                      i := pos(FindBlocking, page2);
                      if (i > 0) or (page = '') then
                        begin
                          ShowMessage('    ');
                          GetBrowserWindow('https://www.kinopoisk.ru/name/' + NameCode + '/relations/');
                          try
                            Application.ProcessMessages;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            Application.ProcessMessages;
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/name/' + NameCode + '/relations/',
                                                    '  .....');
                            Application.ProcessMessages;
                          except
                            page2 := '';
                          end;
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              MovieBase.Free; 
                              LoadInfo.Destroy;
                              Exit;
                            end;
                        end;
                      if page2 <> '' then
                        begin
                          if SaveSourceCode = 1 then
                            SaveResultHtmlText(page2, 'PersonRelations' + NameCode);
                          Link := '<table cellspacing=0 cellpadding=0 width=100% border=0>';
                          i := Pos('class=all>   ?</a>', page2);
                          if i > 0 then
                            begin
                              delete(page2, 1, i - 1);
                              repeat
                                i := Pos('<tr><td colspan=3 height=20 style="padding-left:20px;border-bottom:2px solid #f60"><b>', page2);
                                if i > 0 then
                                  begin
                                    delete(page2, 1, i - 1);
                                    j := Pos('</b></td></tr>', page2);
                                    s := copy(page2, 1, j - 1);
                                    s := HTMLRemoveTags(s);
                                    s := HTMLDecode(s);
                                    ii := Pos('</tr>		<tr><td colspan=3><br /></td></tr>', page2);
                                    jj := 1;
                                    if ii = 0 then
                                      begin
                                        ii := Pos('<tr><td colspan=3 style="padding-left:20px">', page2);
                                        jj := 2;
                                      end;
                                    if ii > 0 then
                                      begin
                                        if jj = 1 then
                                          Link := Link + copy(page2, 1, ii + 42);
                                        if jj = 2 then
                                          Link := Link + copy(page2, 1, ii - 1);
                                      end;
                                    delete(page2, 1, j + 13);
                                  end;
                              until (i = 0);
                            end;
                          Link := Link + '<tr><td colspan=3><br /></td></tr></table>';
                          Link := stringreplace(Link, '<a href="/', '<a href="https://www.kinopoisk.ru/', [rfReplaceAll, rfIgnoreCase]);
                          if Link <> '<table cellspacing=0 cellpadding=0 width=100% border=0></table>' then
                            begin
                              tLinks := Link;
                              if cLinks = 1 then
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret + ret;
                                  if uBold = 1 then
                                    Comment := Comment + '<b>: </b>' + Link
                                  else
                                    Comment := Comment + ': ' + Link;
                                end;
                              if cLinks = 2 then
                                begin
                                  if Biography <> '' then
                                    Biography := Biography + ret + ret;
                                  if uBold = 1 then
                                    Biography := Biography + '<b>: </b>' + Link
                                  else
                                    Biography := Biography + ': ' + Link;
                                end;
                            end;
                        end;
                    end;
                  page2 := '';
                end;
              if UseTemplates = 1 then
                begin
                  try
                    if FileExists(UserDir + 'Kinopoisk_zas_person_Comments.ini') = false then
                      begin
                        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_person_Comments.ini') = true then
                          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_person_Comments.ini'), Pchar(UserDir + 'Kinopoisk_zas_person_Comments.ini'), true);
                      end;
                  except
                  end;
                  if FileExists(UserDir + 'Kinopoisk_zas_person_Comments.ini') = false then
                    begin
                      List := TStringList.Create;
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<br><b>  , : </b><br>%%%%');
                      List.Add('<br><b>:</b>%%%%');
                      List.Add('<br><b>:</b><br>%%%%');
                      List.SaveToFile(UserDir + 'Kinopoisk_zas_person_Comments.ini');
                      List.Free;
                    end;
                  Template := TStringList.Create;
                  Template.LoadFromFile(UserDir + 'Kinopoisk_zas_person_Comments.ini');
                  Comment := '';
                  for i := 0 to Template.Count - 1 do
                    begin
                      ii := pos('%%', Template[i]);
                      if ii > 0 then
                        begin
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRost <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRost, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tAwards <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tAwards, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLinks <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLinks, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tZnaite <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tZnaite, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDeadDay <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDeadDay, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDeadPlace <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDeadPlace, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSuprug <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSuprug, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSupruga <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSupruga, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tTotalFilms <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tTotalFilms, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tGenre <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tGenre, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tFirstFilm <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tFirstFilm, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLastFilm <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLastFilm, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBestFilms <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tBestFilms, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActor <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActor, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActress <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActress, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActorDubbing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActorDubbing, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActressDubbing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActressDubbing, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActorHimself <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActorHimself, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActressHerself <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActressHerself, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tDirector, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoiceDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tVoiceDirector, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tWriter <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tWriter, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tProducer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tProducer, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tOperator <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tOperator, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tComposer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tComposer, [rfReplaceAll]);
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                              Continue;
                            end;
                        end
                      else
                        begin
                          if Comment <> '' then
                            Comment := Comment + ret;
                          Comment := Comment + Template[i];
                        end;
                    end;
                  Template.Free;
                  try //Filmography
                    if FileExists(UserDir + 'Kinopoisk_zas_person_Filmography.ini') = false then
                      begin
                        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_person_Filmography.ini') = true then
                          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_person_Filmography.ini'), Pchar(UserDir + 'Kinopoisk_zas_person_Filmography.ini'), true);
                      end;
                  except
                  end;
                  if FileExists(UserDir + 'Kinopoisk_zas_person_Filmography.ini') = false then
                    begin
                      List := TStringList.Create;
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b>:</b> %%%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b> :</b> %%%%');
                      List.Add('<b> : </b><br>%%%%');
                      List.Add('');
                      List.Add('<b>:</b> %%%% <br>');
                      List.Add('<b>:</b> %%%% <br>');
                      List.Add('<b>. :</b> %%%% <br>');
                      List.Add('<b>. :</b> %%%% <br>');
                      List.Add('<b>.   :</b> %%%% <br>');
                      List.Add('<b>.   :</b> %%%% <br>');
                      List.Add('<b>c:</b> %%c%% <br>');
                      List.Add('<b>c :</b> %%c%% <br>');
                      List.Add('<b>:</b> %%%% <br>');
                      List.Add('<b>:</b> %%%% <br>');
                      List.Add('<b>:</b> %%%% <br>');
                      List.Add('<b>:</b> %%%% <br>');
                      List.SaveToFile(UserDir + 'Kinopoisk_zas_person_Filmography.ini');
                      List.Free;
                    end;
                  Template := TStringList.Create;
                  Template.LoadFromFile(UserDir + 'Kinopoisk_zas_person_Filmography.ini');
                  Filmography := '';
                  for i := 0 to Template.Count - 1 do
                    begin
                      ii := pos('%%', Template[i]);
                      if ii > 0 then
                        begin
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRost <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRost, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tAwards <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tAwards, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLinks <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLinks, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tZnaite <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tZnaite, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDeadDay <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDeadDay, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDeadPlace <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDeadPlace, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSuprug <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSuprug, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSupruga <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSupruga, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tTotalFilms <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tTotalFilms, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tGenre <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tGenre, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tFirstFilm <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tFirstFilm, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLastFilm <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLastFilm, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBestFilms <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tBestFilms, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActor <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActor, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActress <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActress, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActorDubbing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActorDubbing, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActressDubbing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActressDubbing, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActorHimself <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActorHimself, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActressHerself <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActressHerself, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tDirector, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoiceDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tVoiceDirector, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tWriter <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tWriter, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tProducer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tProducer, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tOperator <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tOperator, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tComposer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tComposer, [rfReplaceAll]);
                                  if Filmography <> '' then
                                    Filmography := Filmography + ret;
                                  Filmography := Filmography + Template[i];
                                end;
                              Continue;
                            end;
                        end
                      else
                        begin
                          if Filmography <> '' then
                            Filmography := Filmography + ret;
                          Filmography := Filmography + Template[i];
                        end;
                    end;
                  Template.Free;
                  try //Biography
                    if FileExists(UserDir + 'Kinopoisk_zas_person_Biography.ini') = false then
                      begin
                        if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_person_Biography.ini') = true then
                          CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_person_Biography.ini'), Pchar(UserDir + 'Kinopoisk_zas_person_Biography.ini'), true);
                      end;
                  except
                  end;
                  if FileExists(UserDir + 'Kinopoisk_zas_person_Biography.ini') = false then
                    begin
                      List := TStringList.Create;
                      List.Add('');
                      List.SaveToFile(UserDir + 'Kinopoisk_zas_person_Biography.ini');
                      List.Free;
                    end;
                  Template := TStringList.Create;
                  Template.LoadFromFile(UserDir + 'Kinopoisk_zas_person_Biography.ini');
                  Biography := '';
                  for i := 0 to Template.Count - 1 do
                    begin
                      ii := pos('%%', Template[i]);
                      if ii > 0 then
                        begin
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tRost <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tRost, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tAwards <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tAwards, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLinks <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLinks, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tZnaite <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tZnaite, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDeadDay <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDeadDay, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDeadPlace <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tDeadPlace, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSuprug <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSuprug, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tSupruga <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tSupruga, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tTotalFilms <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tTotalFilms, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tGenre <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tGenre, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tFirstFilm <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tFirstFilm, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tLastFilm <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tLastFilm, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tBestFilms <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tBestFilms, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActor <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActor, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActress <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActress, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActorDubbing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActorDubbing, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActressDubbing <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActressDubbing, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActorHimself <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActorHimself, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tActressHerself <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tActressHerself, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tDirector, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%c%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tVoiceDirector <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%c%%', tVoiceDirector, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tWriter <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tWriter, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tProducer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tProducer, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tOperator <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tOperator, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                          ii := pos('%%%%', Template[i]);
                          if ii > 0 then
                            begin
                              if tComposer <> '' then
                                begin
                                  Template[i] := stringreplace(Template[i], '%%%%', tComposer, [rfReplaceAll]);
                                  if Biography <> '' then
                                    Biography := Biography + ret;
                                  Biography := Biography + Template[i];
                                end;
                              Continue;
                            end;
                        end
                      else
                        begin
                          if Biography <> '' then
                            Biography := Biography + ret;
                          Biography := Biography + Template[i];
                        end;
                    end;
                  Template.Free;
                end;
              if DelHTML = 1 then
                begin
                  Comment := HTMLRemoveTags(Comment);
                  Biography := HTMLRemoveTags(Biography);
                  Filmography := HTMLRemoveTags(Filmography);
                end;
              Comment := trim(Comment);
              if Comment <> '' then
                begin
                  if AddLoadInfoDate = 1 then
                    begin
                      if AddUPLoadInfoDate = 1 then
                        Comment := LoadInfo.GetLoadTime() + ret + '<p>' + Comment + '</p>'
                      else
                        Comment := Comment + ret + '<p>' + LoadInfo.GetLoadTime() + '</p>';
                    end;
                  MovieBase.CurrentName.Comments := ret + Comment;
                end
              else
                begin
                  if AddLoadInfoDate = 1 then
                    MovieBase.CurrentName.Comments := ret + LoadInfo.GetLoadTime();
                end;
              Biography := trim(Biography);
              if Biography <> '' then
                MovieBase.CurrentName.Biography := ret + Biography;
              Filmography := trim(Filmography);
              if Filmography <> '' then
                MovieBase.CurrentName.Filmography := ret + Filmography;
              if uFoto = 1 then //
                begin
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  i := pos(NameCode + '.jpg', page);
                  if i > 0 then
                    begin
                      MovieBase.GetNamePicFromURL('https://st.kp.yandex.net/images/actor/' + NameCode + '.jpg');
                    end
                  else
                    begin
                      try
                        MovieBase.NameGetURL('https://www.kinopoisk.ru/');
                      except
                      end;
                    end;
                end
              else
                begin
                  if NeedURLDelay = 1 then
                    Sleep(MaxURLDelay);
                  try
                    MovieBase.NameGetURL('https://www.kinopoisk.ru/');
                  except
                  end;
                end;
            end;
        end;
    end;
  LoadInfo.Destroy;
  MovieBase.Free;
end;

exports
  GetBaseName4, AMM_NewNamePluginStart4, Init4, GetVersion4;
begin
  SetThreadLocale(1049);
end.
