unit DllFormUnit;

interface

uses
  amm_pluginapi, SetupFormUnit, ShlObj, TntStdCtrls, TntExtCtrls, IniFiles,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, StrUtils,
  Forms, JPEG, Dialogs, StdCtrls, ExtCtrls, ComCtrls, OleCtrls, ActiveX,
  SHDocVw_EWB, EwbCore, EmbeddedWB, IEDownload, DB, MemDS, DBAccess, Uni,
  UniProvider, ODBCUniProvider, AccessUniProvider;

type
  TForm1 = class(TForm) 
    GroupBox1: TTntGroupBox;
    GroupBox2: TTntGroupBox;
    GroupBox3: TTntGroupBox; 
    ComboBox1: TTntComboBox;
    ComboBox2: TTntComboBox;
    CheckBox1: TTntCheckBox;
    CheckBox2: TTntCheckBox; 
    CheckBox3: TTntCheckBox;
    CheckBox4: TTntCheckBox;
    CheckBox5: TTntCheckBox;
    CheckBox6: TTntCheckBox;
    Memo1: TMemo;
    Edit1: TTntEdit;
    Button1: TTntButton;
    Button2: TTntButton;
    Button3: TTntButton;
    Button4: TTntButton;
    Button5: TTntButton; 
    Button6: TTntButton;
    Label1: TTntLabel;
    Label2: TTntLabel;
    Label3: TTntLabel;
    Label4: TTntLabel;
    Label5: TTntLabel;
    Label6: TTntLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    IEDownload1: TIEDownload;
    EmbeddedWB1: TEmbeddedWB;
    DBProvider: TAccessUniProvider;
    DBConnect: TUniConnection;
    SelQuery: TUniQuery;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject); 
    procedure Button3Click(Sender: TObject); 
    procedure Button4Click(Sender: TObject);  
    procedure Button5Click(Sender: TObject); 
    procedure Button6Click(Sender: TObject);  
    procedure CheckBox2Click(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure EmbeddedWB1DocumentComplete(ASender: TObject; const pDisp: IDispatch; var URL: OleVariant);
    procedure IEDownload1StreamComplete(Sender: TBSCB; Stream: TStream; Result: HRESULT);
    procedure GetBrowserWindow(const URL: string);
    procedure InitForm();
    function GetInfoFromUrl(const URL, LCaption: string): string;
    function FindNames(const Names, page: string; MaxNames: Integer): string;
    function CheckLikeMovies(page: string): Boolean;
    function PosName(Name: string):Integer;       
    function CheckExit(Flag: Integer): Integer;
  private
      { Private declarations }
  public
    FormSetup: TForm2;
    ExitFlag, DelAndSave, SaveLogFile, uRole: Integer;
    MovieBase: TMovieBase;
    OldGenre, OldCountry, OldDirector, OldScenario, OldActors, OldStudio, LogFileName, UserDir: string;
    RusNameOnly, UseAltName: Integer;
    NameException: string;
  end;

var
  Form1: TForm1;
  NamePic: string;
  GetPic, GetHTML: Boolean;

type
  TRGBArray = array[Word] of TRGBTriple;
  pRGBArray = ^TRGBArray;

const
  ret = #13#10;

implementation

{$R *.dfm}

function PosExD(const SubStr, s: string; Direct: Integer = -1): Integer;
var
  i, j, LenSubStr: Integer;
  Offset: Cardinal;
begin
  Offset := Length(s);
  if Direct >= 0 then
    begin
      Result := PosEx(SubStr, s, Offset);
      Exit;
    end;
  i := Offset;
  LenSubStr := Length(SubStr);
  while i >= LenSubStr do
  begin
    if s[i] = SubStr[ LenSubStr ] then
    begin
      j := 1;
      while (j < LenSubStr) and (s[i - j] = SubStr[LenSubStr - j]) do
        Inc(j);
      if (j = LenSubStr) then
      begin
        Result := (i - LenSubStr) + 1;
        exit;
      end;
    end;
    Dec(i);
  end;
  Result := 0;
end;

procedure TForm1.InitForm();
begin
  EmbeddedWB1.AddressBar := False;
  EmbeddedWB1.MenuBar := False;
  EmbeddedWB1.StatusBar := False;
  EmbeddedWB1.UserAgent := 'Mozilla/5.0 (X11; U; Linux i686; ru; rv:1.9.1.8) Gecko/20100214 Linux Mint/8 (Helena) Firefox/3.5.8';
  EmbeddedWB1.UserAgentMode := uaInternal;
  Self.Caption := '   ';
  GroupBox1.Caption := '   ';
  GroupBox2.Caption := '     /    ';
  GroupBox3.Caption := ''; 
  Label1.Caption := '';
  Label2.Caption := '   ';
  Label3.Caption := '';
  Label4.Caption := '    ';
  Label5.Caption := '   ';
  Label6.Caption := '';
  CheckBox1.Caption := '   ';
  CheckBox2.Caption := '   ,     ';
  CheckBox3.Caption := '    ';
  CheckBox4.Caption := '    ';
  CheckBox5.Caption := '  ,    ';   
  CheckBox6.Caption := '   ( )';
  CheckBox1.Checked := False;
  CheckBox2.Checked := False;
  CheckBox5.Checked := False;
  CheckBox6.Checked := False;
  Button1.Caption := '';
  Button2.Caption := '';
  Button3.Caption := ''; 
  Button4.Caption := '    ';
  Button5.Caption := '     , ';  
  Button6.Caption := '';
  Edit1.Text := '';
  Memo1.Lines.Clear;
end;

function DeleteLineBreaks(const Str: string): string;
const
  D = [' ', #9, #13, #10];
var
  i, ii, jj, Len: Integer;
  s: string;
begin
  s := Str;
  Len := Length(s);
  ii := 0;
  jj := 0;
  for i := 1 to Len do
    begin
      if not (s[i] in D) then
        begin
          ii := i;
          Break;
        end;
    end;
  for i := Len downto 1 do
    begin
      if not (s[i] in D) then
        begin
          jj := i;
          Break;
        end;
    end;
  Result := Trim(Copy(s, ii, jj - ii + 1));
end;

procedure SmoothResize(Src, Dst: TBitmap);
var
  x, y: Integer;
  xP, yP: Integer;
  xP2, yP2: Integer;
  SrcLine1, SrcLine2: pRGBArray;
  t3: Integer;
  z, z2, iz2: Integer;
  DstLine: pRGBArray;
  DstGap: Integer;
  w1, w2, w3, w4: Integer;
begin
  Src.PixelFormat := pf24Bit;
  Dst.PixelFormat := pf24Bit;
  if (Src.Width = Dst.Width) and (Src.Height = Dst.Height) then
    Dst.Assign(Src)
  else
    begin
      DstLine := Dst.ScanLine[0];
      DstGap := Integer(Dst.ScanLine[1]) - Integer(DstLine);
      xP2 := MulDiv(pred(Src.Width), $10000, Dst.Width);
      yP2 := MulDiv(pred(Src.Height), $10000, Dst.Height);
      yP := 0;
      for y := 0 to pred(Dst.Height) do
        begin
          xP := 0;
          SrcLine1 := Src.ScanLine[yP shr 16];
          if (yP shr 16 < pred(Src.Height)) then
            SrcLine2 := Src.ScanLine[succ(yP shr 16)]
          else
            SrcLine2 := Src.ScanLine[yP shr 16];
          z2 := succ(yP and $FFFF);
          iz2 := succ((not yp) and $FFFF);
          for x := 0 to pred(Dst.Width) do
            begin
              t3 := xP shr 16;
              z := xP and $FFFF;
              w2 := MulDiv(z, iz2, $10000);
              w1 := iz2 - w2;
              w4 := MulDiv(z, z2, $10000);
              w3 := z2 - w4;
              DstLine[x].rgbtRed := (SrcLine1[t3].rgbtRed * w1 +
                SrcLine1[t3 + 1].rgbtRed * w2 +
                SrcLine2[t3].rgbtRed * w3 + SrcLine2[t3 + 1].rgbtRed * w4) shr 16;
              DstLine[x].rgbtGreen :=
                (SrcLine1[t3].rgbtGreen * w1 + SrcLine1[t3 + 1].rgbtGreen * w2 +
                SrcLine2[t3].rgbtGreen * w3 + SrcLine2[t3 + 1].rgbtGreen * w4) shr 16;
              DstLine[x].rgbtBlue := (SrcLine1[t3].rgbtBlue * w1 +
                SrcLine1[t3 + 1].rgbtBlue * w2 +
                SrcLine2[t3].rgbtBlue * w3 +
                SrcLine2[t3 + 1].rgbtBlue * w4) shr 16;
              Inc(xP, xP2);
            end;
          Inc(yP, yP2);
          DstLine := pRGBArray(Integer(DstLine) + DstGap);
        end;
    end;
end;

function ReverseString(s: string): string;
var
  i: integer;
begin
  Result := '';
  if Trim(s) <> '' then
    begin
      for i := Length(s) downto 1 do
        Result := Result + s[i];
    end;
end;

function AnsiUpFirstLetter(const AStr: string): string;
var
  s: string;
begin
  Result := AnsiLowerCase(AStr);
  s := AnsiUpperCase(Astr);
  if length(s) > 0 then
    Result[1] := s[1]
  else
    Result := '';
end;

function HTMLRemoveTags(const AStr: string): string;
var
  s: string;
begin
  s := AStr;
  while (pos('<script', s) > 0) and (pos('</script>', s) > 0) and (pos('</script>', s) > pos('<script', s)) do
    delete(s, pos('<script', s), pos('</script>', s) - pos('<script', s) + 9);
  while (pos('<', s) > 0) and (pos('>', s) > 0) and (pos('>', s) > pos('<', s)) do
    delete(s, pos('<', s), pos('>', s) - pos('<', s) + 1);
  Result := TrimRight(TrimLeft(s));
end;

function ReplaceTagWithChar(text, html_tag: string; char_code: Char): string;
var
  i, j: integer;
begin
  j := 0;
  i := Pos(html_tag, text);
  while i > j do
    begin
      text[i] := char_code;
      text[i + 1] := ' ';
      text[i + 2] := '<';
      j := i;
      i := Pos(html_tag, text);
    end;
  Result := text;
end;

function NotLatinName(const Name, NameException: string): Boolean;
var
  Sp: PChar;
  Code: Integer;
begin
  Result := False;
  Sp := PChar(Name);
  Code := Ord(Sp^);
  if (Code >= 192) and (Code <= 255) then
    Result := True;
  if pos(Name, NameException) > 0 then
    Result := True;
end;

function HTMLDecode(const AStr: String): String;
var
  Sp, Rp, Cp, Tp: PChar;
  S: String;
  I, Code: Integer;
begin
  SetLength(Result, Length(AStr));
  Sp := PChar(AStr);
  Rp := PChar(Result);
  Cp := Sp;
  try
    while Sp^ <> #0 do
      begin
        case Sp^ of
          '\':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                'u':
                  begin
                    Tp := Sp;
                    Inc(Tp);
                    while (Sp^ in ['u','0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f']) do
                      Inc(Sp);
                    SetString(S, Tp, Sp - Tp);
                    dec(Sp);
                    Val('x'+S, I, Code);
                    if I >= $10000 then
                      begin
                        Rp^ := Char(((I - $10000) div $400) + $d800);
                        Inc(Rp);
                        Rp^ := Char(((I - $10000) and $3ff) + $dc00);
                      end
                    else
                      Rp^ := Chr((I));
                  end;
              end;
            end;
          '&':
            begin
              Cp := Sp;
              Inc(Sp);
              case Sp^ of
                ' ':
                  begin
                    Rp^ := '&';
                    Inc(Rp);
                    Rp^ := ' ';
                  end;
                'n':
                  begin
                    if AnsiStrPos(Sp, 'nbsp;') = Sp then
                      begin
                        inc(Sp, 4);
                        Rp^ := ' ';
                      end;
                    if AnsiStrPos(Sp, 'ndash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'm':
                  begin
                    if AnsiStrPos(Sp, 'mdash;') = Sp then
                      begin
                        inc(Sp, 5);
                        Rp^ := '-';
                      end;
                  end;
                'b':
                  if AnsiStrPos(Sp, 'bull;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '|';
                    end;
                'a':
                  if AnsiStrPos(Sp, 'amp;') = Sp then
                    begin
                      Inc(Sp, 3);
                      Rp^ := '&';
                    end;
                'l', 'g':
                  begin
                    if (AnsiStrPos(Sp, 'lt;') = Sp) or (AnsiStrPos(Sp, 'gt;') = Sp) then
                      begin
                        Cp := Sp;
                        Inc(Sp, 2);
                        while (Sp^ <> ';') and (Sp^ <> #0) do
                          Inc(Sp);
                        if Cp^ = 'l' then
                          Rp^ := '<'
                        else
                          Rp^ := '>';
                      end;
                    if (AnsiStrPos(Sp, 'laquo;') = Sp) then
                      begin
                        Inc(Sp, 5);
                        Rp^ := '"';
                      end;
                  end;
                'r':
                  if (AnsiStrPos(Sp, 'raquo;') = Sp) then
                    begin
                      Inc(Sp, 5);
                      Rp^ := '"';
                    end;
                'q':
                  if AnsiStrPos(Sp, 'quot;') = Sp then
                    begin
                      Inc(Sp, 4);
                      Rp^ := '"';
                    end;
                '#':
                begin
                  Tp := Sp;
                  Inc(Tp);
                  while (Sp^ <> ';') and (Sp^ <> #0) do
                    Inc(Sp);
                  SetString(S, Tp, Sp - Tp);
                  Val(S, I, Code);
                  if I >= $100 then
                    begin
                      S := WideChar(I);
                      Rp^ := S[1];
                    end
                  else
                    Rp^ := Chr((I));
                end;
              end;
            end
        else
          Rp^ := Sp^;
        end;
        Inc(Rp);
        Inc(Sp);
      end;
  except
  end;
  SetLength(Result, Rp - PChar(Result));
end;

function ClearHTML(s: string): string;
var
  i, c: integer;
  stt, st1: string;
begin
  s := stringreplace(s, ret, '$ret$', [rfReplaceAll]);
  s := stringreplace(s, '&nbsp;', ' ', [rfReplaceAll]);
  s := stringreplace(s, #$A, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, #9, '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<hr>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br/>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />' + '$ret$', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '<br />', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</p>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</li>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '</div>', ret, [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '&#8211;', '', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '$ret$', ret, [rfReplaceAll]);
  s := trim(HTMLDecode(s));
  s := HTMLRemoveTags(s);
  c := 0;
  for i := 1 to Length(s) do
    begin
      stt := copy(s, i, 1);
      if (stt = ' ') and (c >= 1) then
        begin
          stt := '';
          c := c + 1;
        end
      else
        begin
          if (stt = ' ') and (c = 0) then
            c := c + 1
          else
            if (stt <> ' ') then
              c := 0;
        end;
      st1 := st1 + stt;
    end;
  Result := st1;
end;

function ReplaceLatinExt(s: string): string;
begin
  s := stringreplace(s, '&#224;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#225;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#226;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#227;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#228;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#229;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#230;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe0;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe1;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe2;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe3;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe4;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe5;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#xe6;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#257;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#259;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#261;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#462;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#479;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#481;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#483;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#507;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#509;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#513;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#515;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#551;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#592;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#11365;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&agrave;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aacute;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&acirc;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&atilde;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&auml;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aring;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&aelig;', 'a', [rfReplaceAll]);
  s := stringreplace(s, '&#192;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#193;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#194;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#195;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#196;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#197;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#198;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc0;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc1;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc2;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc3;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc4;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc5;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#xc6;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#256;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#258;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#260;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#461;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#478;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#480;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#482;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#506;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#508;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#512;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#514;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#550;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#570;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#11375;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&AElig;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aring;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Auml;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Atilde;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Acirc;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Aacute;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&Agrave;', 'A', [rfReplaceAll]);
  s := stringreplace(s, '&#384;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#387;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#595;', 'b', [rfReplaceAll]);
  s := stringreplace(s, '&#385;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#386;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#579;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#665;', 'B', [rfReplaceAll]);
  s := stringreplace(s, '&#231;', 'c', [rfReplaceAll]); 
  s := stringreplace(s, '&ccedil;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#xe7;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#263;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#265;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#267;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#269;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#392;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#572;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#597;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#663;', 'c', [rfReplaceAll]);
  s := stringreplace(s, '&#199;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#xc7;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#262;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#264;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#266;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#268;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#391;', 'C', [rfReplaceAll]); 
  s := stringreplace(s, '&#571;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&Ccedil;', 'C', [rfReplaceAll]);
  s := stringreplace(s, '&#240;', 'd', [rfReplaceAll]);  
  s := stringreplace(s, '&#xf0;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#271;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#273;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#396;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#454;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#499;', 'd', [rfReplaceAll]);   
  s := stringreplace(s, '&#545;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&#568;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#598;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#599;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#675;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#677;', 'd', [rfReplaceAll]); 
  s := stringreplace(s, '&eth;', 'd', [rfReplaceAll]);
  s := stringreplace(s, '&#208;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&Eth;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&ETH;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#xd0;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#270;', 'D', [rfReplaceAll]); 
  s := stringreplace(s, '&#272;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#393;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#394;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#395;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#452;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#453;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#497;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#498;', 'D', [rfReplaceAll]);
  s := stringreplace(s, '&#232;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#233;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#234;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#235;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe8;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xe9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xea;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xeb;', 'e', [rfReplaceAll]);  
  s := stringreplace(s, '&#xE9;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEa;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#xEb;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#275;', 'e', [rfReplaceAll]);  
  s := stringreplace(s, '&#277;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#279;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#281;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#283;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#477;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#517;', 'e', [rfReplaceAll]);    
  s := stringreplace(s, '&#519;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#553;', 'e', [rfReplaceAll]); 
  s := stringreplace(s, '&#583;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#600;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#603;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#604;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#605;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#606;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#666;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#11384;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&egrave;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&eacute;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&ecirc;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&euml;', 'e', [rfReplaceAll]);
  s := stringreplace(s, '&#200;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#201;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#202;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#203;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc8;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xc9;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xca;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#xcb;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#274;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#276;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#278;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#280;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#282;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#398;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#400;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#516;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#518;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#552;', 'E', [rfReplaceAll]); 
  s := stringreplace(s, '&#582;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#11387;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Egrave;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Eacute;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Ecirc;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&Euml;', 'E', [rfReplaceAll]);
  s := stringreplace(s, '&#402;', 'f', [rfReplaceAll]);   
  s := stringreplace(s, '&fnof;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#x192;', 'f', [rfReplaceAll]);
  s := stringreplace(s, '&#401;', 'F', [rfReplaceAll]);
  s := stringreplace(s, '&#285;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#287;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#289;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#291;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#485;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#487;', 'g', [rfReplaceAll]);  
  s := stringreplace(s, '&#501;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#608;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#609;', 'g', [rfReplaceAll]);
  s := stringreplace(s, '&#284;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#286;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#288;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#290;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#403;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#484;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#486;', 'G', [rfReplaceAll]);  
  s := stringreplace(s, '&#500;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#610;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#667;', 'G', [rfReplaceAll]);
  s := stringreplace(s, '&#293;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#295;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#543;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#613;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#614;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#686;', 'h', [rfReplaceAll]);   
  s := stringreplace(s, '&#687;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11368;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#11382;', 'h', [rfReplaceAll]);
  s := stringreplace(s, '&#292;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#294;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#542;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#668;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11367;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#11381;', 'H', [rfReplaceAll]);
  s := stringreplace(s, '&#236;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#237;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#238;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#239;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xec;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xed;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xee;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#xef;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#299;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#301;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#303;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#305;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#307;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#297;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#410;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#464;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#521;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#523;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#616;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&igrave;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&icirc;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iacute;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&iuml;', 'i', [rfReplaceAll]);
  s := stringreplace(s, '&#204;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#205;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#206;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#207;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcd;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xce;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#xcf;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#296;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#298;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#300;', 'I', [rfReplaceAll]); 
  s := stringreplace(s, '&#302;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#304;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#306;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#407;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#463;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#520;', 'I', [rfReplaceAll]);  
  s := stringreplace(s, '&#522;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#618;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Igrave;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iacute;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Icirc;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&Iuml;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#11361;', 'I', [rfReplaceAll]);
  s := stringreplace(s, '&#309;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#496;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#567;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#585;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#607;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#644;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#669;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#11388;', 'j', [rfReplaceAll]);
  s := stringreplace(s, '&#308;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#584;', 'J', [rfReplaceAll]);
  s := stringreplace(s, '&#311;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#312;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#409;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#489;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#670;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#11370;', 'k', [rfReplaceAll]);
  s := stringreplace(s, '&#310;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#408;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#488;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#11369;', 'K', [rfReplaceAll]);
  s := stringreplace(s, '&#314;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#316;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#318;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#320;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#322;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#457;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#564;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#620;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#621;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#682;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#683;', 'l', [rfReplaceAll]);
  s := stringreplace(s, '&#313;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#315;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#317;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#319;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#321;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#455;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#456;', 'L', [rfReplaceAll]); 
  s := stringreplace(s, '&#573;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#619;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#671;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11360;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#11362;', 'L', [rfReplaceAll]);
  s := stringreplace(s, '&#623;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#624;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#625;', 'm', [rfReplaceAll]);
  s := stringreplace(s, '&#412;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#11374;', 'M', [rfReplaceAll]);
  s := stringreplace(s, '&#241;', 'n', [rfReplaceAll]); 
  s := stringreplace(s, '&ntilde;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#xf1;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#324;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#326;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#328;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#329;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#331;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#414;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#460;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#505;', 'n', [rfReplaceAll]);  
  s := stringreplace(s, '&#565;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#626;', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#627;', 'n', [rfReplaceAll]);
  s := stringreplace(s, 'ñ', 'n', [rfReplaceAll]);
  s := stringreplace(s, '&#209;', 'N', [rfReplaceAll]); 
  s := stringreplace(s, '&Ntilde;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&&#xd1;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#323;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#325;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#327;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#330;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#413;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#458;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#459;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#504;', 'N', [rfReplaceAll]);  
  s := stringreplace(s, '&#544;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#628;', 'N', [rfReplaceAll]);
  s := stringreplace(s, '&#242;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#243;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#244;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#245;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#246;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#248;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf2;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf3;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf4;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf5;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#xf6;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#xf8;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#333;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#335;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#337;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#339;', 'o', [rfReplaceAll]); 
  s := stringreplace(s, '&#x153;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#417;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#419;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#466;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#491;', 'o', [rfReplaceAll]);  
  s := stringreplace(s, '&#493;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#511;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#525;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#527;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#547;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#555;', 'o', [rfReplaceAll]);    
  s := stringreplace(s, '&#557;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#559;', 'o', [rfReplaceAll]);   
  s := stringreplace(s, '&#561;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#596;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#629;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ograve;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oacute;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ocirc;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oelig;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&otilde;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&ouml;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&oslash;', 'o', [rfReplaceAll]);
  s := stringreplace(s, '&#210;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#211;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#212;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#213;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#214;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#216;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd2;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd3;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd4;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd5;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd6;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#xd8;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#332;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#334;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#336;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#338;', 'O', [rfReplaceAll]); 
  s := stringreplace(s, '&#x152;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#390;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#415;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#416;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#418;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#465;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#490;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#492;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#510;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#524;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#526;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#546;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#554;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#556;', 'O', [rfReplaceAll]);      
  s := stringreplace(s, '&#558;', 'O', [rfReplaceAll]);    
  s := stringreplace(s, '&#560;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#630;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#11386;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ograve;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oacute;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ocirc;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&OElig;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Otilde;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Ouml;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&Oslash;', 'O', [rfReplaceAll]);
  s := stringreplace(s, '&#421;', 'p', [rfReplaceAll]);
  s := stringreplace(s, '&#420;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#11363;', 'P', [rfReplaceAll]);
  s := stringreplace(s, '&#569;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#587;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#672;', 'q', [rfReplaceAll]);
  s := stringreplace(s, '&#586;', 'Q', [rfReplaceAll]);
  s := stringreplace(s, '&#341;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#343;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#345;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#529;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#531;', 'r', [rfReplaceAll]);  
  s := stringreplace(s, '&#589;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#633;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#634;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#635;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#636;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#637;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#638;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#639;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#11385;', 'r', [rfReplaceAll]);
  s := stringreplace(s, '&#340;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#342;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#344;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#528;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#530;', 'R', [rfReplaceAll]); 
  s := stringreplace(s, '&#588;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#640;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#641;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#11364;', 'R', [rfReplaceAll]);
  s := stringreplace(s, '&#223;', 's', [rfReplaceAll]); 
  s := stringreplace(s, '&szlig;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#xdf;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#347;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#349;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#351;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#353;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&scaron;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#x161;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#383;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#537;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#575;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#642;', 's', [rfReplaceAll]);
  s := stringreplace(s, '&#346;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#348;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#350;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#352;', 'S', [rfReplaceAll]); 
  s := stringreplace(s, '&Scaron;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#x160;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#536;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#11390;', 'S', [rfReplaceAll]);
  s := stringreplace(s, '&#355;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#357;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#359;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#427;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#429;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#539;', 't', [rfReplaceAll]);   
  s := stringreplace(s, '&#566;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#647;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#648;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#678;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#680;', 't', [rfReplaceAll]);
  s := stringreplace(s, '&#354;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#356;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#358;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#428;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#430;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#538;', 'T', [rfReplaceAll]);   
  s := stringreplace(s, '&#574;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#11366;', 'T', [rfReplaceAll]);
  s := stringreplace(s, '&#254;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&thorn;', 'th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xfe;', 'th', [rfReplaceAll]);
  s := stringreplace(s, '&#222;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&THORN;', 'Th', [rfReplaceAll]);  
  s := stringreplace(s, '&#xde;', 'Th', [rfReplaceAll]);
  s := stringreplace(s, '&#249;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#250;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#251;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#252;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xf9;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfa;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfb;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#xfc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#361;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#363;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#365;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#367;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#369;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#371;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#432;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#468;', 'u', [rfReplaceAll]);  
  s := stringreplace(s, '&#470;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#472;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#474;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#476;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#533;', 'u', [rfReplaceAll]);     
  s := stringreplace(s, '&#535;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#649;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ugrave;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uacute;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&ucirc;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&uuml;', 'u', [rfReplaceAll]);
  s := stringreplace(s, '&#217;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#218;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#219;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#220;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xd9;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xda;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdb;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#xdc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#360;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#362;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#364;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#366;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#368;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#370;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#431;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#467;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#469;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#471;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#473;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#475;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#532;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#534;', 'U', [rfReplaceAll]);      
  s := stringreplace(s, '&#580;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ugrave;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uacute;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Ucirc;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&Uuml;', 'U', [rfReplaceAll]);
  s := stringreplace(s, '&#651;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#652;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11377;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#11380;', 'v', [rfReplaceAll]);
  s := stringreplace(s, '&#434;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#581;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#11389;', 'V', [rfReplaceAll]);
  s := stringreplace(s, '&#373;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#653;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#11379;', 'w', [rfReplaceAll]);
  s := stringreplace(s, '&#372;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#11378;', 'W', [rfReplaceAll]);
  s := stringreplace(s, '&#253;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&yacute;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xfd;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#255;', 'y', [rfReplaceAll]); 
  s := stringreplace(s, '&yuml;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#xff;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#375;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#422;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#436;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#563;', 'y', [rfReplaceAll]);  
  s := stringreplace(s, '&#591;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#654;', 'y', [rfReplaceAll]);
  s := stringreplace(s, '&#221;', 'Y', [rfReplaceAll]); 
  s := stringreplace(s, '&Yacute;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#xdd;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#374;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#376;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&Yuml;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#x178;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#435;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#562;', 'Y', [rfReplaceAll]);  
  s := stringreplace(s, '&#590;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#655;', 'Y', [rfReplaceAll]);
  s := stringreplace(s, '&#378;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#380;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#382;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#438;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#549;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#576;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#656;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#657;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#11372;', 'z', [rfReplaceAll]);
  s := stringreplace(s, '&#377;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#379;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#381;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#437;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#548;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11371;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&#11391;', 'Z', [rfReplaceAll]);
  s := stringreplace(s, '&middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&Middot;', '', [rfReplaceAll]);
  s := stringreplace(s, '&#769;', '', [rfReplaceAll]);
  Result := s;
end;

function CharReplace(s: string): string;
begin
  s := stringreplace(s, '"', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '`', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '', '''', [rfReplaceAll, rfIgnoreCase]);
  s := stringreplace(s, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
  Result := s;
end;

function RusToTranslit(s: string): string;
const
  rus='Ũ';
  trans: array[1..66] of string =(
   'a','b','v','g','d','e','e','zh','z','i','y','k','l',
   'm','n','o','p','r','s','t','u','f','kh','ts','ch','sh',
   'shc','','y','','e','yu','ya',
   'A','B','V','G','D','E','E','Zh','Z','I','Y','K','L',
   'M','N','O','P','R','S','T','U','F','Kh','Ts','Ch','Sh',
   'Shc','','Y','','E','Yu','Ya');
var
res: string;
i: Integer;
begin
  res := '';
  for i := 1 to Length(s) do
  begin
    if Pos(s[i], rus) > 0 then
      res := res + trans[Pos(s[i], rus)]
    else
       res := res + s[i];
    Result := res;
  end;
end;

function MyPos(sub, s: string; i: Integer): Integer;
var
  j: Integer;
begin
  delete(s, 1, i - 1);
  j := pos(sub, s);
  if j = 0 then
    Result := 0
  else
    Result := i - 1 + j;
end;

function TForm1.PosName(Name: string):Integer;
var
 j,k : Integer;
 l : string;
begin
  if MovieBase.CurrentMovie.UDFieldsCount = 0 then
     begin
       Result := 1000;
       Exit;
     end;
  k := MovieBase.CurrentMovie.UDFieldsCount - 1;
  for j := 0 to k do
    begin
      l := MovieBase.CurrentMovie.GetUDFieldName(j);
      if  l = Name then
        begin
          Result := j;
          Exit;
        end
      else
        Result := 1000;
    end;
end;

function TForm1.FindNames(const Names, page: string; MaxNames: Integer): string;
var
  i, ii, iii, len, p, kol, j: Integer;
  s, s2, s3, s4, s5, ss: string;
begin
  Result := '';
  s := page;
  i := pos(Names, s);
  if i > 0 then
    begin
      delete(s, 1, i);
      repeat
        i := pos('<div class="dubInfo">', s);
        if i > 0 then
          begin
            j := MyPos('<div class="clear"></div>', s, i);
            if j > 0 then
              delete(s, i, j - i);
          end;
      until (i = 0);
      kol := 0;
      i := Pos('padding-left: 20px; border-bottom: 2px solid #f60; font-size: 16px', s);
      if i > 0 then
        s2 := copy(s, 1, i - 1)
      else
        s2 := s;
      if length(s2) > 0 then
        begin
          repeat
            i := Pos('<div class="name"><a href="/name/', s2);
            delete(s2, 1, i + 5);
            j := Pos('</a>', s2);
            if (i > 0) and (j > 0) then
              begin
                ii := Pos('>', s2);
                delete(s2, 1, ii);
                ii := Pos('</a>', s2);
                s3 := copy(s2, 1, ii - 1);
                s3 := HTMLRemoveTags(s3);
                s3 := ReplaceLatinExt(s3);
                s3 := HTMLDecode(s3);
                s3 := trim(s3);
                ss := s3;
                delete(s2, 1, ii - 1);
                ii := Pos('</span>', s2);
                s4 := copy(s2, 1, ii - 1);
                s4 := HTMLRemoveTags(s4);
                s4 := ReplaceLatinExt(s4);
                s4 := HTMLDecode(s4);
                s4 := trim(s4);
                s5 := s4;
                len := Length(s5);
                p := 0;
                for iii := len downto 1 do
                  begin
                    if s5[iii] = ')' then
                      p := iii
                    else
                      begin
                        if (s5[iii] = '(') and (p > 0) then
                          begin
                            Delete(s5, iii, p - iii + 1);
                            p := 0;
                          end;
                      end;
                  end;
                s4 := s5;
                if s4 <> '' then
                  begin
                    if UseAltName = 1 then
                      s3 := s4;
                    if UseAltName = 2 then
                      s3 := s3 + ' /' + s4 + '/';
                    if UseAltName = 3 then
                      s3 := s4 + ' /' + s3 + '/';
                  end;
                if s3 <> '' then
                  begin
                    if ((NotLatinName(ss, NameException)) and (RusNameOnly = 1)) or (RusNameOnly = 0) then
                      begin
                        if Result <> '' then
                          Result := Result + ', ';
                        Result := Result + s3;
                        kol := kol + 1;
                      end;
                  end;
                if GetAMMBuild > 1400 then
                  begin
                    if uRole = 1 then
                      begin
                        ii := Pos('<div class="role">', s2);
                        if ii > 0 then
                          begin
                            delete(s2, 1, ii - 1);
                            ii := Pos('</div>', s2);
                            s4 := copy(s2, 1, ii - 1);
                            ii := Pos(', <font color=', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', ( ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(',  ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', (aka ', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            ii := Pos(', (,', s4);
                            if ii > 0 then
                              s4 := copy(s4, 1, ii - 1);
                            s4 := HTMLRemoveTags(s4);
                            s4 := ReplaceLatinExt(s4);
                            s4 := HTMLDecode(s4);
                            s4 := stringreplace(s4, '... ', '', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, '...', '', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, '/', '\', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, ',', '.', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, '(', '[', [rfReplaceAll, rfIgnoreCase]);
                            s4 := stringreplace(s4, ')', ']', [rfReplaceAll, rfIgnoreCase]);
                            s4 := trim(s4);
                            if s4 <> '' then
                              Result := Result + ' (' + s4 + ')';
                          end;
                      end;
                  end;
              end;
          until (i = 0) or (kol >= MaxNames);
        end;
    end;
  Result := CharReplace(Result);
  Result := trim(Result);
end;

function TForm1.CheckLikeMovies(page: string): Boolean;
var i: Integer;
begin
  Result := False;
  i := Pos('<!--  -->', page);
  if (i > 0) and (Pos('>    ', page) > 0) then
    begin
      delete(page, 1, i);
      i := Pos('$.recoms({', page);
        if i > 0 then
          begin
            delete(page, 1, i);
            i := Pos('</script>', page);
            page := Copy(page, 1, i - 1);
            if Pos('{"films":[],"total_recs":0', page) = 0 then
              Result := True;
          end;
    end;
end;

function TForm1.CheckExit(Flag: Integer): Integer;
begin
  Application.ProcessMessages;
  try
    if SaveLogFile = 1 then
      begin
        if LogFileName <> '' then
          Memo1.Lines.SaveToFile(LogFileName);
      end
  except
  end;
  if ExitFlag = 1 then
    begin
      Memo1.Lines.Add(' .');
      Button2.Caption := '';
      GroupBox1.Enabled := True;
      GroupBox2.Enabled := True;
      Button1.Enabled := True;
      Button3.Enabled := True;
      Button4.Enabled := True;
      Button5.Enabled := True;
      Edit1.Enabled := True;
      ComboBox1.Enabled := True;
      ComboBox2.Enabled := True;
      CheckBox1.Enabled := True;
      CheckBox2.Enabled := True;
      CheckBox5.Enabled := True;
      CheckBox6.Enabled := True;
      Label3.Enabled := True;
      Label4.Enabled := True;
      Label5.Enabled := True;
      Label2.Enabled := True;
      if (DelAndSave = 1) and (Flag = 1) then
        begin
          MovieBase.CurrentMovie.Genre := OldGenre;
          MovieBase.CurrentMovie.Country := OldCountry;
          MovieBase.CurrentMovie.Director := OldDirector;
          MovieBase.CurrentMovie.Scenario := OldScenario;
          MovieBase.CurrentMovie.Actors := OldActors;
          MovieBase.CurrentMovie.Studio := OldStudio;
          MovieBase.SaveMovie;
        end;
      MovieBase.Free;
    end;
  Result := ExitFlag;
end;

function GetSpecialPath(CSIDL: word): string;
var s: string;
begin
  SetLength(s, MAX_PATH);
  if not SHGetSpecialFolderPath(0, PChar(s), CSIDL, true) then
    s := '';
  Result := PChar(s);
end;

function GetLoadTime(): string;
var
  Today: TDateTime;
begin
  Today := Now;
  Result := '<b> : <font color="#ff0000">' +
            stringreplace(DateToStr(Today), '/', '.', [rfReplaceAll, rfIgnoreCase]) +
            ' ' + TimeToStr(Today) + '</font></b>';
end;

function ObjStreamToStr(const aDisp: IDispatch): string;
var
  IPsi: IPersistStreamInit;
  Sa: TStreamAdapter;
  Ss: TStringStream;
begin
  Result := '';
  if aDisp = nil then
    Result := '';
  if aDisp.QueryInterface(IPersistStreamInit, IPsi) <> S_OK then
    Result := '';
  Ss := TStringStream.Create('');
  Sa := TStreamAdapter.Create(Ss, soReference);
  IPsi.Save(Sa, True);
  Result := Ss.DataString;
  FreeAndNil(Sa);
  FreeAndNil(Ss);
end;

procedure TForm1.GetBrowserWindow(const URL: string);
var
  Flags, TargetFrameName, PostData, Headers: OLEVariant;
begin
  GroupBox1.Enabled := False;
  GroupBox2.Enabled := False;
  GroupBox3.Enabled := False;
  GroupBox1.Visible := False;
  GroupBox2.Visible := False;
  GroupBox3.Visible := False;
  EmbeddedWB1.DownloadOptions := [DownloadImages];
  EmbeddedWB1.Align := alClient;
  Button6.Visible := True;
  Button6.Enabled := True;
  Flags :='';
  TargetFrameName := '';
  PostData := '';
  Headers := 'User-Agent:Mozilla/5.0 (X11; U; Linux i686; ru; rv:1.9.1.8) Gecko/20100214 Linux Mint/8 (Helena) Firefox/3.5.8' + ret;
  Headers := Headers + 'Accept:text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8' + ret;
  Headers := Headers + 'Accept-Language:ru,en-us;q=0.7,en;q=0.3' + ret;
  Headers := Headers + 'Accept-Encoding:deflate' + ret;
  Headers := Headers + 'Accept-Charset:windows-1251,utf-8;q=0.7,*;q=0.7' + ret;
  Headers := Headers + 'Keep-Alive:300' + ret;
  Headers := Headers + 'Connection:keep-alive' + ret;
  Headers := Headers + 'Referer:https://www.kinopoisk.ru/' + ret;
  Headers := Headers + 'Cookie:users_info[check_sh_bool]=none; search_last_date=2010-02-19; search_last_month=2010-02; PHPSESSID=b6df76a958983da150476d9cfa0aab18';
  {
  Headers := 'Content-Type:text/html; charset=windows-1251' + ret;
  Headers := Headers + 'Accept:image/gif, image/jpeg, image/pjpeg, application/x-ms-application, application/xaml+xml, application/x-ms-xbap, */*' + ret;
  Headers := Headers + 'Accept-Language:ru-RU' + ret;
  Headers := Headers + 'User-Agent:Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36' + ret;
  Headers := Headers + 'Host:www.kinopoisk.ru' + ret;
  Headers := Headers + 'Connection:Keep-Alive' + ret;
  }
  EmbeddedWB1.Navigate(URL, Flags, TargetFrameName, PostData, Headers);
  while Button6.Enabled = True do
    Application.HandleMessage;
end;

function DelDoubleSpacesAndLineBreaks(OldText: string): string;
var
  i: Integer;
  s: string;
begin
  OldText := StringReplace(StringReplace(OldText, #10, '', [rfReplaceAll]), #13, '', [rfReplaceAll]);
  if Length(OldText) > 0 then
    s := OldText[1]
  else
    s := '';
  for i := 1 to Length(OldText) do
    begin
      if OldText[i] = ' ' then
        begin
          if not (OldText[i - 1] = ' ') then
            s := s + ' ';
        end
      else
        s := s + OldText[i];
    end;
  Result := StringReplace(s, '> <', '><', [rfReplaceAll]);
end;

function TForm1.GetInfoFromUrl(const URL, LCaption: string): string;
var
  Flags, TargetFrameName, PostData, Headers: OLEVariant;
  SecConter: Integer;
begin
  Label6.Caption := LCaption;
  Flags :='';
  TargetFrameName := '';
  PostData := '';
  SecConter := 0;
  Headers := 'User-Agent:Mozilla/5.0 (X11; U; Linux i686; ru; rv:1.9.1.8) Gecko/20100214 Linux Mint/8 (Helena) Firefox/3.5.8' + ret;
  Headers := Headers + 'Accept:text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8' + ret;
  Headers := Headers + 'Accept-Language:ru,en-us;q=0.7,en;q=0.3' + ret;
  Headers := Headers + 'Accept-Encoding:deflate' + ret;
  Headers := Headers + 'Accept-Charset:windows-1251,utf-8;q=0.7,*;q=0.7' + ret;
  Headers := Headers + 'Keep-Alive:300' + ret;
  Headers := Headers + 'Connection:keep-alive' + ret;
  Headers := Headers + 'Referer:https://www.kinopoisk.ru/' + ret;
  Headers := Headers + 'Cookie:users_info[check_sh_bool]=none; search_last_date=2010-02-19; search_last_month=2010-02; PHPSESSID=b6df76a958983da150476d9cfa0aab18';
  {
  Headers := 'Content-Type:text/html; charset=windows-1251' + ret;
  Headers := Headers + 'Accept:image/gif, image/jpeg, image/pjpeg, application/x-ms-application, application/xaml+xml, application/x-ms-xbap, */*' + ret;
  Headers := Headers + 'Accept-Language:ru-RU' + ret;
  Headers := Headers + 'User-Agent:Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36' + ret;
  Headers := Headers + 'Host:www.kinopoisk.ru' + ret;
  Headers := Headers + 'Connection:Keep-Alive' + ret;}
  EmbeddedWB1.Navigate(URL, Flags, TargetFrameName, PostData, Headers);
  while GetHTML <> True do
    begin
      Application.ProcessMessages;
      Sleep(100);
      SecConter := SecConter + 1;
      Application.ProcessMessages;
      if SecConter > 100 then
        Break;
    end;
  if GetHTML = True then
    Result := Utf8Decode(DelDoubleSpacesAndLineBreaks(ObjStreamToStr(EmbeddedWB1.Document)))
  else
    Result := '';
end;

procedure TForm1.Button1Click(Sender: TObject);
const
  FindBlocking = '/captcha/'; //'IP-  ';
var
  CurrentMovie: Integer;
  URL, page, page2, page3: string;
  s, s0, s2, s3, s4, s5, ss, OldTitle: string;
  tags, tags2, tags3, tags4, tags5, tags6, tags7, tags8: string;
  i, ii, iii, iiii, j, jj, kol, x, k, k2, season, episode: Integer;
  TitleSer, TitlePost, OriginalTitle, Description, Descript, MovieCode, FullMovieCode, CoverID, ImagesDir: string;
  Comment, Director, Scenario, Actors, Other, cAllOther, dAllOther, Awards, Link, Studio: string;
  RatingIMDb, RatingKinoPoisk, RatingKritikov, NPage, SleepTime, KolError, AddComments, MaxFilms, Serial: Integer;
  EpisodeTitle, AirDate, EpisodeDescription, Recenzia, LinksList: string;
  uOriginalTitle, uAltOriginalTitle, uYear, uCountry, uSlogan, uGenre, uBudget, uSbor, uPremData, uRecenzia, uTrailer: Integer;
  uAllRecenziaPage, LinksInTable, uEpisodes, uEpisodesIfEmpty, uDuration, uDurationOtherFormat, uMPAA, uMarketing: Integer;
  uDescription, uRating, uRatingKinoPoisk, uRatingIMDb, uAwards, uLinks, uZnaite, uDVD, uBluRay, uRatingKritikov, uBook3500, uLikeMovies, uErrors: Integer;
  MaxPainter, MaxCutter, MaxTranslator, MaxDirector, MaxScenario, MaxActors, MaxProducer, MaxOperator, MaxComposer, MaxVoiceDirector, AddDescription: Integer;
  MaxVoice, MaxStudio, UseTemplates, MaxDelay, VisualEffectsStudio, SmallPic, SmallPicOnly: Integer;
  MaxVisualEffectsStudio, MaxVoiceStudio, VoiceStudio, MaxProkatStudio, ProkatStudio, ZnaiteIns, ErrorIns, FillOrigName: Integer;
  CommentsAddBR, DescriptionAddBR, DelTV, MaxRecenzia, MaxCovers, MaxScreenshots, DelHTML: Integer;
  uCovers, uAllCoversPage, uScreenshots, uAllScreenshotsPage, NeedURLDelay, MaxURLDelay: Integer;
  //[CommentsOptions]
  cBold, cSlogan, cBudget, cSbor, cPremData, cRatingKinoPoisk, cRatingIMDb, cOtherName, cMarketing, AddLoadInfoDate, AddUPLoadInfoDate: Integer;
  cAwards, cLinks, cZnaite, cErrors, cRecenzia, cInsertTegHR, cStudio, cDVD, cBluRay, cRatingKritikov, cBook3500, cLikeMovies: Integer;
  //[DescriptionOptions]
  dBold, dSlogan, dBudget, dSbor, dPremData, dRatingKinoPoisk, dRatingIMDb, dOtherName, dMarketing: Integer;
  dAwards, dLinks, dZnaite, dErrors, dRecenzia, dInsertTegHR, dStudio, dDVD, dBluRay, dRatingKritikov, dBook3500, dLikeMovies: Integer;
  UseRatingKinoPoisk, UseRatingIMDb, UseRatingKritikov, fUseRatingKinoPoisk, fUseRatingIMDb, fUseRatingKritikov: Integer;
  //[KinoPoiskOptions]
  Template, links, MovieList, List: TStringList;
  stream: TMemoryStream;
  Jpeg: TJPEGImage;
  OldDownloadSection, DownloadSection, DownloadSection1, DownloadSection2: string;
  tDescription, tSlogan, tBudget, tSborUS, tSborWord, tSborRF, tSborDVD, tPremDataWord, tPremDataRF, tRatingKinoPoisk, tRatingIMDb: string;
  tProducer, tOperator, tComposer, tVoiceDirector, tVoice, tAwards, tLinks, tZnaite, tErrors, tRecenzia, tMarketing, tBook3500, tLikeMovies: string;
  tVisualEffectsStudio, tVoiceStudio, tProkatStudio, tDVD, tBluRay, tRatingKritikov, tPainter, tCutter, tTranslator: string;
  ResizeCovers, ResizeScreenshots, CoversWidth, CoversHeight, ScreenshotsWidth, ScreenshotsHeight, SecConter: Integer;
  bmp, bmp2: TBItmap;
  Scale, Scale2: Double;
  DodPol,DodPolPoz: Integer;
  DodPolName, DodPolName1: string;
  ProxyPort: Integer;
  ProxyServer, ProxyUsername, ProxyPassword: string;
  uPictures: array of string;
begin
  MovieBase := TMovieBase.Create;
  DownloadSection1 := ComboBox1.Items[ComboBox1.ItemIndex];
  DownloadSection2 := ComboBox2.Items[ComboBox2.ItemIndex];
  DownloadSection := DownloadSection1;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      uOriginalTitle := ReadInteger(DownloadSection, 'OriginalTitle', 1);
      uAltOriginalTitle := ReadInteger(DownloadSection, 'AltOriginalTitle', 0);
      uYear := ReadInteger(DownloadSection, 'Year', 1);
      uCountry := ReadInteger(DownloadSection, 'Country', 1);
      uSlogan := ReadInteger(DownloadSection, 'Slogan', 1);
      uGenre := ReadInteger(DownloadSection, 'Genre', 1);
      uBudget := ReadInteger(DownloadSection, 'Budget', 1);
      uMarketing := ReadInteger(DownloadSection, 'Marketing', 0);
      uSbor := ReadInteger(DownloadSection, 'Sbor', 1);
      uPremData := ReadInteger(DownloadSection, 'PremData', 1);
      uTrailer := ReadInteger(DownloadSection, 'Trailer', 0);
      uRole := ReadInteger(DownloadSection, 'Role', 0);
      uMPAA := ReadInteger(DownloadSection, 'MPAA', 1);
      uDuration := ReadInteger(DownloadSection, 'Duration', 0);
      uDurationOtherFormat := ReadInteger(DownloadSection, 'DurationOtherFormat', 0);
      uDescription := ReadInteger(DownloadSection, 'Description', 1);
      uRating := ReadInteger(DownloadSection, 'Rating', 1);
      uRatingKinoPoisk := ReadInteger(DownloadSection, 'RatingKinoPoisk', 1);
      uRatingIMDb := ReadInteger(DownloadSection, 'RatingIMDb', 1);
      uRatingKritikov := ReadInteger(DownloadSection, 'RatingKritikov', 0);
      uAwards := ReadInteger(DownloadSection, 'Awards', 1);
      uLinks := ReadInteger(DownloadSection, 'Links', 1);
      LinksInTable := ReadInteger(DownloadSection, 'LinksInTable', 1);
      uZnaite := ReadInteger(DownloadSection, 'Znaite', 1);
      ZnaiteIns := ReadInteger(DownloadSection, 'ZnaiteIns', 1);
      uErrors := ReadInteger(DownloadSection, 'Errors', 0);
      ErrorIns := ReadInteger(DownloadSection, 'ErrorIns', 0);
      uRecenzia := ReadInteger(DownloadSection, 'Recenzia', 0);
      uAllRecenziaPage := ReadInteger(DownloadSection, 'AllRecenziaPage', 0);
      uEpisodes := ReadInteger(DownloadSection, 'Episodes', 1);
      uEpisodesIfEmpty := ReadInteger(DownloadSection, 'EpisodesIfEmpty', 1);
      uDVD := ReadInteger(DownloadSection, 'DVD', 0);
      uBluRay := ReadInteger(DownloadSection, 'BluRay', 0);
      uBook3500 := ReadInteger(DownloadSection, 'Book3500', 0);
      uLikeMovies := ReadInteger(DownloadSection, 'LikeMovies', 0);
      uCovers := ReadInteger(DownloadSection, 'Covers', 1);
      uAllCoversPage := ReadInteger(DownloadSection, 'AllCoversPage', 0);
      uScreenshots := ReadInteger(DownloadSection, 'Screenshots', 1);
      uAllScreenshotsPage := ReadInteger(DownloadSection, 'AllScreenshotsPage', 0);
      MaxCovers := ReadInteger(DownloadSection, 'MaxCovers', 500);
      MaxScreenshots := ReadInteger(DownloadSection, 'MaxScreenshots', 500);
      MaxRecenzia := ReadInteger(DownloadSection, 'MaxRecenzia', 500);
      if CheckBox2.Checked = False then
        begin
          uCovers := 0;
          uScreenshots := 0;
        end;
      MaxDirector := ReadInteger(DownloadSection, 'MaxDirector', 10);
      MaxScenario := ReadInteger(DownloadSection, 'MaxScenario', 10);
      MaxActors := ReadInteger(DownloadSection, 'MaxActors', 50);
      MaxProducer := ReadInteger(DownloadSection, 'MaxProducer', 10);
      MaxOperator := ReadInteger(DownloadSection, 'MaxOperator', 10);
      MaxComposer := ReadInteger(DownloadSection, 'MaxComposer', 10);
      MaxVoiceDirector := ReadInteger(DownloadSection, 'MaxVoiceDirector', 10);
      MaxVoice := ReadInteger(DownloadSection, 'MaxVoice', 10);
      MaxPainter := ReadInteger(DownloadSection, 'MaxPainter', 0);
      MaxCutter := ReadInteger(DownloadSection, 'MaxCutter', 0);
      MaxTranslator := ReadInteger(DownloadSection, 'MaxTranslator', 0);
      RusNameOnly := ReadInteger(DownloadSection, 'RusNameOnly', 0);
      NameException := ReadString(DownloadSection, 'NameException', '');
      MaxStudio := ReadInteger(DownloadSection, 'MaxStudio', 5);
      MaxVisualEffectsStudio := ReadInteger(DownloadSection, 'MaxVisualEffectsStudio', 0);
      VisualEffectsStudio := ReadInteger(DownloadSection, 'VisualEffectsStudio', 0);
      MaxVoiceStudio := ReadInteger(DownloadSection, 'MaxVoiceStudio', 0);
      VoiceStudio := ReadInteger(DownloadSection, 'VoiceStudio', 0);
      MaxProkatStudio := ReadInteger(DownloadSection, 'MaxProkatStudio', 0);
      ProkatStudio := ReadInteger(DownloadSection, 'ProkatStudio', 0);
      DelAndSave := ReadInteger('OtherOptions', 'DelAndSave', 1);
      SaveLogFile := ReadInteger('OtherOptions', 'SaveLogFile', 0);
      UseTemplates := ReadInteger('OtherOptions', 'UseTemplates', 0);
      MaxDelay := ReadInteger('OtherOptions', 'MaxDelay', 3);
      MaxFilms := ReadInteger('OtherOptions', 'MaxFilms', 1);
      UseAltName := ReadInteger('OtherOptions', 'UseAltName', 0);
      SmallPic := ReadInteger('OtherOptions', 'SmallPic', 0);
      SmallPicOnly := ReadInteger('OtherOptions', 'SmallPicOnly', 0);
      AddDescription := ReadInteger('OtherOptions', 'AddDescription2', 0);
      AddComments := ReadInteger('OtherOptions', 'AddComments2', 0);
      DelHTML := ReadInteger('OtherOptions', 'DelHTML', 0);
      if DelHTML = 1 then
        LinksInTable := 0;
      NeedURLDelay := ReadInteger('OtherOptions', 'NeedURLDelay', 0);
      MaxURLDelay := ReadInteger('OtherOptions', 'MaxURLDelay', 0);
      NeedURLDelay := 1;
      if NeedURLDelay = 1 then
        begin
          if MaxURLDelay = 0 then
            MaxURLDelay := 500
          else
            if MaxURLDelay > 0 then
              MaxURLDelay := MaxURLDelay * 1000;
        end;
      DescriptionAddBR := ReadInteger('OtherOptions', 'DescriptionAddBR', 0);
      CommentsAddBR := ReadInteger('OtherOptions', 'CommentsAddBR', 0);
      LinksList := ReadString('OtherOptions', 'LinksList', '::: : : : : :-: :');
      cBold := ReadInteger('OtherOptions', 'Bold', 1);
      dBold := ReadInteger('OtherOptions', 'Bold', 1);
      cInsertTegHR := ReadInteger('OtherOptions', 'InsertTegHR', 1);
      dInsertTegHR := ReadInteger('OtherOptions', 'InsertTegHR', 1);
      DelTV := ReadInteger('OtherOptions', 'DelTV', 0);
      FillOrigName := ReadInteger('OtherOptions', 'FillOrigName', 1);
      cSlogan := ReadInteger('CommentsOptions', 'Slogan', 1);
      cBudget := ReadInteger('CommentsOptions', 'Budget', 1);
      cMarketing := ReadInteger('CommentsOptions', 'Marketing', 1);
      cSbor := ReadInteger('CommentsOptions', 'Sbor', 1);
      cPremData := ReadInteger('CommentsOptions', 'PremData', 1);
      cRatingKinoPoisk := ReadInteger('CommentsOptions', 'RatingKinoPoisk', 1);
      cRatingIMDb := ReadInteger('CommentsOptions', 'RatingIMDb', 1);
      cRatingKritikov := ReadInteger('CommentsOptions', 'RatingKritikov', 1);
      cOtherName := ReadInteger('CommentsOptions', 'OtherName', 1);
      cAwards := ReadInteger('CommentsOptions', 'Awards', 0);
      cLinks := ReadInteger('CommentsOptions', 'Links', 0);
      cZnaite := ReadInteger('CommentsOptions', 'Znaite', 0);
      cErrors := ReadInteger('CommentsOptions', 'Errors', 0);
      cRecenzia := ReadInteger('CommentsOptions', 'Recenzia', 1);
      cStudio := ReadInteger('CommentsOptions', 'Studio', 1);
      cDVD := ReadInteger('CommentsOptions', 'DVD', 1);
      cBluRay := ReadInteger('CommentsOptions', 'BluRay', 1);
      cBook3500 := ReadInteger('CommentsOptions', 'Book3500', 0);
      cLikeMovies := ReadInteger('CommentsOptions', 'LikeMovies', 0);
      AddLoadInfoDate := ReadInteger('CommentsOptions', 'AddLoadInfoDate', 0);
      dSlogan := ReadInteger('DescriptionOptions', 'Slogan', 0);
      dBudget := ReadInteger('DescriptionOptions', 'Budget', 0);
      dMarketing := ReadInteger('DescriptionOptions', 'Marketing', 0);
      dSbor := ReadInteger('DescriptionOptions', 'Sbor', 0);
      dPremData := ReadInteger('DescriptionOptions', 'PremData', 0);
      dRatingKinoPoisk := ReadInteger('DescriptionOptions', 'RatingKinoPoisk', 0);
      dRatingIMDb := ReadInteger('DescriptionOptions', 'RatingIMDb', 0);
      dRatingKritikov := ReadInteger('DescriptionOptions', 'RatingKritikov', 0);
      dOtherName := ReadInteger('DescriptionOptions', 'OtherName', 0);
      dAwards := ReadInteger('DescriptionOptions', 'Awards', 1);
      dLinks := ReadInteger('DescriptionOptions', 'Links', 1);
      dZnaite := ReadInteger('DescriptionOptions', 'Znaite', 1);
      dErrors := ReadInteger('DescriptionOptions', 'Errors', 0);
      dRecenzia := ReadInteger('DescriptionOptions', 'Recenzia', 0);
      dStudio := ReadInteger('DescriptionOptions', 'Studio', 0);
      dDVD := ReadInteger('DescriptionOptions', 'DVD', 0);
      dBluRay := ReadInteger('DescriptionOptions', 'BluRay', 0);
      dBook3500 := ReadInteger('DescriptionOptions', 'Book3500', 0);
      dLikeMovies := ReadInteger('DescriptionOptions', 'LikeMovies', 0);
      UseRatingKinoPoisk := ReadInteger('RatingOptions', 'UseRatingKinoPoisk', 1);
      UseRatingIMDb := ReadInteger('RatingOptions', 'UseRatingIMDb', 0);
      UseRatingKritikov := ReadInteger('RatingOptions', 'UseRatingKritikov', 0);
      // 
      ProxyServer := ReadString('ProxyOptions', 'ProxyServer', '');
      ProxyPort := ReadInteger('ProxyOptions', 'ProxyPort', 0);
      ProxyUsername := ReadString('ProxyOptions', 'ProxyUsername', '');
      ProxyPassword := ReadString('ProxyOptions', 'ProxyPassword', '');
      AddUPLoadInfoDate := ReadInteger('OtherOptions', 'AddUPLoadInfoDate', 0);
      ResizeCovers := ReadInteger('OtherOptions', 'ResizeCovers', 0);
      ResizeScreenshots := ReadInteger('OtherOptions', 'ResizeScreenshots', 0);
      CoversWidth := ReadInteger('OtherOptions', 'CoversWidth', 10000);
      if CoversWidth = 0 then
        CoversWidth := 10000;
      CoversHeight := ReadInteger('OtherOptions', 'CoversHeight', 10000);
      if CoversHeight = 0 then
        CoversHeight := 10000;
      ScreenshotsWidth := ReadInteger('OtherOptions', 'ScreenshotsWidth', 10000);
      if ScreenshotsWidth = 0 then
        ScreenshotsWidth := 10000;
      ScreenshotsHeight := ReadInteger('OtherOptions', 'ScreenshotsHeight', 10000);
      if ScreenshotsHeight = 0 then
        ScreenshotsHeight := 10000;
    finally
      Free;
    end;
  ExitFlag := 0;
  Button2.Caption := '';
  GroupBox1.Enabled := False;
  GroupBox2.Enabled := False;
  Button1.Enabled := False;
  Button3.Enabled := False;
  Button4.Enabled := False;
  Button5.Enabled := False;
  Edit1.Enabled := False;
  ComboBox1.Enabled := False;
  ComboBox2.Enabled := False;
  CheckBox1.Enabled := False;
  CheckBox2.Enabled := False;
  CheckBox5.Enabled := False;
  CheckBox6.Enabled := False;
  Label3.Enabled := False;
  Label4.Enabled := False;
  Label5.Enabled := False;
  Label2.Enabled := False;
  Memo1.Lines.Clear;
  ProgressBar1.Position := 0;
  ProgressBar2.Position := 0;
  Application.ProcessMessages;
  LogFileName := MovieBase.Filename + '.log';
  if Pos('.amm', MovieBase.Filename) > 0 then
    ImagesDir := copy(MovieBase.Filename, 1, Pos('.amm', MovieBase.Filename) - 1) + '_images\m';
  NamePic := MovieBase.Filename + '.jpg';
  x := MovieBase.MovieCount;
  Application.ProcessMessages;
  if CheckBox1.Checked = False then
    MovieBase.First;
  MovieBase.EditMovie;
  KolError := 0;
  for iii := 1 to x do
    begin
      Label1.Caption := MovieBase.CurrentMovie.Title + ' (' + IntToStr(iii) + '/' + IntToStr(x) + ')';
      if CheckExit(0) = 1 then
        Exit;
      if iii > 1 then
        begin
          if MaxDelay > 3 then
            SleepTime := MaxDelay
          else
            SleepTime := 3;
          Memo1.Lines.Add(' ... ' + IntToStr(SleepTime) + ' .');
          for ii := 1 to SleepTime do
            begin
              if CheckExit(0) = 1 then
                Exit;
              Sleep(1000);
              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := ' ... ' + IntToStr(SleepTime - ii) + ' .';
            end;
          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := '';
          if CheckExit(0) = 1 then
            Exit;
        end;
      if (trim(Edit1.Text) = MovieBase.CurrentMovie.Year) or (trim(Edit1.Text) = '') then
        begin //  ,       
          ProgressBar2.Position := 1;
          if CheckExit(0) = 1 then
            Exit;
          URL := MovieBase.CurrentMovie.URL;
          URL := stringreplace(URL, '/id_film/', '/film/', [rfReplaceAll, rfIgnoreCase]);
          URL := stringreplace(URL, 'http:', 'https:', [rfReplaceAll, rfIgnoreCase]);
          i := pos('kinopoisk.ru', URL);
          if i > 0 then
            begin //  URL  
              if URL[Length(URL)] <> '/' then
                URL := URL + '/';
              Memo1.Lines.Add(': ' + MovieBase.CurrentMovie.Title);
              Memo1.Lines.Add('     ...');
              try
                GetHTML := False;
                page := GetInfoFromUrl(URL, '    .....');
                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
              except
                page := '';
                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
              end;
              Label6.Caption := '';
              if pos(FindBlocking, page) > 0 then
                begin
                  ShowMessage('    ');
                  GetBrowserWindow(URL);
                  try
                    GetHTML := False;
                    if NeedURLDelay = 1 then
                      Sleep(MaxURLDelay);
                    page := GetInfoFromUrl(URL, '    .....');
                  except
                    page := '';
                  end;
                end;
              Label6.Caption := '';
              ProgressBar2.Position := 5;
              if CheckExit(0) = 1 then
                Exit;
              if page <> '' then
                begin //  
                  Memo1.Lines.Add('        ...');
                  s := page;
                  s2 := '';
                  i := Pos('content="https://www.kinopoisk.ru/film/', s);
                  if i = 0 then
                    i := Pos('content="https://desktop.kinopoisk.ru/film/', s);
                  if i > 0 then
                    begin
                      delete(s, 1, i);
                      i := Pos('/film/', s);
                      if i > 0 then
                        delete(s, 1, i + 5);
                      s2 := copy(s, 1, pos('/"', s) - 1);
                      i := PosExD('-', s2);
                      if i > 0 then
                        Delete(s2, 1, i);
                    end;
                  MovieCode := s2;
                  if MovieCode = '' then
                    begin
                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                      KolError := KolError + 1;
                      if KolError > 4 then
                        ExitFlag := 1;
                      if CheckExit(1) = 1 then
                        Exit;
                    end
                  else
                    begin
                      KolError := 0;
                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                      if DelAndSave = 1 then
                        begin
                          Memo1.Lines.Add('          ...');
                          OldGenre := MovieBase.CurrentMovie.Genre;
                          OldCountry := MovieBase.CurrentMovie.Country;
                          OldDirector := MovieBase.CurrentMovie.Director;
                          OldScenario := MovieBase.CurrentMovie.Scenario;
                          OldActors := MovieBase.CurrentMovie.Actors;
                          OldStudio := MovieBase.CurrentMovie.Studio;
                          try
                            if uGenre = 1 then
                              MovieBase.CurrentMovie.Genre := '';
                            if uCountry = 1 then
                              MovieBase.CurrentMovie.Country := '';
                            if MaxDirector > 0 then
                              MovieBase.CurrentMovie.Director := '';
                            if MaxScenario > 0 then
                              MovieBase.CurrentMovie.Scenario := '';
                            if MaxActors > 0 then
                              MovieBase.CurrentMovie.Actors := '';
                            if MaxStudio > 0 then
                              MovieBase.CurrentMovie.Studio := '';
                            MovieBase.SaveMovie;
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                          except
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                          end;
                        end;
                      Comment := '';
                      Descript := '';
                      Description := '';
                      OriginalTitle := '';
                      FullMovieCode := '';
                      if CheckExit(1) = 1 then
                        Exit;
                      s := page;
                      OldDownloadSection := DownloadSection;
                      DownloadSection := DownloadSection1;
                      s2 := '';
                      i := pos('<link rel="alternate" href="', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 27);
                          s2 := copy(s, 1, pos('/"', s) - 1);
                          i := pos('/film/', s2);
                          if i > 0 then
                            begin
                              delete(s2, 1, pos('/film/', s2) + 5);
                              FullMovieCode := s2;
                            end;
                        end;
                      i := pos('class="moviename-big"', s); //    
                      if i > 0 then
                        begin
                          delete(s, 1, i + 20);
                          i := pos('">', s);
                          if i > 0 then
                            delete(s, 1, i + 1);
                          i := pos('</', s);
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := ReplaceLatinExt(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          i := pos('(', s2);
                          if i > 0 then
                            Serial := 1;
                          DownloadSection := DownloadSection2;
                        end;
                      if DownloadSection <> OldDownloadSection then
                        begin
                          with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
                            try
                              uOriginalTitle := ReadInteger(DownloadSection, 'OriginalTitle', 1);
                              uAltOriginalTitle := ReadInteger(DownloadSection, 'AltOriginalTitle', 0);
                              uYear := ReadInteger(DownloadSection, 'Year', 1);
                              uCountry := ReadInteger(DownloadSection, 'Country', 1);
                              uSlogan := ReadInteger(DownloadSection, 'Slogan', 1);
                              uGenre := ReadInteger(DownloadSection, 'Genre', 1);
                              uBudget := ReadInteger(DownloadSection, 'Budget', 1);
                              uMarketing := ReadInteger(DownloadSection, 'Marketing', 0);
                              uSbor := ReadInteger(DownloadSection, 'Sbor', 1);
                              uPremData := ReadInteger(DownloadSection, 'PremData', 1);
                              uTrailer := ReadInteger(DownloadSection, 'Trailer', 0);
                              uRole := ReadInteger(DownloadSection, 'Role', 0);
                              uMPAA := ReadInteger(DownloadSection, 'MPAA', 1);
                              uDuration := ReadInteger(DownloadSection, 'Duration', 0);
                              uDurationOtherFormat := ReadInteger(DownloadSection, 'DurationOtherFormat', 0);
                              uDescription := ReadInteger(DownloadSection, 'Description', 1);
                              uRating := ReadInteger(DownloadSection, 'Rating', 1);
                              uRatingKinoPoisk := ReadInteger(DownloadSection, 'RatingKinoPoisk', 1);
                              uRatingIMDb := ReadInteger(DownloadSection, 'RatingIMDb', 1);
                              uRatingKritikov := ReadInteger(DownloadSection, 'RatingKritikov', 0);
                              uAwards := ReadInteger(DownloadSection, 'Awards', 1);
                              uLinks := ReadInteger(DownloadSection, 'Links', 1);
                              LinksInTable := ReadInteger(DownloadSection, 'LinksInTable', 1);
                              uZnaite := ReadInteger(DownloadSection, 'Znaite', 1);
                              ZnaiteIns := ReadInteger(DownloadSection, 'ZnaiteIns', 1);
                              uErrors := ReadInteger(DownloadSection2, 'Errors', 0);
                              ErrorIns := ReadInteger(DownloadSection2, 'ErrorIns', 0);
                              uRecenzia := ReadInteger(DownloadSection, 'Recenzia', 0);
                              uAllRecenziaPage := ReadInteger(DownloadSection, 'AllRecenziaPage', 0);
                              uEpisodes := ReadInteger(DownloadSection, 'Episodes', 1);
                              uEpisodesIfEmpty := ReadInteger(DownloadSection, 'EpisodesIfEmpty', 1);
                              uDVD := ReadInteger(DownloadSection, 'DVD', 0);
                              uBluRay := ReadInteger(DownloadSection, 'BluRay', 0);
                              uBook3500 := ReadInteger(DownloadSection, 'Book3500', 0);
                              uLikeMovies := ReadInteger(DownloadSection, 'LikeMovies', 0);
                              uCovers := ReadInteger(DownloadSection, 'Covers', 1);
                              uAllCoversPage := ReadInteger(DownloadSection, 'AllCoversPage', 0);
                              uScreenshots := ReadInteger(DownloadSection, 'Screenshots', 1);
                              uAllScreenshotsPage := ReadInteger(DownloadSection, 'AllScreenshotsPage', 0);
                              MaxCovers := ReadInteger(DownloadSection, 'MaxCovers', 500);
                              MaxScreenshots := ReadInteger(DownloadSection, 'MaxScreenshots', 500);
                              MaxRecenzia := ReadInteger(DownloadSection, 'MaxRecenzia', 500);
                              if CheckBox2.Checked = False then
                                begin
                                  uCovers := 0;
                                  uScreenshots := 0;
                                end;
                              MaxDirector := ReadInteger(DownloadSection, 'MaxDirector', 10);
                              MaxScenario := ReadInteger(DownloadSection, 'MaxScenario', 10);
                              MaxActors := ReadInteger(DownloadSection, 'MaxActors', 50);
                              MaxProducer := ReadInteger(DownloadSection, 'MaxProducer', 10);
                              MaxOperator := ReadInteger(DownloadSection, 'MaxOperator', 10);
                              MaxComposer := ReadInteger(DownloadSection, 'MaxComposer', 10);
                              MaxVoiceDirector := ReadInteger(DownloadSection, 'MaxVoiceDirector', 10);
                              MaxVoice := ReadInteger(DownloadSection, 'MaxVoice', 10);
                              MaxPainter := ReadInteger(DownloadSection, 'MaxPainter', 0);
                              MaxCutter := ReadInteger(DownloadSection, 'MaxCutter', 0);
                              MaxTranslator := ReadInteger(DownloadSection, 'MaxTranslator', 0);
                              RusNameOnly := ReadInteger(DownloadSection, 'RusNameOnly', 0);
                              NameException := ReadString(DownloadSection, 'NameException', '');
                              MaxStudio := ReadInteger(DownloadSection, 'MaxStudio', 5);
                              MaxVisualEffectsStudio := ReadInteger(DownloadSection, 'MaxVisualEffectsStudio', 0);
                              VisualEffectsStudio := ReadInteger(DownloadSection, 'VisualEffectsStudio', 0);
                              MaxVoiceStudio := ReadInteger(DownloadSection, 'MaxVoiceStudio', 0);
                              VoiceStudio := ReadInteger(DownloadSection, 'VoiceStudio', 0);
                              MaxProkatStudio := ReadInteger(DownloadSection, 'MaxProkatStudio', 0);
                              ProkatStudio := ReadInteger(DownloadSection, 'ProkatStudio', 0);
                            finally
                              Free;
                            end;
                        end;
                      s := page; //  
                      if GetAMMBuild > 1283 then //
                        begin
                          if uTrailer = 1 then
                            begin //,     
                              Memo1.Lines.Add('           ...');
                              if (Pos('<li><s></s><u></u><a href="/film/' + FullMovieCode + '/video/"', page) > 0) or
                                 (Pos('<li><s></s><u></u><a href="/film/' + MovieCode + '/video/"', page) > 0)
                              then
                                begin
                                  MovieBase.CurrentMovie.TrailerLink := 'https://www.kinopoisk.ru/film/' + MovieCode + '/video/';
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end;
                        end;
                      ProgressBar2.Position := 6;
                      Application.ProcessMessages;
                      tDescription := ''; //
                      if uDescription = 1 then
                        begin
                          Memo1.Lines.Add('       ...');
                          i := pos('<div class="brand_words film-synopsys" itemprop="description">', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 61);
                              s2 := '';
                              i := pos('</td></tr>', s);
                              if i > 0 then
                                s2 := copy(s, 1, i - 1);
                              s2 := ClearHTML(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  Description := s2;
                                  tDescription := s2;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      s := page;
                      i := pos('> </', s);
                      if i > 0 then
                        s := copy(s, 1, i - 1);
                      s := stringreplace(s, '</a>)</', ')</a></', [rfReplaceAll, rfIgnoreCase]);
                      s := stringreplace(s, '</a>]</', ']</a></', [rfReplaceAll, rfIgnoreCase]);
                      s := stringreplace(s, '>-</', '>-</a></', [rfReplaceAll, rfIgnoreCase]);
                      ProgressBar2.Position := 7;
                      Application.ProcessMessages;
                      Memo1.Lines.Add('       ...'); // ,    
                      s2 := '';
                      i := pos('class="moviename-big"', s);
                      if i > 0 then
                        begin
                          delete(s, 1, i + 20);
                          i := pos('">', s);
                          if i > 0 then
                            delete(s, 1, i + 1);
                          i := pos('</', s);
                          s2 := copy(s, 1, i - 1);
                          s2 := HTMLRemoveTags(s2);
                          s2 := ReplaceLatinExt(s2);
                          s2 := HTMLDecode(s2);
                          s2 := trim(s2);
                          if TitleSer <> '' then
                            begin
                              i := pos('(', s2);
                              if i > 0 then
                                begin
                                  s2 := copy(s2, 1, i - 1);
                                  s2 := trim(s2);
                                end;
                              s2 := s2 + ' ' + TitleSer;
                            end
                          else
                            s2 := s2 + TitlePost;
                           if DelTV = 1 then
                            begin
                              i := pos('(', s2);
                              if i > 0 then
                                s2 := copy(s2, 1, i - 1);
                              i := pos('(-', s2);
                              if i > 0 then
                                s2 := copy(s2, 1, i - 1);
                              i := pos('()', s2);
                              if i > 0 then
                                s2 := copy(s2, 1, i - 1);
                              i := pos('()', s2);
                              if i > 0 then
                                s2 := copy(s2, 1, i - 1);
                            end;
                          s2 := stringreplace(s2, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                          s2 := trim(s2);
                          if (s2 <> '') and (s2 <> '-') then
                            begin
                              if CheckBox6.Checked = True then
                                begin
                                  MovieBase.CurrentMovie.Title := s2;
                                end;
                              if MovieBase.CurrentMovie.Title <> s2 then
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!: ' + s2
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end
                      else
                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                      Application.ProcessMessages;
                      if uOriginalTitle = 1 then // 
                        begin
                          Memo1.Lines.Add('        ...');
                          i := pos('class="moviename-big"', s);
                          if i > 0 then
                            delete(s, 1, i + 20);
                          i := pos('</h1>', s);
                          if i > 0 then
                            delete(s, 1, i + 4);
                          i := pos('<span', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i - 1);
                              i := pos('</span>', s);
                              if i > 0 then
                                begin
                                  s2 := copy(s, 1, i - 1);
                                  s2 := HTMLRemoveTags(s2);
                                  s2 := ReplaceLatinExt(s2);
                                  s2 := HTMLDecode(s2);
                                  s2 := stringreplace(s2, '  ', ' ', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := trim(s2);
                                  if (s2 <> '') and (s2 <> '-') then
                                    begin    
                                      MovieBase.CurrentMovie.OriginalTitle := s2;
                                      OriginalTitle := s2;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          if (trim(OriginalTitle) = '') and (FillOrigName = 1) then
                            begin
                              if trim(MovieBase.CurrentMovie.Title) <> '' then
                                MovieBase.CurrentMovie.OriginalTitle := MovieBase.CurrentMovie.Title;
                            end;
                        end;
                      if uAltOriginalTitle = 1 then
                        begin
                          if MovieBase.CurrentMovie.OriginalTitle = MovieBase.CurrentMovie.Title then
                            MovieBase.CurrentMovie.OriginalTitle := RusToTranslit(MovieBase.CurrentMovie.Title);
                        end;
                      ProgressBar2.Position := 8;
                      Application.ProcessMessages;
                      if uYear = 1 then //
                        begin
                          Memo1.Lines.Add('       ...');
                          i := pos('></', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 5);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              i := pos('&nbsp;', s2);
                              if i > 0 then
                                s2 := copy(s2, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  MovieBase.CurrentMovie.Year := s2;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 9;
                      Application.ProcessMessages;
                      if uCountry = 1 then //
                        begin
                          i := pos('></', s);
                          if i > 0 then
                            begin
                              Memo1.Lines.Add('       ...');
                              delete(s, 1, i + 8);
                              i := pos('</td>', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  MovieBase.CurrentMovie.Country := s2;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 10;
                      Application.ProcessMessages;
                      tSlogan := '';
                      if uSlogan = 1 then //
                        begin
                          Memo1.Lines.Add('       ...');
                          i := pos('></', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 8);
                              i := pos('">', s);
                              if i > 0 then
                                delete(s, 1, i + 1);
                              i := pos('</', s);
                              s2 := copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := ReplaceLatinExt(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tSlogan := s2;
                                  if cSlogan = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>: </b>' + s2
                                      else
                                        Comment := Comment + ': ' + s2;
                                    end;
                                  if dSlogan = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>: </b>' + s2
                                      else
                                        Descript := Descript + ': ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 11;
                      Application.ProcessMessages;
                      if uGenre = 1 then //
                        begin
                          Memo1.Lines.Add('       ...');
                          i := pos('></', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 6);
                              i := pos('>', s);
                              delete(s, 1, i);
                              i := pos('</td></tr>', s);
                              s2 := copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := stringreplace(s2, ', ...', '', [rfReplaceAll, rfIgnoreCase]);
                              s2 := stringreplace(s2, '', '', [rfReplaceAll, rfIgnoreCase]);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  MovieBase.CurrentMovie.Genre := AnsiUpFirstLetter(s2);
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 12;
                      Application.ProcessMessages;
                      tBudget := '';
                      if uBudget = 1 then //  
                        begin
                          Memo1.Lines.Add('       ...');
                          i := pos('></', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 8);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tBudget := s2;
                                  if cBudget = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>: </b>' + s2
                                      else
                                        Comment := Comment + ': ' + s2;
                                    end;
                                  if dBudget = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>: </b>' + s2
                                      else
                                        Descript := Descript + ': ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 13;
                      Application.ProcessMessages;
                      tMarketing := '';
                      if uMarketing = 1 then //
                        begin
                          Memo1.Lines.Add('       ...');
                          i := pos('></', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 11);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tMarketing := s2;
                                  if cMarketing = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>: </b>' + s2
                                      else
                                        Comment := Comment + ': ' + s2;
                                    end;
                                  if dMarketing = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>: </b>' + s2
                                      else
                                        Descript := Descript + ': ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 14;
                      Application.ProcessMessages;
                      tSborUS := '';
                      tSborWord := '';
                      tSborRF := '';
                      tSborDVD := '';
                      if uSbor = 1 then
                        begin
                          Memo1.Lines.Add('         ...');
                          i := pos('>  </', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 13);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tSborUS := s2;
                                  if cSbor = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>  : </b>' + s2
                                      else
                                        Comment := Comment + '  : ' + s2;
                                    end;
                                  if dSbor = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>  : </b>' + s2
                                      else
                                        Descript := Descript + '  : ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          ProgressBar2.Position := 15;
                          Application.ProcessMessages;
                          Memo1.Lines.Add('       DVD...');
                          i := pos('> DVD</', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 12);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tSborDVD := s2;
                                  if cSbor = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> DVD: </b>' + s2
                                      else
                                        Comment := Comment + ' DVD: ' + s2;
                                    end;
                                  if dSbor = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> DVD: </b>' + s2
                                      else
                                        Descript := Descript + ' DVD: ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          ProgressBar2.Position := 16;
                          Application.ProcessMessages;
                          Memo1.Lines.Add('         ...');
                          i := pos('>  </', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 14);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tSborWord := s2;
                                  if cSbor = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>  : </b>' + s2
                                      else
                                        Comment := Comment + '  : ' + s2;
                                    end;
                                  if dSbor = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>  : </b>' + s2
                                      else
                                        Descript := Descript + '  : ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          ProgressBar2.Position := 17;
                          Application.ProcessMessages;
                          Memo1.Lines.Add('         ...');
                          i := pos('>  </', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 16);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tSborRF := s2;
                                  if cSbor = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>  : </b>' + s2
                                      else
                                        Comment := Comment + '  : ' + s2;
                                    end;
                                  if dSbor = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>  : </b>' + s2
                                      else
                                        Descript := Descript + '  : ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 18;
                      Application.ProcessMessages;
                      tPremDataWord := '';
                      tPremDataRF := '';
                      if uPremData = 1 then //
                        begin
                          Memo1.Lines.Add('        ()...');
                          i := pos('> ()</', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 16);
                              i := pos('</a>', s);
                              s2 := '<a' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tPremDataWord := s2;
                                  if cPremData = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> (): </b>' + s2
                                      else
                                        Comment := Comment + ' (): ' + s2;
                                    end;
                                  if dPremData = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> (): </b>' + s2
                                      else
                                        Descript := Descript + ' (): ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          ProgressBar2.Position := 19;
                          Application.ProcessMessages;
                          Memo1.Lines.Add('        ()...');
                          i := pos('> ()</', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 15);
                              i := pos('</a>', s);
                              s2 := '<a' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  tPremDataRF := s2;
                                  if cPremData = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b> (): </b>' + s2
                                      else
                                        Comment := Comment + ' (): ' + s2;
                                    end;
                                  if dPremData = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b> (): </b>' + s2
                                      else
                                        Descript := Descript + ' (): ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      Application.ProcessMessages;
                      s5 := s;
                      tDVD := '';
                      if uDVD = 1 then
                        begin
                          Memo1.Lines.Add('         DVD...');
                          i := pos('>  DVD</', s5);
                          if i > 0 then
                            begin
                              delete(s5, 1, i + 14);
                              i := pos('</td>', s5);
                              s2 := '<' + copy(s5, 1, i + 4);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  i := pos(',', s2);
                                  if i > 0 then
                                    s2 := copy(s2, 1, i - 1);
                                  tDVD := s2;
                                  if cDVD = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>  DVD: </b>' + s2
                                      else
                                        Comment := Comment + '  DVD: ' + s2;
                                    end;
                                  if dDVD = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>  DVD: </b>' + s2
                                      else
                                        Descript := Descript + '  DVD: ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      Application.ProcessMessages;
                      s5 := s;
                      tBluRay := '';
                      if uBluRay = 1 then
                        begin
                          Memo1.Lines.Add('         Blu-Ray...');
                          i := pos('>  Blu-ray</', s5);
                          if i > 0 then
                            begin
                              delete(s5, 1, i + 18);
                              i := pos('</td>', s5);
                              s2 := '<' + copy(s5, 1, i + 4);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  i := pos(',', s2);
                                  if i > 0 then
                                    s2 := copy(s2, 1, i - 1);
                                  tBluRay := s2;
                                  if cBluRay = 1 then
                                    begin
                                      if Comment <> '' then
                                        Comment := Comment + ret;
                                      if cBold = 1 then
                                        Comment := Comment + '<b>  Blu-Ray: </b>' + s2
                                      else
                                        Comment := Comment + '  Blu-Ray: ' + s2;
                                    end;
                                  if dBluRay = 1 then
                                    begin
                                      if Descript <> '' then
                                        Descript := Descript + ret;
                                      if dBold = 1 then
                                        Descript := Descript + '<b>  Blu-Ray: </b>' + s2
                                      else
                                        Descript := Descript + '  Blu-Ray: ' + s2;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 20;
                      Application.ProcessMessages;
                      if uMPAA = 1 then // MPAA
                        begin
                          Memo1.Lines.Add('        MPAA ...');
                          i := pos('> MPAA</', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 14);
                              i := pos('/rn/', s);
                              delete(s, 1, i + 3);
                              i := pos('/', s);
                              s2 := copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  MovieBase.CurrentMovie.MPAA := s2;
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      Application.ProcessMessages;
                      if uDuration = 1 then // 
                        begin
                          Memo1.Lines.Add('       ...');
                          i := pos('></', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 7);
                              i := pos('</', s);
                              s2 := '<' + copy(s, 1, i - 1);
                              s2 := HTMLRemoveTags(s2);
                              s2 := HTMLDecode(s2);
                              s2 := trim(s2);
                              if (s2 <> '') and (s2 <> '-') then
                                begin
                                  if uDurationOtherFormat = 1 then
                                    begin
                                      s4 := s2;
                                      i := pos('', s2);
                                      if i > 0 then
                                        begin
                                          s2 := trim(copy(s2, 1, i - 1));
                                          try
                                            i := StrToInt(s2);
                                            j := i div 60;
                                            i := i mod 60;
                                            s2 := IntToStr(j);
                                            s3 := IntToStr(i);
                                            if length(s3) = 1 then
                                              s3 := '0' + s3;
                                            s2 := s2 + ':' + s3;
                                          except
                                            s2 := s4;
                                          end;
                                        end;
                                    end;
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  MovieBase.CurrentMovie.Duration := s2;
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 21;
                      Application.ProcessMessages;
                      tRatingKinoPoisk := '';
                      tRatingIMDb := '';
                      tRatingKritikov := '';
                      RatingKinoPoisk := 0;
                      if (uRatingKinoPoisk = 1) or (UseRatingKinoPoisk + uRating = 2) then // kinopoisk
                        begin
                          Memo1.Lines.Add('        ...');
                          i := Pos('<a href="/film/' + FullMovieCode + '/votes/', s);
                          if i = 0 then
                            i := Pos('<a href="/film/' + MovieCode + '/votes/', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i - 1);
                              i := Pos('<a ', s);
                              j := Pos('</div>', s);
                              if (i > 0) and (j > 0) then
                                begin
                                  j := j + 6;
                                  s2 := copy(s, i, j - i);
                                  s2 := stringreplace(s2, 'ratingCount">', 'ratingCount"> (',[rfReplaceAll, rfIgnoreCase]);
                                  s2 := ClearHTML(s2);
                                  s2 := StringReplace(s2, #10, '', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := StringReplace(s2, #13, '', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := s2 + ')';
                                  i := pos('>To250:', s);
                                  if i = 0 then
                                    i := pos('>250:', s);
                                  if i > 0 then
                                    begin
                                      j := MyPos('</a>', s, i);
                                      s3 := '<' + copy(s, i, j - i);
                                      s3 := HTMLRemoveTags(s3);
                                      s3 := HTMLDecode(s3);
                                      s3 := trim(s3);
                                      if s3 <> '' then
                                        s2 := s2 + ', ' + s3;
                                    end;
                                  if length(s2) > 0 then
                                    begin
                                      s3 := s2;
                                      i := pos('.', s3);
                                      if i > 0 then
                                        delete(s3, i, 1)
                                      else
                                        i := 2;
                                      s3 := copy(s3, 1, i);
                                      try
                                        RatingKinoPoisk := StrToInt(s3);
                                      except
                                      end;
                                      if (uRatingKinoPoisk = 1) and (RatingKinoPoisk > 0) then
                                        begin
                                          tRatingKinoPoisk := s2;
                                          if cRatingKinoPoisk = 1 then
                                            begin
                                              if Comment <> '' then
                                                Comment := Comment + ret;
                                              if cBold = 1 then
                                                Comment := Comment + '<b> : </b>' + s2
                                              else
                                                Comment := Comment + ' : ' + s2;
                                            end;
                                          if dRatingKinoPoisk = 1 then
                                            begin
                                              if Descript <> '' then
                                                Descript := Descript + ret;
                                              if dBold = 1 then
                                                Descript := Descript + '<b> : </b>' + s2
                                              else
                                                Descript := Descript + ' : ' + s2;
                                            end;
                                        end;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      Application.ProcessMessages;
                      RatingIMDb := 0;
                      if (uRatingIMDb = 1) or (UseRatingIMDb + uRating = 2) then // imdb
                        begin
                          Memo1.Lines.Add('        IMDB...');
                          i := pos('IMDB: ', s);
                          if i = 0 then
                            i := pos('IMDb: ', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i + 5);
                              i := pos(' ', s);
                              j := pos(')', s);
                              s2 := copy(s, 1, i - 1);
                              s3 := copy(s, 1, j);
                              s3 := HTMLRemoveTags(s3);
                              s3 := HTMLDecode(s3);
                              s3 := trim(s3);
                              if uRatingIMDb = 1 then
                                begin
                                  if (s3 <> '') and (s3 <> '-') then
                                    begin
                                      tRatingIMDb := s3;
                                      if cRatingIMDb = 1 then
                                        begin
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          if cBold = 1 then
                                            Comment := Comment + '<b> IMDb: </b>' + s3
                                          else
                                            Comment := Comment + ' IMDb: ' + s3;
                                        end;
                                      if dRatingIMDb = 1 then
                                        begin
                                          if Descript <> '' then
                                            Descript := Descript + ret;
                                          if dBold = 1 then
                                            Descript := Descript + '<b> IMDb: </b>' + s3
                                          else
                                            Descript := Descript + ' IMDb: ' + s3;
                                        end;
                                    end;
                                end;
                              i := pos('.', s2);
                              if i > 0 then
                                delete(s2, i, 1)
                              else
                                i := 2;
                              s2 := copy(s2, 1, i);
                              try
                                RatingIMDb := StrToInt(s2);
                              except
                              end;
                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      Application.ProcessMessages;
                      RatingKritikov := 0;
                      if (uRatingKritikov = 1) or (UseRatingKritikov + uRating = 2) then // 
                        begin
                          Memo1.Lines.Add('        ...');
                          i := pos('> <', s);
                          if i > 0 then
                            begin
                              delete(s, 1, i);
                              s4 := '';
                              i := pos('<span class="num">', s);
                              if i > 0 then
                                begin
                                  delete(s, 1, i + 17);
                                  j := pos('</span>', s);
                                  s4 := trim(copy(s, 1, j - 1));
                                  if s4 <> '' then
                                    begin
                                      s2 := '';
                                      i := pos('<span class="el1">', s);
                                      if i > 0 then
                                        begin
                                          delete(s, 1, i + 17);
                                          j := pos('<div', s);
                                          s2 := trim(copy(s, 1, j - 1));
                                          s2 := HTMLRemoveTags(s2);
                                        end;
                                      if s2 <> '' then
                                        s4 := ' (' + s4 + '%, ' + s2 + ')'
                                      else
                                        s4 := ' (' + s4 + '%)';
                                    end;
                                  s2 := '';
                                  i := pos('<div class="star"><s></s>', s);
                                  if i > 0 then
                                    begin
                                      delete(s, 1, i + 24);
                                      j := pos('</div>', s);
                                      s2 := trim(copy(s, 1, j - 1));
                                    end;
                                  s3 := s2 + s4;
                                  if uRatingKritikov = 1 then
                                    begin
                                      if (s3 <> '') and (s3 <> '-') then
                                        begin
                                          tRatingKritikov := s3;
                                          if cRatingKritikov = 1 then
                                            begin
                                              if Comment <> '' then
                                                Comment := Comment + ret;
                                              if cBold = 1 then
                                                Comment := Comment + '<b> : </b>' + s3
                                              else
                                                Comment := Comment + ' : ' + s3;
                                            end;
                                          if dRatingKritikov = 1 then
                                            begin
                                              if Descript <> '' then
                                                Descript := Descript + ret;
                                              if dBold = 1 then
                                                Descript := Descript + '<b> : </b>' + s3
                                              else
                                                Descript := Descript + ' : ' + s3;
                                            end;
                                        end;
                                    end;
                                end;
                              i := pos('.', s2);
                              if i > 0 then
                                delete(s2, i, 1)
                              else
                                i := 2;
                              s2 := copy(s2, 1, i);
                              try
                                RatingKritikov := StrToInt(s2);
                              except
                              end;
                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      Application.ProcessMessages;
                      if uRating = 1 then
                        begin
                          Memo1.Lines.Add('       ...');
                          MovieBase.CurrentMovie.Rating := 0;
                          if UseRatingKinoPoisk = 0 then
                            RatingKinoPoisk := 0;
                          if UseRatingIMDb = 0 then
                            RatingIMDb := 0;
                          if UseRatingKritikov = 0 then
                            RatingKritikov := 0;
                          fUseRatingKinoPoisk := UseRatingKinoPoisk;
                          fUseRatingIMDb := UseRatingIMDb;
                          fUseRatingKritikov := UseRatingKritikov;
                          if RatingKinoPoisk = 0 then
                            fUseRatingKinoPoisk := 0;
                          if RatingIMDb = 0 then
                            fUseRatingIMDb := 0;
                          if RatingKritikov = 0 then
                            fUseRatingKritikov := 0;
                          if (fUseRatingKinoPoisk + fUseRatingIMDb + fUseRatingKritikov) > 0 then
                            MovieBase.CurrentMovie.Rating := Round((RatingIMDb + RatingKinoPoisk + RatingKritikov) /
                                                                   (fUseRatingKinoPoisk + fUseRatingIMDb + fUseRatingKritikov));
                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                        end;
                      ProgressBar2.Position := 22;
                      if CheckExit(1) = 1 then
                        Exit;
                      if MaxStudio + MaxVisualEffectsStudio + MaxVoiceStudio + MaxProkatStudio > 0 then
                        begin //,    
                          Memo1.Lines.Add('     ...');
                          if (Pos('href="/film/' + FullMovieCode + '/studio/', page) > 0) or
                             (Pos('href="/film/' + MovieCode + '/studio/', page) > 0)
                          then
                            begin
                              try
                                GetHTML := False;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/studio/',
                                                        '  .....');
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                page2 := '';
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              Label6.Caption := '';
                              i := Pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/studio/');
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/studio/',
                                                            '  .....');
                                  except
                                    page2 := '';
                                  end;
                                end;
                              Label6.Caption := '';
                              ProgressBar2.Position := 23;
                              if CheckExit(1) = 1 then
                                Exit;
                              if page2 <> '' then
                                begin
                                  Studio := '';
                                  if MaxStudio > 0 then
                                    begin
                                      kol := 0;
                                      Memo1.Lines.Add('       ...');
                                      i := Pos('>:</b></td>', page2);
                                      if i > 0 then
                                        begin
                                          delete(page2, 1, i - 1);
                                          i := Pos('<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                          s2 := copy(page2, 1, i - 1);
                                          repeat
                                            Application.ProcessMessages;
                                            i := Pos('/" class="all">', s2);
                                            if i > 0 then
                                              begin
                                                delete(s2, 1, i + 14);
                                                j := Pos('</a>', s2);
                                                s := copy(s2, 1, j - 1);
                                                delete(s2, 1, j + 3);
                                                s := HTMLRemoveTags(s);
                                                s := ReplaceLatinExt(s);
                                                s := HTMLDecode(s);
                                                if Studio <> '' then
                                                  Studio := Studio + ', ';
                                                Studio := Studio + trim(s);
                                                kol := kol + 1;
                                              end;
                                          until (i = 0) or (kol >= MaxStudio);
                                        end;
                                    end;
                                  tVisualEffectsStudio := '';
                                  if MaxVisualEffectsStudio > 0 then
                                    begin
                                      kol := 0;
                                      i := Pos('>:</b></td>', page2);
                                      if i > 0 then
                                        begin
                                          delete(page2, 1, i - 1);
                                          i := Pos('<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                          s2 := copy(page2, 1, i - 1);
                                          repeat
                                            Application.ProcessMessages;
                                            i := Pos('/" class="all">', s2);
                                            if i > 0 then
                                              begin
                                                delete(s2, 1, i + 14);
                                                j := Pos('</a>', s2);
                                                s := copy(s2, 1, j - 1);
                                                delete(s2, 1, j + 3);
                                                s := HTMLRemoveTags(s);
                                                s := ReplaceLatinExt(s);
                                                s := HTMLDecode(s);
                                                if tVisualEffectsStudio <> '' then
                                                  tVisualEffectsStudio := tVisualEffectsStudio + ', ';
                                                tVisualEffectsStudio := tVisualEffectsStudio + trim(s);
                                                kol := kol + 1;
                                              end;
                                          until (i = 0) or (kol >= MaxVisualEffectsStudio);
                                        end;
                                    end;
                                  if tVisualEffectsStudio <> '' then
                                    begin
                                      if VisualEffectsStudio = 1 then
                                        begin
                                          Studio := Studio + ', ' + trim(tVisualEffectsStudio);
                                          tVisualEffectsStudio := '';
                                        end
                                      else
                                        begin
                                          if cStudio = 1 then
                                            begin
                                              if Comment <> '' then
                                                Comment := Comment + ret;
                                              if cBold = 1 then
                                                Comment := Comment + '<b>: </b>' + tVisualEffectsStudio
                                              else
                                                Comment := Comment + ': ' + tVisualEffectsStudio;
                                            end;
                                          if dStudio = 1 then
                                            begin
                                              if Descript <> '' then
                                                Descript := Descript + ret;
                                              if dBold = 1 then
                                                Descript := Descript + '<b>: </b>' + tVisualEffectsStudio
                                              else
                                                Descript := Descript + ': ' + tVisualEffectsStudio;
                                            end;
                                        end;
                                    end;
                                  tVoiceStudio := '';
                                  if MaxVoiceStudio > 0 then
                                    begin
                                      kol := 0;
                                      i := Pos('> :</b></td>', page2);
                                      if i > 0 then
                                        begin
                                          delete(page2, 1, i - 1);
                                          i := Pos('<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                          s2 := copy(page2, 1, i - 1);
                                          repeat
                                            Application.ProcessMessages;
                                            i := Pos('/" class="all">', s2);
                                            if i > 0 then
                                              begin
                                                delete(s2, 1, i + 14);
                                                j := Pos('</a>', s2);
                                                s := copy(s2, 1, j - 1);
                                                delete(s2, 1, j + 3);
                                                s := HTMLRemoveTags(s);
                                                s := ReplaceLatinExt(s);
                                                s := HTMLDecode(s);
                                                if tVoiceStudio <> '' then
                                                  tVoiceStudio := tVoiceStudio + ', ';
                                                tVoiceStudio := tVoiceStudio + trim(s);
                                                kol := kol + 1;
                                              end;
                                          until (i = 0) or (kol >= MaxVoiceStudio);
                                        end;
                                    end;
                                  if tVoiceStudio <> '' then
                                    begin
                                      if VoiceStudio = 1 then
                                        begin
                                          Studio := Studio + ', ' + trim(tVoiceStudio);
                                          tVoiceStudio := '';
                                        end
                                      else
                                        begin
                                          if cStudio = 1 then
                                            begin
                                              if Comment <> '' then
                                                Comment := Comment + ret;
                                              if cBold = 1 then
                                                Comment := Comment + '<b> : </b>' + tVoiceStudio
                                              else
                                                Comment := Comment + ' : ' + tVoiceStudio;
                                            end;
                                          if dStudio = 1 then
                                            begin
                                              if Descript <> '' then
                                                Descript := Descript + ret;
                                              if dBold = 1 then
                                                Descript := Descript + '<b> : </b>' + tVoiceStudio
                                              else
                                                Descript := Descript + ' : ' + tVoiceStudio;
                                            end;
                                        end;
                                    end;
                                  tProkatStudio := '';
                                  if MaxProkatStudio > 0 then
                                    begin
                                      kol := 0;
                                      i := Pos('>:</b></td>', page2);
                                      if i > 0 then
                                        begin
                                          delete(page2, 1, i - 1);
                                          i := Pos('<tr><td colspan=3 style="border-bottom:2px solid #ccc">&nbsp;</td></tr>', page2);
                                          s2 := copy(page2, 1, i - 1);
                                          repeat
                                            Application.ProcessMessages;
                                            i := Pos('/" class="all">', s2);
                                            if i > 0 then
                                              begin
                                                delete(s2, 1, i + 14);
                                                j := Pos('</a>', s2);
                                                s := copy(s2, 1, j - 1);
                                                delete(s2, 1, j + 3);
                                                s := HTMLRemoveTags(s);
                                                s := ReplaceLatinExt(s);
                                                s := HTMLDecode(s);
                                                if tProkatStudio <> '' then
                                                  tProkatStudio := tProkatStudio + ', ';
                                                tProkatStudio := tProkatStudio + trim(s);
                                                kol := kol + 1;
                                              end;
                                          until (i = 0) or (kol >= MaxProkatStudio);
                                        end;
                                    end;
                                  if tProkatStudio <> '' then
                                    begin
                                      if ProkatStudio = 1 then
                                        begin
                                          Studio := Studio + ', ' + trim(tProkatStudio);
                                          tProkatStudio := '';
                                        end
                                      else
                                        begin
                                          if cStudio = 1 then
                                            begin
                                              if Comment <> '' then
                                                Comment := Comment + ret;
                                              if cBold = 1 then
                                                Comment := Comment + '<b>: </b>' + tProkatStudio
                                              else
                                                Comment := Comment + ': ' + tProkatStudio;
                                            end;
                                          if dStudio = 1 then
                                            begin
                                              if Descript <> '' then
                                                Descript := Descript + ret;
                                              if dBold = 1 then
                                                Descript := Descript + '<b>: </b>' + tProkatStudio
                                              else
                                                Descript := Descript + ': ' + tProkatStudio;
                                            end;
                                        end;
                                    end;
                                  Studio := trim(Studio);
                                  if Studio <> '' then
                                    begin
                                      MovieBase.CurrentMovie.Studio := Studio;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          page2 := '';
                        end;
                      if Descript <> '' then
                        begin
                          if Description <> '' then
                            begin
                              if dInsertTegHR = 1 then
                                Description := Description + ret + '<hr>'
                              else
                                Description := Description + ret + ret;
                            end;
                          Description := Description + Descript;
                        end;
                      ProgressBar2.Position := 24;
                      if CheckExit(1) = 1 then
                        Exit;
                      tProducer := '';
                      tOperator := '';
                      tComposer := '';
                      tVoiceDirector := '';
                      tVoice := '';
                      tPainter := '';
                      tCutter := '';
                      tTranslator := '';
                      if (MaxDirector + MaxScenario + MaxActors + MaxProducer + MaxOperator + MaxComposer +
                          MaxVoiceDirector + MaxVoice + MaxPainter + MaxCutter + MaxTranslator) > 0
                      then
                        begin
                          Memo1.Lines.Add('      ...');
                          try
                            GetHTML := False;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/',
                                                    '  .....');
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                          except
                            page2 := '';
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                          end;
                          Label6.Caption := '';
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/');
                              try
                                GetHTML := False;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/',
                                                        '  .....');
                              except
                                page2 := '';
                              end;
                            end;
                          Label6.Caption := '';
                          ProgressBar2.Position := 25;
                          if CheckExit(1) = 1 then
                            Exit;
                          if page2 <> '' then //   
                            begin
                              if MaxDirector > 0 then //
                                begin
                                  Memo1.Lines.Add('       ...');
                                  if Serial = 1 then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                                '  .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                                    '  .....');
                                          except
                                            page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                    end;
                                  Director := FindNames('></div>', page2, MaxDirector);
                                  if Director = '' then
                                    Director := FindNames('></div>', page2, MaxDirector);
                                  if Director = '' then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                                '  .....');
                                      except
                                        page3 := '';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/director/',
                                                                    '  .....');
                                          except
                                            page3 := '';
                                          end;
                                          Label6.Caption := '';
                                        end;
                                      Director := FindNames('></div>', page3, MaxDirector);
                                      if Director = '' then
                                        Director := FindNames('></div>', page3, MaxDirector);
                                    end;
                                  if Director <> '' then
                                    begin
                                      MovieBase.CurrentMovie.Director := Director;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                              ProgressBar2.Position := 26;
                              Application.ProcessMessages;
                              if MaxScenario > 0 then //
                                begin
                                  Memo1.Lines.Add('       ...');
                                  if Serial = 1 then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                                '  .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                                    '  .....');
                                          except
                                            page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                    end;
                                  Scenario := FindNames('></div>', page2, MaxScenario);
                                  if Scenario = '' then
                                    Scenario := FindNames('></div>', page2, MaxScenario);
                                  if Scenario = '' then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                                '  .....');
                                      except
                                        page3 := '';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/writer/',
                                                                    '  .....');
                                          except
                                            page3 := '';
                                          end;
                                          Label6.Caption := '';
                                        end;
                                      Scenario := FindNames('></div>', page3, MaxScenario);
                                      if Scenario = '' then
                                        Scenario := FindNames('></div>', page3, MaxScenario);
                                    end;
                                  if Scenario <> '' then
                                    begin
                                      MovieBase.CurrentMovie.Scenario := Scenario;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                              ProgressBar2.Position := 27;
                              Application.ProcessMessages;
                              if MaxActors > 0 then //
                                begin
                                  Memo1.Lines.Add('       ...');
                                  if Serial = 1 then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/actor/',
                                                                '  .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/actor/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/actor/',
                                                                    '  .....');
                                          except
                                            page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                    end;
                                  Actors := FindNames('></div>', page2, MaxActors);
                                  if Actors = '' then
                                    Actors := FindNames('></div>', page2, MaxActors);
                                  if Actors <> '' then
                                    begin
                                      MovieBase.CurrentMovie.Actors := Actors;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                              ProgressBar2.Position := 28;
                              Application.ProcessMessages;
                              DodPol := 0; // 1 -     , 0 - 
                              if (MaxProducer + MaxOperator + MaxComposer + MaxVoiceDirector + MaxVoice + MaxPainter + MaxCutter + MaxTranslator) > 0 then
                                begin
                                  cAllOther := '';
                                  dAllOther := '';
                                  if MaxProducer > 0 then //
                                    begin
                                      Memo1.Lines.Add('       ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/producer/',
                                                                    '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/producer/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/producer/',
                                                                        '  .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := '';
                                      Other := FindNames('></div>', page2, MaxProducer);
                                      if Other = '' then
                                        Other := FindNames('></div>', page2, MaxProducer);
                                      if Other <> '' then
                                        begin
                                          tProducer := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then
                                                    cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + ': ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then
                                                    dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + ': ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  ProgressBar2.Position := 29;
                                  Application.ProcessMessages;
                                  if MaxOperator > 0 then //
                                    begin
                                      Memo1.Lines.Add('       ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/operator/',
                                                                    '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/operator/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/operator/',
                                                                        '  .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := '';
                                      Other := FindNames('></div>', page2, MaxOperator);
                                      if Other = '' then
                                        Other := FindNames('></div>', page2, MaxOperator);
                                      if Other <> '' then
                                        begin
                                          tOperator := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then
                                                    cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + ': ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then
                                                    dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + ': ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  ProgressBar2.Position := 30;
                                  Application.ProcessMessages;
                                  if MaxComposer > 0 then //
                                    begin
                                      Memo1.Lines.Add('       ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/composer/',
                                                                    '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/composer/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/composer/',
                                                                        '  .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := '';
                                      Other := FindNames('></div>', page2, MaxComposer);
                                      if Other = '' then
                                        Other := FindNames('></div>', page2, MaxComposer);
                                      if Other <> '' then
                                        begin
                                          tComposer := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then
                                                    cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + ': ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then
                                                    dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + ': ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  ProgressBar2.Position := 31;
                                  Application.ProcessMessages;
                                  if MaxVoiceDirector > 0 then //c 
                                    begin
                                      Memo1.Lines.Add('       c ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice_director/',
                                                                    '   .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice_director/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice_director/',
                                                                        '   .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := 'c ';
                                      Other := FindNames('> </div>', page2, MaxVoiceDirector);
                                      if Other = '' then
                                        Other := FindNames('> </div>', page2, MaxVoiceDirector);
                                      if Other <> '' then
                                        begin
                                          tVoiceDirector := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then
                                                    cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b>c : </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + 'c : ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then
                                                    dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b>c : </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + 'c : ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  ProgressBar2.Position := 32;
                                  Application.ProcessMessages;
                                  if MaxVoice > 0 then //  ( )
                                    begin
                                      Memo1.Lines.Add('        ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice/',
                                                                    '   .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/voice/',
                                                                        '   .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := ' ';
                                      Other := FindNames('> </div>', page2, MaxVoice);
                                      if Other = '' then
                                        Other := FindNames('> </div>', page2, MaxVoice);
                                      if Other <> '' then
                                        begin
                                          tVoice := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then
                                                    cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b> : </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + ' : ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then
                                                    dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b> : </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + ' : ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  if MaxPainter > 0 then //
                                    begin
                                      Memo1.Lines.Add('       ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/design/',
                                                                    '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/design/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/design/',
                                                                        '  .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := '';
                                      Other := FindNames('></div>', page2, MaxPainter);
                                      if Other = '' then
                                        Other := FindNames('></div>', page2, MaxPainter);
                                      if Other <> '' then
                                        begin
                                          tPainter := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + ': ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + ': ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  if MaxCutter > 0 then //
                                    begin
                                      Memo1.Lines.Add('       ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/editor/',
                                                                    '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/editor/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/editor/',
                                                                        '  .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := '';
                                      Other := FindNames('></div>', page2, MaxCutter);
                                      if Other = '' then
                                        Other := FindNames('></div>', page2, MaxCutter);
                                      if Other <> '' then
                                        begin
                                          tCutter := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + ': ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + ': ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  if MaxTranslator > 0 then //
                                    begin
                                      Memo1.Lines.Add('       ...');
                                      if Serial = 1 then
                                        begin
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/translator/',
                                                                    '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page2 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page2);
                                          if (i > 0) or (page2 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/translator/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/cast/who_is/translator/',
                                                                        '  .....');
                                              except
                                                page2 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                        end;
                                      DodPolName := '';
                                      Other := FindNames('></div>', page2, MaxTranslator);
                                      if Other = '' then
                                        Other := FindNames('></div>', page2, MaxTranslator);
                                      if Other <> '' then
                                        begin
                                          tTranslator := trim(Other);
                                          DodPolPoz := PosName(DodPolName);
                                          if DodPolPoz <> 1000 then
                                            begin
                                              MovieBase.CurrentMovie.SetUDFieldValue(DodPolPoz,trim(Other));
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            begin
                                              if cOtherName = 1 then
                                                begin
                                                  if cAllOther <> '' then cAllOther := cAllOther + ret;
                                                  if cBold = 1 then
                                                    cAllOther := cAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    cAllOther := cAllOther + ': ' + trim(Other);
                                                end;
                                              if dOtherName = 1 then
                                                begin
                                                  if dAllOther <> '' then dAllOther := dAllOther + ret;
                                                  if dBold = 1 then
                                                    dAllOther := dAllOther + '<b>: </b>' + trim(Other)
                                                  else
                                                    dAllOther := dAllOther + ': ' + trim(Other);
                                                end;
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                  if cAllOther <> '' then
                                    begin
                                      if Comment <> '' then
                                        begin
                                          if cInsertTegHR = 1 then
                                            Comment := Comment + ret + '<hr>'
                                          else
                                            Comment := Comment + ret + ret;
                                        end;
                                      cAllOther := CharReplace(cAllOther);
                                      Comment := Comment + trim(cAllOther);
                                    end;
                                  if dAllOther <> '' then
                                    begin
                                      if Description <> '' then
                                        begin
                                          if dInsertTegHR = 1 then
                                            Description := Description + ret + '<hr>'
                                          else
                                            Description := Description + ret + ret;
                                        end;
                                      dAllOther := CharReplace(dAllOther);
                                      Description := Description + trim(dAllOther);
                                    end;
                                 end;
                            end;
                          page2 := '';
                        end;
                      ProgressBar2.Position := 33;
                      if CheckExit(1) = 1 then
                        Exit;
                      tAwards := '';
                      if uAwards = 1 then //
                        begin //,    
                          Memo1.Lines.Add('      ...');
                          if (Pos('href="/film/' + FullMovieCode + '/awards/', page) > 0) or
                             (Pos('href="/film/' + MovieCode + '/awards/', page) > 0)
                          then
                            begin
                              try
                                GetHTML := False;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/awards/', '  .....');
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                page2 := '';
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              Label6.Caption := '';
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/awards/');
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/awards/',
                                                            '  .....');
                                  except
                                    page2 := '';
                                  end;
                                end;
                              Label6.Caption := '';
                              ProgressBar2.Position := 34;
                              if CheckExit(1) = 1 then
                                Exit;
                              if page2 <> '' then
                                begin
                                  Memo1.Lines.Add('       ...');
                                  i := Pos('class=all> ', page2);
                                  if i > 0 then
                                    begin
                                      Awards := '<b>:</b>';
                                      delete(page2, 1, i - 1);
                                      //      ,   . 
                                      i := Pos('<div style="background-color:#f2f2f2;padding:15px">', page2);
                                      if i > 0 then
                                        begin
                                          delete(page2, 1, i - 1);
                                          i := Pos('</div>', page2);
                                          s := copy(page2, 1, i - 1);
                                          s := HTMLRemoveTags(s);
                                          s := HTMLDecode(s);
                                          Awards := Awards + ret + trim(s);
                                        end;
                                      repeat //    
                                        Application.ProcessMessages;
                                        i := Pos('<b><a href="/awards/', page2);
                                        if i > 0 then
                                          begin
                                            j := Pos('<b><a href="/awards/', page2);
                                            delete(page2, 1, j + 12);
                                            j := Pos('</a></b></td>', page2);
                                            s := copy(page2, 1, j - 1);
                                            jj := Pos('="all">', s);
                                            delete(s, 1, jj + 6);
                                            s := HTMLRemoveTags(s);
                                            s := HTMLDecode(s);
                                            if Awards = '<b>:</b>' then
                                              Awards := Awards + ret + '<b><u>' + trim(s) + '</u></b>'
                                            else
                                              Awards := Awards + ret + ret + '<b><u>' + trim(s) + '</u></b>';
                                            delete(page2, 1, j + 12);
                                            ii := Pos('<tr><td class="news">&nbsp;</td></tr>', page2);
                                            s2 := copy(page2, 1, ii - 1);
                                            repeat
                                              ii := Pos('<tr><td class="news" style="padding: 10px; color: #777">', s2);
                                              if ii > 0 then
                                                begin
                                                  delete(s2, 1, ii + 55);
                                                  j := Pos('</td></tr>', s2);
                                                  s := copy(s2, 1, j - 1);
                                                  delete(s2, 1, j + 9);
                                                  Awards := Awards + ret + trim(s) + ' ';
                                                  j := Pos('<ul class="trivia">', s2);
                                                  delete(s2, 1, j - 1);
                                                  j := Pos('</ul>', s2);
                                                  s := copy(s2, 1, j - 1);
                                                  s := stringreplace(s, #13, '', [rfReplaceAll, rfIgnoreCase]);
                                                  s := stringreplace(s, #10, '', [rfReplaceAll, rfIgnoreCase]);
                                                  s := ReplaceTagWithChar(s, '</li>', ';');
                                                  s := HTMLRemoveTags(s);
                                                  s := stringreplace(s, '  ', '', [rfReplaceAll]);
                                                  s := HTMLDecode(s);
                                                  s[Length(s)] := ' ';
                                                  Awards := Awards + trim(s);
                                                end;
                                            until (ii = 0);
                                          end;
                                      until (i = 0);
                                    end;
                                  if Awards <> '<b>:</b>' then
                                    begin
                                      Awards := stringreplace(Awards, ' ;', ';', [rfReplaceAll, rfIgnoreCase]);
                                      if cAwards = 1 then
                                        begin
                                          if Comment <> '' then
                                            begin
                                              if cInsertTegHR = 1 then
                                                Comment := Comment + ret + '<hr>'
                                              else
                                                Comment := Comment + ret + ret;
                                            end;
                                          Comment := Comment + Awards;
                                        end;
                                      if dAwards = 1 then
                                        begin
                                          if Description <> '' then
                                            begin
                                              if dInsertTegHR = 1 then
                                                Description := Description + ret + '<hr>'
                                              else
                                                Description := Description + ret + ret;
                                            end;
                                          Description := Description + Awards;
                                        end;
                                      delete(Awards, 1, 17);
                                      tAwards := Awards;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          page2 := '';
                        end;
                      ProgressBar2.Position := 35;
                      if CheckExit(1) = 1 then
                        Exit;
                      tLinks := '';
                      if uLinks = 1 then //
                        begin //,    
                          Memo1.Lines.Add('     ...');
                          if (Pos('href="/film/' + FullMovieCode + '/other/', page) > 0) or
                             (Pos('href="/film/' + MovieCode + '/other/', page) > 0)
                          then
                            begin
                              try
                                GetHTML := False;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/other/',
                                                        '  .....');
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                page2 := '';
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              Label6.Caption := '';
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/other/');
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/other/',
                                                            '  .....');
                                  except
                                    page2 := '';
                                  end;
                                end;
                              Label6.Caption := '';
                              ProgressBar2.Position := 36;
                              if CheckExit(1) = 1 then
                                Exit;
                              if page2 <> '' then
                                begin
                                  Memo1.Lines.Add('       ...');
                                  i := Pos('>', page2);
                                  if i > 0 then
                                    begin
                                      Link := '<b>:</b>';
                                      delete(page2, 1, i - 1);
                                      if LinksInTable = 1 then
                                        begin
                                          tags := '<table width=100% border=0><tr><td colspan=2 style="border-bottom:2px solid #f60"><b>';
                                          tags2 := '</b></td></tr><tr><td colspan=2 height=10><spacer type=block height=10></td></tr><tr>';
                                          tags3 := '<td width="5%" valign="top">';
                                          tags4 := '.</td>';
                                          tags5 := '<td width="95%" align="left"><div style="position: relative; padding-right: 22px">';
                                          tags6 := '<font color="#999999">';
                                          tags7 := '</font></div></td></tr>';
                                          tags8 := '<tr><td colspan=2 style="border-bottom:2px solid #ccc">&nbsp;</td></tr></table>';
                                          i := Pos('<table cellspacing="0" cellpadding="0" border="0" width="100%">', page2);
                                          delete(page2, 1, i - 1);
                                          j := Pos('<td style="border-top: 1px solid #ccc; padding-left: 15px">', page2);
                                          s := copy(page2, 1 , j + 58);
                                          repeat
                                            Application.ProcessMessages;
                                            i := Pos('style="color: #f60; white-space: nowrap">', s);
                                            if i > 0 then
                                              begin
                                                delete(s, 1, i + 40);
                                                j := Pos('</td></tr>', s);
                                                s2 := copy(s, 1, j - 1);
                                                if pos(s2, LinksList) = 0 then
                                                  begin
                                                    delete(s, 1, j + 9);
                                                    Continue;
                                                  end;
                                                if LinksInTable = 1 then
                                                  begin
                                                    delete(s, 1, j + 9);
                                                    s2 := tags + s2 + tags2;
                                                    s2 := HTMLDecode(s2);
                                                    Link := Link + ret + s2;
                                                    j := Pos('<table cellspacing="0" cellpadding="0" border="0" width="100%">', s);
                                                    if j = 0 then
                                                      j := Pos('<td style="border-top: 1px solid #ccc; padding-left: 15px">', s);
                                                    if j > 0 then
                                                    ss := copy(s, 1, j - 1);
                                                    repeat
                                                      Application.ProcessMessages;
                                                      ii := Pos('<span class="num">', ss);
                                                      if ii > 0 then
                                                        begin
                                                          delete(ss, 1, ii + 17);
                                                          j := Pos('</span>', ss);
                                                          s3 := copy(ss, 1, j - 1);
                                                          delete(ss, 1, j + 6);
                                                          s3 := tags3 + s3 + tags4;
                                                          iiii := Pos('<span class="name">', ss);
                                                          delete(ss, 1, iiii + 18);
                                                          j := Pos('</a>', ss);
                                                          s4 := ReplaceLatinExt(copy(ss, 1, j + 3));
                                                          s4 := stringreplace(s4, #13, '', [rfReplaceAll]);
                                                          s4 := stringreplace(s4, #10, '', [rfReplaceAll]);
                                                          s4 := trim(s4);
                                                          s4 := tags5 + s4 + '<br />';
                                                          iiii := Pos('<span class="role">', ss);
                                                          delete(ss, 1, iiii + 18);
                                                          j := Pos('</span>', ss);
                                                          s5 := ReplaceLatinExt(copy(ss, 1, j - 1));
                                                          s5 := stringreplace(s5, #13, '', [rfReplaceAll]);
                                                          s5 := stringreplace(s5, #10, '', [rfReplaceAll]);
                                                          s5 := trim(s5);
                                                          s5 := tags6 + s5 + tags7;
                                                          s5 := s3 + s4 + s5;
                                                          s5 := HTMLDecode(s5);
                                                          Link := Link + s5;
                                                        end;
                                                    until (ii = 0);
                                                    Link := Link + tags8;
                                                    delete(s, 1, j + 62);
                                                  end;
                                              end;
                                          until (i = 0);
                                        end
                                      else
                                        begin
                                          repeat
                                            Application.ProcessMessages;
                                            i := Pos('style="color: #f60; white-space: nowrap">', page2);
                                            if i > 0 then
                                              begin
                                                delete(page2, 1, i + 40);
                                                j := Pos('</td></tr>', page2);
                                                s := copy(page2, 1, j - 1);
                                                s := HTMLRemoveTags(s);
                                                s := HTMLDecode(s);
                                                if pos(s, LinksList) = 0 then
                                                  begin
                                                    delete(page2, 1, j + 9);
                                                    Continue;
                                                  end;
                                                if LinksInTable = 0 then
                                                  begin
                                                    delete(page2, 1, j + 9);
                                                    Link := Link + ret + '<b><u>' + trim(s) + '</u></b>';
                                                    ii := Pos('<table cellspacing="0" cellpadding="0" border="0" width="100%">', page2);
                                                    if ii = 0 then
                                                      ii := Pos('<td style="border-top: 1px solid #ccc; padding-left: 15px">', page2);
                                                    if ii > 0 then
                                                    s2 := copy(page2, 1, ii - 1);
                                                    repeat
                                                      Application.ProcessMessages;
                                                      ii := Pos(' class="name">', s2);
                                                      if ii > 0 then
                                                        begin
                                                          delete(s2, 1, ii + 13);
                                                          ii := Pos('/">', s2);
                                                          delete(s2, 1, ii + 2);
                                                          j := Pos('</a>', s2);
                                                          s := ReplaceLatinExt(copy(s2, 1, j - 1));
                                                          delete(s2, 1, j - 1);
                                                          s := HTMLDecode(s);
                                                          s := HTMLRemoveTags(s);
                                                          Link := Link + ret + '  ' + trim(s);
                                                        end;
                                                    until (ii = 0);
                                                  end;
                                              end;
                                          until (i = 0);
                                        end;
                                    end;
                                  Link := stringreplace(Link, '<a href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                                  if Link <> '<b>:</b>' then
                                    begin
                                      if cLinks = 1 then
                                        begin
                                          if Comment <> '' then
                                            begin
                                              if cInsertTegHR = 1 then
                                                Comment := Comment + ret + '<hr>'
                                              else
                                                Comment := Comment + ret + ret;
                                            end;
                                          Comment := Comment + Link;
                                        end;
                                      if dLinks = 1 then
                                        begin
                                          if Description <> '' then
                                            begin
                                              if dInsertTegHR = 1 then
                                                Description := Description + ret + '<hr>'
                                              else
                                                Description := Description + ret + ret;
                                            end;
                                          Description := Description + Link;
                                        end;
                                      if LinksInTable = 1 then
                                        delete(Link, 1, 13)
                                      else
                                        delete(Link, 1, 15);
                                      tLinks := Link;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          page2 := '';
                        end;
                      ProgressBar2.Position := 37;
                      if CheckExit(1) = 1 then
                        Exit;
                      tZnaite := '';
                      if uZnaite = 1 then //   , ...
                        begin
                          Memo1.Lines.Add('      , ...');
                          i := pos('>  , ...<', page);
                          if i > 0 then
                            begin
                              s := page;
                              delete(s, 1, i);
                              i := Pos('<ul', s);
                              j := Pos('<li class="add', s);
                              if (j = 0) then
                                j := Pos('</div>', s);
                              if (i > 0) and (j > 0) then
                                begin
                                  s2 := copy(s, i, j - i);
                                  i := Pos('<li class="attention', s2);
                                  if (i > 0) then
                                    begin
                                      s3 := copy(s2, 1, i - 1);
                                      delete(s2, 1, i + 19);
                                      j := Pos('</li>', s2);
                                      delete(s2, 1, j + 4);
                                      s2 := s3 + s2;
                                    end;
                                  s2 := stringreplace(s2, '<ul>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '</li>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '<li>', ' ', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '</ul>', '', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '</span>', '</span></li>', [rfReplaceAll, rfIgnoreCase]);
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                begin
                                  s2 := '';
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                end;
                              s2 := ClearHTML(s2);
                              if s2 <> '' then
                                begin
                                  if ZnaiteIns = 1 then
                                    begin
                                      Template := TStringList.Create;
                                      Template.Text := s2;
                                      s2 := '';
                                      for i := 0 to Template.Count - 1 do
                                        begin
                                          Application.ProcessMessages;
                                          if trim(Template[i]) <> '' then
                                            begin
                                              if s2 <> '' then
                                                s2 := s2 + ret;
                                              if (Template[i][1] <> '') and (Template[i][1] <> '-') then
                                                s2 := s2 + ' ';
                                              s2 := s2 + Template[i];
                                            end;
                                        end;
                                      Template.Free;
                                    end;
                                  s2 := stringreplace(s2, ' ', '', [rfReplaceAll, rfIgnoreCase]);
                                  tZnaite := s2;
                                  if cZnaite = 1 then
                                    begin
                                      if Comment <> '' then
                                        begin
                                          if cInsertTegHR = 1 then
                                            Comment := Comment + ret + '<hr>'
                                          else
                                            Comment := Comment + ret + ret;
                                        end;
                                      Comment := Comment + '<b>  , : </b>' + ret;
                                      Comment := Comment + s2;
                                    end;
                                  if dZnaite = 1 then
                                    begin
                                      if Description <> '' then
                                        begin
                                          if dInsertTegHR = 1 then
                                            Description := Description + ret + '<hr>'
                                          else
                                            Description := Description + ret + ret;
                                        end;
                                      Description := Description + '<b>  , : </b>' + ret;
                                      Description := Description + s2;
                                    end;
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 38;
                      if CheckExit(1) = 1 then
                        Exit;
                      tErrors := '';
                      if uErrors = 1 then //   
                        begin
                          Memo1.Lines.Add('      ...');
                          i := pos('>  ', page);
                          if i > 0 then
                            begin
                              s := page;
                              delete(s, 1, i);
                              i := Pos('<ul', s);
                              j := Pos('<li class="add', s);
                              if (j = 0) then
                                j := Pos('</div>', s);
                              if (i > 0) and (j > 0) then
                                begin
                                  s2 := copy(s, i, j - i);
                                  i := Pos('<li class="attention', s2);
                                  if (i > 0) then
                                    begin
                                      s3 := copy(s2, 1, i - 1);
                                      delete(s2, 1, i + 19);
                                      j := Pos('</li>', s2);
                                      delete(s2, 1, j + 4);
                                      s2 := s3 + s2;
                                    end;
                                  s2 := stringreplace(s2, '<ul>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '</li>', '<br>', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '<li>', ' ', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '</ul>', '', [rfReplaceAll, rfIgnoreCase]);
                                  s2 := stringreplace(s2, '</span>', '</span></li>', [rfReplaceAll, rfIgnoreCase]);
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                begin
                                  s2 := '';
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                end;
                              s2 := ClearHTML(s2);
                              if s2 <> '' then
                                begin
                                  if ErrorIns = 1 then
                                    begin
                                      Template := TStringList.Create;
                                      Template.Text := s2;
                                      s2 := '';
                                      for i := 0 to Template.Count - 1 do
                                        begin
                                          Application.ProcessMessages;
                                          if trim(Template[i]) <> '' then
                                            begin
                                              if s2 <> '' then
                                                s2 := s2 + ret;
                                              if (Template[i][1] <> '') and (Template[i][1] <> '-') then
                                                s2 := s2 + ' ';
                                              s2 := s2 + Template[i];
                                            end;
                                        end;
                                      Template.Free;
                                    end;
                                  s2 := stringreplace(s2, ' ', '', [rfReplaceAll, rfIgnoreCase]);
                                  tErrors := s2;
                                  if cErrors = 1 then
                                    begin
                                      if Comment <> '' then
                                        begin
                                          if cInsertTegHR = 1 then
                                            Comment := Comment + ret + '<hr>'
                                          else
                                            Comment := Comment + ret + ret;
                                        end;
                                      Comment := Comment + '<b>  : </b>' + ret;
                                      Comment := Comment + s2;
                                    end;
                                  if dErrors = 1 then
                                    begin
                                      if Description <> '' then
                                        begin
                                          if dInsertTegHR = 1 then
                                            Description := Description + ret + '<hr>'
                                          else
                                            Description := Description + ret + ret;
                                        end;
                                      Description := Description + '<b>  : </b>' + ret;
                                      Description := Description + s2;
                                    end;
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 39;
                      if CheckExit(1) = 1 then
                        Exit;
                      tBook3500 := '';
                      if uBook3500 = 1 then //   3500 
                        begin
                          Memo1.Lines.Add('      3500 ...');
                          i := pos('>  3500 <', page);
                          if i > 0 then
                            begin
                              s := page;
                              delete(s, 1, i);
                              i := Pos('<table', s);
                              j := Pos('</table>', s);
                              if (i > 0) and (j > 0) then
                                begin
                                  s2 := copy(s, i, j - i);
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                end
                              else
                                begin
                                  s2 := '';
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                end;
                              Memo1.Lines.Add('       (... )');
                              i := pos('<a href="/review/', s2);
                              if i > 0 then
                                begin
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  Memo1.Lines.Add('          3500 ...');
                                  j := Pos('" class="continue">', s2);
                                  if j > 0 then
                                    s3 := copy(s2, i, j - i)
                                  else
                                    s3 := '';
                                  s3 := stringreplace(s3, '<a href="', 'https://www.kinopoisk.ru', [rfReplaceAll, rfIgnoreCase]);
                                  s3 := stringreplace(s3, 'rev_id/', '', [rfReplaceAll, rfIgnoreCase]);
                                  if s3 <> '' then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl(s3, '    3500 .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow(s3);
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl(s3, '    3500 .....');
                                          except
                                                page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                      ProgressBar2.Position := 40;
                                      if CheckExit(1) = 1 then
                                        Exit;
                                      Memo1.Lines.Add('            3500 ...');
                                      i := pos('>* !    .  .<', page2);
                                      if i > 0 then
                                        begin
                                          s3 := '';
                                          s4 := '';
                                          delete(page2, 1, i);
                                          i := Pos('> <', page2);
                                          j := Pos('</table>', page2);
                                          if (i > 0) and (j > 0) then
                                            begin
                                              s2 := copy(page2, i, j - i);
                                              s2 := stringreplace(s2, '</i><br><br>', '</i>', [rfReplaceAll, rfIgnoreCase]);
                                              i := Pos('<td style=', s2);
                                              j := Pos('</tr>', s2);
                                              if (i > 0) and (j > 0) then
                                                s3 := copy(s2, i, j - i);
                                              i := Pos('<i>', s2);
                                              j := Pos('</i>', s2);
                                              if (i > 0) and (j > 0) then
                                                s4 := copy(s2, i, j - i);
                                              if s3 <> '' then
                                                s4 := s4 + ' (' + s3 + ')';
                                              i := Pos('<img src=', s2);
                                              j := Pos('<br><br>', s2);
                                              if (i > 0) and (j > 0) then
                                                s2 := copy(s2, i, j - i);
                                              if s4 <> '' then
                                                s2 := s4 + ret + ret + s2;
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                              s2 := ClearHTML(s2);
                              s2 := trim(s2);
                              if s2 <> '' then
                                begin
                                  tBook3500 := s2;
                                  if cBook3500 = 1 then
                                    begin
                                      if Comment <> '' then
                                        begin
                                          if cInsertTegHR = 1 then
                                            Comment := Comment + ret + '<hr>'
                                          else
                                            Comment := Comment + ret + ret;
                                        end;
                                      Comment := Comment + '<b>  3500 : </b>' + ret;
                                      Comment := Comment + s2;
                                    end;
                                  if dBook3500 = 1 then
                                    begin
                                      if Description <> '' then
                                        begin
                                          if dInsertTegHR = 1 then
                                            Description := Description + ret + '<hr>'
                                          else
                                            Description := Description + ret + ret;
                                        end;
                                      Description := Description + '<b>  3500 : </b>' + ret;
                                      Description := Description + s2;
                                    end;
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          page2 := '';
                        end;
                      ProgressBar2.Position := 41;
                      if CheckExit(1) = 1 then
                        Exit;
                      tLikeMovies := '';
                      if (uLikeMovies = 1) and (CheckLikeMovies(page)) then //     ,  ...
                        begin
                          Memo1.Lines.Add('        ...');
                          i := pos('>    ', page);
                          if i > 0 then
                            begin
                              try
                                GetHTML := False;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/like/',
                                                        '     .....');
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                page2 := '';
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              Label6.Caption := '';
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/like/');
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/like/',
                                                            '     .....');
                                  except
                                    page2 := '';
                                  end;
                                end;
                              Label6.Caption := '';
                              if page2 <> '' then
                                begin
                                  s4 := '';
                                  ii := pos('<div style="margin-bottom: 9px"><a style="font-size: 13px; font-weight: bold" href=', page2);
                                  while ii > 0 do
                                    begin
                                      delete(page2, 1, ii);
                                      i := pos('<a style="font-size: 13px; font-weight: bold" href=', page2);
                                      j := Pos('<nobr>', page2);
                                      if (i > 0) and (j > 0) then
                                        s3 := copy(page2, i, j - i)
                                      else
                                        s3 := '';
                                      s3 := stringreplace(s3, '</a><span style="color: #888; font-family: arial; font-size: 11px; display: block">', '</a> <font color="#999999"> / ', [rfReplaceAll, rfIgnoreCase]);
                                      s3 := stringreplace(s3, '<a style="font-size: 13px; font-weight: bold" href="/film/', '<a href="https://www.kinopoisk.ru/film/', [rfReplaceAll, rfIgnoreCase]);
                                      s3 := stringreplace(s3, '" class="all">', '">', [rfReplaceAll, rfIgnoreCase]);
                                      s3 := s3 + '</font>';
                                      s3 := stringreplace(s3, '</a> <font color="#999999"> / </font>', '</a>', [rfReplaceAll, rfIgnoreCase]);
                                      if s4 <> '' then
                                        s4 := s4 + ret;
                                      s4 := s4 + s3;
                                      ii := pos('<div style="margin-bottom: 9px"><a style="font-size: 13px; font-weight: bold" href=', page2);
                                    end;
                                  s2 := trim(s4);
                                end;
                              if s2 <> '' then
                                begin
                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  tLikeMovies := s2;
                                  if cLikeMovies = 1 then
                                    begin
                                      if Comment <> '' then
                                        begin
                                          if cInsertTegHR = 1 then
                                            Comment := Comment + ret + '<hr>'
                                          else
                                            Comment := Comment + ret + ret;
                                        end;
                                      Comment := Comment + '<b>    ,  : </b>' + ret;
                                      Comment := Comment + s2;
                                    end;
                                  if dLikeMovies = 1 then
                                    begin
                                      if Description <> '' then
                                        begin
                                          if dInsertTegHR = 1 then
                                            Description := Description + ret + '<hr>'
                                          else
                                            Description := Description + ret + ret;
                                        end;
                                      Description := Description + '<b>    ,  : </b>' + ret;
                                      Description := Description + s2;
                                    end;
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                          page2 := '';
                        end;
                      ProgressBar2.Position := 42;
                      if CheckExit(1) = 1 then
                        Exit;
                      if uEpisodes = 1 then // 
                        begin
                          if (uEpisodesIfEmpty = 0) or (MovieBase.CurrentMovie.EpisodesCount = 0) then
                            begin
                              Memo1.Lines.Add('      ...');
                              if pos('/episodes/', page) > 0 then //,   
                                begin
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/episodes/',
                                                            '  .....');
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  except
                                    page2 := '';
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                  end;
                                  Label6.Caption := '';
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/episodes/');
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/episodes/',
                                                                '  .....');
                                      except
                                        page2 := '';
                                      end;
                                    end;
                                  Label6.Caption := '';
                                  ProgressBar2.Position := 43;
                                  if CheckExit(1) = 1 then
                                    Exit;
                                  if page2 <> '' then
                                    begin //  
                                      Memo1.Lines.Add('       ...');
                                      j := MovieBase.CurrentMovie.EpisodesCount;
                                      while j > 0 do
                                        begin
                                          Application.ProcessMessages;
                                          MovieBase.CurrentMovie.EpisodeDelete(0);
                                          j := MovieBase.CurrentMovie.EpisodesCount;
                                        end;
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      Memo1.Lines.Add('       ...');
                                      i := pos('<a name="s1"></a>', page2);
                                      j := MyPos('<br><br><br><br><br>', page2, i + 1);
                                      if j = 0 then
                                        j := MyPos('<br /><br /><br /><br /><br />', page2, i + 1);
                                      if (i > 0) and (j > 0) then
                                        begin
                                          s := copy(page2, i, j - i);
                                          season := 0;
                                          i := pos('<span style="color:#777"> ', s);
                                          while i > 0 do
                                            begin
                                              Application.ProcessMessages;
                                              episode := -1;
                                              s2 := '<h1 class="moviename-big" style="font-size:21px;padding:0px;margin:0px;color:#f60"> ';
                                              k := pos(s2, s);
                                              if (k < i) and (k <> 0) then
                                                begin
                                                  j := MyPos('</h1>', s, k + 1);
                                                  s3 := copy(s, k + length(s2), j - k - length(s2));
                                                  try
                                                    season := StrToInt(s3);
                                                  except
                                                    season := 0;
                                                  end;
                                                end;
                                              j := MyPos('</tr>', s, i + 1);
                                              if j > 0 then
                                                begin
                                                  s2 := '<span style="color:#777"> ';
                                                  s3 := copy(s, i + length(s2), j - i - length(s2));
                                                  delete(s, 1, j + 4);
                                                  k := pos('</span>', s3);
                                                  try
                                                    if k > 0 then
                                                      try
                                                        episode := StrToInt(copy(s3, 1, k - 1));
                                                      finally
                                                      end
                                                    else
                                                      episode := -1;
                                                  except
                                                    episode := -1;
                                                  end;
                                                  if episode >= 0 then
                                                    begin
                                                      delete(s3, 1, k + 6);
                                                      EpisodeTitle := '';
                                                      k := pos('<b>', s3);
                                                      if k > 0 then
                                                        begin
                                                          k2 := MyPos('</b>', s3, k + 1);
                                                          if k2 > 0 then
                                                            begin
                                                              EpisodeTitle := copy(s3, k + 3, k2 - k - 3);
                                                              EpisodeTitle := ClearHTML(EpisodeTitle);
                                                            end;
                                                        end;
                                                      AirDate := '';
                                                      s2 := '<td width=20% class="news" align=right valign=bottom style="border-bottom:1px dotted #ccc;padding:15px 0px;font-size:12px" align=left>';
                                                      k := pos(s2, s3);
                                                      if k > 0 then
                                                        begin
                                                          k2 := MyPos('</td>', s3, k + 1);
                                                          if k2 > 0 then
                                                            AirDate := copy(s3, k + length(s2), k2 - k - length(s2));
                                                          AirDate := ClearHTML(AirDate);
                                                        end;
                                                      EpisodeDescription := '';
                                                    end;
                                                end;
                                              if episode >= 0 then
                                                begin
                                                  MovieBase.CurrentMovie.EpisodeAdd(season, episode, EpisodeTitle, EpisodeDescription, '', AirDate);
                                                end;
                                              i := pos('<span style="color:#777"> ', s);
                                            end;
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                    end;
                                end
                              else
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                            end;
                        end;
                      ProgressBar2.Position := 44;
                      if CheckExit(1) = 1 then
                        Exit;
                      tRecenzia := '';
                      if uRecenzia = 1 then //  
                        begin
                          Recenzia := '<b> :</b>';
                          Memo1.Lines.Add('       ...');
                          try
                            GetHTML := False;
                            if NeedURLDelay = 1 then
                              Sleep(MaxURLDelay);
                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/ord/rating/',
                                                    '   .....');
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                          except
                            page2 := '';
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                          end;
                          Label6.Caption := '';
                          i := pos(FindBlocking, page2);
                          if (i > 0) or (page2 = '') then
                            begin
                              ShowMessage('    ');
                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/ord/rating/');
                              try
                                GetHTML := False;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/ord/rating/',
                                                        '   .....');
                              except
                                page2 := '';
                              end;
                            end;
                          Label6.Caption := '';
                          s := page2;
                          Kol := 0;
                          Memo1.Lines.Add('        ...');
                          i := pos('>   ', s); //,   
                          if i > 0 then
                            begin
                              delete(s, 1, i - 1);
                              i := pos('<p class="profile_name">', s);
                              while i > 0 do
                                begin
                                  Application.ProcessMessages;
                                  if Kol >= MaxRecenzia then
                                    break;
                                  Kol := Kol + 1;
                                  delete(s, 1, i - 1);
                                  j := pos('</p>', s); //
                                  s2 := copy(s, 1, j - 1);
                                  s2 := HTMLRemoveTags(s2);
                                  s2 := ReplaceLatinExt(s2);
                                  s2 := HTMLDecode(s2);
                                  s2 := trim(s2);
                                  if Recenzia = '<b> :</b>' then
                                    Recenzia := Recenzia + ret + '<b><u>' + trim(s2) + '</u></b>'
                                  else
                                    Recenzia := Recenzia + ret + ret + '<b><u>' + trim(s2) + '</u></b>';
                                  delete(s, 1, j - 1);
                                  j := pos('<p class="sub_title"', s); // 
                                  if j > 0 then
                                    begin
                                      delete(s, 1, j - 1);
                                      j := pos('</p>', s);
                                      s2 := copy(s, 1, j - 1);
                                      s2 := ClearHTML(s2);
                                      s2 := trim(s2);
                                      if s2 <> '' then
                                        Recenzia := Recenzia + ret + '<b>' + s2 + '</b>';
                                      delete(s, 1, j - 1);
                                    end;
                                  j := pos('<p id="ext_text', s); // 
                                  if j > 0 then
                                    begin
                                      delete(s, 1, j - 1);
                                      j := pos('</p>', s);
                                      s2 := copy(s, 1, j - 1);
                                      s2 := ClearHTML(s2);
                                      s2 := trim(s2);
                                      if s2 <> '' then
                                        Recenzia := Recenzia + ret + s2;
                                      delete(s, 1, j - 1);
                                    end;
                                  i := pos('<p class="profile_name">', s);
                                end;
                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              ProgressBar2.Position := 45;
                              if CheckExit(1) = 1 then
                                Exit;
                              if (uAllRecenziaPage = 1) and (Kol < MaxRecenzia) then //    
                                begin
                                  NPage := 2;
                                  ii := pos('href="/film/' + FullMovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                                  if ii = 0 then
                                  ii := pos('href="/film/' + MovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                                  while ii > 0 do
                                    begin
                                      Application.ProcessMessages;
                                      if Kol >= MaxRecenzia then
                                        break;
                                      Memo1.Lines.Add('          ' + IntToStr(NPage) + ' ...');
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                                '/ord/rating/perpage/10/page/' + IntToStr(NPage) + '/',
                                                                '   .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode +
                                                           '/ord/rating/perpage/10/page/' + IntToStr(NPage) + '/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode +
                                                                    '/ord/rating/perpage/10/page/' + IntToStr(NPage) + '/',
                                                                    '   .....');
                                          except
                                            page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                      if CheckExit(1) = 1 then
                                        Exit;
                                      if page2 <> '' then
                                        begin
                                          s := page2;
                                          Memo1.Lines.Add('             ...'); //,   
                                          i := pos('>   ', s);
                                          if i > 0 then
                                            begin
                                              delete(s, 1, i - 1);
                                              i := pos('<p class="profile_name">', s);
                                              while i > 0 do
                                                begin
                                                  if CheckExit(1) = 1 then
                                                    Exit;
                                                  if Kol >= MaxRecenzia then
                                                    break;
                                                  Kol := Kol + 1;
                                                  delete(s, 1, i - 1);
                                                  j := pos('</p>', s); //
                                                  s2 := copy(s, 1, j - 1);
                                                  s2 := HTMLDecode(s2);
                                                  s2 := HTMLRemoveTags(s2);
                                                  s2 := trim(s2);
                                                  if Recenzia = '<b> :</b>' then
                                                    Recenzia := Recenzia + ret + '<b><u>' + trim(s2) + '</u></b>'
                                                  else
                                                    Recenzia := Recenzia + ret + ret + '<b><u>' + trim(s2) + '</u></b>';
                                                  delete(s, 1, j - 1);
                                                  j := pos('<p class="sub_title"', s); // 
                                                  if j > 0 then
                                                    begin
                                                      delete(s, 1, j - 1);
                                                      j := pos('</p>', s);
                                                      s2 := copy(s, 1, j - 1);
                                                      s2 := ClearHTML(s2);
                                                      s2 := trim(s2);
                                                      if s2 <> '' then
                                                        Recenzia := Recenzia + ret + '<b>' + s2 + '</b>';
                                                      delete(s, 1, j - 1);
                                                    end;
                                                  j := pos('<p id="ext_text', s); // 
                                                  if j > 0 then
                                                    begin
                                                      delete(s, 1, j - 1);
                                                      j := pos('</p>', s);
                                                      s2 := copy(s, 1, j - 1);
                                                      s2 := ClearHTML(s2);
                                                      s2 := trim(s2);
                                                      if s2 <> '' then
                                                        Recenzia := Recenzia + ret + s2;
                                                      delete(s, 1, j - 1);
                                                    end;
                                                  i := pos('<p class="profile_name">', s);
                                                end;
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                            end
                                          else
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                        end;
                                      NPage := NPage + 1;
                                      ii := pos('href="/film/' + FullMovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                                      if ii = 0 then
                                        ii := pos('href="/film/' + MovieCode + '/ord/rating/perpage/10/page/' + IntToStr(NPage), page2);
                                    end;
                                end;
                              if Recenzia <> '<b> :</b>' then
                                begin
                                  if cRecenzia = 1 then
                                    begin
                                      if Comment <> '' then
                                        begin
                                          if cInsertTegHR = 1 then
                                            Comment := Comment + ret + '<hr>'
                                          else
                                            Comment := Comment + ret + ret;
                                        end;
                                      Comment := Comment + Recenzia;
                                    end;
                                  if dRecenzia = 1 then
                                    begin
                                      if Description <> '' then
                                        begin
                                          if dInsertTegHR = 1 then
                                            Description := Description + ret + '<hr>'
                                          else
                                            Description := Description + ret + ret;
                                        end;
                                      Description := Description + Recenzia;
                                    end;
                                  delete(Recenzia, 1, 25);
                                  tRecenzia := Recenzia;
                                end;
                            end
                          else
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                        end;
                      ProgressBar2.Position := 46;
                      if CheckExit(1) = 1 then
                        Exit;
                      Memo1.Lines.Add('    ...');
                      if UseTemplates = 1 then
                        begin
                          try
                            if FileExists(UserDir + 'Kinopoisk_zas_Description.ini') = false then
                              begin
                                if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Description.ini') = true then
                                  CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Description.ini'), Pchar(UserDir + 'Kinopoisk_zas_Description.ini'), true);
                              end;
                          except
                          end;
                          if FileExists(UserDir + 'Kinopoisk_zas_Description.ini') = false then
                            begin
                              List := TStringList.Create;
                              List.Add('%%%%');
                              List.Add('<hr><b>:</b><br>%%%%');
                              List.Add('<hr><b>:</b><br>%%%%');
                              List.Add('<hr><b>  , : </b><br>%%%%');
                              List.Add('<hr><b>  3500 : </b><br>%%3500%%');
                              List.SaveToFile(UserDir + 'Kinopoisk_zas_Description.ini');
                              List.Free;
                            end;
                          Template := TStringList.Create;
                          Template.LoadFromFile(UserDir + 'Kinopoisk_zas_Description.ini');
                          Description := '';
                          for i := 0 to Template.Count - 1 do
                            begin
                              Application.ProcessMessages;
                              ii := pos('%%', Template[i]);
                              if ii > 0 then
                                begin
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tDescription <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tDescription, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tAwards <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tAwards, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tLinks <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tLinks, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tZnaite <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tZnaite, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tErrors <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tErrors, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%3500%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tBook3500 <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%3500%%', tBook3500, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tLikeMovies <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tLikeMovies, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSlogan <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSlogan, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tBudget <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tBudget, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tMarketing <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tMarketing, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborUS <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSborUS, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborWord <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSborWord, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborRF <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSborRF, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%DVD%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborDVD <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%DVD%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborDVD <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tPremDataWord <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tPremDataWord, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tPremDataRF <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tPremDataRF, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%DVD%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tDVD <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%DVD%%', tDVD, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%BluRay%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tBluRay <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%BluRay%%', tBluRay, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVisualEffectsStudio <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tVisualEffectsStudio, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoiceStudio <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tVoiceStudio, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tProkatStudio <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tProkatStudio, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRatingKinoPoisk <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tRatingKinoPoisk, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRatingKritikov <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tRatingKritikov, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%IMDb%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRatingIMDb <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%IMDb%%', tRatingIMDb, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tProducer <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tProducer, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tOperator <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tOperator, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tComposer <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tComposer, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%c%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoiceDirector <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%c%%', tVoiceDirector, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tVoice, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tTranslator, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tPainter, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tCutter, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRecenzia <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tRecenzia, [rfReplaceAll]);
                                          if Description <> '' then
                                            Description := Description + ret;
                                          Description := Description + Template[i];
                                        end;
                                      Continue;
                                    end;
                                end
                              else
                                begin
                                  if Description <> '' then
                                    Description := Description + ret;
                                  Description := Description + Template[i];
                                end;
                            end;
                          Template.Free;
                          try
                            if FileExists(UserDir + 'Kinopoisk_zas_Comments.ini') = false then
                              begin
                                if FileExists(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Comments.ini') = true then
                                  CopyFile(Pchar(ExtractFilePath(ParamStr(0)) + 'plugins\Kinopoisk_zas_Comments.ini'), Pchar(UserDir + 'Kinopoisk_zas_Comments.ini'), true);
                              end;
                          except
                          end;
                          if FileExists(UserDir + 'Kinopoisk_zas_Comments.ini') = false then
                            begin
                              List := TStringList.Create;
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>  :</b> %%%%');
                              List.Add('<b> DVD:</b> %%DVD%%');
                              List.Add('<b>  :</b> %%%%');
                              List.Add('<b>  :</b> %%%%');
                              List.Add('<b> ():</b> %%%%');
                              List.Add('<b> ():</b> %%%%');
                              List.Add('<b>  DVD:</b> %%DVD%%');
                              List.Add('<b>  Blu-Ray:</b> %%BluRay%%');
                              List.Add('<b> :</b> %%%%');
                              List.Add('<b> IMDb:</b> %%IMDb%%');
                              List.Add('<b> :</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b> :</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>c :</b> %%c%%');
                              List.Add('<b> :</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b> %%%%');
                              List.Add('<b>:</b><br>%%%%');
                              List.Add('<hr><b> :</b><br>%%%%');
                              List.SaveToFile(UserDir + 'Kinopoisk_zas_Comments.ini');
                              List.Free;
                            end;
                          Template := TStringList.Create;
                          Template.LoadFromFile(UserDir + 'Kinopoisk_zas_Comments.ini');
                          Comment := '';
                          for i := 0 to Template.Count - 1 do
                            begin
                              Application.ProcessMessages;
                              ii := pos('%%', Template[i]);
                              if ii > 0 then
                                begin
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tDescription <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tDescription, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tAwards <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tAwards, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tLinks <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tLinks, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tZnaite <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tZnaite, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tErrors <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tErrors, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%3500%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tBook3500 <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%3500%%', tBook3500, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tLikeMovies <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tLikeMovies, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSlogan <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSlogan, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tBudget <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tBudget, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tMarketing <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tMarketing, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborUS <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSborUS, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborWord <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSborWord, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborRF <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tSborRF, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%DVD%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborDVD <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%DVD%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tSborDVD <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%DVD%%', tSborDVD, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tPremDataWord <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tPremDataWord, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tPremDataRF <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tPremDataRF, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%DVD%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tDVD <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%DVD%%', tDVD, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%BluRay%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tBluRay <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%BluRay%%', tBluRay, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVisualEffectsStudio <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tVisualEffectsStudio, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoiceStudio <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tVoiceStudio, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tProkatStudio <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tProkatStudio, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRatingKinoPoisk <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tRatingKinoPoisk, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRatingKritikov <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tRatingKritikov, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%IMDb%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRatingIMDb <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%IMDb%%', tRatingIMDb, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tProducer <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tProducer, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tOperator <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tOperator, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tComposer <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tComposer, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%c%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoiceDirector <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%c%%', tVoiceDirector, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tVoice, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tTranslator, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tPainter, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tVoice <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tCutter, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                  ii := pos('%%%%', Template[i]);
                                  if ii > 0 then
                                    begin
                                      if tRecenzia <> '' then
                                        begin
                                          Template[i] := stringreplace(Template[i], '%%%%', tRecenzia, [rfReplaceAll]);
                                          if Comment <> '' then
                                            Comment := Comment + ret;
                                          Comment := Comment + Template[i];
                                        end;
                                      Continue;
                                    end;
                                end
                              else
                                begin
                                  if Comment <> '' then
                                    Comment := Comment + ret;
                                  Comment := Comment + Template[i];
                                end;
                            end;
                          Template.Free;
                        end;
                      if DelHTML = 1 then
                        begin
                          Comment := ClearHTML(Comment);
                          Description := ClearHTML(Description);
                        end;
                      if Comment <> '' then
                        begin
                          if AddLoadInfoDate = 1 then
                            begin
                              if AddUPLoadInfoDate = 1 then
                                begin
                                  if AddComments = 1 then
                                    begin
                                      if MovieBase.CurrentMovie.Comments <> '' then
                                        begin
                                          s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                          i := Pos('<b> : <font', s);
                                          if i > 0 then
                                            begin
                                              s2 := Copy(s, 1, i - 1);
                                              delete(s, 1, i + 27);
                                              i := Pos('</font></b>', s);
                                              delete(s, 1, i + 10);
                                              s2 := DeleteLineBreaks(Trim(s2));
                                              s := DeleteLineBreaks(Trim(s));
                                              if s2 <> '' then
                                                begin
                                                  if s <> '' then
                                                    s2 := s2 + ret + s;
                                                end
                                              else
                                                s2 := s;
                                              if s2 <> '' then
                                                MovieBase.CurrentMovie.Comments := GetLoadTime() + ret + ret + s2 + ret + Comment
                                              else
                                                MovieBase.CurrentMovie.Comments := GetLoadTime() + ret + ret + Comment;
                                            end
                                          else
                                            MovieBase.CurrentMovie.Comments := GetLoadTime() + ret + ret + s + ret + Comment;
                                        end
                                      else
                                        MovieBase.CurrentMovie.Comments := GetLoadTime() + ret + ret + Comment;
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := GetLoadTime() + ret + ret + Comment;
                                  if CommentsAddBR = 1 then
                                    MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret;
                                end
                              else
                                begin
                                  if AddComments = 1 then
                                    begin
                                      if MovieBase.CurrentMovie.Comments <> '' then
                                        begin
                                          s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                          i := Pos('<b> : <font', s);
                                          if i > 0 then
                                            begin
                                              s2 := Copy(s, 1, i - 1);
                                              delete(s, 1, i + 27);
                                              i := Pos('</font></b>', s);
                                              delete(s, 1, i + 10);
                                              s2 := DeleteLineBreaks(Trim(s2));
                                              s := DeleteLineBreaks(Trim(s));
                                              if s2 <> '' then
                                                begin
                                                  if s <> '' then
                                                    s2 := s2 + ret + s;
                                                end
                                              else
                                                s2 := s;
                                              if s2 <> '' then
                                                MovieBase.CurrentMovie.Comments := s2 + ret + Comment + ret + ret + GetLoadTime()
                                              else
                                                MovieBase.CurrentMovie.Comments := Comment + ret + ret + GetLoadTime();
                                            end
                                          else
                                            MovieBase.CurrentMovie.Comments := s + ret + Comment + ret + ret + GetLoadTime();
                                        end
                                      else
                                        MovieBase.CurrentMovie.Comments := Comment + ret + ret + GetLoadTime();
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := Comment + ret + ret + GetLoadTime();
                                  if CommentsAddBR = 1 then
                                    MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret;
                                end;
                            end
                          else
                            begin
                              if AddComments = 1 then
                                begin
                                  if MovieBase.CurrentMovie.Comments <> '' then
                                    MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret + Comment
                                  else
                                    MovieBase.CurrentMovie.Comments := Comment;
                                end
                              else
                                MovieBase.CurrentMovie.Comments := Comment;
                              if CommentsAddBR = 1 then
                                MovieBase.CurrentMovie.Comments := MovieBase.CurrentMovie.Comments + ret;
                            end;
                        end
                      else
                        begin
                          if AddLoadInfoDate = 1 then
                            begin
                              if AddUPLoadInfoDate = 1 then
                                begin
                                  if AddComments = 1 then
                                    begin
                                      if MovieBase.CurrentMovie.Comments <> '' then
                                        begin
                                          s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                          i := Pos('<b> : <font', s);
                                          if i > 0 then
                                            begin
                                              s2 := Copy(s, 1, i - 1);
                                              delete(s, 1, i + 27);
                                              i := Pos('</font></b>', s);
                                              delete(s, 1, i + 10);
                                              s2 := DeleteLineBreaks(Trim(s2));
                                              s := DeleteLineBreaks(Trim(s));
                                              if s2 <> '' then
                                                begin
                                                  if s <> '' then
                                                    s2 := s2 + ret + s;
                                                end
                                              else
                                                s2 := s;
                                              if s2 <> '' then
                                                MovieBase.CurrentMovie.Comments := GetLoadTime() + ret + ret + s2
                                              else
                                                MovieBase.CurrentMovie.Comments := GetLoadTime();
                                            end
                                          else
                                            MovieBase.CurrentMovie.Comments := GetLoadTime() +
                                              ret + ret + s;
                                        end
                                      else
                                        MovieBase.CurrentMovie.Comments := GetLoadTime();
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := GetLoadTime();
                                end
                              else
                                begin
                                  if AddComments = 1 then
                                    begin
                                      if MovieBase.CurrentMovie.Comments <> '' then
                                        begin
                                          s := DeleteLineBreaks(Trim(MovieBase.CurrentMovie.Comments));
                                          i := Pos('<b> : <font', s);
                                          if i > 0 then
                                            begin
                                              s2 := Copy(s, 1, i - 1);
                                              delete(s, 1, i + 27);
                                              i := Pos('</font></b>', s);
                                              delete(s, 1, i + 10);
                                              s2 := DeleteLineBreaks(Trim(s2));
                                              s := DeleteLineBreaks(Trim(s));
                                              if s2 <> '' then
                                                begin
                                                  if s <> '' then
                                                    s2 := s2 + ret + s;
                                                end
                                              else
                                                s2 := s;
                                              if s2 <> '' then
                                                MovieBase.CurrentMovie.Comments := s2 + ret + ret + GetLoadTime()
                                              else
                                                MovieBase.CurrentMovie.Comments := GetLoadTime();
                                            end
                                          else
                                            MovieBase.CurrentMovie.Comments := s + ret + ret + GetLoadTime();
                                        end
                                      else
                                        MovieBase.CurrentMovie.Comments := GetLoadTime();
                                    end
                                  else
                                    MovieBase.CurrentMovie.Comments := GetLoadTime();
                                end;
                            end;
                        end;
                      if Description <> '' then
                        begin
                          if AddDescription = 1 then
                            begin
                              if MovieBase.CurrentMovie.Description <> '' then
                                MovieBase.CurrentMovie.Description := MovieBase.CurrentMovie.Description + ret;
                              MovieBase.CurrentMovie.Description := Description;
                            end
                          else
                            MovieBase.CurrentMovie.Description := Description;
                          if DescriptionAddBR = 1 then
                            MovieBase.CurrentMovie.Description := MovieBase.CurrentMovie.Description + ret;
                        end;
                      if DelAndSave = 1 then
                        begin
                          if trim(MovieBase.CurrentMovie.Genre) = '' then
                            MovieBase.CurrentMovie.Genre := OldGenre;
                          if trim(MovieBase.CurrentMovie.Country) = '' then
                            MovieBase.CurrentMovie.Country := OldCountry;
                          if trim(MovieBase.CurrentMovie.Director) = '' then
                            MovieBase.CurrentMovie.Director := OldDirector;
                          if trim(MovieBase.CurrentMovie.Scenario) = '' then
                            MovieBase.CurrentMovie.Scenario := OldScenario;
                          if trim(MovieBase.CurrentMovie.Actors) = '' then
                            MovieBase.CurrentMovie.Actors := OldActors;
                          if trim(MovieBase.CurrentMovie.Studio) = '' then
                            MovieBase.CurrentMovie.Studio := OldStudio;
                        end;
                      try
                        MovieBase.SaveMovie;
                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                      except
                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                      end;
                      ProgressBar2.Position := 47;
                      Application.ProcessMessages;
                      if CheckExit(0) = 1 then
                        Exit;
                      if CheckBox3.Checked = True then // 
                        begin
                          if MovieBase.CurrentMovie.IsCoverExists then
                            begin
                              ProgressBar2.Position := 48;
                              Application.ProcessMessages;
                              Memo1.Lines.Add(' ...');
                              with SelQuery do
                                begin
                                  try
                                    DBConnect.Database := MovieBase.Filename;
                                    DBConnect.Connect;
                                    SQL.Text := 'SELECT ID FROM images WHERE MovieID = ' + IntToStr(MovieBase.CurrentMovie.ID) + ' AND cover = -1';
                                    DisableControls;
                                    try
                                      Execute;
                                      First;
                                      if RecordCount > 0 then
                                        CoverID := Fields.Fields[0].AsString;
                                      DBConnect.Disconnect;
                                      MovieBase.CurrentMovie.DeleteCover;
                                      Application.ProcessMessages;
                                      s := ImagesDir + CoverID + '.jpg';
                                      if FileExists(s) = True then
                                        begin
                                          try
                                            if DeleteFile(s) = True then
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                            Memo1.Lines.Add('        !');
                                          end;
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    except
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      Memo1.Lines.Add('       ID!');
                                    end;
                                  except
                                    Memo1.Lines.Add('          ID!');
                                  end;
                                end;
                              ProgressBar2.Position := 50;
                              Application.ProcessMessages;
                              Memo1.Lines.Add('    ...');
                              try
                                MovieBase.SaveMovie;
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              ProgressBar2.Position := 53;
                              Application.ProcessMessages;
                            end;
                        end;
                      if uCovers = 1 then // 
                        begin
                          if SmallPicOnly = 1 then
                            begin
                              Memo1.Lines.Add(' : ' + MovieBase.CurrentMovie.Title);
                              Memo1.Lines.Add('        ...');
                              ProgressBar2.Position := 55;
                              Application.ProcessMessages;
                              try 
                                GetPic := False;
                                if CheckBox5.Checked = True then
                                  begin
                                    s3 := MovieBase.Filename;
                                    j := pos('.amm', s3);
                                    if j > 0 then
                                      s3 := copy(s3, 1, j - 1);
                                    s4 := MovieBase.CurrentMovie.Title + ' (' + MovieBase.CurrentMovie.Year + ')';
                                    s4 := stringreplace(s4, '\', '_', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, '/', '_', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, ':', '.', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, '*', '_', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, '?', '_', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, '<', '_', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, '>', '_', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, '|', '_', [rfReplaceAll, rfIgnoreCase]);
                                    s4 := stringreplace(s4, '"', '''', [rfReplaceAll, rfIgnoreCase]);
                                    s3 := s3 + '_img\' + s4 + '\\';
                                    if FileExists(s4) = false then
                                      begin
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        IEDownload1.Go('https://st.kp.yandex.net/images/film_iphone/iphone360_' + MovieCode + '.jpg');
                                        SecConter := 0;
                                        while GetPic <> True do
                                          begin
                                            Application.ProcessMessages;
                                            Sleep(100);
                                            SecConter := SecConter + 1;
                                            Application.ProcessMessages;
                                            if SecConter > 100 then
                                              Break;
                                          end;
                                        ProgressBar2.Position := 59;
                                        Application.ProcessMessages;
                                        if CheckExit(0) = 1 then
                                          Exit;
                                        if GetPic = True then
                                          begin
                                            Jpeg := TJPEGImage.Create();
                                            Jpeg.LoadFromFile(NamePic);
                                            if ResizeCovers = 1 then
                                              begin
                                                bmp := Tbitmap.Create;
                                                bmp2 := Tbitmap.Create;
                                                bmp.Assign(Jpeg);
                                                Scale := 1;
                                                Scale2 := 1;
                                                if Jpeg.Width > CoversWidth then
                                                  Scale := Jpeg.Width / CoversWidth;
                                                if Jpeg.Height > CoversHeight then
                                                  Scale2 := Jpeg.Height / CoversHeight;
                                                if Scale2 > Scale then
                                                  Scale := Scale2;
                                                if Scale > 1 then
                                                  begin
                                                    bmp2.Width := Round(bmp.Width / Scale);
                                                    bmp2.Height := Round(bmp.Height / Scale);
                                                    SmoothResize(bmp, bmp2);
                                                    Jpeg.Assign(bmp2);
                                                    Jpeg.CompressionQuality := 85;
                                                    Jpeg.Compress;
                                                  end;
                                                bmp.Free;
                                                bmp2.Free;
                                              end; 
                                            if DirectoryExists(s3) = False then
                                              ForceDirectories(s3);
                                            Jpeg.SaveToFile(s4);
                                            Jpeg.Free;
                                            DeleteFile(NamePic);
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          end
                                        else
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end
                                    else
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                  end
                                else
                                  begin
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    IEDownload1.Go('https://st.kp.yandex.net/images/film_iphone/iphone360_' + MovieCode + '.jpg');
                                    SecConter := 0;
                                    while GetPic <> True do
                                      begin
                                        Application.ProcessMessages;
                                        Sleep(100);
                                        SecConter := SecConter + 1;
                                        Application.ProcessMessages;
                                        if SecConter > 100 then
                                          Break;
                                      end;
                                    ProgressBar2.Position := 59;
                                    Application.ProcessMessages;
                                    if CheckExit(0) = 1 then
                                      Exit;
                                    if GetPic = True then
                                      begin
                                        if ResizeCovers = 1 then
                                          begin
                                            Jpeg := TJPEGImage.Create();
                                            Jpeg.LoadFromFile(NamePic);
                                            bmp := Tbitmap.Create;
                                            bmp2 := Tbitmap.Create;
                                            bmp.Assign(Jpeg);
                                            Scale := 1;
                                            Scale2 := 1;
                                            if Jpeg.Width > CoversWidth then
                                              Scale := jpeg.Width / CoversWidth;
                                            if Jpeg.Height > CoversHeight then
                                              Scale2 := Jpeg.Height / CoversHeight;
                                            if Scale2 > Scale then
                                              Scale := Scale2;
                                            if Scale > 1 then
                                              begin
                                                bmp2.Width := Round(bmp.Width / Scale);
                                                bmp2.Height := Round(bmp.Height / Scale);
                                                SmoothResize(bmp, bmp2);
                                                Jpeg.Assign(bmp2);
                                                Jpeg.CompressionQuality := 85;
                                                Jpeg.Compress;
                                              end;
                                            bmp.Free;
                                            bmp2.Free;
                                            Jpeg.SaveToFile(NamePic);
                                            Jpeg.Free;
                                          end;
                                        if MovieBase.CurrentMovie.IsCoverExists then
                                          MovieBase.CurrentMovie.SetScreenshot(NamePic)
                                        else
                                          MovieBase.CurrentMovie.SetCoverImage(NamePic);
                                        DeleteFile(NamePic);
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      end
                                    else
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                  end;
                              except
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              ProgressBar2.Position := 65;
                              Application.ProcessMessages;
                              if CheckExit(1) = 1 then
                                Exit;
                              Memo1.Lines.Add('    ...');
                              try
                                if CheckBox5.Checked = False then
                                  MovieBase.SaveMovie;
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              ProgressBar2.Position := 75;
                              Application.ProcessMessages;
                              if CheckExit(0) = 1 then
                                Exit;
                            end
                          else
                            begin //,    
                              Memo1.Lines.Add(' : ' + MovieBase.CurrentMovie.Title);
                              Memo1.Lines.Add('       ...');
                              ProgressBar2.Position := 55;
                              Application.ProcessMessages;
                              if (Pos('href="/film/' + FullMovieCode + '/posters/', page) > 0) or
                                 (Pos('href="/film/' + MovieCode + '/posters/', page) > 0) or
                                 (Pos('href="/film/' + FullMovieCode + '/covers/', page) > 0) or
                                 (Pos('href="/film/' + MovieCode + '/covers/', page) > 0)
                              then
                                begin
                                  Kol := 0;
                                  links := TStringList.Create;
                                  MovieList := TStringList.Create;
                                  if (Pos('href="/film/' + FullMovieCode + '/posters/', page) > 0) or
                                     (Pos('href="/film/' + MovieCode + '/posters/', page) > 0)
                                  then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/',
                                                                '  .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/',
                                                                    '  .....');
                                          except
                                            page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                      ProgressBar2.Position := 59;
                                      if CheckExit(0) = 1 then
                                        Exit;
                                      if page2 <> '' then
                                        begin
                                          s := page2;
                                          i := pos('/images/poster/sm_', s);
                                          delete(s, 1, i + 17);
                                          j := pos('</table>', s);
                                          s := copy(s, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              Application.ProcessMessages;
                                              if Kol >= MaxCovers then
                                                break;
                                              s2 := '';
                                              j := pos('</td>', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  delete(s, 1, j - 1);
                                                  j := pos('.jpg', s2);
                                                  if j = 0 then
                                                    j := pos('.JPG', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  s3 := ' ' + IntToStr(Kol) + ': ';
                                                  s4 := '';
                                                  delete(s2, 1, j);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + copy(s2, 1, j - 1);
                                                  s4 := s4 + copy(s2, 1, j - 1);
                                                  delete(s2, 1, j + 14);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  MovieList.Add(s3);
                                                end;
                                              i := pos('/images/poster/sm_', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      if (uAllCoversPage = 1) and (Kol < MaxCovers) then //    
                                        begin
                                          NPage := 2;
                                          ii := pos('/page/' + IntToStr(NPage) + '/', page2);
                                          while ii > 0 do
                                            begin
                                              if Kol >= MaxCovers then
                                                break;
                                              Memo1.Lines.Add('       ' + IntToStr(NPage) + '...');
                                              if CheckExit(0) = 1 then
                                                Exit;
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' +
                                                                        IntToStr(NPage) + '/', '  .....');
                                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                              except
                                                page3 := '';
                                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                              end;
                                              Label6.Caption := '';
                                              i := pos(FindBlocking, page3);
                                              if (i > 0) or (page3 = '') then
                                                begin
                                                  ShowMessage('    ');
                                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' + IntToStr(NPage) + '/');
                                                  try
                                                    GetHTML := False;
                                                    if NeedURLDelay = 1 then
                                                      Sleep(MaxURLDelay);
                                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/posters/' +
                                                                            IntToStr(NPage) + '/', '  .....');
                                                  except
                                                    page3 := '';
                                                  end;
                                                end;
                                              Label6.Caption := '';
                                              ProgressBar2.Position := 62;
                                              if CheckExit(0) = 1 then
                                                Exit;
                                              if page3 <> '' then
                                                begin
                                                  i := pos('/images/poster/sm_', page3);
                                                  delete(page3, 1, i + 17);
                                                  j := pos('</table>', page3);
                                                  s := copy(page3, 1, j - 1);
                                                  while i > 0 do
                                                    begin
                                                      Application.ProcessMessages;
                                                      if Kol >= MaxCovers then
                                                        break;
                                                      s2 := '';
                                                      j := pos('</td>', s);
                                                      if j > 0 then
                                                        begin
                                                          Kol := Kol + 1;
                                                          s2 := copy(s, 1, j - 1);
                                                          delete(s, 1, j - 1);
                                                          j := pos('.jpg', s2);
                                                          if j = 0 then
                                                            j := pos('.JPG', s2);
                                                          s3 := copy(s2, 1, j - 1);
                                                          links.Add(s3);
                                                          s3 := ' ' + IntToStr(Kol) + ': ';
                                                          s4 := '';
                                                          delete(s2, 1, j);
                                                          j := pos('<font color="#777777">', s2);
                                                          delete(s2, 1, j + 21);
                                                          j := pos('</font></small>', s2);
                                                          s3 := s3 + copy(s2, 1, j - 1);
                                                          s4 := s4 + copy(s2, 1, j - 1);
                                                          delete(s2, 1, j + 14);
                                                          j := pos('<font color="#777777">', s2);
                                                          delete(s2, 1, j + 21);
                                                          j := pos('</font></small>', s2);
                                                          s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                          s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                          MovieList.Add(s3);
                                                        end;
                                                      i := pos('/images/poster/sm_', s);
                                                      if i > 0 then
                                                        delete(s, 1, i + 17);
                                                    end;
                                                end;
                                              NPage := NPage + 1;
                                              ii := pos('/page/' + IntToStr(NPage) + '/', page3);
                                            end;
                                        end;
                                    end;
                                  if ((Pos('href="/film/' + FullMovieCode + '/covers/', page) > 0) or
                                      (Pos('href="/film/' + MovieCode + '/covers/', page) > 0)) and (Kol < MaxCovers)
                                  then
                                    begin //   
                                      Memo1.Lines.Add('      ...');
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/',
                                                                '  .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/',
                                                                    '  .....');
                                          except
                                            page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                      ProgressBar2.Position := 63;
                                      if CheckExit(0) = 1 then
                                        Exit;
                                      if page2 <> '' then
                                        begin
                                          i := pos('/images/poster/sm_', page2);
                                          delete(page2, 1, i + 17);
                                          j := pos('</table>', page2);
                                          s := copy(page2, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              Application.ProcessMessages;
                                              if Kol >= MaxCovers then
                                                break;
                                              s2 := '';
                                              j := pos('</td>', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  delete(s, 1, j - 1);
                                                  j := pos('.jpg', s2);
                                                  if j = 0 then
                                                    j := pos('.JPG', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  s3 := ' ' + IntToStr(Kol) + ': ';
                                                  s4 := '';
                                                  delete(s2, 1, j);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + copy(s2, 1, j - 1);
                                                  s4 := s4 + copy(s2, 1, j - 1);
                                                  delete(s2, 1, j + 14);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  MovieList.Add(s3);
                                                end;
                                              i := pos('/images/poster/sm_', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      if (uAllCoversPage = 1) and (Kol < MaxCovers) then //    
                                        begin
                                          NPage := 2;
                                          ii := pos('/page/' + IntToStr(NPage) + '/', page2);
                                          while ii > 0 do
                                            begin
                                              if Kol >= MaxCovers then
                                                break;
                                              Memo1.Lines.Add('       ' + IntToStr(NPage) + '...');
                                              if CheckExit(0) = 1 then
                                                Exit;
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' +
                                                                        IntToStr(NPage) + '/', '  .....');
                                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                              except
                                                page3 := '';
                                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                              end;
                                              Label6.Caption := '';
                                              i := pos(FindBlocking, page3);
                                              if (i > 0) or (page3 = '') then
                                                begin
                                                  ShowMessage('    ');
                                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' + IntToStr(NPage) + '/');
                                                  try
                                                    GetHTML := False;
                                                    if NeedURLDelay = 1 then
                                                      Sleep(MaxURLDelay);
                                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/covers/' +
                                                                            IntToStr(NPage) + '/', '  .....');
                                                  except
                                                    page3 := '';
                                                  end;
                                                end;
                                              Label6.Caption := '';
                                              ProgressBar2.Position := 65;
                                              if CheckExit(0) = 1 then
                                                Exit;
                                              if page3 <> '' then
                                                begin
                                                  i := pos('/images/poster/sm_', page3);
                                                  delete(page3, 1, i + 17);
                                                  j := pos('</table>', page3);
                                                  s := copy(page3, 1, j - 1);
                                                  while i > 0 do
                                                    begin
                                                      Application.ProcessMessages;
                                                      if Kol >= MaxCovers then
                                                        break;
                                                      s2 := '';
                                                      j := pos('</td>', s);
                                                      if j > 0 then
                                                        begin
                                                          Kol := Kol + 1;
                                                          s2 := copy(s, 1, j - 1);
                                                          delete(s, 1, j - 1);
                                                          j := pos('.jpg', s2);
                                                          if j = 0 then
                                                            j := pos('.JPG', s2);
                                                          s3 := copy(s2, 1, j - 1);
                                                          links.Add(s3);
                                                          s3 := ' ' + IntToStr(Kol) + ': ';
                                                          s4 := '';
                                                          delete(s2, 1, j);
                                                          j := pos('<font color="#777777">', s2);
                                                          delete(s2, 1, j + 21);
                                                          j := pos('</font></small>', s2);
                                                          s3 := s3 + copy(s2, 1, j - 1);
                                                          s4 := s4 + copy(s2, 1, j - 1);
                                                          delete(s2, 1, j + 14);
                                                          j := pos('<font color="#777777">', s2);
                                                          delete(s2, 1, j + 21);
                                                          j := pos('</font></small>', s2);
                                                          s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                          s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                          MovieList.Add(s3);
                                                        end;
                                                      i := pos('/images/poster/sm_', s);
                                                      if i > 0 then
                                                        delete(s, 1, i + 17);
                                                    end;
                                                end;
                                              NPage := NPage + 1;
                                              ii := pos('/page/' + IntToStr(NPage) + '/', page3);
                                            end;
                                        end;
                                    end;
                                  if Kol > 0 then
                                    begin
                                      for ii := 0 to Kol - 1 do
                                        begin
                                          Memo1.Lines.Add('     ' + IntToStr(ii + 1) + '...');
                                          try
                                            GetPic := False;
                                            if CheckBox5.Checked = True then
                                              begin
                                                s3 := MovieBase.Filename;
                                                j := pos('.amm', s3);
                                                if j > 0 then
                                                  s3 := copy(s3, 1, j - 1);
                                                s4 := MovieBase.CurrentMovie.Title + ' (' + MovieBase.CurrentMovie.Year + ')';
                                                s4 := stringreplace(s4, '\', '_', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, '/', '_', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, ':', '.', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, '*', '_', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, '?', '_', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, '<', '_', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, '>', '_', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, '|', '_', [rfReplaceAll, rfIgnoreCase]);
                                                s4 := stringreplace(s4, '"', '''', [rfReplaceAll, rfIgnoreCase]);
                                                s3 := s3 + '_img\' + s4 + '\\';
                                                s4 := s3 + links[ii] + '.jpg';
                                                if FileExists(s4) = false then
                                                  begin
                                                    if NeedURLDelay = 1 then
                                                      Sleep(MaxURLDelay);
                                                    IEDownload1.Go('https://www.kinopoisk.ru/images/poster/' + links[ii] + '.jpg');
                                                    SecConter := 0;
                                                    while GetPic <> True do
                                                      begin
                                                        Application.ProcessMessages;
                                                        Sleep(100);
                                                        SecConter := SecConter + 1;
                                                        Application.ProcessMessages;
                                                        if SecConter > 100 then
                                                          Break;
                                                      end;
                                                    if CheckExit(0) = 1 then
                                                      Exit;
                                                    if GetPic = True then
                                                      begin
                                                        Jpeg := TJPEGImage.Create();
                                                        Jpeg.LoadFromFile(NamePic);
                                                        if ResizeCovers = 1 then
                                                          begin
                                                            bmp := Tbitmap.Create;
                                                            bmp2 := Tbitmap.Create;
                                                            bmp.Assign(Jpeg);
                                                            Scale := 1;
                                                            Scale2 := 1;
                                                            if Jpeg.Width > CoversWidth then
                                                              Scale := Jpeg.Width / CoversWidth;
                                                            if Jpeg.Height > CoversHeight then
                                                              Scale2 := Jpeg.Height / CoversHeight;
                                                            if Scale2 > Scale then
                                                              Scale := Scale2;
                                                            if Scale > 1 then
                                                              begin
                                                                bmp2.Width := Round(bmp.Width / Scale);
                                                                bmp2.Height := Round(bmp.Height / Scale);
                                                                SmoothResize(bmp, bmp2);
                                                                Jpeg.Assign(bmp2);
                                                                Jpeg.CompressionQuality := 85;
                                                                Jpeg.Compress;
                                                              end;
                                                            bmp.Free;
                                                            bmp2.Free;
                                                          end; 
                                                        if DirectoryExists(s3) = False then
                                                          ForceDirectories(s3);
                                                        Jpeg.SaveToFile(s4);
                                                        Jpeg.Free;
                                                        DeleteFile(NamePic);
                                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                                      end
                                                    else
                                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                                  end
                                                else
                                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                              end
                                            else
                                              begin
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                IEDownload1.Go('https://www.kinopoisk.ru/images/poster/' + links[ii] + '.jpg');
                                                SecConter := 0;
                                                while GetPic <> True do
                                                  begin
                                                    Application.ProcessMessages;
                                                    Sleep(100);
                                                    SecConter := SecConter + 1;
                                                    Application.ProcessMessages;
                                                    if SecConter > 100 then
                                                      Break;
                                                  end;
                                                if CheckExit(0) = 1 then
                                                  Exit;
                                                if GetPic = True then
                                                  begin
                                                    if ResizeCovers = 1 then
                                                      begin
                                                        Jpeg := TJPEGImage.Create();
                                                        Jpeg.LoadFromFile(NamePic);
                                                        bmp := Tbitmap.Create;
                                                        bmp2 := Tbitmap.Create;
                                                        bmp.Assign(Jpeg);
                                                        Scale := 1;
                                                        Scale2 := 1;
                                                        if Jpeg.Width > CoversWidth then
                                                          Scale := jpeg.Width / CoversWidth;
                                                        if Jpeg.Height > CoversHeight then
                                                          Scale2 := Jpeg.Height / CoversHeight;
                                                        if Scale2 > Scale then
                                                          Scale := Scale2;
                                                        if Scale > 1 then
                                                          begin
                                                            bmp2.Width := Round(bmp.Width / Scale);
                                                            bmp2.Height := Round(bmp.Height / Scale);
                                                            SmoothResize(bmp, bmp2);
                                                            Jpeg.Assign(bmp2);
                                                            Jpeg.CompressionQuality := 85;
                                                            Jpeg.Compress;
                                                          end;
                                                        bmp.Free;
                                                        bmp2.Free;
                                                        Jpeg.SaveToFile(NamePic);
                                                        Jpeg.Free;
                                                      end;
                                                    if ii = 0 then
                                                      begin
                                                        if MovieBase.CurrentMovie.IsCoverExists then
                                                          MovieBase.CurrentMovie.SetScreenshot(NamePic)
                                                        else
                                                          MovieBase.CurrentMovie.SetCoverImage(NamePic);
                                                      end
                                                    else
                                                      MovieBase.CurrentMovie.SetScreenshot(NamePic);
                                                    DeleteFile(NamePic);
                                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                                  end
                                                else
                                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                              end;
                                          except
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                        end;
                                      ProgressBar2.Position := 67;
                                      Application.ProcessMessages;
                                    end;
                                  links.Free;
                                  MovieList.Free;
                                end
                              else
                                begin
                                  if SmallPic = 1 then
                                    begin
                                      try
                                        GetPic := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        IEDownload1.Go('https://st.kp.yandex.net/images/film_iphone/iphone360_' + MovieCode + '.jpg');
                                        SecConter := 0;
                                        while GetPic <> True do
                                          begin
                                            Application.ProcessMessages;
                                            Sleep(100);
                                            SecConter := SecConter + 1;
                                            Application.ProcessMessages;
                                            if SecConter > 100 then
                                              Break;
                                          end;
                                        ProgressBar2.Position := 67;
                                        Application.ProcessMessages;
                                        if CheckExit(0) = 1 then
                                          Exit;
                                        if GetPic = True then
                                          begin
                                            if MovieBase.CurrentMovie.IsCoverExists then
                                              MovieBase.CurrentMovie.SetScreenshot(NamePic)
                                            else
                                              MovieBase.CurrentMovie.SetCoverImage(NamePic);
                                            DeleteFile(NamePic);
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          end
                                        else
                                          begin
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                      except
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                    end;
                                end;
                              ProgressBar2.Position := 68;
                              Application.ProcessMessages;
                              if CheckExit(1) = 1 then
                                Exit;
                              Memo1.Lines.Add('    ...');
                              try
                                if CheckBox5.Checked = False then
                                  MovieBase.SaveMovie;
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              ProgressBar2.Position := 69;
                              Application.ProcessMessages;
                              if CheckExit(0) = 1 then
                                Exit;
                            end;
                        end;
                      if CheckBox4.Checked = True then // 
                        begin
                          i := MovieBase.CurrentMovie.ScreenshotsCount;
                          if i > 0 then
                            begin
                              ProgressBar2.Position := 70;
                              Application.ProcessMessages;
                              Memo1.Lines.Add(' ...');
                              if CheckExit(0) = 1 then
                                Exit;
                              SetLength(uPictures, i);
                              with SelQuery do
                                begin
                                  try
                                    DBConnect.Database := MovieBase.Filename;
                                    DBConnect.Connect;
                                    SQL.Text := 'SELECT ID FROM images WHERE MovieID = ' + IntToStr(MovieBase.CurrentMovie.ID) + ' AND cover = 0';
                                    DisableControls;
                                    try
                                      Execute;
                                      First;
                                      if RecordCount > 0 then
                                        begin
                                          for ii := 0 to i - 1 do
                                            begin
                                              uPictures[ii] := ImagesDir + Fields.Fields[0].AsString + '.jpg';
                                              Next;
                                            end;
                                        end
                                      else
                                        uPictures := nil;
                                      DBConnect.Disconnect;
                                    except
                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      Memo1.Lines.Add('       ID !'); 
                                      uPictures := nil;
                                    end;
                                  except
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                    Memo1.Lines.Add('          ID !'); 
                                    uPictures := nil;
                                  end;
                                end;
                              for ii := 0 to i - 1 do
                                begin
                                  Memo1.Lines.Add('     ' + IntToStr(ii + 1) + '...');
                                  MovieBase.CurrentMovie.DeleteScreenshot(i - ii - 1);
                                  Application.ProcessMessages;
                                  if Length(uPictures) > 0 then
                                    begin
                                      if FileExists(uPictures[ii]) = True then
                                        try
                                          if DeleteFile(uPictures[ii]) = True then
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                        except
                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          Memo1.Lines.Add('          ' + IntToStr(ii + 1));
                                        end
                                      else
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                    end
                                  else
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  if CheckExit(0) = 1 then
                                    Exit;
                                end;
                              uPictures := nil;
                              ProgressBar2.Position := 71;
                              Application.ProcessMessages;
                              Memo1.Lines.Add('    ...');
                              try
                                MovieBase.SaveMovie;
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              ProgressBar2.Position := 72;
                              Application.ProcessMessages;
                            end;
                        end;
                      if uScreenshots = 1 then // 
                        begin //,     
                          Memo1.Lines.Add(' : ' + MovieBase.CurrentMovie.Title);
                          Memo1.Lines.Add('       ...');
                          ProgressBar2.Position := 73;
                          Application.ProcessMessages;
                          if (Pos('href="/film/' + FullMovieCode + '/stills/', page) > 0) or
                             (Pos('href="/film/' + MovieCode + '/stills/', page) > 0)
                          then
                            begin
                              Kol := 0;
                              links := TStringList.Create;
                              MovieList := TStringList.Create;
                              try
                                GetHTML := False;
                                if NeedURLDelay = 1 then
                                  Sleep(MaxURLDelay);
                                page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/', '  .....');
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                              except
                                page2 := '';
                                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                              end;
                              Label6.Caption := '';
                              i := pos(FindBlocking, page2);
                              if (i > 0) or (page2 = '') then
                                begin
                                  ShowMessage('    ');
                                  GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/');
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/', '  .....');
                                  except
                                    page2 := '';
                                  end;
                                end;
                              Label6.Caption := '';
                              ProgressBar2.Position := 74;
                              if CheckExit(0) = 1 then
                                Exit;
                              if page2 <> '' then
                                begin
                                  s := page2;
                                  i := pos('<a href="/picture/', s);
                                  delete(s, 1, i + 17);
                                  j := pos('</table>', s);
                                  s := copy(s, 1, j - 1);
                                  while i > 0 do
                                    begin
                                      Application.ProcessMessages;
                                      if Kol >= MaxScreenshots then
                                        break;
                                      s2 := '';
                                      j := pos('</td>', s);
                                      ii := pos('<img src=', s);
                                      k := pos('.jpg', s);
                                      if k = 0 then
                                        k := pos('.JPG', s);
                                      if j > 0 then
                                        begin
                                          Kol := Kol + 1;
                                          s2 := copy(s, 1, j - 1);
                                          s4 := copy(s, ii + 10, k - (ii + 10));
                                          s4 := 'https://www.kinopoisk.ru' + s4 + '.jpg';
                                          delete(s, 1, j - 1);
                                          j := pos('/', s2);
                                          s3 := copy(s2, 1, j - 1);
                                          links.Add(s3);
                                          s3 := ' ' + IntToStr(Kol) + ': ';
                                          s4 := '';
                                          delete(s2, 1, j);
                                          j := pos('<font color="#777777">', s2);
                                          delete(s2, 1, j + 21);
                                          j := pos('</font></small>', s2);
                                          s3 := s3 + copy(s2, 1, j - 1);
                                          s4 := s4 + copy(s2, 1, j - 1);
                                          delete(s2, 1, j + 14);
                                          j := pos('<font color="#777777">', s2);
                                          delete(s2, 1, j + 21);
                                          j := pos('</font></small>', s2);
                                          s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                          s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                          MovieList.Add(s3);
                                        end;
                                      i := pos('<a href="/picture/', s);
                                      if i > 0 then
                                        delete(s, 1, i + 17);
                                    end;
                                end;
                              if (uAllScreenshotsPage = 1) and (Kol < MaxScreenshots) then //    
                                begin
                                  NPage := 2;
                                  ii := pos('/page/' + IntToStr(NPage), page2);
                                  while ii > 0 do
                                    begin
                                      if Kol >= MaxScreenshots then
                                        break;
                                      Memo1.Lines.Add('       ' + IntToStr(NPage) + '...');
                                      if CheckExit(0) = 1 then
                                        Exit;
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' +
                                                                IntToStr(NPage) + '/', '  .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page3 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' + IntToStr(NPage) + '/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/stills/page/' +
                                                                    IntToStr(NPage) + '/', '  .....');
                                          except
                                            page3 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                      ProgressBar2.Position := 75;
                                      if CheckExit(0) = 1 then
                                        Exit;
                                      if page3 <> '' then
                                        begin
                                          i := pos('<a href="/picture/', page3);
                                          delete(page3, 1, i + 17);
                                          j := pos('</table>', page3);
                                          s := copy(page3, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              Application.ProcessMessages;
                                              if Kol >= MaxScreenshots then
                                                break;
                                              s2 := '';
                                              j := pos('</td>', s);
                                              ii := pos('<img src=', s);
                                              k := pos('.jpg', s);
                                              if k = 0 then
                                                k := pos('.JPG', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  s4 := copy(s, ii + 10, k - (ii + 10));
                                                  s4 := 'https://www.kinopoisk.ru' + s4 + '.jpg';
                                                  delete(s, 1, j - 1);
                                                  j := pos('/', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  s3 := ' ' + IntToStr(Kol) + ': ';
                                                  s4 := '';
                                                  delete(s2, 1, j);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + copy(s2, 1, j - 1);
                                                  s4 := s4 + copy(s2, 1, j - 1);
                                                  delete(s2, 1, j + 14);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  MovieList.Add(s3);
                                                end;
                                              i := pos('<a href="/picture/', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      NPage := NPage + 1;
                                      ii := pos('/page/' + IntToStr(NPage), page3);
                                    end;
                                  if ((Pos('/film/' + FullMovieCode + '/screenshots/', page2) > 0) or
                                      (Pos('/film/' + MovieCode + '/screenshots/', page2) > 0)) and (Kol < MaxScreenshots)
                                  then
                                    begin //,     
                                      Memo1.Lines.Add('       1...');
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/',
                                                                '  .....');
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                      except
                                        page2 := '';
                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page2);
                                      if (i > 0) or (page2 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/',
                                                                    '  .....');
                                          except
                                            page2 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                      ProgressBar2.Position := 77;
                                      if CheckExit(0) = 1 then
                                        Exit;
                                      if page2 <> '' then
                                        begin
                                          i := pos('<a href="/picture/', page2);
                                          delete(page2, 1, i + 17);
                                          j := pos('</table>', page2);
                                          s := copy(page2, 1, j - 1);
                                          while i > 0 do
                                            begin
                                              if Kol >= MaxScreenshots then
                                                break;
                                              s2 := '';
                                              j := pos('</td>', s);
                                              ii := pos('<img src=', s);
                                              k := pos('.jpg', s);
                                              if k = 0 then
                                                k := pos('.JPG', s);
                                              if j > 0 then
                                                begin
                                                  Kol := Kol + 1;
                                                  s2 := copy(s, 1, j - 1);
                                                  s4 := copy(s, ii + 10, k - (ii + 10));
                                                  s4 := 'https://www.kinopoisk.ru' + s4 + '.jpg';
                                                  delete(s, 1, j - 1);
                                                  j := pos('/', s2);
                                                  s3 := copy(s2, 1, j - 1);
                                                  links.Add(s3);
                                                  s3 := ' ' + IntToStr(Kol) + ': ';
                                                  s4 := '';
                                                  delete(s2, 1, j);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + copy(s2, 1, j - 1);
                                                  s4 := s4 + copy(s2, 1, j - 1);
                                                  delete(s2, 1, j + 14);
                                                  j := pos('<font color="#777777">', s2);
                                                  delete(s2, 1, j + 21);
                                                  j := pos('</font></small>', s2);
                                                  s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                  MovieList.Add(s3);
                                                end;
                                              i := pos('<a href="/picture/', s);
                                              if i > 0 then
                                                delete(s, 1, i + 17);
                                            end;
                                        end;
                                      NPage := 2;
                                      ii := pos('/screenshots/page/' + IntToStr(NPage), page2); //    
                                      while ii > 0 do
                                        begin
                                          if Kol >= MaxScreenshots then
                                            break;
                                          Memo1.Lines.Add('       ' + IntToStr(NPage) + '...');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                                    IntToStr(NPage) + '/', '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page3 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page3);
                                          if (i > 0) or (page3 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' + IntToStr(NPage) + '/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                                        IntToStr(NPage) + '/', '  .....');
                                              except
                                                page3 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                          ProgressBar2.Position := 79;
                                          if CheckExit(0) = 1 then
                                            Exit;
                                          if page3 <> '' then
                                            begin
                                              i := pos('<a href="/picture/', page3);
                                              delete(page3, 1, i + 17);
                                              j := pos('</table>', page3);
                                              s := copy(page3, 1, j - 1);
                                              while i > 0 do
                                                begin
                                                  if Kol >= MaxScreenshots then
                                                    break;
                                                  s2 := '';
                                                  j := pos('</td>', s);
                                                  ii := pos('<img src=', s);
                                                  k := pos('.jpg', s);
                                                  if k = 0 then
                                                    k := pos('.JPG', s);
                                                  if j > 0 then
                                                    begin
                                                      Kol := Kol + 1;
                                                      s2 := copy(s, 1, j - 1);
                                                      s4 := copy(s, ii + 10, k - (ii + 10));
                                                      s4 := 'https://www.kinopoisk.ru' + s4 + '.jpg';
                                                      delete(s, 1, j - 1);
                                                      j := pos('/', s2);
                                                      s3 := copy(s2, 1, j - 1);
                                                      links.Add(s3);
                                                      s3 := ' ' + IntToStr(Kol) + ': ';
                                                      s4 := '';
                                                      delete(s2, 1, j);
                                                      j := pos('<font color="#777777">', s2);
                                                      delete(s2, 1, j + 21);
                                                      j := pos('</font></small>', s2);
                                                      s3 := s3 + copy(s2, 1, j - 1);
                                                      s4 := s4 + copy(s2, 1, j - 1);
                                                      delete(s2, 1, j + 14);
                                                      j := pos('<font color="#777777">', s2);
                                                      delete(s2, 1, j + 21);
                                                      j := pos('</font></small>', s2);
                                                      s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                      s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                      MovieList.Add(s3);
                                                    end;
                                                  i := pos('<a href="/picture/', s);
                                                  if i > 0 then
                                                    delete(s, 1, i + 17);
                                                end;
                                            end;
                                          NPage := NPage + 1;
                                          ii := pos('/screenshots/page/' + IntToStr(NPage), page3);
                                        end;
                                    end;
                                end;
                              if Kol > 0 then
                                begin
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/',
                                                            '  .....');
                                  except
                                    page3 := '';
                                  end;
                                  Label6.Caption := '';
                                  i := pos(FindBlocking, page3);
                                  if (i > 0) or (page3 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/picture/' + links[0] + '/');
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/',
                                                                '  .....');
                                      except
                                        page3 := '';
                                      end;
                                    end;
                                  Label6.Caption := '';
                                  if page3 <> '' then
                                    begin
                                      ii := pos('/im/kadr/', page3);
                                      if ii > 0 then
                                        delete(page3, 1, ii - 1);
                                      ii := pos('.jpg', page3);
                                      if ii = 0 then ii := pos('.JPG', page3);
                                      if ii > 0 then
                                        begin
                                          s := copy(page3, 1, ii - 1);
                                          s := ReverseString(s);
                                          ii := pos('-', s);
                                          if ii > 0 then
                                            delete(s, 1, ii - 1);
                                          ii := pos('/', s);
                                          if ii > 0 then
                                            begin
                                              s := copy(s, 1, ii - 1);
                                              ss := ReverseString(s);
                                            end;
                                        end;
                                    end;
                                  for ii := 0 to Kol - 1 do
                                    begin
                                      Memo1.Lines.Add('     ' + IntToStr(ii + 1) + '...');
                                      Application.ProcessMessages;
                                      if page3 <> '' then
                                        begin
                                          begin
                                            s := links[ii];
                                            try
                                              GetPic := False;
                                              if CheckBox5.Checked = True then
                                                begin
                                                  s3 := MovieBase.Filename;
                                                  j := pos('.amm', s3);
                                                  if j > 0 then
                                                    s3 := copy(s3, 1, j - 1);
                                                  s4 := MovieBase.CurrentMovie.Title + ' (' + MovieBase.CurrentMovie.Year + ')';
                                                  s4 := stringreplace(s4, '\', '_', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, '/', '_', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, ':', '.', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, '*', '_', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, '?', '_', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, '<', '_', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, '>', '_', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, '|', '_', [rfReplaceAll, rfIgnoreCase]);
                                                  s4 := stringreplace(s4, '"', '''', [rfReplaceAll, rfIgnoreCase]);
                                                  s3 := s3 + '_img\' + s4 + '\\';
                                                  s4 := s3 + links[ii] + '.jpg';
                                                  if FileExists(s4) = false then
                                                    begin
                                                      if NeedURLDelay = 1 then
                                                        Sleep(MaxURLDelay);
                                                      IEDownload1.Go('https://www.kinopoisk.ru/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg');
                                                      SecConter := 0;
                                                      while GetPic <> True do
                                                        begin
                                                          Application.ProcessMessages;
                                                          Sleep(100);
                                                          SecConter := SecConter + 1;
                                                          Application.ProcessMessages;
                                                          if SecConter > 100 then
                                                            Break;
                                                        end;
                                                      if CheckExit(0) = 1 then
                                                        Exit;
                                                      if GetPic = True then
                                                        begin
                                                          Jpeg := TJPEGImage.Create();
                                                          Jpeg.LoadFromFile(NamePic);
                                                          if ResizeScreenshots = 1 then
                                                            begin
                                                              bmp := Tbitmap.Create;
                                                              bmp2 := Tbitmap.Create;
                                                              bmp.Assign(Jpeg);
                                                              Scale := 1;
                                                              Scale2 := 1;
                                                              if Jpeg.Width > ScreenshotsWidth then
                                                                Scale := Jpeg.Width / ScreenshotsWidth;
                                                              if Jpeg.Height > ScreenshotsHeight then
                                                                Scale2 := Jpeg.Height / ScreenshotsHeight;
                                                              if Scale2 > Scale then
                                                                Scale := Scale2;
                                                              if Scale > 1 then
                                                                begin
                                                                  bmp2.Width := Round(bmp.Width / Scale);
                                                                  bmp2.Height := Round(bmp.Height / Scale);
                                                                  SmoothResize(bmp, bmp2);
                                                                  Jpeg.Assign(bmp2);
                                                                  Jpeg.CompressionQuality := 85;
                                                                  Jpeg.Compress;
                                                                end;
                                                              bmp.Free;
                                                              bmp2.Free;
                                                            end;
                                                          if DirectoryExists(s3) = False then
                                                            ForceDirectories(s3);
                                                          Jpeg.SaveToFile(s4);
                                                          Jpeg.Free;
                                                          DeleteFile(NamePic);
                                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                                        end
                                                      else
                                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                                    end
                                                  else
                                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                                end
                                              else
                                                begin
                                                  if NeedURLDelay = 1 then
                                                    Sleep(MaxURLDelay);
                                                  IEDownload1.Go('https://www.kinopoisk.ru/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg');
                                                  SecConter := 0;
                                                  while GetPic <> True do
                                                    begin
                                                      Application.ProcessMessages;
                                                      Sleep(100);
                                                      SecConter := SecConter + 1;
                                                      Application.ProcessMessages;
                                                      if SecConter > 100 then
                                                        Break;
                                                    end;
                                                  if CheckExit(0) = 1 then
                                                    Exit;
                                                  if GetPic = True then
                                                    begin
                                                      if ResizeScreenshots = 1 then
                                                        begin
                                                          Jpeg := TJPEGImage.Create();
                                                          Jpeg.LoadFromFile(NamePic);
                                                          bmp := Tbitmap.Create;
                                                          bmp2 := Tbitmap.Create;
                                                          bmp.Assign(jpeg);
                                                          Scale := 1;
                                                          Scale2 := 1;
                                                          if jpeg.Width > ScreenshotsWidth then
                                                            Scale := jpeg.Width / ScreenshotsWidth;
                                                          if jpeg.Height > ScreenshotsHeight then
                                                            Scale2 := jpeg.Height / ScreenshotsHeight;
                                                          if Scale2 > Scale then
                                                            Scale := Scale2;
                                                          if Scale > 1 then
                                                            begin
                                                              bmp2.Width := Round(bmp.Width / Scale);
                                                              bmp2.Height := Round(bmp.Height / Scale);
                                                              SmoothResize(bmp, bmp2);
                                                              jpeg.Assign(bmp2);
                                                              jpeg.CompressionQuality := 85;
                                                              jpeg.Compress;
                                                            end;
                                                          bmp.Free;
                                                          bmp2.Free;
                                                          Jpeg.SaveToFile(NamePic);
                                                          Jpeg.Free;
                                                        end;
                                                      MovieBase.CurrentMovie.SetScreenshot(NamePic);
                                                      DeleteFile(NamePic);
                                                      Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                                    end
                                                  else
                                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                                end;
                                            except
                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                            end;
                                          end;
                                        end;
                                    end;
                                  ProgressBar2.Position := 83;
                                  Application.ProcessMessages;
                                end;
                              links.Free;
                              MovieList.Free;
                            end
                          else
                            begin
                              if (Pos('href="/film/' + FullMovieCode + '/screenshots/', page) > 0) or
                                 (Pos('href="/film/' + MovieCode + '/screenshots/', page) > 0)
                              then
                                begin
                                  Kol := 0;
                                  links := TStringList.Create;
                                  MovieList := TStringList.Create;
                                  try
                                    GetHTML := False;
                                    if NeedURLDelay = 1 then
                                      Sleep(MaxURLDelay);
                                    page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/',
                                                            '  .....');
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                  except
                                    page2 := '';
                                    Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                  end;
                                  Label6.Caption := '';
                                  i := pos(FindBlocking, page2);
                                  if (i > 0) or (page2 = '') then
                                    begin
                                      ShowMessage('    ');
                                      GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/');
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page2 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/',
                                                                '  .....');
                                      except
                                        page2 := '';
                                      end;
                                    end;
                                  Label6.Caption := '';
                                  ProgressBar2.Position := 74;
                                  if CheckExit(0) = 1 then
                                    Exit;
                                  if page2 <> '' then
                                    begin
                                      s := page2;
                                      i := pos('<a href="/picture/', s);
                                      delete(s, 1, i + 17);
                                      j := pos('</table>', s);
                                      s := copy(s, 1, j - 1);
                                      while i > 0 do
                                        begin
                                          Application.ProcessMessages;
                                          if Kol >= MaxScreenshots then
                                            break;
                                          s2 := '';
                                          j := pos('</td>', s);
                                          ii := pos('<img src=', s);
                                          k := pos('.jpg', s);
                                          if k = 0 then
                                            k := pos('.JPG', s);
                                          if j > 0 then
                                            begin
                                              Kol := Kol + 1;
                                              s2 := copy(s, 1, j - 1);
                                              s4 := copy(s, ii + 10, k - (ii + 10));
                                              s4 := 'https://www.kinopoisk.ru' + s4 + '.jpg';
                                              delete(s, 1, j - 1);
                                              j := pos('/', s2);
                                              s3 := copy(s2, 1, j - 1);
                                              links.Add(s3);
                                              s3 := ' ' + IntToStr(Kol) + ': ';
                                              s4 := '';
                                              delete(s2, 1, j);
                                              j := pos('<font color="#777777">', s2);
                                              delete(s2, 1, j + 21);
                                              j := pos('</font></small>', s2);
                                              s3 := s3 + copy(s2, 1, j - 1);
                                              s4 := s4 + copy(s2, 1, j - 1);
                                              delete(s2, 1, j + 14);
                                              j := pos('<font color="#777777">', s2);
                                              delete(s2, 1, j + 21);
                                              j := pos('</font></small>', s2);
                                              s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                              s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                              MovieList.Add(s3);
                                            end;
                                          i := pos('<a href="/picture/', s);
                                          if i > 0 then
                                            delete(s, 1, i + 17);
                                        end;
                                    end;
                                  if (uAllScreenshotsPage = 1) and (Kol < MaxScreenshots) then //    
                                    begin
                                      NPage := 2;
                                      ii := pos('/page/' + IntToStr(NPage), page2);
                                      while ii > 0 do
                                        begin
                                          if Kol >= MaxScreenshots then
                                            break;
                                          Memo1.Lines.Add('       ' + IntToStr(NPage) + '...');
                                          if CheckExit(0) = 1 then
                                            Exit;
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                                    IntToStr(NPage) + '/', '  .....');
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                          except
                                            page3 := '';
                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                          end;
                                          Label6.Caption := '';
                                          i := pos(FindBlocking, page3);
                                          if (i > 0) or (page3 = '') then
                                            begin
                                              ShowMessage('    ');
                                              GetBrowserWindow('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' + IntToStr(NPage) + '/');
                                              try
                                                GetHTML := False;
                                                if NeedURLDelay = 1 then
                                                  Sleep(MaxURLDelay);
                                                page3 := GetInfoFromUrl('https://www.kinopoisk.ru/film/' + MovieCode + '/screenshots/page/' +
                                                                        IntToStr(NPage) + '/', '  .....');
                                              except
                                                page3 := '';
                                              end;
                                            end;
                                          Label6.Caption := '';
                                          ProgressBar2.Position := 77;
                                          if CheckExit(0) = 1 then
                                            Exit;
                                          if page3 <> '' then
                                            begin
                                              i := pos('<a href="/picture/', page3);
                                              delete(page3, 1, i + 17);
                                              j := pos('</table>', page3);
                                              s := copy(page3, 1, j - 1);
                                              while i > 0 do
                                                begin
                                                  Application.ProcessMessages;
                                                  if Kol >= MaxScreenshots then
                                                    break;
                                                  s2 := '';
                                                  j := pos('</td>', s);
                                                  ii := pos('<img src=', s);
                                                  k := pos('.jpg', s);
                                                  if k = 0 then
                                                    k := pos('.JPG', s);
                                                  if j > 0 then
                                                    begin
                                                      Kol := Kol + 1;
                                                      s2 := copy(s, 1, j - 1);
                                                      s4 := copy(s, ii + 10, k - (ii + 10));
                                                      s4 := 'https://www.kinopoisk.ru' + s4 + '.jpg';
                                                      delete(s, 1, j - 1);
                                                      j := pos('/', s2);
                                                      s3 := copy(s2, 1, j - 1);
                                                      links.Add(s3);
                                                      s3 := ' ' + IntToStr(Kol) + ': ';
                                                      s4 := '';
                                                      delete(s2, 1, j);
                                                      j := pos('<font color="#777777">', s2);
                                                      delete(s2, 1, j + 21);
                                                      j := pos('</font></small>', s2);
                                                      s3 := s3 + copy(s2, 1, j - 1);
                                                      s4 := s4 + copy(s2, 1, j - 1);
                                                      delete(s2, 1, j + 14);
                                                      j := pos('<font color="#777777">', s2);
                                                      delete(s2, 1, j + 21);
                                                      j := pos('</font></small>', s2);
                                                      s3 := s3 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                      s4 := s4 + ' (' + copy(s2, 1, j - 1) + ' )';
                                                      MovieList.Add(s3);
                                                    end;
                                                  i := pos('<a href="/picture/', s);
                                                  if i > 0 then
                                                    delete(s, 1, i + 17);
                                                end;
                                            end;
                                          NPage := NPage + 1;
                                          ii := pos('/page/' + IntToStr(NPage), page3);
                                        end;
                                    end;
                                  if Kol > 0 then
                                    begin
                                      try
                                        GetHTML := False;
                                        if NeedURLDelay = 1 then
                                          Sleep(MaxURLDelay);
                                        page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/',
                                                                '  .....');
                                      except
                                        page3 := '';
                                      end;
                                      Label6.Caption := '';
                                      i := pos(FindBlocking, page3);
                                      if (i > 0) or (page3 = '') then
                                        begin
                                          ShowMessage('    ');
                                          GetBrowserWindow('https://www.kinopoisk.ru/picture/' + links[0] + '/');
                                          try
                                            GetHTML := False;
                                            if NeedURLDelay = 1 then
                                              Sleep(MaxURLDelay);
                                            page3 := GetInfoFromUrl('https://www.kinopoisk.ru/picture/' + links[0] + '/',
                                                                    '  .....');
                                          except
                                            page3 := '';
                                          end;
                                        end;
                                      Label6.Caption := '';
                                      if page3 <> '' then
                                        begin
                                          ii := pos('/im/kadr/', page3);
                                          if ii > 0 then
                                            delete(page3, 1, ii - 1);
                                          ii := pos('.jpg', page3);
                                          if ii = 0 then ii := pos('.JPG', page3);
                                          if ii > 0 then
                                            begin
                                              s := copy(page3, 1, ii - 1);
                                              s := ReverseString(s);
                                              ii := pos('-', s);
                                              if ii > 0 then
                                                delete(s, 1, ii - 1);
                                              ii := pos('/', s);
                                              if ii > 0 then
                                                begin
                                                  s := copy(s, 1, ii - 1);
                                                  ss := ReverseString(s);
                                                end;
                                            end;
                                        end;
                                      for ii := 0 to Kol - 1 do
                                        begin
                                          Memo1.Lines.Add('     ' + IntToStr(ii + 1) + '...');
                                          Application.ProcessMessages;
                                          if page3 <> '' then
                                            begin
                                              begin
                                                s := links[ii];
                                                try
                                                  GetPic := False;
                                                  if CheckBox5.Checked = True then
                                                    begin
                                                      s3 := MovieBase.Filename;
                                                      j := pos('.amm', s3);
                                                      if j > 0 then
                                                        s3 := copy(s3, 1, j - 1);
                                                      s4 := MovieBase.CurrentMovie.Title + ' (' + MovieBase.CurrentMovie.Year + ')';
                                                      s4 := stringreplace(s4, '\', '_', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, '/', '_', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, ':', '.', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, '*', '_', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, '?', '_', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, '<', '_', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, '>', '_', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, '|', '_', [rfReplaceAll, rfIgnoreCase]);
                                                      s4 := stringreplace(s4, '"', '''', [rfReplaceAll, rfIgnoreCase]);
                                                      s3 := s3 + '_img\' + s4 + '\\';
                                                      s4 := s3 + links[ii] + '.jpg';
                                                      if FileExists(s4) = false then
                                                        begin
                                                          if NeedURLDelay = 1 then
                                                            Sleep(MaxURLDelay);
                                                          IEDownload1.Go('https://www.kinopoisk.ru/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg');
                                                          SecConter := 0;
                                                          while GetPic <> True do
                                                            begin
                                                              Application.ProcessMessages;
                                                              Sleep(100);
                                                              SecConter := SecConter + 1;
                                                              Application.ProcessMessages;
                                                              if SecConter > 100 then
                                                                Break;
                                                            end;
                                                          if CheckExit(0) = 1 then
                                                            Exit;
                                                          if GetPic = True then
                                                            begin
                                                              Jpeg := TJPEGImage.Create();
                                                              Jpeg.LoadFromFile(NamePic);
                                                              if ResizeScreenshots = 1 then
                                                                begin
                                                                  bmp := Tbitmap.Create;
                                                                  bmp2 := Tbitmap.Create;
                                                                  bmp.Assign(Jpeg);
                                                                  Scale := 1;
                                                                  Scale2 := 1;
                                                                  if Jpeg.Width > ScreenshotsWidth then
                                                                    Scale := Jpeg.Width / ScreenshotsWidth;
                                                                  if Jpeg.Height > ScreenshotsHeight then
                                                                    Scale2 := Jpeg.Height / ScreenshotsHeight;
                                                                  if Scale2 > Scale then
                                                                    Scale := Scale2;
                                                                  if Scale > 1 then
                                                                    begin
                                                                      bmp2.Width := Round(bmp.Width / Scale);
                                                                      bmp2.Height := Round(bmp.Height / Scale);
                                                                      SmoothResize(bmp, bmp2);
                                                                      Jpeg.Assign(bmp2);
                                                                      Jpeg.CompressionQuality := 85;
                                                                      Jpeg.Compress;
                                                                    end;
                                                                  bmp.Free;
                                                                  bmp2.Free;
                                                                end;
                                                              if DirectoryExists(s3) = False then
                                                                ForceDirectories(s3);
                                                              Jpeg.SaveToFile(s4);
                                                              Jpeg.Free;
                                                              DeleteFile(NamePic);
                                                              Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                                            end
                                                          else
                                                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                                        end
                                                      else
                                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + ' ';
                                                    end
                                                  else
                                                    begin
                                                      if NeedURLDelay = 1 then
                                                        Sleep(MaxURLDelay);
                                                      IEDownload1.Go('https://www.kinopoisk.ru/im/kadr/' + s[1] + '/' + s[2] + '/' + s[3] + '/' + ss + s + '.jpg');
                                                      SecConter := 0;
                                                      while GetPic <> True do
                                                        begin
                                                          Application.ProcessMessages;
                                                          Sleep(100);
                                                          SecConter := SecConter + 1;
                                                          Application.ProcessMessages;
                                                          if SecConter > 100 then
                                                            Break;
                                                        end;
                                                      if CheckExit(0) = 1 then
                                                        Exit;
                                                      if GetPic = True then
                                                        begin
                                                          if ResizeScreenshots = 1 then
                                                            begin
                                                              Jpeg := TJPEGImage.Create();
                                                              Jpeg.LoadFromFile(NamePic);
                                                              bmp := Tbitmap.Create;
                                                              bmp2 := Tbitmap.Create;
                                                              bmp.Assign(Jpeg);
                                                              Scale := 1;
                                                              Scale2 := 1;
                                                              if Jpeg.Width > ScreenshotsWidth then
                                                                Scale := Jpeg.Width / ScreenshotsWidth;
                                                              if Jpeg.Height > ScreenshotsHeight then
                                                                Scale2 := Jpeg.Height / ScreenshotsHeight;
                                                              if Scale2 > Scale then
                                                                Scale := Scale2;
                                                              if Scale > 1 then
                                                                begin
                                                                  bmp2.Width := Round(bmp.Width / Scale);
                                                                  bmp2.Height := Round(bmp.Height / Scale);
                                                                  SmoothResize(bmp, bmp2);
                                                                  Jpeg.Assign(bmp2);
                                                                  Jpeg.CompressionQuality := 85;
                                                                  Jpeg.Compress;
                                                                end;
                                                              bmp.Free;
                                                              bmp2.Free;
                                                              Jpeg.SaveToFile(NamePic);
                                                              Jpeg.Free;
                                                            end;
                                                          MovieBase.CurrentMovie.SetScreenshot(NamePic);
                                                          DeleteFile(NamePic);
                                                          Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                                                        end
                                                      else
                                                        Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                                    end;
                                                except
                                                  Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                                                end;
                                              end;
                                            end;
                                        end;
                                      ProgressBar2.Position := 88;
                                    end;
                                  links.Free;
                                  MovieList.Free;
                                end;
                            end;
                          ProgressBar2.Position := 95;
                          if CheckExit(1) = 1 then
                            Exit;
                          Memo1.Lines.Add('    ...');
                          try
                            if CheckBox5.Checked = False then
                              MovieBase.SaveMovie;
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
                          except
                            Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
                          end;
                          ProgressBar2.Position := 100;
                          if CheckExit(0) = 1 then
                            Exit;
                        end;
                    end;
                end;
            end
          else
            begin
              if URL = '' then
                Memo1.Lines.Add('   URL: ' + MovieBase.CurrentMovie.Title)
              else
                Memo1.Lines.Add('URL   : ' + MovieBase.CurrentMovie.Title);
              ProgressBar2.Position := 100;
              if CheckExit(0) = 1 then
                Exit;
            end;
        end
      else
        Memo1.Lines.Add('  : ' + MovieBase.CurrentMovie.Title);
      ProgressBar2.Position := 100;
      ProgressBar1.Position := Round(100 * iii / x);
      if CheckExit(0) = 1 then
        Exit;
      CurrentMovie := MovieBase.CurrentMovie.ID;
      MovieBase.Next;
      MovieBase.EditMovie;
      if CurrentMovie = MovieBase.CurrentMovie.ID then
        begin
          ProgressBar1.Position := 100;
          Break;
        end;
    end;
  ExitFlag := 1;
  Button2.Caption := '';
  GroupBox1.Enabled := True;
  GroupBox2.Enabled := True;
  Button1.Enabled := True;
  Button3.Enabled := True;
  Button4.Enabled := True;
  Button5.Enabled := True;
  Edit1.Enabled := True;
  ComboBox1.Enabled := True;
  ComboBox2.Enabled := True;
  CheckBox1.Enabled := True;
  CheckBox2.Enabled := True;
  CheckBox5.Enabled := True;
  CheckBox6.Enabled := True;
  Label3.Enabled := True;
  Label4.Enabled := True;
  Label5.Enabled := True;
  Label2.Enabled := True;
  Application.ProcessMessages;
  Memo1.Lines.Add('.');
  if SaveLogFile = 1 then
    begin
      if LogFileName <> '' then
        try
          Memo1.Lines.SaveToFile(LogFileName);
        except
        end;
    end;
  MovieBase.First;
  MovieBase.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if ExitFlag = 1 then
    Close
  else
    begin
      Button2.Caption := '';
      ExitFlag := 1;
      Application.ProcessMessages;
    end;
  if SaveLogFile = 1 then
    begin
      if LogFileName <> '' then
        Memo1.Lines.SaveToFile(LogFileName);
    end
  else
    begin
      if FileExists(LogFileName) = True then
        DeleteFile(LogFileName);
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  List: TStringList;
  i: Integer;
begin
  FormSetup := TForm2.Create(Application);
  FormSetup.UserDir := UserDir;
  List := TStringList.Create;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      ReadSections(List);
    finally
      Free;
    end;
  i := 0;
  repeat
    begin
      if (List[i] = 'CommentsOptions') or (List[i] = 'DescriptionOptions') or
         (List[i] = 'RatingOptions') or (List[i] = 'KinoPoiskOptions') or
         (List[i] = 'ProxyOptions') or (List[i] = 'NameOptions') or (List[i] = 'OtherOptions')
      then
        List.Delete(i)
      else
        i := i + 1;
    end;
  until (i = List.Count);
  FormSetup.ComboBox1.Items := List;
  FormSetup.ComboBox1.ItemIndex := 0;
  FormSetup.ComboBox2.Items := List;
  FormSetup.ComboBox2.ItemIndex := 0;
  FormSetup.ComboBox3.Items := List;
  FormSetup.ComboBox3.ItemIndex := 0;
  List.Free;
  FormSetup.OldSection := FormSetup.ComboBox1.Items[0];
  if GetAMMBuild < 1284 then
    begin
      FormSetup.CheckBox106.Enabled := False;
    end;
  if GetAMMBuild < 1401 then
    begin
      FormSetup.CheckBox169.Enabled := False;
    end;
  FormSetup.ShowModal;
  FormSetup.Free;
  List := TStringList.Create;
  with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
    try
      ReadSections(List);
    finally
      Free;
    end;
  i := 0;
  repeat
    begin
      if (List[i] = 'CommentsOptions') or (List[i] = 'DescriptionOptions') or
         (List[i] = 'RatingOptions') or (List[i] = 'KinoPoiskOptions') or
         (List[i] = 'ProxyOptions') or (List[i] = 'NameOptions') or (List[i] = 'OtherOptions')
      then
        List.Delete(i)
      else
        i := i + 1;
    end;
  until (i = List.Count);
  for i := 0 to List.Count - 1 do
    begin
      ComboBox1.Items.Add(List[i]);
      ComboBox2.Items.Add(List[i]);
    end;
  ComboBox1.ItemIndex := 0;
  ComboBox2.ItemIndex := 0;
  List.Free;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  i, ii, iii, x, CurrentMovie: Integer;
begin
  i := MessageDlg('      ?', mtWarning, [mbYes, mbNo], 0);
  if i = 6 then
    begin
      MovieBase := TMovieBase.Create;
      RefreshOff;
      ExitFlag := 0;
      Button2.Caption := '';
      with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
        try
          SaveLogFile := ReadInteger('OtherOptions', 'SaveLogFile', 0);
        finally
          Free;
        end;
      LogFileName := MovieBase.Filename + '_del.log';
      GroupBox1.Enabled := False;
      GroupBox2.Enabled := False;
      Button1.Enabled := False;
      Button3.Enabled := False;
      Button4.Enabled := False;
      Button5.Enabled := False;
      Edit1.Enabled := False;
      ComboBox1.Enabled := False;
      ComboBox2.Enabled := False;
      CheckBox1.Enabled := False;
      CheckBox2.Enabled := False;
      CheckBox5.Enabled := False;
      CheckBox6.Enabled := False;
      Label3.Enabled := False;
      Label4.Enabled := False;
      Label5.Enabled := False;
      Label2.Enabled := False;
      Memo1.Lines.Clear;
      ProgressBar1.Position := 0;
      ProgressBar2.Position := 0;
      if CheckExit(0) = 1 then
        Exit;
      if CheckBox1.Checked = False then
        MovieBase.First;
      MovieBase.EditMovie;
      x := MovieBase.MovieCount;
      for iii := 1 to x do
        begin
          Memo1.Lines.Add(': ' + MovieBase.CurrentMovie.Title);
          Application.ProcessMessages;
          Label1.Caption := MovieBase.CurrentMovie.Title + ' (' + IntToStr(iii) + '/' + IntToStr(x) + ')';
          ProgressBar2.Position := 1;
          if CheckExit(0) = 1 then
            Exit;
          i := MovieBase.CurrentMovie.ScreenshotsCount;
          for ii := 0 to i - 1 do
            begin
              Memo1.Lines.Add('     ' + IntToStr(ii + 1));
              MovieBase.CurrentMovie.DeleteScreenshot(i - ii - 1);
              ProgressBar2.Position := Round(100 * (ii + 1) / i);
              if CheckExit(0) = 1 then
                Exit;
            end;
          if MovieBase.CurrentMovie.IsCoverExists then
            begin
              Memo1.Lines.Add('    ');
              MovieBase.CurrentMovie.DeleteCover;
              i := 1;
            end;
          if i > 0 then
            MovieBase.SaveMovie;
          ProgressBar2.Position := 100;
          ProgressBar1.Position := Round(100 * iii / x);
          if CheckExit(0) = 1 then
            Exit;
          CurrentMovie := MovieBase.CurrentMovie.ID;
          MovieBase.Next;
          MovieBase.EditMovie;
          if CurrentMovie = MovieBase.CurrentMovie.ID then
            begin
              ProgressBar1.Position := 100;
              Break;
            end;
        end;
      Memo1.Lines.Add('.');
      if SaveLogFile = 1 then
        begin
          if LogFileName <> '' then
            try
              Memo1.Lines.SaveToFile(LogFileName);
            except
            end;
        end;
      MovieBase.First;
      RefreshOn;
      RefreshWin;
      MovieBase.Free;
      ExitFlag := 1;
      Button2.Caption := '';
      GroupBox1.Enabled := True;
      GroupBox2.Enabled := True;
      Button1.Enabled := True;
      Button3.Enabled := True;
      Button4.Enabled := True;
      Button5.Enabled := True;
      Edit1.Enabled := True;
      ComboBox1.Enabled := True;
      ComboBox2.Enabled := True;
      CheckBox1.Enabled := True;
      CheckBox2.Enabled := True;
      CheckBox5.Enabled := True;
      CheckBox6.Enabled := True;
      Label3.Enabled := True;
      Label4.Enabled := True;
      Label5.Enabled := True;
      Label2.Enabled := True;
      Application.ProcessMessages;
    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  i, j, iii, x, CurrentMovie: Integer;
  s, s3, s4: string;
  FindHandle: THandle;
  FindData: TWin32FindData;
  b: boolean;
begin
  i := MessageDlg('     ?', mtWarning, [mbYes, mbNo], 0);
  if i = 6 then
    begin
      MovieBase := TMovieBase.Create;
      RefreshOff;
      ExitFlag := 0;
      Button2.Caption := '';
      with TIniFile.Create(UserDir + 'Kinopoisk_zas.ini') do
        try
          SaveLogFile := ReadInteger('OtherOptions', 'SaveLogFile', 0);
        finally
          Free;
        end;
      LogFileName := MovieBase.Filename + '_load.log';
      GroupBox1.Enabled := False;
      GroupBox2.Enabled := False;
      Button1.Enabled := False;
      Button3.Enabled := False;
      Button4.Enabled := False;
      Button5.Enabled := False;
      Edit1.Enabled := False;
      ComboBox1.Enabled := False;
      ComboBox2.Enabled := False;
      CheckBox1.Enabled := False;
      CheckBox2.Enabled := False;
      CheckBox5.Enabled := False;
      CheckBox6.Enabled := False;
      Label3.Enabled := False;
      Label4.Enabled := False;
      Label5.Enabled := False;
      Label2.Enabled := False;
      Memo1.Lines.Clear;
      ProgressBar1.Position := 0;
      ProgressBar2.Position := 0;
      if CheckExit(0) = 1 then
        Exit;
      if CheckBox1.Checked = False then
        MovieBase.First;
      MovieBase.EditMovie;
      x := MovieBase.MovieCount;
      for iii := 1 to x do
        begin
          Memo1.Lines.Add(': ' + MovieBase.CurrentMovie.Title);
          Application.ProcessMessages;
          Label1.Caption := MovieBase.CurrentMovie.Title + ' (' + IntToStr(iii) + '/' + IntToStr(x) + ')';
          ProgressBar2.Position := 1;
          if CheckExit(0) = 1 then Exit;
          s3 := MovieBase.Filename;
          j := pos('.amm', s3);
          if j > 0 then
            begin
              s3 := copy(s3, 1, j - 1);
            end;
          s4 := MovieBase.CurrentMovie.Title + ' (' + MovieBase.CurrentMovie.Year + ')';
          s4 := stringreplace(s4, '\', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '/', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, ':', '.', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '*', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '?', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '<', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '>', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '|', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '"', '''', [rfReplaceAll, rfIgnoreCase]);
          s3 := s3 + '_img\' + s4 + '\\';
          FindData.dwFileAttributes := FILE_ATTRIBUTE_NORMAL; //   
          FindHandle := FindFirstFile(PChar(s3 + '*.jpg'), FindData); //     
          if FindHandle <> INVALID_HANDLE_VALUE then //   Ok,  
            begin
              b := true;
              while b do
                begin
                  s := FindData.cFileName;
                  if (s <> '..') and (s <> '.') then //       
                    begin
                      Memo1.Lines.Add('    : ' + s);
                      MovieBase.CurrentMovie.SetScreenshot(s3 + s);
                    end;
                  b := FindNextFile(FindHandle, FindData);
                end;
              Memo1.Lines.Add('    ...');
              try
                MovieBase.SaveMovie;
                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
              except
                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
              end;
            end
          else
            Memo1.Lines.Add('     !!!');
          s3 := MovieBase.Filename;
          j := pos('.amm', s3);
          if j > 0 then
            begin
              s3 := copy(s3, 1, j - 1);
            end;
          s4 := MovieBase.CurrentMovie.Title + ' (' + MovieBase.CurrentMovie.Year + ')';
          s4 := stringreplace(s4, '\', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '/', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, ':', '.', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '*', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '?', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '<', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '>', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '|', '_', [rfReplaceAll, rfIgnoreCase]);
          s4 := stringreplace(s4, '"', '''', [rfReplaceAll, rfIgnoreCase]);
          s3 := s3 + '_img\' + s4 + '\\';
          FindData.dwFileAttributes := FILE_ATTRIBUTE_NORMAL; //   
          FindHandle := FindFirstFile(PChar(s3 + '*.jpg'), FindData); //     
          if FindHandle <> INVALID_HANDLE_VALUE then //   Ok,  
            begin
              b := true;
              while b do
                begin
                  s := FindData.cFileName;
                  if (s <> '..') and (s <> '.') then //       
                    begin
                      Memo1.Lines.Add('    : ' + s);
                      MovieBase.CurrentMovie.SetScreenshot(s3 + s);
                    end;
                  b := FindNextFile(FindHandle, FindData);
                end;
              Memo1.Lines.Add('    ...');
              try
                MovieBase.SaveMovie;
                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '';
              except
                Memo1.Lines.Strings[Memo1.Lines.Count - 1] := Memo1.Lines.Strings[Memo1.Lines.Count - 1] + '!!!';
              end;
            end
          else
            Memo1.Lines.Add('     !!!');
          ProgressBar2.Position := 100;
          ProgressBar1.Position := Round(100 * iii / x);
          if CheckExit(0) = 1 then
            Exit;
          CurrentMovie := MovieBase.CurrentMovie.ID;
          MovieBase.Next;
          MovieBase.EditMovie;
          if CurrentMovie = MovieBase.CurrentMovie.ID then
            begin
              ProgressBar1.Position := 100;
              Break;
            end;
        end;
      Memo1.Lines.Add('.');
      if SaveLogFile = 1 then
        begin
          if LogFileName <> '' then
            try
              Memo1.Lines.SaveToFile(LogFileName);
            except
            end;
        end;
      MovieBase.First;
      RefreshOn;
      RefreshWin;
      MovieBase.Free;
      ExitFlag := 1;
      Button2.Caption := '';
      GroupBox1.Enabled := True;
      GroupBox2.Enabled := True;
      Button1.Enabled := True;
      Button3.Enabled := True;
      Button4.Enabled := True;
      Button5.Enabled := True;
      Edit1.Enabled := True;
      ComboBox1.Enabled := True;
      ComboBox2.Enabled := True;
      CheckBox1.Enabled := True;
      CheckBox2.Enabled := True;
      CheckBox5.Enabled := True;
      CheckBox6.Enabled := True;
      Label3.Enabled := True;
      Label4.Enabled := True;
      Label5.Enabled := True;
      Label2.Enabled := True;
      Application.ProcessMessages;
    end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  EmbeddedWB1.DownloadOptions := [DontExecuteScripts,DontExecuteJava,DontExecuteActiveX,DontDownloadActiveX,DownloadButDontDisplay,DontDownloadFrame,DontDownloadBehaviors,DownloadInSilentMode];
  EmbeddedWB1.Align := alNone;
  EmbeddedWB1.Left := 0;
  EmbeddedWB1.Top := 0;
  EmbeddedWB1.Width := 0;
  EmbeddedWB1.Height := 0;
  GroupBox1.Visible := True; 
  GroupBox2.Visible := True;
  GroupBox3.Visible := True;
  GroupBox1.Enabled := True;
  GroupBox2.Enabled := True;
  GroupBox3.Enabled := True;
  Button6.Visible := False;
  Button6.Enabled := False;
end; 

procedure TForm1.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #8]) then //  Key    backspase
    Key := #0; //  
end;

procedure TForm1.IEDownload1StreamComplete(Sender: TBSCB; Stream: TStream; Result: HRESULT);
var
  MemoryStream: TMemoryStream;
begin
  try
    MemoryStream := TMemoryStream.Create();
    with MemoryStream do
      begin
        Seek(0, 0);
        LoadFromStream(Stream);
      end;
    MemoryStream.Position := 0;
    MemoryStream.SaveToFile(NamePic);
    MemoryStream.Free();
    GetPic := True;
  except
    GetPic := False;;
  end;
end;

procedure TForm1.EmbeddedWB1DocumentComplete(ASender: TObject; const pDisp: IDispatch; var URL: OleVariant);
begin
  GetHTML := True;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked = True then
    begin
      CheckBox3.Checked := True;
      CheckBox4.Checked := True;
    end
  else
    begin
      CheckBox3.Checked := False;
      CheckBox4.Checked := False;
    end;
end;

end.
